
/*
*  Copyright (c) 2004 – 2014 Texas Instruments Incorporated
*  All rights reserved not granted herein.
*
*  Limited License. 
*
*  Texas Instruments Incorporated grants a world-wide, royalty-free,
*  non-exclusive license under copyrights and patents it now or hereafter 
*  owns or controls to make, have made, use, import, offer to sell and 
*  sell ("Utilize") this software subject to the terms herein. With respect
*  to the foregoing patent license, such license is granted solely to the 
*  extent that any such patent is necessary to Utilize the software alone. 
*  The patent license shall not apply to any combinations which include 
*  this software, other than combinations with devices manufactured 
*  by or for TI (“TI Devices”). No hardware patent is licensed hereunder.
*
*  Redistributions must preserve existing copyright notices and reproduce 
*  this license (including the above copyright notice and the disclaimer 
*  and (if applicable) source code license limitations below) in the 
*  documentation and/or other materials provided with the distribution
*
*  Redistribution and use in binary form, without modification, are permitted 
*  provided that the following conditions are met:
*
* 	No reverse engineering, decompilation, or disassembly of this software
*	is permitted with respect to any software provided in binary form.
*
* 	any redistribution and use are licensed by TI for use only with TI Devices.
*
* 	Nothing shall obligate TI to provide you with source code for the software 
*	licensed and provided to you in object code.
*
*  If software source code is provided to you, modification and redistribution 
*  of the source code are permitted provided that the following conditions are met:
*
*	any redistribution and use of the source code, including any resulting 
*	derivative works, are licensed by TI for use only with TI Devices.
*
*	any redistribution and use of any object code compiled from the source code 
*	and any resulting derivative works, are licensed by TI for use only 
*	with TI Devices.
*
*  Neither the name of Texas Instruments Incorporated nor the names of its 
*  suppliers may be used to endorse or promote products derived from 
*  this software without specific prior written permission.
*
*  DISCLAIMER.
*
*	THIS SOFTWARE IS PROVIDED BY TI AND TI’S LICENSORS "AS IS" 
*	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
*	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
*	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL TI AND TI’S LICENSORS 
*	BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
*	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
*	OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
*	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
*	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
*	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
*	EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

//
//
// Deemphasis alpha codes
//
//
//

#ifndef _DEM_A
#define _DEM_A

#include <acpbeta.h>

#define  readDEMMode 0xc200+STD_BETA_DEM,0x0400
#define writeDEMModeDisable 0xca00+STD_BETA_DEM,0x0400
#define writeDEMModeEnable  0xca00+STD_BETA_DEM,0x0401

#define  readDEMFilterMode 0xc200+STD_BETA_DEM,0x0500
#define writeDEMFilterModeOff   0xca00+STD_BETA_DEM,0x0500
#define writeDEMFilterModeAuto  0xca00+STD_BETA_DEM,0x0501
#define writeDEMFilterModeOn    0xca00+STD_BETA_DEM,0x0502

#define  readDEMFilterActive 0xc200+STD_BETA_DEM,0x0600
#define wroteDEMFilterActiveNo  0xca00+STD_BETA_DEM,0x0600
#define wroteDEMFilterActiveYes 0xca00+STD_BETA_DEM,0x0601

#if PAF_MAXNUMCHAN <= 8     /* PAF_ChannelMask = XDAS_Int8 */

#define  readDEMChannelEnable 0xc200+STD_BETA_DEM,0x0800
#define  readDEMChannelActive 0xc200+STD_BETA_DEM,0x0900

#define writeDEMChannelEnableN(NN) 0xca00+STD_BETA_DEM,0x0800+((NN)&0xff)

#elif PAF_MAXNUMCHAN <= 16  /* PAF_ChannelMask = XDAS_Int16 */

#define  readDEMChannelEnable 0xc300+STD_BETA_DEM,0x0008
#define  readDEMChannelActive 0xc300+STD_BETA_DEM,0x000a

#define writeDEMChannelEnableN(NN)    0xcb00+STD_BETA_DEM,0x0008,NN

#elif PAF_MAXNUMCHAN <= 32  /* PAF_ChannelMask = XDAS_Int32 */

#define  readDEMChannelEnable 0xc400+STD_BETA_DEM,0x0008
#define  readDEMChannelActive 0xc400+STD_BETA_DEM,0x000c

#define writeDEMChannelEnableN(NN) 0xcc00+STD_BETA_DEM,0x0008,LSW(NN),MSW(NN)

#else
#error unsupported option: PAF_MAXNUMCHAN > 32
#endif

#if PAF_MAXNUMCHAN == 2

#define writeDEMChannelEnableNone     0xca00+STD_BETA_DEM,0x0800
#define writeDEMChannelEnableLeftRght 0xca00+STD_BETA_DEM,0x0803
#define writeDEMChannelEnableAll      writeDEMChannelEnableLeftRght

#define wroteDEMChannelActiveNone     0xca00+STD_BETA_DEM,0x0900
#define wroteDEMChannelActiveLeftRght 0xca00+STD_BETA_DEM,0x0903

#elif PAF_MAXNUMCHAN == 4

#define writeDEMChannelEnableNone     0xca00+STD_BETA_DEM,0x0800
#define writeDEMChannelEnableLeftRght 0xca00+STD_BETA_DEM,0x0803
#define writeDEMChannelEnableCntrSurr 0xca00+STD_BETA_DEM,0x080c
#define writeDEMChannelEnableAll      0xca00+STD_BETA_DEM,0x080f

#define wroteDEMChannelActiveNone     0xca00+STD_BETA_DEM,0x0900
#define wroteDEMChannelActiveLeftRght 0xca00+STD_BETA_DEM,0x0903
#define wroteDEMChannelActiveCntrSurr 0xca00+STD_BETA_DEM,0x090c
#define wroteDEMChannelActiveAll      0xca00+STD_BETA_DEM,0x090f

#elif PAF_MAXNUMCHAN == 6

#define writeDEMChannelEnableNone     0xca00+STD_BETA_DEM,0x0800
#define writeDEMChannelEnableLeftRght 0xca00+STD_BETA_DEM,0x0803
#define writeDEMChannelEnableLSurRSur 0xca00+STD_BETA_DEM,0x0818
#define writeDEMChannelEnableCntrSubw 0xca00+STD_BETA_DEM,0x0824
#define writeDEMChannelEnableAll      0xca00+STD_BETA_DEM,0x083f

#define wroteDEMChannelActiveNone     0xca00+STD_BETA_DEM,0x0900
#define wroteDEMChannelActiveLeftRght 0xca00+STD_BETA_DEM,0x0903
#define wroteDEMChannelActiveLSurRSur 0xca00+STD_BETA_DEM,0x0918
#define wroteDEMChannelActiveCntrSubw 0xca00+STD_BETA_DEM,0x0924
#define wroteDEMChannelActiveAll      0xca00+STD_BETA_DEM,0x093f

#elif PAF_MAXNUMCHAN == 8

#define writeDEMChannelEnableNone     0xca00+STD_BETA_DEM,0x0800
#define writeDEMChannelEnableLeftRght 0xca00+STD_BETA_DEM,0x0803
#define writeDEMChannelEnableLSurRSur 0xca00+STD_BETA_DEM,0x0818
#define writeDEMChannelEnableLBakRBak 0xca00+STD_BETA_DEM,0x0860
#define writeDEMChannelEnableCntrSubw 0xca00+STD_BETA_DEM,0x0824
#define writeDEMChannelEnableAll      0xca00+STD_BETA_DEM,0x08ff

#define wroteDEMChannelActiveNone     0xca00+STD_BETA_DEM,0x0900
#define wroteDEMChannelActiveLeftRght 0xca00+STD_BETA_DEM,0x0903
#define wroteDEMChannelActiveLSurRSur 0xca00+STD_BETA_DEM,0x0918
#define wroteDEMChannelActiveLBakRBak 0xca00+STD_BETA_DEM,0x0960
#define wroteDEMChannelActiveCntrSubw 0xca00+STD_BETA_DEM,0x0924
#define wroteDEMChannelActiveAll      0xca00+STD_BETA_DEM,0x09ff

#elif PAF_MAXNUMCHAN == 16

#define writeDEMChannelEnableNone     0xcb00+STD_BETA_DEM,0x0008,0x0000
#define writeDEMChannelEnableLeftRght 0xcb00+STD_BETA_DEM,0x0008,0x0003
#define writeDEMChannelEnableLCtrRCtr 0xcb00+STD_BETA_DEM,0x0008,0x000c
#define writeDEMChannelEnableLWidRWid 0xcb00+STD_BETA_DEM,0x0008,0x0030
#define writeDEMChannelEnableLOvrROvr 0xcb00+STD_BETA_DEM,0x0008,0x00c0

#define writeDEMChannelEnableLTrrRTrr 0xcb00+STD_BETA_DEM,0x0008,0x00c0
#define writeDEMChannelEnableLTrhRTrh 0xcb00+STD_BETA_DEM,0x0008,0x00c0

#define writeDEMChannelEnableLSurRSur 0xcb00+STD_BETA_DEM,0x0008,0x0300
#define writeDEMChannelEnableLBakRBak 0xcb00+STD_BETA_DEM,0x0008,0x0c00
#define writeDEMChannelEnableLSubRSub 0xcb00+STD_BETA_DEM,0x0008,0x3000
#define writeDEMChannelEnableLHedRHed 0xcb00+STD_BETA_DEM,0x0008,0xc000

#define writeDEMChannelEnableLTmdRTmd 0xcb00+STD_BETA_DEM,0x0008,0xc000
#define writeDEMChannelEnableLTftRTft 0xcb00+STD_BETA_DEM,0x0008,0xc000
#define writeDEMChannelEnableLTfhRTfh 0xcb00+STD_BETA_DEM,0x0008,0xc000

#define writeDEMChannelEnableAll      0xcb00+STD_BETA_DEM,0x0008,0xffff

#define wroteDEMChannelActiveNone     0xcb00+STD_BETA_DEM,0x000a,0x0000
#define wroteDEMChannelActiveLeftRght 0xcb00+STD_BETA_DEM,0x000a,0x0003
#define wroteDEMChannelActiveLCtrRCtr 0xcb00+STD_BETA_DEM,0x000a,0x000c
#define wroteDEMChannelActiveLWidRWid 0xcb00+STD_BETA_DEM,0x000a,0x0030
#define wroteDEMChannelActiveLOvrROvr 0xcb00+STD_BETA_DEM,0x000a,0x00c0

#define wroteDEMChannelActiveLTrrRTrr 0xcb00+STD_BETA_DEM,0x000a,0x00c0
#define wroteDEMChannelActiveLTrhRTrh 0xcb00+STD_BETA_DEM,0x000a,0x00c0

#define wroteDEMChannelActiveLSurRSur 0xcb00+STD_BETA_DEM,0x000a,0x0300
#define wroteDEMChannelActiveLBakRBak 0xcb00+STD_BETA_DEM,0x000a,0x0c00
#define wroteDEMChannelActiveLSubRSub 0xcb00+STD_BETA_DEM,0x000a,0x3000
#define wroteDEMChannelActiveLHedRHed 0xcb00+STD_BETA_DEM,0x000a,0xc000

#define wroteDEMChannelActiveLTmdRTmd 0xcb00+STD_BETA_DEM,0x000a,0xc000
#define wroteDEMChannelActiveLTftRTft 0xcb00+STD_BETA_DEM,0x000a,0xc000
#define wroteDEMChannelActiveLTfhRTfh 0xcb00+STD_BETA_DEM,0x000a,0xc000

#define wroteDEMChannelActiveAll      0xcb00+STD_BETA_DEM,0x000a,0xffff

#elif PAF_MAXNUMCHAN == 32

#define writeDEMChannelEnableAll      0xcc00+STD_BETA_DEM,0x0008,0xffff,0xffff
#define wroteDEMChannelActiveAll      0xcc00+STD_BETA_DEM,0x000c,0xffff,0xffff

#else /* PAF_MAXNUMCHAN */
#error unsupported option: PAF_MAXNUMCHAN > 32
#endif /* PAF_MAXNUMCHAN */

#define  readDEMStatus 0xc508,STD_BETA_DEM
#define  readDEMControl \
         readDEMMode, \
         readDEMFilterMode, \
         readDEMChannelEnable

#endif /* _DEM_A */

