
/*
*  Copyright (c) 2004 – 2014 Texas Instruments Incorporated
*  All rights reserved not granted herein.
*
*  Limited License. 
*
*  Texas Instruments Incorporated grants a world-wide, royalty-free,
*  non-exclusive license under copyrights and patents it now or hereafter 
*  owns or controls to make, have made, use, import, offer to sell and 
*  sell ("Utilize") this software subject to the terms herein. With respect
*  to the foregoing patent license, such license is granted solely to the 
*  extent that any such patent is necessary to Utilize the software alone. 
*  The patent license shall not apply to any combinations which include 
*  this software, other than combinations with devices manufactured 
*  by or for TI (“TI Devices”). No hardware patent is licensed hereunder.
*
*  Redistributions must preserve existing copyright notices and reproduce 
*  this license (including the above copyright notice and the disclaimer 
*  and (if applicable) source code license limitations below) in the 
*  documentation and/or other materials provided with the distribution
*
*  Redistribution and use in binary form, without modification, are permitted 
*  provided that the following conditions are met:
*
* 	No reverse engineering, decompilation, or disassembly of this software
*	is permitted with respect to any software provided in binary form.
*
* 	any redistribution and use are licensed by TI for use only with TI Devices.
*
* 	Nothing shall obligate TI to provide you with source code for the software 
*	licensed and provided to you in object code.
*
*  If software source code is provided to you, modification and redistribution 
*  of the source code are permitted provided that the following conditions are met:
*
*	any redistribution and use of the source code, including any resulting 
*	derivative works, are licensed by TI for use only with TI Devices.
*
*	any redistribution and use of any object code compiled from the source code 
*	and any resulting derivative works, are licensed by TI for use only 
*	with TI Devices.
*
*  Neither the name of Texas Instruments Incorporated nor the names of its 
*  suppliers may be used to endorse or promote products derived from 
*  this software without specific prior written permission.
*
*  DISCLAIMER.
*
*	THIS SOFTWARE IS PROVIDED BY TI AND TI’S LICENSORS "AS IS" 
*	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
*	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
*	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL TI AND TI’S LICENSORS 
*	BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
*	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
*	OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
*	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
*	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
*	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
*	EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

//
//
// Board initialization code
//
//
//	

#include <da830lib.h>

#pragma CODE_SECTION (board_init, ".text:board_init")
void board_init (void)
{
	CPUARBU = 0x00020010;
	MSTPRI0 = 0x44443333;
	MSTPRI1 = 0x44441110;
	BPRIO   = 0x0;
	
	// Setup PINMUX
	// Created using the Pin Setup Utility (Version: 1.0.426.6)
	PINMUX0 = 0x11112188;
	PINMUX1 = 0x11111111;
	PINMUX2 = 0x11111111;
	PINMUX3 = 0x11111111;
	PINMUX4 = 0x11111111;
	PINMUX5 = 0x11111111;
	PINMUX6 = 0x11111111;
	PINMUX7 = 0x11111111;
	PINMUX8 = 0x21122111;
	PINMUX9 = 0x11011112;
	PINMUX10 = 0x22222221;
	PINMUX11 = 0x11142222;
	PINMUX12 = 0x11111111;
	PINMUX13 = 0x22111111;
	PINMUX14 = 0x88222222;
	PINMUX15 = 0x21888888;
	PINMUX16 = 0x11111112;
	PINMUX17 = 0x00100111;
	PINMUX18 = 0x11111111;
	PINMUX19 = 0x00000001;

	// Enable peripherals through PSC0
	lpscEnable (PSC0, PD0, 0);								// TPCC
	lpscEnable (PSC0, PD0, 1);								// TPTC0
	lpscEnable (PSC0, PD0, 2);								// TPTC1
	lpscEnable (PSC0, PD0, 3);								// EMIFA
	lpscEnable (PSC0, PD0, 4);								// SPI0
	lpscEnable (PSC0, PD0, 5);								// MMC/SD0
	lpscEnable (PSC0, PD0, 6);								// AINTC
//  lpscEnable (PSC0, PD0, 7);                              // ARM RAM / ROM
	lpscEnable (PSC0, PD0, 8);								// Security Controller / Key Manager
	lpscEnable (PSC0, PD0, 9);								// UART0
	lpscEnable (PSC0, PD0, 10);								// SCR0_SS
	lpscEnable (PSC0, PD0, 11);								// SCR1_SS
	lpscEnable (PSC0, PD0, 12);								// SCR2_SS
	lpscEnable (PSC0, PD0, 13);								// dMAX
//  lpscEnable (PSC0, PD0, 14);                             // ARM
//  lpscEnable (PSC0, PD0, 15);                             // GEM

	// Enable peripherals through PSC1
	lpscEnable (PSC1, PD0, 1);								// USB 2.0
	lpscEnable (PSC1, PD0, 2);								// USB 1.1
	lpscEnable (PSC1, PD0, 3);								// GPIO
	lpscEnable (PSC1, PD0, 4);								// UHPI
	lpscEnable (PSC1, PD0, 5);								// CPGMAC
	lpscEnable (PSC1, PD0, 6);								// EMIFB
	lpscEnable (PSC1, PD0, 7);								// McASP0
	lpscEnable (PSC1, PD0, 8);								// McASP1
	lpscEnable (PSC1, PD0, 9);								// McASP2
	lpscEnable (PSC1, PD0, 10);								// SPI1
	lpscEnable (PSC1, PD0, 11);								// I2C1
	lpscEnable (PSC1, PD0, 12);								// UART1
	lpscEnable (PSC1, PD0, 13);								// UART2
	lpscEnable (PSC1, PD0, 16);								// LCDC
	lpscEnable (PSC1, PD0, 17);								// HR/EPWM0/1/2
	lpscEnable (PSC1, PD0, 20);								// ECAP0/1/2
	lpscEnable (PSC1, PD0, 21);								// EQEP0/1
	lpscEnable (PSC1, PD0, 24);								// SCR_P0_SS
	lpscEnable (PSC1, PD0, 25);								// SCR_P1_SS
	lpscEnable (PSC1, PD0, 26);								// CR_P3_SS
	lpscEnable (PSC1, PD0, 31);								// L3_CBA_RAM
#if 0
    // Boot ARM
	armBoot (0xC1080000);

	// FIXME: Workaround for MID 3996
	{
		unsigned int i;
		for (i = 0; i < 0x31000000; i++)
			asm (" NOP 5 ");
	}
#endif
}
