#
# $Source: /cvsstl/ti/pa/f/s19/i4/evmda830/parselog.awk,v $
# $Revision: 1.2 $
#
# Awk script to parse traceio.csv
#
# Copyright 2009 Texas Instruments Incorporated.  All rights reserved.
# Texas Instruments Proprietary and Confidential.
# Use without a license from Texas Instruments is prohibited.
#
# $Log: parselog.awk,v $
# -----------------------------------------------------------------------------

# usage
#   awk -f parselog.awk < traceio.csv

# ------------------------------------------------------------------------------

BEGIN {
    caseNum = 0;
    speed[0] = "faster";
    speed[1] = "slower";
}

# ------------------------------------------------------------------------------

/caseNum/ {
    caseNum += 1;
}

/adjDir/ {
    adjDir[caseNum] = gensub(/^.*adjDir = ([[:digit:]]+),.*$/,"\\1", "g", $0);
}

/drift/ {
    drift[caseNum] = gensub(/^.*drift = (.*),.*$/,"\\1", "g", $0);
}

/frame/ {
    frame[caseNum] = gensub(/^.*frame = ([[:digit:]]+),.*$/,"\\1", "g", $0);
}

/fs/ {
    fs[caseNum] = gensub(/^.*fs = ([[:digit:]]+),.*$/,"\\1", "g", $0);
}

/loadMips/ {
    loadMips[caseNum] = gensub(/^.*loadMips = ([[:digit:]]+),.*$/,"\\1", "g", $0);
}

/maxNumBuf/ {
    maxNumBuf[caseNum] = gensub(/^.*maxNumBuf = ([[:digit:]]+),.*$/,"\\1", "g", $0);
}

/ppm/ {
    ppm[caseNum] = gensub(/^.*ppm = ([[:digit:]]+),.*$/,"\\1", "g", $0);
}

/preFill/ {
    preFill[caseNum] = gensub(/^.*preFill = ([[:digit:]]+),.*$/,"\\1", "g", $0);
}

# ------------------------------------------------------------------------------

END {
    printf ("Input Clock     FS          loadMips         Prefill        numMaxBuf        Drift    Frame\n");
    printf ("--------------------------------------------------------------------------------------------\n");
    for (i=1; i <= caseNum; i++) {
        printf ("%s\t\t%d\t\t%d\t\t%d\t\t%d\t\t%d\t%d\n",
                speed[adjDir[i]], fs[i], loadMips[i], preFill[i], maxNumBuf[i], drift[i], frame[i]);
    }
}

# ------------------------------------------------------------------------------
