
/*
*  Copyright (c) 2004 – 2014 Texas Instruments Incorporated
*  All rights reserved not granted herein.
*
*  Limited License. 
*
*  Texas Instruments Incorporated grants a world-wide, royalty-free,
*  non-exclusive license under copyrights and patents it now or hereafter 
*  owns or controls to make, have made, use, import, offer to sell and 
*  sell ("Utilize") this software subject to the terms herein. With respect
*  to the foregoing patent license, such license is granted solely to the 
*  extent that any such patent is necessary to Utilize the software alone. 
*  The patent license shall not apply to any combinations which include 
*  this software, other than combinations with devices manufactured 
*  by or for TI (“TI Devices”). No hardware patent is licensed hereunder.
*
*  Redistributions must preserve existing copyright notices and reproduce 
*  this license (including the above copyright notice and the disclaimer 
*  and (if applicable) source code license limitations below) in the 
*  documentation and/or other materials provided with the distribution
*
*  Redistribution and use in binary form, without modification, are permitted 
*  provided that the following conditions are met:
*
* 	No reverse engineering, decompilation, or disassembly of this software
*	is permitted with respect to any software provided in binary form.
*
* 	any redistribution and use are licensed by TI for use only with TI Devices.
*
* 	Nothing shall obligate TI to provide you with source code for the software 
*	licensed and provided to you in object code.
*
*  If software source code is provided to you, modification and redistribution 
*  of the source code are permitted provided that the following conditions are met:
*
*	any redistribution and use of the source code, including any resulting 
*	derivative works, are licensed by TI for use only with TI Devices.
*
*	any redistribution and use of any object code compiled from the source code 
*	and any resulting derivative works, are licensed by TI for use only 
*	with TI Devices.
*
*  Neither the name of Texas Instruments Incorporated nor the names of its 
*  suppliers may be used to endorse or promote products derived from 
*  this software without specific prior written permission.
*
*  DISCLAIMER.
*
*	THIS SOFTWARE IS PROVIDED BY TI AND TI’S LICENSORS "AS IS" 
*	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
*	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
*	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL TI AND TI’S LICENSORS 
*	BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
*	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
*	OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
*	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
*	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
*	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
*	EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

//
// Framework Declarations
//

#include <as1-f2-patchs.h>
#include <asp0.h>
#include <asp1.h>

//
// Decoder Definitions
//

#include <sng.h>
#include <sng_mds.h>

#include <pcm.h>
#include <pcm_mds.h>

#include <dtshd.h>
#include <dtshd_tii.h>

#include <thd.h>
#include <thd_tii.h>

#include <dxp.h>
#include <dxp_tii.h>

#include <ddp.h>
#include <ddp_tij.h>

#include <aac.h>
#include <aac_tii.h>

#include <dwr_inp.h>

const PAF_ASP_LinkInit decLinkInitY13[] =
{
    PAF_ASP_LINKINITPARAMS (STD, DWRPCM, TII, &IDWRPCM_PARAMS),
#if(PAF_DEVICE) == 0xD8000001
    PAF_ASP_LINKINITPARAMS (STD, DWRAAC, TII, &IDWRAAC_PARAMS),
    PAF_ASP_LINKINIT (STD, DTSHD, TII),
    PAF_ASP_LINKINIT (STD, DXP, TII),
    PAF_ASP_LINKINIT (STD, THD, TII),
    PAF_ASP_LINKINITPARAMS (STD, DDP, TIJ, &IDDP_PARAMS_SDRAM),
    PAF_ASP_LINKINIT (STD, SNG, MDS),
#endif /* (PAF_DEVICE) == 0xD8000001 */
    PAF_ASP_LINKNONE,
};

const PAF_ASP_LinkInit *const patchs_decLinkInit[] =
{
    decLinkInitY13,
};

//
// Audio Stream Processing Declarations & Definitions
//

//#define AE0  /* optional -- not inserted if commented out */

//#define AE_1  /* optional -- not inserted if commented out */
//#define AE_2  /* optional -- not inserted if commented out */
//#define AE_3  /* optional -- not inserted if commented out */

#include <dem.h>
#include <dem_mds.h>
#include <ass.h>
#include <ass_tii.h>

#ifndef TTC

#include <pl2x.h>
#include <pl2x_tii.h>

#include <neox.h>
#include <neox_tig.h>

#endif /* TTC */

#include <mtx.h>
#include <mtx_wav.h>

#include <rvb.h>
#include <rvb_wav.h>

#include <dm.h>
#include <dm_tii.h>

#include <geq.h>
#include <geq_tii.h>
#define LOU_TII_init GEQ_TII_init
#define LOU_TII_ILOU GEQ_TII_IGEQ

#include <bm.h>
#include <bm_mds.h>
/*
**  MID 2918:  Standard BM2 BLKSIZE is 256.  
**  If the maximum sampleCount to be supported is 256, do _not_ 
**  #define NONSTANDARD_BM2_BLKSIZE, and the from-ROM instantiation 
**  param IBM_PARAMS will be used.
**  If the maximum sampleCount to be supported is _not_ 256,
**  #define NONSTANDARD_BM2_BLKSIZE to the appropriate value.
*/
//#define NONSTANDARD_BM2_BLKSIZE 128

#ifdef NONSTANDARD_BM2_BLKSIZE /*******************************************************/

extern IBM_Status  IBM_PARAMS_STATUS;
extern IBM_Config  IBM_PARAMS_CONFIG;
extern IFIL_Params IBM_FIL_PARAMS_HPMAIN;
extern IFIL_Params IBM_FIL_PARAMS_HPCNTR;
extern IFIL_Params IBM_FIL_PARAMS_HPSURR;
#ifdef PAF_BACK
extern IFIL_Params IBM_FIL_PARAMS_HPBACK;
extern IFIL_Params IBM_FIL_PARAMS_LPREARLEFT;
extern IFIL_Params IBM_FIL_PARAMS_LPREARRGHT;
#endif /* PAF_BACK */
extern IFIL_Params IBM_FIL_PARAMS_LPMAIN;
extern IFIL_Params IBM_FIL_PARAMS_LPCNTR;
extern IFIL_Params IBM_FIL_PARAMS_LPSURR;
extern IFIL_Params IBM_FIL_PARAMS_LPBACK;
extern IFIL_Params IBM_FIL_PARAMS_LPLFE;
extern IFIL_Params IBM_FIL_PARAMS_LPSUBW;

const IBM_Params newIbmParams = 
{
    sizeof(IBM_Params),         /* size */
    &IBM_PARAMS_STATUS,         /* pStatus */
    &IBM_PARAMS_CONFIG,         /* pConfig */
    &IBM_ACTIVE,                /* pActive */
    0,                          /* pScrach */
    &IBM_FIL_PARAMS_HPMAIN,     /* pParamsHpMain */
    &IBM_FIL_PARAMS_HPCNTR,     /* pParamsHpCntr */
    &IBM_FIL_PARAMS_HPSURR,     /* pParamsHpSurr */
#ifdef PAF_BACK
    &IBM_FIL_PARAMS_HPBACK,     /* pParamsHpBack */
    &IBM_FIL_PARAMS_LPREARLEFT, /* pParamsLpRearLeft */
    &IBM_FIL_PARAMS_LPREARRGHT, /* pParamsLpRearRght */
#endif /* PAF_BACK */
    &IBM_FIL_PARAMS_LPMAIN,     /* pParamsLpMain */
    &IBM_FIL_PARAMS_LPCNTR,     /* pParamsLpCntr */
    &IBM_FIL_PARAMS_LPSURR,     /* pParamsLpSurr */
    &IBM_FIL_PARAMS_LPBACK,     /* pParamsLpBack */
    &IBM_FIL_PARAMS_LPLFE,      /* pParamsLpLFE */
    &IBM_FIL_PARAMS_LPSUBW,     /* pParamsLpSubw */
	NONSTANDARD_BM2_BLKSIZE     /* blksize */
};	
#endif /*********** NONSTANDARD_BLKSIZE ************************************/

#include <ml.h>
#include <ml_mds.h>

#include <dh2.h>
#include <dh2_tii.h>

#include <dvs2.h>
#include <dvs2_tii.h>

#ifdef THX
#include <asa.h>
#include <asa_tii.h>

#include <bc.h>
#include <bc_tii.h>

#include <tm.h>
#include <tm_tii.h>

#include <ad.h>
#include <ad_tii.h>

#include <req.h>
#include <req_tii.h>


#include <fil.h>
#include <fil_tii.h>

extern const IFIL_Params IBGC_PARAMS;
#define BGC_TII_init FIL_TII_init
#define BGC_TII_IBGC FIL_TII_IFIL
#endif /* THX */
#ifdef AE0
#include <ae.h>
#include <ae_mds.h>
#endif

#if defined (AE_1) || defined (AE_2) || defined (AE_3)
#include <ae.h>
#include <ae_tii.h>
#endif

#include <src.h>
#include <src_tih.h>
#define SUC_TIH_init SRC_TIH_init
#define SUC_TIH_ISUC SRC_TIH_ISRC

#include <aspstd.h>

const PAF_ASP_LinkInit aspLinkInitAllY13[] =
{
#ifdef AE0
    PAF_ASP_LINKINIT (CUS, AE, MDS),
#endif
#ifdef AE_1
    PAF_ASP_LINKINITPARAMS (CUS, AE, TII, &IAE_PARAMS_DIRECT),
#endif
#ifdef AE_2
    PAF_ASP_LINKINITPARAMS (CUS, AE, TII, &IAE_PARAMS_SIMPLE_DMA),
#endif
#ifdef AE_3
    PAF_ASP_LINKINITPARAMS (CUS, AE, TII, &IAE_PARAMS_CONCURRENT_DMA),
#endif /* AE_3 */
    PAF_ASP_LINKINITPARAMS (STD, SRC, TIH, &ISRC_PARAMS_DS_8CH_HBW),
    PAF_ASP_LINKINIT (STD, DEM, MDS),
    PAF_ASP_LINKINIT(STD,ASS,TII),

#if(PAF_DEVICE) == 0xD8000001
#ifndef TTC
    PAF_ASP_LINKINIT (STD, PL2x, TII),
   PAF_ASP_LINKINITPARAMS (STD, NEOX, TIG, &INEOX_PARAMS),
#endif /* TTC */
    PAF_ASP_LINKINIT (STD, MTX, WAV),
    PAF_ASP_LINKINITPARAMS (STD, RVB, WAV, &IRVB_PARAMS_PSDELAY),
    PAF_ASP_LINKINIT (STD, DM, TII),
    PAF_ASP_LINKINITPARAMS (STD, GEQ, TII, &IGEQ_PARAMS_EQX_16CHN_UNICOEF),
    PAF_ASP_LINKINITPARAMS (STD, LOU, TII, &IGEQ_PARAMS_LOU),
#ifdef THX
    PAF_ASP_LINKINITPARAMS(STD,BGC,TII,&IBGC_PARAMS),
#endif /* THX */

#ifdef NONSTANDARD_BM2_BLKSIZE
    PAF_ASP_LINKINITPARAMS(STD,BM,MDS,&newIbmParams),
#else
    PAF_ASP_LINKINITPARAMS(STD,BM,MDS,&IBM_PARAMS_256),
#endif

#ifdef BASS
    PAF_ASP_LINKINIT(STD,BASS,TIJ),
#endif /* BASS */
#ifdef THX
    PAF_ASP_LINKINIT(STD,ASA,TII),
    PAF_ASP_LINKINIT(STD,REQ,TII),
    PAF_ASP_LINKINIT(STD,TM,TII),
    PAF_ASP_LINKINITPARAMS(STD,AD,TII,&IAD_PARAMS_DAT_11),
    PAF_ASP_LINKINIT(STD,BC,TII),
#endif /* THX */
	PAF_ASP_LINKINIT(STD,DH2,TII),
	PAF_ASP_LINKINIT(STD,DVS2,TII),
    PAF_ASP_LINKINIT (STD, ML, MDS),
#endif /* (PAF_DEVICE) == 0xD8000001 */   
    PAF_ASP_LINKNONE,
};

const PAF_ASP_LinkInit aspLinkInitNilY13[] =
{
    PAF_ASP_LINKINIT(STD,ASS,TII),
    PAF_ASP_LINKNONE,
};

const PAF_ASP_LinkInit aspLinkInitStdY13[] =
{

#ifdef AE0
    PAF_ASP_LINKINIT (CUS, AE, MDS),
#endif
    PAF_ASP_LINKINITPARAMS (STD, SRC, TIH, &ISRC_PARAMS_DS_8CH_HBW),
    PAF_ASP_LINKINIT (STD, DEM, MDS),
    PAF_ASP_LINKINIT(STD,ASS,TII),
#if(PAF_DEVICE) == 0xD8000001
#ifndef TTC
    PAF_ASP_LINKINIT (STD, PL2x, TII),
    PAF_ASP_LINKINITPARAMS (STD, NEOX, TIG, &INEOX_PARAMS),
#endif /* TTC */
    PAF_ASP_LINKINIT (STD, MTX, WAV),
    PAF_ASP_LINKINITPARAMS (STD, RVB, WAV, &IRVB_PARAMS_PSDELAY),
    PAF_ASP_LINKINIT (STD, DM, TII),
    PAF_ASP_LINKINITPARAMS (STD, GEQ, TII, &IGEQ_PARAMS_EQX_16CHN_UNICOEF),
    PAF_ASP_LINKINITPARAMS (STD, LOU, TII, &IGEQ_PARAMS_LOU),
#ifdef THX
    PAF_ASP_LINKINITPARAMS(STD,BGC,TII,&IBGC_PARAMS),
#endif /* THX */

#ifdef NONSTANDARD_BM2_BLKSIZE
    PAF_ASP_LINKINITPARAMS(STD,BM,MDS,&newIbmParams),
#else
    PAF_ASP_LINKINITPARAMS(STD,BM,MDS,&IBM_PARAMS_256),
#endif

#ifdef BASS
    PAF_ASP_LINKINIT(STD,BASS,TIJ),
#endif /* BASS */
#ifdef THX
    PAF_ASP_LINKINIT(STD,ASA,TII),
    PAF_ASP_LINKINIT(STD,REQ,TII),
    PAF_ASP_LINKINIT(STD,TM,TII),
    PAF_ASP_LINKINITPARAMS(STD,AD,TII,&IAD_PARAMS_DAT_11),
    PAF_ASP_LINKINIT(STD,BC,TII),
#endif /* THX */
	PAF_ASP_LINKINIT(STD,DH2,TII),
	PAF_ASP_LINKINIT(STD,DVS2,TII),
    PAF_ASP_LINKINIT (STD, ML, MDS),
#endif /* (PAF_DEVICE) == 0xD8000001 */
    PAF_ASP_LINKNONE,
};

const PAF_ASP_LinkInit aspLinkInitCusY13[] =
{
#ifdef AE0
    PAF_ASP_LINKINIT (CUS, AE, MDS),
#endif
	PAF_ASP_LINKINIT(STD,ASS,TII),

#ifdef AE_1
    PAF_ASP_LINKINITPARAMS (CUS, AE, TII, &IAE_PARAMS_DIRECT),
#endif /* AE_1 */
#ifdef AE_2
    PAF_ASP_LINKINITPARAMS (CUS, AE, TII, &IAE_PARAMS_SIMPLE_DMA),
#endif /* AE_2 */
#ifdef AE_3
    PAF_ASP_LINKINITPARAMS (CUS, AE, TII, &IAE_PARAMS_CONCURRENT_DMA),
#endif /* AE_3 */
    PAF_ASP_LINKNONE,
};
static const PAF_ASP_LinkInit aspLinkInitAllY13_2[] =
{
    PAF_ASP_LINKINITPARAMS(STD,SRC,TIH,&ISRC_PARAMS_MAX48_HBW),
    PAF_ASP_LINKNONE,
};

#define aspLinkInitNilY13_2 NULL

static const PAF_ASP_LinkInit aspLinkInitStdY13_2[] =
{
    PAF_ASP_LINKINITPARAMS(STD,SRC,TIH,&ISRC_PARAMS_MAX48_HBW),
    PAF_ASP_LINKNONE,
};

static const PAF_ASP_LinkInit aspLinkInitCusY13_2[] =
{
    PAF_ASP_LINKNONE,
};


const PAF_ASP_LinkInit *const patchs_aspLinkInit[2][GEARS] =
{
    {
     aspLinkInitAllY13,
     aspLinkInitNilY13,
     aspLinkInitStdY13,
     aspLinkInitCusY13,
     },
     {
     aspLinkInitAllY13_2,
     aspLinkInitNilY13_2,
     aspLinkInitStdY13_2,
     aspLinkInitCusY13_2,
     },
};

//
// Encoder Definitions
//

#include <pce.h>
#include <pce_tii.h>
extern const IPCE_Params IPCE_PARAMS_CUS;
extern const IPCE_Params IPCE_PARAMS_THX_EXT; // use if extended channels needed 
extern const IPCE_Params IPCE_PARAMS_THX; // use if 7.1 channels needed
extern const IPCE_Params IPCE_PARAMS_CUS_SEC; 
const PAF_ASP_LinkInit encLinkInitY13[] =
{
    PAF_ASP_LINKINITPARAMS (STD, PCE, TII, &IPCE_PARAMS_THX_EXT),
    PAF_ASP_LINKNONE,
};
static const PAF_ASP_LinkInit encLinkInitY13Secondary[] =
{
    PAF_ASP_LINKINITPARAMS(STD,PCE,TII,&IPCE_PARAMS_CUS_SEC),
    PAF_ASP_LINKNONE,
};


const PAF_ASP_LinkInit *const patchs_encLinkInit[] =
{
    encLinkInitY13,
    encLinkInitY13Secondary,
};

//
// Audio Stream Patch Definition
//

extern const PAF_SIO_ParamsN patchs_devinp[];
extern const PAF_SIO_ParamsN patchs_devout[];

const PAF_AST_Patchs patchs_PAy =
{
    patchs_devinp,
    patchs_devout,
    patchs_decLinkInit,
    patchs_aspLinkInit,
    patchs_encLinkInit,
};

// EOF
