
/*
*  Copyright (c) 2004 – 2014 Texas Instruments Incorporated
*  All rights reserved not granted herein.
*
*  Limited License. 
*
*  Texas Instruments Incorporated grants a world-wide, royalty-free,
*  non-exclusive license under copyrights and patents it now or hereafter 
*  owns or controls to make, have made, use, import, offer to sell and 
*  sell ("Utilize") this software subject to the terms herein. With respect
*  to the foregoing patent license, such license is granted solely to the 
*  extent that any such patent is necessary to Utilize the software alone. 
*  The patent license shall not apply to any combinations which include 
*  this software, other than combinations with devices manufactured 
*  by or for TI (“TI Devices”). No hardware patent is licensed hereunder.
*
*  Redistributions must preserve existing copyright notices and reproduce 
*  this license (including the above copyright notice and the disclaimer 
*  and (if applicable) source code license limitations below) in the 
*  documentation and/or other materials provided with the distribution
*
*  Redistribution and use in binary form, without modification, are permitted 
*  provided that the following conditions are met:
*
* 	No reverse engineering, decompilation, or disassembly of this software
*	is permitted with respect to any software provided in binary form.
*
* 	any redistribution and use are licensed by TI for use only with TI Devices.
*
* 	Nothing shall obligate TI to provide you with source code for the software 
*	licensed and provided to you in object code.
*
*  If software source code is provided to you, modification and redistribution 
*  of the source code are permitted provided that the following conditions are met:
*
*	any redistribution and use of the source code, including any resulting 
*	derivative works, are licensed by TI for use only with TI Devices.
*
*	any redistribution and use of any object code compiled from the source code 
*	and any resulting derivative works, are licensed by TI for use only 
*	with TI Devices.
*
*  Neither the name of Texas Instruments Incorporated nor the names of its 
*  suppliers may be used to endorse or promote products derived from 
*  this software without specific prior written permission.
*
*  DISCLAIMER.
*
*	THIS SOFTWARE IS PROVIDED BY TI AND TI’S LICENSORS "AS IS" 
*	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
*	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
*	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL TI AND TI’S LICENSORS 
*	BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
*	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
*	OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
*	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
*	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
*	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
*	EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

//
//
// GEQ alpha codes
//
//
//

/*
 * !! THIS IS A MACHINE GENERATED FILE !!
 *
 *         Please do not hand edit
 *
 */

#ifndef _GEQ_A
#define _GEQ_A

#include <acpbeta.h>

#ifndef STD_BETA_GEQ
#   define STD_BETA_GEQ     0x55
#endif

#ifndef PAF_MAXNUMCHAN
#   define PAF_MAXNUMCHAN   16
#endif

#define  readGEQMode            0xc200+STD_BETA_GEQ,0x0400
#define writeGEQModeDisable     0xca00+STD_BETA_GEQ,0x0400
#define writeGEQModeEnable      0xca00+STD_BETA_GEQ,0x0401
 
#define  readGEQUse             0xc200+STD_BETA_GEQ,0x0500
#define writeGEQUseDisable      0xca00+STD_BETA_GEQ,0x0500
#define writeGEQUseEnable       0xca00+STD_BETA_GEQ,0x0501

#define  readGEQparamChg        0xc200+STD_BETA_GEQ,0x0600
#define writeGEQparamChg(N)     0xca00+STD_BETA_GEQ,0x0600+((N)&0xFF)
#define wroteGEQparamChg        0xca00+STD_BETA_GEQ,0x0600
#define writeGEQparamChgRamp     0xca00+STD_BETA_GEQ,0x0601
#define writeGEQparamChgNoRamp     0xca00+STD_BETA_GEQ,0x0602
#define writeGEQparamChgNone     0xca00+STD_BETA_GEQ,0x0600

#define  readGEQnumBands        0xc200+STD_BETA_GEQ,0x0700
#define writeGEQnumBands(N)     0xca00+STD_BETA_GEQ,0x0700+((N)&0xff)

#define  readGEQenableBand      0xc400+STD_BETA_GEQ,0x0008
#define writeGEQenableBand(N)   0xcc00+STD_BETA_GEQ,0x0008,((N)&0xFFFF),(((N)>>16)&0xFFFF)

#define  readGEQenableChan      0xc400+STD_BETA_GEQ,0x000c
#define writeGEQenableChan(N)   0xcc00+STD_BETA_GEQ,0x000c,((N)&0xFFFF),(((N)>>16)&0xFFFF)

/* readGEQStatus is commented out for now. The GEQ3 status
   structure may be too large to be transmitted in a single
   payload within PA/F. */
// #define  readGEQStatus 0xc508,0x0000+STD_BETA_GEQ

// -- Not expected to be used externally --
// ---- uni-coef
#define  readGEQFreq(b)         0xc300+STD_BETA_GEQ,0x0010+((b)*6)
#define writeGEQFreq(b,N)       0xcb00+STD_BETA_GEQ,0x0010+((b)*6),N
#define wroteGEQFreq(b)         0xcb00+STD_BETA_GEQ,0x0010+((b)*6)
#define  readGEQLevel(b)        0xc300+STD_BETA_GEQ,0x0012+((b)*6)
#define writeGEQLevel(b,N)      0xcb00+STD_BETA_GEQ,0x0012+((b)*6),N
#define wroteGEQLevel(b)        0xcb00+STD_BETA_GEQ,0x0012+((b)*6)
#define  readGEQWidth(b)        0xc300+STD_BETA_GEQ,0x0014+((b)*6)
#define writeGEQWidth(b,N)      0xcb00+STD_BETA_GEQ,0x0014+((b)*6),N
#define wroteGEQWidth(b)        0xcb00+STD_BETA_GEQ,0x0014+((b)*6)

// -- channel-wise coeffs 
#define  readGEQFreqCh(c,b,B)     0xc300+STD_BETA_GEQ,0x0010+(((c)*(B) + (b))*6)
#define writeGEQFreqCh(c,b,B,N)   0xcb00+STD_BETA_GEQ,0x0010+(((c)*(B) + (b))*6),N
#define wroteGEQFreqCh(c,b,B)     0xcb00+STD_BETA_GEQ,0x0010+(((c)*(B) + (b))*6)
#define  readGEQLevelCh(c,b,B)    0xc300+STD_BETA_GEQ,0x0012+(((c)*(B) + (b))*6)
#define writeGEQLevelCh(c,b,B,N)  0xcb00+STD_BETA_GEQ,0x0012+(((c)*(B) + (b))*6),N
#define wroteGEQLevelCh(c,b,B)    0xcb00+STD_BETA_GEQ,0x0012+(((c)*(B) + (b))*6)
#define  readGEQWidthCh(c,b,B)    0xc300+STD_BETA_GEQ,0x0014+(((c)*(B) + (b))*6)
#define writeGEQWidthCh(c,b,B,N)  0xcb00+STD_BETA_GEQ,0x0014+(((c)*(B) + (b))*6),N
#define wroteGEQWidthCh(c,b,B)    0xcb00+STD_BETA_GEQ,0x0014+(((c)*(B) + (b))*6)
// -- End of "private" alpha commands --

// -- Uni-coef Generic Alpha Codes -- symbol-compatible with old GEQ[12]

#define  readGEQ1Freq            readGEQFreq(0)
#define writeGEQ1Freq(N)        writeGEQFreq(0,N)
#define wroteGEQ1Freq           wroteGEQFreq(0)
#define  readGEQ1Level           readGEQLevel(0)
#define writeGEQ1Level(N)       writeGEQLevel(0,N)
#define wroteGEQ1Level          wroteGEQLevel(0)
#define  readGEQ1Width           readGEQWidth(0)
#define writeGEQ1Width(N)       writeGEQWidth(0,N)
#define wroteGEQ1Width          wroteGEQWidth(0)

#define  readGEQ2Freq            readGEQFreq(1)
#define writeGEQ2Freq(N)        writeGEQFreq(1,N)
#define wroteGEQ2Freq           wroteGEQFreq(1)
#define  readGEQ2Level           readGEQLevel(1)
#define writeGEQ2Level(N)       writeGEQLevel(1,N)
#define wroteGEQ2Level          wroteGEQLevel(1)
#define  readGEQ2Width           readGEQWidth(1)
#define writeGEQ2Width(N)       writeGEQWidth(1,N)
#define wroteGEQ2Width          wroteGEQWidth(1)

#define  readGEQ3Freq            readGEQFreq(2)
#define writeGEQ3Freq(N)        writeGEQFreq(2,N)
#define wroteGEQ3Freq           wroteGEQFreq(2)
#define  readGEQ3Level           readGEQLevel(2)
#define writeGEQ3Level(N)       writeGEQLevel(2,N)
#define wroteGEQ3Level          wroteGEQLevel(2)
#define  readGEQ3Width           readGEQWidth(2)
#define writeGEQ3Width(N)       writeGEQWidth(2,N)
#define wroteGEQ3Width          wroteGEQWidth(2)

#define  readGEQ4Freq            readGEQFreq(3)
#define writeGEQ4Freq(N)        writeGEQFreq(3,N)
#define wroteGEQ4Freq           wroteGEQFreq(3)
#define  readGEQ4Level           readGEQLevel(3)
#define writeGEQ4Level(N)       writeGEQLevel(3,N)
#define wroteGEQ4Level          wroteGEQLevel(3)
#define  readGEQ4Width           readGEQWidth(3)
#define writeGEQ4Width(N)       writeGEQWidth(3,N)
#define wroteGEQ4Width          wroteGEQWidth(3)

#define  readGEQ5Freq            readGEQFreq(4)
#define writeGEQ5Freq(N)        writeGEQFreq(4,N)
#define wroteGEQ5Freq           wroteGEQFreq(4)
#define  readGEQ5Level           readGEQLevel(4)
#define writeGEQ5Level(N)       writeGEQLevel(4,N)
#define wroteGEQ5Level          wroteGEQLevel(4)
#define  readGEQ5Width           readGEQWidth(4)
#define writeGEQ5Width(N)       writeGEQWidth(4,N)
#define wroteGEQ5Width          wroteGEQWidth(4)

#define  readGEQ6Freq            readGEQFreq(5)
#define writeGEQ6Freq(N)        writeGEQFreq(5,N)
#define wroteGEQ6Freq           wroteGEQFreq(5)
#define  readGEQ6Level           readGEQLevel(5)
#define writeGEQ6Level(N)       writeGEQLevel(5,N)
#define wroteGEQ6Level          wroteGEQLevel(5)
#define  readGEQ6Width           readGEQWidth(5)
#define writeGEQ6Width(N)       writeGEQWidth(5,N)
#define wroteGEQ6Width          wroteGEQWidth(5)

#define  readGEQ7Freq            readGEQFreq(6)
#define writeGEQ7Freq(N)        writeGEQFreq(6,N)
#define wroteGEQ7Freq           wroteGEQFreq(6)
#define  readGEQ7Level           readGEQLevel(6)
#define writeGEQ7Level(N)       writeGEQLevel(6,N)
#define wroteGEQ7Level          wroteGEQLevel(6)
#define  readGEQ7Width           readGEQWidth(6)
#define writeGEQ7Width(N)       writeGEQWidth(6,N)
#define wroteGEQ7Width          wroteGEQWidth(6)

#define  readGEQ8Freq            readGEQFreq(7)
#define writeGEQ8Freq(N)        writeGEQFreq(7,N)
#define wroteGEQ8Freq           wroteGEQFreq(7)
#define  readGEQ8Level           readGEQLevel(7)
#define writeGEQ8Level(N)       writeGEQLevel(7,N)
#define wroteGEQ8Level          wroteGEQLevel(7)
#define  readGEQ8Width           readGEQWidth(7)
#define writeGEQ8Width(N)       writeGEQWidth(7,N)
#define wroteGEQ8Width          wroteGEQWidth(7)

#define  readGEQ9Freq            readGEQFreq(8)
#define writeGEQ9Freq(N)        writeGEQFreq(8,N)
#define wroteGEQ9Freq           wroteGEQFreq(8)
#define  readGEQ9Level           readGEQLevel(8)
#define writeGEQ9Level(N)       writeGEQLevel(8,N)
#define wroteGEQ9Level          wroteGEQLevel(8)
#define  readGEQ9Width           readGEQWidth(8)
#define writeGEQ9Width(N)       writeGEQWidth(8,N)
#define wroteGEQ9Width          wroteGEQWidth(8)

#define  readGEQ10Freq            readGEQFreq(9)
#define writeGEQ10Freq(N)        writeGEQFreq(9,N)
#define wroteGEQ10Freq           wroteGEQFreq(9)
#define  readGEQ10Level           readGEQLevel(9)
#define writeGEQ10Level(N)       writeGEQLevel(9,N)
#define wroteGEQ10Level          wroteGEQLevel(9)
#define  readGEQ10Width           readGEQWidth(9)
#define writeGEQ10Width(N)       writeGEQWidth(9,N)
#define wroteGEQ10Width          wroteGEQWidth(9)

// -- Multi-coef Generic Alpha Codes -- symbol-compatible with old GEQ3.  Fixed for GEQ_MAXNUMBANDS
#ifndef GEQ_MAXNUMBANDS
#   define GEQ_MAXNUMBANDS  (10)
#endif


#define  readGEQLeft1Freq        readGEQFreqCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQLeft1Freq(N)    writeGEQFreqCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft1Freq       wroteGEQFreqCh(0, 0, GEQ_MAXNUMBANDS)
#define  readGEQLeft1Level       readGEQLevelCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQLeft1Level(N)   writeGEQLevelCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft1Level      wroteGEQLevelCh(0, 0, GEQ_MAXNUMBANDS)
#define  readGEQLeft1Width       readGEQWidthCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQLeft1Width(N)   writeGEQWidthCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft1Width      wroteGEQWidthCh(0, 0, GEQ_MAXNUMBANDS)

#define  readGEQLeft2Freq        readGEQFreqCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQLeft2Freq(N)    writeGEQFreqCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft2Freq       wroteGEQFreqCh(0, 1, GEQ_MAXNUMBANDS)
#define  readGEQLeft2Level       readGEQLevelCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQLeft2Level(N)   writeGEQLevelCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft2Level      wroteGEQLevelCh(0, 1, GEQ_MAXNUMBANDS)
#define  readGEQLeft2Width       readGEQWidthCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQLeft2Width(N)   writeGEQWidthCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft2Width      wroteGEQWidthCh(0, 1, GEQ_MAXNUMBANDS)

#define  readGEQLeft3Freq        readGEQFreqCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQLeft3Freq(N)    writeGEQFreqCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft3Freq       wroteGEQFreqCh(0, 2, GEQ_MAXNUMBANDS)
#define  readGEQLeft3Level       readGEQLevelCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQLeft3Level(N)   writeGEQLevelCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft3Level      wroteGEQLevelCh(0, 2, GEQ_MAXNUMBANDS)
#define  readGEQLeft3Width       readGEQWidthCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQLeft3Width(N)   writeGEQWidthCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft3Width      wroteGEQWidthCh(0, 2, GEQ_MAXNUMBANDS)

#define  readGEQLeft4Freq        readGEQFreqCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQLeft4Freq(N)    writeGEQFreqCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft4Freq       wroteGEQFreqCh(0, 3, GEQ_MAXNUMBANDS)
#define  readGEQLeft4Level       readGEQLevelCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQLeft4Level(N)   writeGEQLevelCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft4Level      wroteGEQLevelCh(0, 3, GEQ_MAXNUMBANDS)
#define  readGEQLeft4Width       readGEQWidthCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQLeft4Width(N)   writeGEQWidthCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft4Width      wroteGEQWidthCh(0, 3, GEQ_MAXNUMBANDS)

#define  readGEQLeft5Freq        readGEQFreqCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQLeft5Freq(N)    writeGEQFreqCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft5Freq       wroteGEQFreqCh(0, 4, GEQ_MAXNUMBANDS)
#define  readGEQLeft5Level       readGEQLevelCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQLeft5Level(N)   writeGEQLevelCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft5Level      wroteGEQLevelCh(0, 4, GEQ_MAXNUMBANDS)
#define  readGEQLeft5Width       readGEQWidthCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQLeft5Width(N)   writeGEQWidthCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft5Width      wroteGEQWidthCh(0, 4, GEQ_MAXNUMBANDS)

#define  readGEQLeft6Freq        readGEQFreqCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQLeft6Freq(N)    writeGEQFreqCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft6Freq       wroteGEQFreqCh(0, 5, GEQ_MAXNUMBANDS)
#define  readGEQLeft6Level       readGEQLevelCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQLeft6Level(N)   writeGEQLevelCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft6Level      wroteGEQLevelCh(0, 5, GEQ_MAXNUMBANDS)
#define  readGEQLeft6Width       readGEQWidthCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQLeft6Width(N)   writeGEQWidthCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft6Width      wroteGEQWidthCh(0, 5, GEQ_MAXNUMBANDS)

#define  readGEQLeft7Freq        readGEQFreqCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQLeft7Freq(N)    writeGEQFreqCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft7Freq       wroteGEQFreqCh(0, 6, GEQ_MAXNUMBANDS)
#define  readGEQLeft7Level       readGEQLevelCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQLeft7Level(N)   writeGEQLevelCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft7Level      wroteGEQLevelCh(0, 6, GEQ_MAXNUMBANDS)
#define  readGEQLeft7Width       readGEQWidthCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQLeft7Width(N)   writeGEQWidthCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft7Width      wroteGEQWidthCh(0, 6, GEQ_MAXNUMBANDS)

#define  readGEQLeft8Freq        readGEQFreqCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQLeft8Freq(N)    writeGEQFreqCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft8Freq       wroteGEQFreqCh(0, 7, GEQ_MAXNUMBANDS)
#define  readGEQLeft8Level       readGEQLevelCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQLeft8Level(N)   writeGEQLevelCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft8Level      wroteGEQLevelCh(0, 7, GEQ_MAXNUMBANDS)
#define  readGEQLeft8Width       readGEQWidthCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQLeft8Width(N)   writeGEQWidthCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft8Width      wroteGEQWidthCh(0, 7, GEQ_MAXNUMBANDS)

#define  readGEQLeft9Freq        readGEQFreqCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQLeft9Freq(N)    writeGEQFreqCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft9Freq       wroteGEQFreqCh(0, 8, GEQ_MAXNUMBANDS)
#define  readGEQLeft9Level       readGEQLevelCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQLeft9Level(N)   writeGEQLevelCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft9Level      wroteGEQLevelCh(0, 8, GEQ_MAXNUMBANDS)
#define  readGEQLeft9Width       readGEQWidthCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQLeft9Width(N)   writeGEQWidthCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft9Width      wroteGEQWidthCh(0, 8, GEQ_MAXNUMBANDS)

#define  readGEQLeft10Freq        readGEQFreqCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQLeft10Freq(N)    writeGEQFreqCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft10Freq       wroteGEQFreqCh(0, 9, GEQ_MAXNUMBANDS)
#define  readGEQLeft10Level       readGEQLevelCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQLeft10Level(N)   writeGEQLevelCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft10Level      wroteGEQLevelCh(0, 9, GEQ_MAXNUMBANDS)
#define  readGEQLeft10Width       readGEQWidthCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQLeft10Width(N)   writeGEQWidthCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft10Width      wroteGEQWidthCh(0, 9, GEQ_MAXNUMBANDS)

#define  readGEQLeft11Freq        readGEQFreqCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQLeft11Freq(N)    writeGEQFreqCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft11Freq       wroteGEQFreqCh(0, 10, GEQ_MAXNUMBANDS)
#define  readGEQLeft11Level       readGEQLevelCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQLeft11Level(N)   writeGEQLevelCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft11Level      wroteGEQLevelCh(0, 10, GEQ_MAXNUMBANDS)
#define  readGEQLeft11Width       readGEQWidthCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQLeft11Width(N)   writeGEQWidthCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft11Width      wroteGEQWidthCh(0, 10, GEQ_MAXNUMBANDS)

#define  readGEQLeft12Freq        readGEQFreqCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQLeft12Freq(N)    writeGEQFreqCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft12Freq       wroteGEQFreqCh(0, 11, GEQ_MAXNUMBANDS)
#define  readGEQLeft12Level       readGEQLevelCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQLeft12Level(N)   writeGEQLevelCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft12Level      wroteGEQLevelCh(0, 11, GEQ_MAXNUMBANDS)
#define  readGEQLeft12Width       readGEQWidthCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQLeft12Width(N)   writeGEQWidthCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft12Width      wroteGEQWidthCh(0, 11, GEQ_MAXNUMBANDS)

#define  readGEQLeft13Freq        readGEQFreqCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQLeft13Freq(N)    writeGEQFreqCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft13Freq       wroteGEQFreqCh(0, 12, GEQ_MAXNUMBANDS)
#define  readGEQLeft13Level       readGEQLevelCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQLeft13Level(N)   writeGEQLevelCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft13Level      wroteGEQLevelCh(0, 12, GEQ_MAXNUMBANDS)
#define  readGEQLeft13Width       readGEQWidthCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQLeft13Width(N)   writeGEQWidthCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft13Width      wroteGEQWidthCh(0, 12, GEQ_MAXNUMBANDS)

#define  readGEQLeft14Freq        readGEQFreqCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQLeft14Freq(N)    writeGEQFreqCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft14Freq       wroteGEQFreqCh(0, 13, GEQ_MAXNUMBANDS)
#define  readGEQLeft14Level       readGEQLevelCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQLeft14Level(N)   writeGEQLevelCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft14Level      wroteGEQLevelCh(0, 13, GEQ_MAXNUMBANDS)
#define  readGEQLeft14Width       readGEQWidthCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQLeft14Width(N)   writeGEQWidthCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft14Width      wroteGEQWidthCh(0, 13, GEQ_MAXNUMBANDS)

#define  readGEQLeft15Freq        readGEQFreqCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQLeft15Freq(N)    writeGEQFreqCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft15Freq       wroteGEQFreqCh(0, 14, GEQ_MAXNUMBANDS)
#define  readGEQLeft15Level       readGEQLevelCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQLeft15Level(N)   writeGEQLevelCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft15Level      wroteGEQLevelCh(0, 14, GEQ_MAXNUMBANDS)
#define  readGEQLeft15Width       readGEQWidthCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQLeft15Width(N)   writeGEQWidthCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft15Width      wroteGEQWidthCh(0, 14, GEQ_MAXNUMBANDS)

#define  readGEQLeft16Freq        readGEQFreqCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQLeft16Freq(N)    writeGEQFreqCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft16Freq       wroteGEQFreqCh(0, 15, GEQ_MAXNUMBANDS)
#define  readGEQLeft16Level       readGEQLevelCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQLeft16Level(N)   writeGEQLevelCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft16Level      wroteGEQLevelCh(0, 15, GEQ_MAXNUMBANDS)
#define  readGEQLeft16Width       readGEQWidthCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQLeft16Width(N)   writeGEQWidthCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft16Width      wroteGEQWidthCh(0, 15, GEQ_MAXNUMBANDS)

#define  readGEQLeft17Freq        readGEQFreqCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQLeft17Freq(N)    writeGEQFreqCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft17Freq       wroteGEQFreqCh(0, 16, GEQ_MAXNUMBANDS)
#define  readGEQLeft17Level       readGEQLevelCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQLeft17Level(N)   writeGEQLevelCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft17Level      wroteGEQLevelCh(0, 16, GEQ_MAXNUMBANDS)
#define  readGEQLeft17Width       readGEQWidthCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQLeft17Width(N)   writeGEQWidthCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft17Width      wroteGEQWidthCh(0, 16, GEQ_MAXNUMBANDS)

#define  readGEQLeft18Freq        readGEQFreqCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQLeft18Freq(N)    writeGEQFreqCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft18Freq       wroteGEQFreqCh(0, 17, GEQ_MAXNUMBANDS)
#define  readGEQLeft18Level       readGEQLevelCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQLeft18Level(N)   writeGEQLevelCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft18Level      wroteGEQLevelCh(0, 17, GEQ_MAXNUMBANDS)
#define  readGEQLeft18Width       readGEQWidthCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQLeft18Width(N)   writeGEQWidthCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft18Width      wroteGEQWidthCh(0, 17, GEQ_MAXNUMBANDS)

#define  readGEQLeft19Freq        readGEQFreqCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQLeft19Freq(N)    writeGEQFreqCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft19Freq       wroteGEQFreqCh(0, 18, GEQ_MAXNUMBANDS)
#define  readGEQLeft19Level       readGEQLevelCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQLeft19Level(N)   writeGEQLevelCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft19Level      wroteGEQLevelCh(0, 18, GEQ_MAXNUMBANDS)
#define  readGEQLeft19Width       readGEQWidthCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQLeft19Width(N)   writeGEQWidthCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft19Width      wroteGEQWidthCh(0, 18, GEQ_MAXNUMBANDS)

#define  readGEQLeft20Freq        readGEQFreqCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQLeft20Freq(N)    writeGEQFreqCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft20Freq       wroteGEQFreqCh(0, 19, GEQ_MAXNUMBANDS)
#define  readGEQLeft20Level       readGEQLevelCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQLeft20Level(N)   writeGEQLevelCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft20Level      wroteGEQLevelCh(0, 19, GEQ_MAXNUMBANDS)
#define  readGEQLeft20Width       readGEQWidthCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQLeft20Width(N)   writeGEQWidthCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft20Width      wroteGEQWidthCh(0, 19, GEQ_MAXNUMBANDS)

#define  readGEQLeft21Freq        readGEQFreqCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQLeft21Freq(N)    writeGEQFreqCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft21Freq       wroteGEQFreqCh(0, 20, GEQ_MAXNUMBANDS)
#define  readGEQLeft21Level       readGEQLevelCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQLeft21Level(N)   writeGEQLevelCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft21Level      wroteGEQLevelCh(0, 20, GEQ_MAXNUMBANDS)
#define  readGEQLeft21Width       readGEQWidthCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQLeft21Width(N)   writeGEQWidthCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft21Width      wroteGEQWidthCh(0, 20, GEQ_MAXNUMBANDS)

#define  readGEQLeft22Freq        readGEQFreqCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQLeft22Freq(N)    writeGEQFreqCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft22Freq       wroteGEQFreqCh(0, 21, GEQ_MAXNUMBANDS)
#define  readGEQLeft22Level       readGEQLevelCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQLeft22Level(N)   writeGEQLevelCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft22Level      wroteGEQLevelCh(0, 21, GEQ_MAXNUMBANDS)
#define  readGEQLeft22Width       readGEQWidthCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQLeft22Width(N)   writeGEQWidthCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft22Width      wroteGEQWidthCh(0, 21, GEQ_MAXNUMBANDS)

#define  readGEQLeft23Freq        readGEQFreqCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQLeft23Freq(N)    writeGEQFreqCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft23Freq       wroteGEQFreqCh(0, 22, GEQ_MAXNUMBANDS)
#define  readGEQLeft23Level       readGEQLevelCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQLeft23Level(N)   writeGEQLevelCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft23Level      wroteGEQLevelCh(0, 22, GEQ_MAXNUMBANDS)
#define  readGEQLeft23Width       readGEQWidthCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQLeft23Width(N)   writeGEQWidthCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft23Width      wroteGEQWidthCh(0, 22, GEQ_MAXNUMBANDS)

#define  readGEQLeft24Freq        readGEQFreqCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQLeft24Freq(N)    writeGEQFreqCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft24Freq       wroteGEQFreqCh(0, 23, GEQ_MAXNUMBANDS)
#define  readGEQLeft24Level       readGEQLevelCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQLeft24Level(N)   writeGEQLevelCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft24Level      wroteGEQLevelCh(0, 23, GEQ_MAXNUMBANDS)
#define  readGEQLeft24Width       readGEQWidthCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQLeft24Width(N)   writeGEQWidthCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft24Width      wroteGEQWidthCh(0, 23, GEQ_MAXNUMBANDS)

#define  readGEQLeft25Freq        readGEQFreqCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQLeft25Freq(N)    writeGEQFreqCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft25Freq       wroteGEQFreqCh(0, 24, GEQ_MAXNUMBANDS)
#define  readGEQLeft25Level       readGEQLevelCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQLeft25Level(N)   writeGEQLevelCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft25Level      wroteGEQLevelCh(0, 24, GEQ_MAXNUMBANDS)
#define  readGEQLeft25Width       readGEQWidthCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQLeft25Width(N)   writeGEQWidthCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft25Width      wroteGEQWidthCh(0, 24, GEQ_MAXNUMBANDS)

#define  readGEQLeft26Freq        readGEQFreqCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQLeft26Freq(N)    writeGEQFreqCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft26Freq       wroteGEQFreqCh(0, 25, GEQ_MAXNUMBANDS)
#define  readGEQLeft26Level       readGEQLevelCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQLeft26Level(N)   writeGEQLevelCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft26Level      wroteGEQLevelCh(0, 25, GEQ_MAXNUMBANDS)
#define  readGEQLeft26Width       readGEQWidthCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQLeft26Width(N)   writeGEQWidthCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft26Width      wroteGEQWidthCh(0, 25, GEQ_MAXNUMBANDS)

#define  readGEQLeft27Freq        readGEQFreqCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQLeft27Freq(N)    writeGEQFreqCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft27Freq       wroteGEQFreqCh(0, 26, GEQ_MAXNUMBANDS)
#define  readGEQLeft27Level       readGEQLevelCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQLeft27Level(N)   writeGEQLevelCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft27Level      wroteGEQLevelCh(0, 26, GEQ_MAXNUMBANDS)
#define  readGEQLeft27Width       readGEQWidthCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQLeft27Width(N)   writeGEQWidthCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft27Width      wroteGEQWidthCh(0, 26, GEQ_MAXNUMBANDS)

#define  readGEQLeft28Freq        readGEQFreqCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQLeft28Freq(N)    writeGEQFreqCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft28Freq       wroteGEQFreqCh(0, 27, GEQ_MAXNUMBANDS)
#define  readGEQLeft28Level       readGEQLevelCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQLeft28Level(N)   writeGEQLevelCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft28Level      wroteGEQLevelCh(0, 27, GEQ_MAXNUMBANDS)
#define  readGEQLeft28Width       readGEQWidthCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQLeft28Width(N)   writeGEQWidthCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft28Width      wroteGEQWidthCh(0, 27, GEQ_MAXNUMBANDS)

#define  readGEQLeft29Freq        readGEQFreqCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQLeft29Freq(N)    writeGEQFreqCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft29Freq       wroteGEQFreqCh(0, 28, GEQ_MAXNUMBANDS)
#define  readGEQLeft29Level       readGEQLevelCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQLeft29Level(N)   writeGEQLevelCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft29Level      wroteGEQLevelCh(0, 28, GEQ_MAXNUMBANDS)
#define  readGEQLeft29Width       readGEQWidthCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQLeft29Width(N)   writeGEQWidthCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft29Width      wroteGEQWidthCh(0, 28, GEQ_MAXNUMBANDS)

#define  readGEQLeft30Freq        readGEQFreqCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQLeft30Freq(N)    writeGEQFreqCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft30Freq       wroteGEQFreqCh(0, 29, GEQ_MAXNUMBANDS)
#define  readGEQLeft30Level       readGEQLevelCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQLeft30Level(N)   writeGEQLevelCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft30Level      wroteGEQLevelCh(0, 29, GEQ_MAXNUMBANDS)
#define  readGEQLeft30Width       readGEQWidthCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQLeft30Width(N)   writeGEQWidthCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft30Width      wroteGEQWidthCh(0, 29, GEQ_MAXNUMBANDS)

#define  readGEQLeft31Freq        readGEQFreqCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQLeft31Freq(N)    writeGEQFreqCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft31Freq       wroteGEQFreqCh(0, 30, GEQ_MAXNUMBANDS)
#define  readGEQLeft31Level       readGEQLevelCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQLeft31Level(N)   writeGEQLevelCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft31Level      wroteGEQLevelCh(0, 30, GEQ_MAXNUMBANDS)
#define  readGEQLeft31Width       readGEQWidthCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQLeft31Width(N)   writeGEQWidthCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft31Width      wroteGEQWidthCh(0, 30, GEQ_MAXNUMBANDS)

#define  readGEQLeft32Freq        readGEQFreqCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQLeft32Freq(N)    writeGEQFreqCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft32Freq       wroteGEQFreqCh(0, 31, GEQ_MAXNUMBANDS)
#define  readGEQLeft32Level       readGEQLevelCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQLeft32Level(N)   writeGEQLevelCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft32Level      wroteGEQLevelCh(0, 31, GEQ_MAXNUMBANDS)
#define  readGEQLeft32Width       readGEQWidthCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQLeft32Width(N)   writeGEQWidthCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLeft32Width      wroteGEQWidthCh(0, 31, GEQ_MAXNUMBANDS)

#define  readGEQRght1Freq        readGEQFreqCh(1, 0, GEQ_MAXNUMBANDS)
#define writeGEQRght1Freq(N)    writeGEQFreqCh(1, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght1Freq       wroteGEQFreqCh(1, 0, GEQ_MAXNUMBANDS)
#define  readGEQRght1Level       readGEQLevelCh(1, 0, GEQ_MAXNUMBANDS)
#define writeGEQRght1Level(N)   writeGEQLevelCh(1, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght1Level      wroteGEQLevelCh(1, 0, GEQ_MAXNUMBANDS)
#define  readGEQRght1Width       readGEQWidthCh(1, 0, GEQ_MAXNUMBANDS)
#define writeGEQRght1Width(N)   writeGEQWidthCh(1, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght1Width      wroteGEQWidthCh(1, 0, GEQ_MAXNUMBANDS)

#define  readGEQRght2Freq        readGEQFreqCh(1, 1, GEQ_MAXNUMBANDS)
#define writeGEQRght2Freq(N)    writeGEQFreqCh(1, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght2Freq       wroteGEQFreqCh(1, 1, GEQ_MAXNUMBANDS)
#define  readGEQRght2Level       readGEQLevelCh(1, 1, GEQ_MAXNUMBANDS)
#define writeGEQRght2Level(N)   writeGEQLevelCh(1, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght2Level      wroteGEQLevelCh(1, 1, GEQ_MAXNUMBANDS)
#define  readGEQRght2Width       readGEQWidthCh(1, 1, GEQ_MAXNUMBANDS)
#define writeGEQRght2Width(N)   writeGEQWidthCh(1, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght2Width      wroteGEQWidthCh(1, 1, GEQ_MAXNUMBANDS)

#define  readGEQRght3Freq        readGEQFreqCh(1, 2, GEQ_MAXNUMBANDS)
#define writeGEQRght3Freq(N)    writeGEQFreqCh(1, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght3Freq       wroteGEQFreqCh(1, 2, GEQ_MAXNUMBANDS)
#define  readGEQRght3Level       readGEQLevelCh(1, 2, GEQ_MAXNUMBANDS)
#define writeGEQRght3Level(N)   writeGEQLevelCh(1, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght3Level      wroteGEQLevelCh(1, 2, GEQ_MAXNUMBANDS)
#define  readGEQRght3Width       readGEQWidthCh(1, 2, GEQ_MAXNUMBANDS)
#define writeGEQRght3Width(N)   writeGEQWidthCh(1, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght3Width      wroteGEQWidthCh(1, 2, GEQ_MAXNUMBANDS)

#define  readGEQRght4Freq        readGEQFreqCh(1, 3, GEQ_MAXNUMBANDS)
#define writeGEQRght4Freq(N)    writeGEQFreqCh(1, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght4Freq       wroteGEQFreqCh(1, 3, GEQ_MAXNUMBANDS)
#define  readGEQRght4Level       readGEQLevelCh(1, 3, GEQ_MAXNUMBANDS)
#define writeGEQRght4Level(N)   writeGEQLevelCh(1, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght4Level      wroteGEQLevelCh(1, 3, GEQ_MAXNUMBANDS)
#define  readGEQRght4Width       readGEQWidthCh(1, 3, GEQ_MAXNUMBANDS)
#define writeGEQRght4Width(N)   writeGEQWidthCh(1, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght4Width      wroteGEQWidthCh(1, 3, GEQ_MAXNUMBANDS)

#define  readGEQRght5Freq        readGEQFreqCh(1, 4, GEQ_MAXNUMBANDS)
#define writeGEQRght5Freq(N)    writeGEQFreqCh(1, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght5Freq       wroteGEQFreqCh(1, 4, GEQ_MAXNUMBANDS)
#define  readGEQRght5Level       readGEQLevelCh(1, 4, GEQ_MAXNUMBANDS)
#define writeGEQRght5Level(N)   writeGEQLevelCh(1, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght5Level      wroteGEQLevelCh(1, 4, GEQ_MAXNUMBANDS)
#define  readGEQRght5Width       readGEQWidthCh(1, 4, GEQ_MAXNUMBANDS)
#define writeGEQRght5Width(N)   writeGEQWidthCh(1, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght5Width      wroteGEQWidthCh(1, 4, GEQ_MAXNUMBANDS)

#define  readGEQRght6Freq        readGEQFreqCh(1, 5, GEQ_MAXNUMBANDS)
#define writeGEQRght6Freq(N)    writeGEQFreqCh(1, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght6Freq       wroteGEQFreqCh(1, 5, GEQ_MAXNUMBANDS)
#define  readGEQRght6Level       readGEQLevelCh(1, 5, GEQ_MAXNUMBANDS)
#define writeGEQRght6Level(N)   writeGEQLevelCh(1, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght6Level      wroteGEQLevelCh(1, 5, GEQ_MAXNUMBANDS)
#define  readGEQRght6Width       readGEQWidthCh(1, 5, GEQ_MAXNUMBANDS)
#define writeGEQRght6Width(N)   writeGEQWidthCh(1, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght6Width      wroteGEQWidthCh(1, 5, GEQ_MAXNUMBANDS)

#define  readGEQRght7Freq        readGEQFreqCh(1, 6, GEQ_MAXNUMBANDS)
#define writeGEQRght7Freq(N)    writeGEQFreqCh(1, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght7Freq       wroteGEQFreqCh(1, 6, GEQ_MAXNUMBANDS)
#define  readGEQRght7Level       readGEQLevelCh(1, 6, GEQ_MAXNUMBANDS)
#define writeGEQRght7Level(N)   writeGEQLevelCh(1, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght7Level      wroteGEQLevelCh(1, 6, GEQ_MAXNUMBANDS)
#define  readGEQRght7Width       readGEQWidthCh(1, 6, GEQ_MAXNUMBANDS)
#define writeGEQRght7Width(N)   writeGEQWidthCh(1, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght7Width      wroteGEQWidthCh(1, 6, GEQ_MAXNUMBANDS)

#define  readGEQRght8Freq        readGEQFreqCh(1, 7, GEQ_MAXNUMBANDS)
#define writeGEQRght8Freq(N)    writeGEQFreqCh(1, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght8Freq       wroteGEQFreqCh(1, 7, GEQ_MAXNUMBANDS)
#define  readGEQRght8Level       readGEQLevelCh(1, 7, GEQ_MAXNUMBANDS)
#define writeGEQRght8Level(N)   writeGEQLevelCh(1, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght8Level      wroteGEQLevelCh(1, 7, GEQ_MAXNUMBANDS)
#define  readGEQRght8Width       readGEQWidthCh(1, 7, GEQ_MAXNUMBANDS)
#define writeGEQRght8Width(N)   writeGEQWidthCh(1, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght8Width      wroteGEQWidthCh(1, 7, GEQ_MAXNUMBANDS)

#define  readGEQRght9Freq        readGEQFreqCh(1, 8, GEQ_MAXNUMBANDS)
#define writeGEQRght9Freq(N)    writeGEQFreqCh(1, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght9Freq       wroteGEQFreqCh(1, 8, GEQ_MAXNUMBANDS)
#define  readGEQRght9Level       readGEQLevelCh(1, 8, GEQ_MAXNUMBANDS)
#define writeGEQRght9Level(N)   writeGEQLevelCh(1, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght9Level      wroteGEQLevelCh(1, 8, GEQ_MAXNUMBANDS)
#define  readGEQRght9Width       readGEQWidthCh(1, 8, GEQ_MAXNUMBANDS)
#define writeGEQRght9Width(N)   writeGEQWidthCh(1, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght9Width      wroteGEQWidthCh(1, 8, GEQ_MAXNUMBANDS)

#define  readGEQRght10Freq        readGEQFreqCh(1, 9, GEQ_MAXNUMBANDS)
#define writeGEQRght10Freq(N)    writeGEQFreqCh(1, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght10Freq       wroteGEQFreqCh(1, 9, GEQ_MAXNUMBANDS)
#define  readGEQRght10Level       readGEQLevelCh(1, 9, GEQ_MAXNUMBANDS)
#define writeGEQRght10Level(N)   writeGEQLevelCh(1, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght10Level      wroteGEQLevelCh(1, 9, GEQ_MAXNUMBANDS)
#define  readGEQRght10Width       readGEQWidthCh(1, 9, GEQ_MAXNUMBANDS)
#define writeGEQRght10Width(N)   writeGEQWidthCh(1, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght10Width      wroteGEQWidthCh(1, 9, GEQ_MAXNUMBANDS)

#define  readGEQRght11Freq        readGEQFreqCh(1, 10, GEQ_MAXNUMBANDS)
#define writeGEQRght11Freq(N)    writeGEQFreqCh(1, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght11Freq       wroteGEQFreqCh(1, 10, GEQ_MAXNUMBANDS)
#define  readGEQRght11Level       readGEQLevelCh(1, 10, GEQ_MAXNUMBANDS)
#define writeGEQRght11Level(N)   writeGEQLevelCh(1, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght11Level      wroteGEQLevelCh(1, 10, GEQ_MAXNUMBANDS)
#define  readGEQRght11Width       readGEQWidthCh(1, 10, GEQ_MAXNUMBANDS)
#define writeGEQRght11Width(N)   writeGEQWidthCh(1, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght11Width      wroteGEQWidthCh(1, 10, GEQ_MAXNUMBANDS)

#define  readGEQRght12Freq        readGEQFreqCh(1, 11, GEQ_MAXNUMBANDS)
#define writeGEQRght12Freq(N)    writeGEQFreqCh(1, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght12Freq       wroteGEQFreqCh(1, 11, GEQ_MAXNUMBANDS)
#define  readGEQRght12Level       readGEQLevelCh(1, 11, GEQ_MAXNUMBANDS)
#define writeGEQRght12Level(N)   writeGEQLevelCh(1, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght12Level      wroteGEQLevelCh(1, 11, GEQ_MAXNUMBANDS)
#define  readGEQRght12Width       readGEQWidthCh(1, 11, GEQ_MAXNUMBANDS)
#define writeGEQRght12Width(N)   writeGEQWidthCh(1, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght12Width      wroteGEQWidthCh(1, 11, GEQ_MAXNUMBANDS)

#define  readGEQRght13Freq        readGEQFreqCh(1, 12, GEQ_MAXNUMBANDS)
#define writeGEQRght13Freq(N)    writeGEQFreqCh(1, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght13Freq       wroteGEQFreqCh(1, 12, GEQ_MAXNUMBANDS)
#define  readGEQRght13Level       readGEQLevelCh(1, 12, GEQ_MAXNUMBANDS)
#define writeGEQRght13Level(N)   writeGEQLevelCh(1, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght13Level      wroteGEQLevelCh(1, 12, GEQ_MAXNUMBANDS)
#define  readGEQRght13Width       readGEQWidthCh(1, 12, GEQ_MAXNUMBANDS)
#define writeGEQRght13Width(N)   writeGEQWidthCh(1, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght13Width      wroteGEQWidthCh(1, 12, GEQ_MAXNUMBANDS)

#define  readGEQRght14Freq        readGEQFreqCh(1, 13, GEQ_MAXNUMBANDS)
#define writeGEQRght14Freq(N)    writeGEQFreqCh(1, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght14Freq       wroteGEQFreqCh(1, 13, GEQ_MAXNUMBANDS)
#define  readGEQRght14Level       readGEQLevelCh(1, 13, GEQ_MAXNUMBANDS)
#define writeGEQRght14Level(N)   writeGEQLevelCh(1, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght14Level      wroteGEQLevelCh(1, 13, GEQ_MAXNUMBANDS)
#define  readGEQRght14Width       readGEQWidthCh(1, 13, GEQ_MAXNUMBANDS)
#define writeGEQRght14Width(N)   writeGEQWidthCh(1, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght14Width      wroteGEQWidthCh(1, 13, GEQ_MAXNUMBANDS)

#define  readGEQRght15Freq        readGEQFreqCh(1, 14, GEQ_MAXNUMBANDS)
#define writeGEQRght15Freq(N)    writeGEQFreqCh(1, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght15Freq       wroteGEQFreqCh(1, 14, GEQ_MAXNUMBANDS)
#define  readGEQRght15Level       readGEQLevelCh(1, 14, GEQ_MAXNUMBANDS)
#define writeGEQRght15Level(N)   writeGEQLevelCh(1, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght15Level      wroteGEQLevelCh(1, 14, GEQ_MAXNUMBANDS)
#define  readGEQRght15Width       readGEQWidthCh(1, 14, GEQ_MAXNUMBANDS)
#define writeGEQRght15Width(N)   writeGEQWidthCh(1, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght15Width      wroteGEQWidthCh(1, 14, GEQ_MAXNUMBANDS)

#define  readGEQRght16Freq        readGEQFreqCh(1, 15, GEQ_MAXNUMBANDS)
#define writeGEQRght16Freq(N)    writeGEQFreqCh(1, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght16Freq       wroteGEQFreqCh(1, 15, GEQ_MAXNUMBANDS)
#define  readGEQRght16Level       readGEQLevelCh(1, 15, GEQ_MAXNUMBANDS)
#define writeGEQRght16Level(N)   writeGEQLevelCh(1, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght16Level      wroteGEQLevelCh(1, 15, GEQ_MAXNUMBANDS)
#define  readGEQRght16Width       readGEQWidthCh(1, 15, GEQ_MAXNUMBANDS)
#define writeGEQRght16Width(N)   writeGEQWidthCh(1, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght16Width      wroteGEQWidthCh(1, 15, GEQ_MAXNUMBANDS)

#define  readGEQRght17Freq        readGEQFreqCh(1, 16, GEQ_MAXNUMBANDS)
#define writeGEQRght17Freq(N)    writeGEQFreqCh(1, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght17Freq       wroteGEQFreqCh(1, 16, GEQ_MAXNUMBANDS)
#define  readGEQRght17Level       readGEQLevelCh(1, 16, GEQ_MAXNUMBANDS)
#define writeGEQRght17Level(N)   writeGEQLevelCh(1, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght17Level      wroteGEQLevelCh(1, 16, GEQ_MAXNUMBANDS)
#define  readGEQRght17Width       readGEQWidthCh(1, 16, GEQ_MAXNUMBANDS)
#define writeGEQRght17Width(N)   writeGEQWidthCh(1, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght17Width      wroteGEQWidthCh(1, 16, GEQ_MAXNUMBANDS)

#define  readGEQRght18Freq        readGEQFreqCh(1, 17, GEQ_MAXNUMBANDS)
#define writeGEQRght18Freq(N)    writeGEQFreqCh(1, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght18Freq       wroteGEQFreqCh(1, 17, GEQ_MAXNUMBANDS)
#define  readGEQRght18Level       readGEQLevelCh(1, 17, GEQ_MAXNUMBANDS)
#define writeGEQRght18Level(N)   writeGEQLevelCh(1, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght18Level      wroteGEQLevelCh(1, 17, GEQ_MAXNUMBANDS)
#define  readGEQRght18Width       readGEQWidthCh(1, 17, GEQ_MAXNUMBANDS)
#define writeGEQRght18Width(N)   writeGEQWidthCh(1, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght18Width      wroteGEQWidthCh(1, 17, GEQ_MAXNUMBANDS)

#define  readGEQRght19Freq        readGEQFreqCh(1, 18, GEQ_MAXNUMBANDS)
#define writeGEQRght19Freq(N)    writeGEQFreqCh(1, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght19Freq       wroteGEQFreqCh(1, 18, GEQ_MAXNUMBANDS)
#define  readGEQRght19Level       readGEQLevelCh(1, 18, GEQ_MAXNUMBANDS)
#define writeGEQRght19Level(N)   writeGEQLevelCh(1, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght19Level      wroteGEQLevelCh(1, 18, GEQ_MAXNUMBANDS)
#define  readGEQRght19Width       readGEQWidthCh(1, 18, GEQ_MAXNUMBANDS)
#define writeGEQRght19Width(N)   writeGEQWidthCh(1, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght19Width      wroteGEQWidthCh(1, 18, GEQ_MAXNUMBANDS)

#define  readGEQRght20Freq        readGEQFreqCh(1, 19, GEQ_MAXNUMBANDS)
#define writeGEQRght20Freq(N)    writeGEQFreqCh(1, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght20Freq       wroteGEQFreqCh(1, 19, GEQ_MAXNUMBANDS)
#define  readGEQRght20Level       readGEQLevelCh(1, 19, GEQ_MAXNUMBANDS)
#define writeGEQRght20Level(N)   writeGEQLevelCh(1, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght20Level      wroteGEQLevelCh(1, 19, GEQ_MAXNUMBANDS)
#define  readGEQRght20Width       readGEQWidthCh(1, 19, GEQ_MAXNUMBANDS)
#define writeGEQRght20Width(N)   writeGEQWidthCh(1, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght20Width      wroteGEQWidthCh(1, 19, GEQ_MAXNUMBANDS)

#define  readGEQRght21Freq        readGEQFreqCh(1, 20, GEQ_MAXNUMBANDS)
#define writeGEQRght21Freq(N)    writeGEQFreqCh(1, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght21Freq       wroteGEQFreqCh(1, 20, GEQ_MAXNUMBANDS)
#define  readGEQRght21Level       readGEQLevelCh(1, 20, GEQ_MAXNUMBANDS)
#define writeGEQRght21Level(N)   writeGEQLevelCh(1, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght21Level      wroteGEQLevelCh(1, 20, GEQ_MAXNUMBANDS)
#define  readGEQRght21Width       readGEQWidthCh(1, 20, GEQ_MAXNUMBANDS)
#define writeGEQRght21Width(N)   writeGEQWidthCh(1, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght21Width      wroteGEQWidthCh(1, 20, GEQ_MAXNUMBANDS)

#define  readGEQRght22Freq        readGEQFreqCh(1, 21, GEQ_MAXNUMBANDS)
#define writeGEQRght22Freq(N)    writeGEQFreqCh(1, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght22Freq       wroteGEQFreqCh(1, 21, GEQ_MAXNUMBANDS)
#define  readGEQRght22Level       readGEQLevelCh(1, 21, GEQ_MAXNUMBANDS)
#define writeGEQRght22Level(N)   writeGEQLevelCh(1, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght22Level      wroteGEQLevelCh(1, 21, GEQ_MAXNUMBANDS)
#define  readGEQRght22Width       readGEQWidthCh(1, 21, GEQ_MAXNUMBANDS)
#define writeGEQRght22Width(N)   writeGEQWidthCh(1, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght22Width      wroteGEQWidthCh(1, 21, GEQ_MAXNUMBANDS)

#define  readGEQRght23Freq        readGEQFreqCh(1, 22, GEQ_MAXNUMBANDS)
#define writeGEQRght23Freq(N)    writeGEQFreqCh(1, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght23Freq       wroteGEQFreqCh(1, 22, GEQ_MAXNUMBANDS)
#define  readGEQRght23Level       readGEQLevelCh(1, 22, GEQ_MAXNUMBANDS)
#define writeGEQRght23Level(N)   writeGEQLevelCh(1, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght23Level      wroteGEQLevelCh(1, 22, GEQ_MAXNUMBANDS)
#define  readGEQRght23Width       readGEQWidthCh(1, 22, GEQ_MAXNUMBANDS)
#define writeGEQRght23Width(N)   writeGEQWidthCh(1, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght23Width      wroteGEQWidthCh(1, 22, GEQ_MAXNUMBANDS)

#define  readGEQRght24Freq        readGEQFreqCh(1, 23, GEQ_MAXNUMBANDS)
#define writeGEQRght24Freq(N)    writeGEQFreqCh(1, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght24Freq       wroteGEQFreqCh(1, 23, GEQ_MAXNUMBANDS)
#define  readGEQRght24Level       readGEQLevelCh(1, 23, GEQ_MAXNUMBANDS)
#define writeGEQRght24Level(N)   writeGEQLevelCh(1, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght24Level      wroteGEQLevelCh(1, 23, GEQ_MAXNUMBANDS)
#define  readGEQRght24Width       readGEQWidthCh(1, 23, GEQ_MAXNUMBANDS)
#define writeGEQRght24Width(N)   writeGEQWidthCh(1, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght24Width      wroteGEQWidthCh(1, 23, GEQ_MAXNUMBANDS)

#define  readGEQRght25Freq        readGEQFreqCh(1, 24, GEQ_MAXNUMBANDS)
#define writeGEQRght25Freq(N)    writeGEQFreqCh(1, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght25Freq       wroteGEQFreqCh(1, 24, GEQ_MAXNUMBANDS)
#define  readGEQRght25Level       readGEQLevelCh(1, 24, GEQ_MAXNUMBANDS)
#define writeGEQRght25Level(N)   writeGEQLevelCh(1, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght25Level      wroteGEQLevelCh(1, 24, GEQ_MAXNUMBANDS)
#define  readGEQRght25Width       readGEQWidthCh(1, 24, GEQ_MAXNUMBANDS)
#define writeGEQRght25Width(N)   writeGEQWidthCh(1, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght25Width      wroteGEQWidthCh(1, 24, GEQ_MAXNUMBANDS)

#define  readGEQRght26Freq        readGEQFreqCh(1, 25, GEQ_MAXNUMBANDS)
#define writeGEQRght26Freq(N)    writeGEQFreqCh(1, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght26Freq       wroteGEQFreqCh(1, 25, GEQ_MAXNUMBANDS)
#define  readGEQRght26Level       readGEQLevelCh(1, 25, GEQ_MAXNUMBANDS)
#define writeGEQRght26Level(N)   writeGEQLevelCh(1, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght26Level      wroteGEQLevelCh(1, 25, GEQ_MAXNUMBANDS)
#define  readGEQRght26Width       readGEQWidthCh(1, 25, GEQ_MAXNUMBANDS)
#define writeGEQRght26Width(N)   writeGEQWidthCh(1, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght26Width      wroteGEQWidthCh(1, 25, GEQ_MAXNUMBANDS)

#define  readGEQRght27Freq        readGEQFreqCh(1, 26, GEQ_MAXNUMBANDS)
#define writeGEQRght27Freq(N)    writeGEQFreqCh(1, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght27Freq       wroteGEQFreqCh(1, 26, GEQ_MAXNUMBANDS)
#define  readGEQRght27Level       readGEQLevelCh(1, 26, GEQ_MAXNUMBANDS)
#define writeGEQRght27Level(N)   writeGEQLevelCh(1, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght27Level      wroteGEQLevelCh(1, 26, GEQ_MAXNUMBANDS)
#define  readGEQRght27Width       readGEQWidthCh(1, 26, GEQ_MAXNUMBANDS)
#define writeGEQRght27Width(N)   writeGEQWidthCh(1, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght27Width      wroteGEQWidthCh(1, 26, GEQ_MAXNUMBANDS)

#define  readGEQRght28Freq        readGEQFreqCh(1, 27, GEQ_MAXNUMBANDS)
#define writeGEQRght28Freq(N)    writeGEQFreqCh(1, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght28Freq       wroteGEQFreqCh(1, 27, GEQ_MAXNUMBANDS)
#define  readGEQRght28Level       readGEQLevelCh(1, 27, GEQ_MAXNUMBANDS)
#define writeGEQRght28Level(N)   writeGEQLevelCh(1, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght28Level      wroteGEQLevelCh(1, 27, GEQ_MAXNUMBANDS)
#define  readGEQRght28Width       readGEQWidthCh(1, 27, GEQ_MAXNUMBANDS)
#define writeGEQRght28Width(N)   writeGEQWidthCh(1, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght28Width      wroteGEQWidthCh(1, 27, GEQ_MAXNUMBANDS)

#define  readGEQRght29Freq        readGEQFreqCh(1, 28, GEQ_MAXNUMBANDS)
#define writeGEQRght29Freq(N)    writeGEQFreqCh(1, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght29Freq       wroteGEQFreqCh(1, 28, GEQ_MAXNUMBANDS)
#define  readGEQRght29Level       readGEQLevelCh(1, 28, GEQ_MAXNUMBANDS)
#define writeGEQRght29Level(N)   writeGEQLevelCh(1, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght29Level      wroteGEQLevelCh(1, 28, GEQ_MAXNUMBANDS)
#define  readGEQRght29Width       readGEQWidthCh(1, 28, GEQ_MAXNUMBANDS)
#define writeGEQRght29Width(N)   writeGEQWidthCh(1, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght29Width      wroteGEQWidthCh(1, 28, GEQ_MAXNUMBANDS)

#define  readGEQRght30Freq        readGEQFreqCh(1, 29, GEQ_MAXNUMBANDS)
#define writeGEQRght30Freq(N)    writeGEQFreqCh(1, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght30Freq       wroteGEQFreqCh(1, 29, GEQ_MAXNUMBANDS)
#define  readGEQRght30Level       readGEQLevelCh(1, 29, GEQ_MAXNUMBANDS)
#define writeGEQRght30Level(N)   writeGEQLevelCh(1, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght30Level      wroteGEQLevelCh(1, 29, GEQ_MAXNUMBANDS)
#define  readGEQRght30Width       readGEQWidthCh(1, 29, GEQ_MAXNUMBANDS)
#define writeGEQRght30Width(N)   writeGEQWidthCh(1, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght30Width      wroteGEQWidthCh(1, 29, GEQ_MAXNUMBANDS)

#define  readGEQRght31Freq        readGEQFreqCh(1, 30, GEQ_MAXNUMBANDS)
#define writeGEQRght31Freq(N)    writeGEQFreqCh(1, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght31Freq       wroteGEQFreqCh(1, 30, GEQ_MAXNUMBANDS)
#define  readGEQRght31Level       readGEQLevelCh(1, 30, GEQ_MAXNUMBANDS)
#define writeGEQRght31Level(N)   writeGEQLevelCh(1, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght31Level      wroteGEQLevelCh(1, 30, GEQ_MAXNUMBANDS)
#define  readGEQRght31Width       readGEQWidthCh(1, 30, GEQ_MAXNUMBANDS)
#define writeGEQRght31Width(N)   writeGEQWidthCh(1, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght31Width      wroteGEQWidthCh(1, 30, GEQ_MAXNUMBANDS)

#define  readGEQRght32Freq        readGEQFreqCh(1, 31, GEQ_MAXNUMBANDS)
#define writeGEQRght32Freq(N)    writeGEQFreqCh(1, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght32Freq       wroteGEQFreqCh(1, 31, GEQ_MAXNUMBANDS)
#define  readGEQRght32Level       readGEQLevelCh(1, 31, GEQ_MAXNUMBANDS)
#define writeGEQRght32Level(N)   writeGEQLevelCh(1, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght32Level      wroteGEQLevelCh(1, 31, GEQ_MAXNUMBANDS)
#define  readGEQRght32Width       readGEQWidthCh(1, 31, GEQ_MAXNUMBANDS)
#define writeGEQRght32Width(N)   writeGEQWidthCh(1, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRght32Width      wroteGEQWidthCh(1, 31, GEQ_MAXNUMBANDS)

#define  readGEQCntr1Freq        readGEQFreqCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQCntr1Freq(N)    writeGEQFreqCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr1Freq       wroteGEQFreqCh(2, 0, GEQ_MAXNUMBANDS)
#define  readGEQCntr1Level       readGEQLevelCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQCntr1Level(N)   writeGEQLevelCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr1Level      wroteGEQLevelCh(2, 0, GEQ_MAXNUMBANDS)
#define  readGEQCntr1Width       readGEQWidthCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQCntr1Width(N)   writeGEQWidthCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr1Width      wroteGEQWidthCh(2, 0, GEQ_MAXNUMBANDS)

#define  readGEQCntr2Freq        readGEQFreqCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQCntr2Freq(N)    writeGEQFreqCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr2Freq       wroteGEQFreqCh(2, 1, GEQ_MAXNUMBANDS)
#define  readGEQCntr2Level       readGEQLevelCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQCntr2Level(N)   writeGEQLevelCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr2Level      wroteGEQLevelCh(2, 1, GEQ_MAXNUMBANDS)
#define  readGEQCntr2Width       readGEQWidthCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQCntr2Width(N)   writeGEQWidthCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr2Width      wroteGEQWidthCh(2, 1, GEQ_MAXNUMBANDS)

#define  readGEQCntr3Freq        readGEQFreqCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQCntr3Freq(N)    writeGEQFreqCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr3Freq       wroteGEQFreqCh(2, 2, GEQ_MAXNUMBANDS)
#define  readGEQCntr3Level       readGEQLevelCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQCntr3Level(N)   writeGEQLevelCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr3Level      wroteGEQLevelCh(2, 2, GEQ_MAXNUMBANDS)
#define  readGEQCntr3Width       readGEQWidthCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQCntr3Width(N)   writeGEQWidthCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr3Width      wroteGEQWidthCh(2, 2, GEQ_MAXNUMBANDS)

#define  readGEQCntr4Freq        readGEQFreqCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQCntr4Freq(N)    writeGEQFreqCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr4Freq       wroteGEQFreqCh(2, 3, GEQ_MAXNUMBANDS)
#define  readGEQCntr4Level       readGEQLevelCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQCntr4Level(N)   writeGEQLevelCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr4Level      wroteGEQLevelCh(2, 3, GEQ_MAXNUMBANDS)
#define  readGEQCntr4Width       readGEQWidthCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQCntr4Width(N)   writeGEQWidthCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr4Width      wroteGEQWidthCh(2, 3, GEQ_MAXNUMBANDS)

#define  readGEQCntr5Freq        readGEQFreqCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQCntr5Freq(N)    writeGEQFreqCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr5Freq       wroteGEQFreqCh(2, 4, GEQ_MAXNUMBANDS)
#define  readGEQCntr5Level       readGEQLevelCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQCntr5Level(N)   writeGEQLevelCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr5Level      wroteGEQLevelCh(2, 4, GEQ_MAXNUMBANDS)
#define  readGEQCntr5Width       readGEQWidthCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQCntr5Width(N)   writeGEQWidthCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr5Width      wroteGEQWidthCh(2, 4, GEQ_MAXNUMBANDS)

#define  readGEQCntr6Freq        readGEQFreqCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQCntr6Freq(N)    writeGEQFreqCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr6Freq       wroteGEQFreqCh(2, 5, GEQ_MAXNUMBANDS)
#define  readGEQCntr6Level       readGEQLevelCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQCntr6Level(N)   writeGEQLevelCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr6Level      wroteGEQLevelCh(2, 5, GEQ_MAXNUMBANDS)
#define  readGEQCntr6Width       readGEQWidthCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQCntr6Width(N)   writeGEQWidthCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr6Width      wroteGEQWidthCh(2, 5, GEQ_MAXNUMBANDS)

#define  readGEQCntr7Freq        readGEQFreqCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQCntr7Freq(N)    writeGEQFreqCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr7Freq       wroteGEQFreqCh(2, 6, GEQ_MAXNUMBANDS)
#define  readGEQCntr7Level       readGEQLevelCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQCntr7Level(N)   writeGEQLevelCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr7Level      wroteGEQLevelCh(2, 6, GEQ_MAXNUMBANDS)
#define  readGEQCntr7Width       readGEQWidthCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQCntr7Width(N)   writeGEQWidthCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr7Width      wroteGEQWidthCh(2, 6, GEQ_MAXNUMBANDS)

#define  readGEQCntr8Freq        readGEQFreqCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQCntr8Freq(N)    writeGEQFreqCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr8Freq       wroteGEQFreqCh(2, 7, GEQ_MAXNUMBANDS)
#define  readGEQCntr8Level       readGEQLevelCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQCntr8Level(N)   writeGEQLevelCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr8Level      wroteGEQLevelCh(2, 7, GEQ_MAXNUMBANDS)
#define  readGEQCntr8Width       readGEQWidthCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQCntr8Width(N)   writeGEQWidthCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr8Width      wroteGEQWidthCh(2, 7, GEQ_MAXNUMBANDS)

#define  readGEQCntr9Freq        readGEQFreqCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQCntr9Freq(N)    writeGEQFreqCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr9Freq       wroteGEQFreqCh(2, 8, GEQ_MAXNUMBANDS)
#define  readGEQCntr9Level       readGEQLevelCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQCntr9Level(N)   writeGEQLevelCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr9Level      wroteGEQLevelCh(2, 8, GEQ_MAXNUMBANDS)
#define  readGEQCntr9Width       readGEQWidthCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQCntr9Width(N)   writeGEQWidthCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr9Width      wroteGEQWidthCh(2, 8, GEQ_MAXNUMBANDS)

#define  readGEQCntr10Freq        readGEQFreqCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQCntr10Freq(N)    writeGEQFreqCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr10Freq       wroteGEQFreqCh(2, 9, GEQ_MAXNUMBANDS)
#define  readGEQCntr10Level       readGEQLevelCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQCntr10Level(N)   writeGEQLevelCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr10Level      wroteGEQLevelCh(2, 9, GEQ_MAXNUMBANDS)
#define  readGEQCntr10Width       readGEQWidthCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQCntr10Width(N)   writeGEQWidthCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr10Width      wroteGEQWidthCh(2, 9, GEQ_MAXNUMBANDS)

#define  readGEQCntr11Freq        readGEQFreqCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQCntr11Freq(N)    writeGEQFreqCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr11Freq       wroteGEQFreqCh(2, 10, GEQ_MAXNUMBANDS)
#define  readGEQCntr11Level       readGEQLevelCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQCntr11Level(N)   writeGEQLevelCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr11Level      wroteGEQLevelCh(2, 10, GEQ_MAXNUMBANDS)
#define  readGEQCntr11Width       readGEQWidthCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQCntr11Width(N)   writeGEQWidthCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr11Width      wroteGEQWidthCh(2, 10, GEQ_MAXNUMBANDS)

#define  readGEQCntr12Freq        readGEQFreqCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQCntr12Freq(N)    writeGEQFreqCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr12Freq       wroteGEQFreqCh(2, 11, GEQ_MAXNUMBANDS)
#define  readGEQCntr12Level       readGEQLevelCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQCntr12Level(N)   writeGEQLevelCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr12Level      wroteGEQLevelCh(2, 11, GEQ_MAXNUMBANDS)
#define  readGEQCntr12Width       readGEQWidthCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQCntr12Width(N)   writeGEQWidthCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr12Width      wroteGEQWidthCh(2, 11, GEQ_MAXNUMBANDS)

#define  readGEQCntr13Freq        readGEQFreqCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQCntr13Freq(N)    writeGEQFreqCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr13Freq       wroteGEQFreqCh(2, 12, GEQ_MAXNUMBANDS)
#define  readGEQCntr13Level       readGEQLevelCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQCntr13Level(N)   writeGEQLevelCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr13Level      wroteGEQLevelCh(2, 12, GEQ_MAXNUMBANDS)
#define  readGEQCntr13Width       readGEQWidthCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQCntr13Width(N)   writeGEQWidthCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr13Width      wroteGEQWidthCh(2, 12, GEQ_MAXNUMBANDS)

#define  readGEQCntr14Freq        readGEQFreqCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQCntr14Freq(N)    writeGEQFreqCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr14Freq       wroteGEQFreqCh(2, 13, GEQ_MAXNUMBANDS)
#define  readGEQCntr14Level       readGEQLevelCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQCntr14Level(N)   writeGEQLevelCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr14Level      wroteGEQLevelCh(2, 13, GEQ_MAXNUMBANDS)
#define  readGEQCntr14Width       readGEQWidthCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQCntr14Width(N)   writeGEQWidthCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr14Width      wroteGEQWidthCh(2, 13, GEQ_MAXNUMBANDS)

#define  readGEQCntr15Freq        readGEQFreqCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQCntr15Freq(N)    writeGEQFreqCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr15Freq       wroteGEQFreqCh(2, 14, GEQ_MAXNUMBANDS)
#define  readGEQCntr15Level       readGEQLevelCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQCntr15Level(N)   writeGEQLevelCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr15Level      wroteGEQLevelCh(2, 14, GEQ_MAXNUMBANDS)
#define  readGEQCntr15Width       readGEQWidthCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQCntr15Width(N)   writeGEQWidthCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr15Width      wroteGEQWidthCh(2, 14, GEQ_MAXNUMBANDS)

#define  readGEQCntr16Freq        readGEQFreqCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQCntr16Freq(N)    writeGEQFreqCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr16Freq       wroteGEQFreqCh(2, 15, GEQ_MAXNUMBANDS)
#define  readGEQCntr16Level       readGEQLevelCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQCntr16Level(N)   writeGEQLevelCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr16Level      wroteGEQLevelCh(2, 15, GEQ_MAXNUMBANDS)
#define  readGEQCntr16Width       readGEQWidthCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQCntr16Width(N)   writeGEQWidthCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr16Width      wroteGEQWidthCh(2, 15, GEQ_MAXNUMBANDS)

#define  readGEQCntr17Freq        readGEQFreqCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQCntr17Freq(N)    writeGEQFreqCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr17Freq       wroteGEQFreqCh(2, 16, GEQ_MAXNUMBANDS)
#define  readGEQCntr17Level       readGEQLevelCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQCntr17Level(N)   writeGEQLevelCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr17Level      wroteGEQLevelCh(2, 16, GEQ_MAXNUMBANDS)
#define  readGEQCntr17Width       readGEQWidthCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQCntr17Width(N)   writeGEQWidthCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr17Width      wroteGEQWidthCh(2, 16, GEQ_MAXNUMBANDS)

#define  readGEQCntr18Freq        readGEQFreqCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQCntr18Freq(N)    writeGEQFreqCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr18Freq       wroteGEQFreqCh(2, 17, GEQ_MAXNUMBANDS)
#define  readGEQCntr18Level       readGEQLevelCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQCntr18Level(N)   writeGEQLevelCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr18Level      wroteGEQLevelCh(2, 17, GEQ_MAXNUMBANDS)
#define  readGEQCntr18Width       readGEQWidthCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQCntr18Width(N)   writeGEQWidthCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr18Width      wroteGEQWidthCh(2, 17, GEQ_MAXNUMBANDS)

#define  readGEQCntr19Freq        readGEQFreqCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQCntr19Freq(N)    writeGEQFreqCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr19Freq       wroteGEQFreqCh(2, 18, GEQ_MAXNUMBANDS)
#define  readGEQCntr19Level       readGEQLevelCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQCntr19Level(N)   writeGEQLevelCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr19Level      wroteGEQLevelCh(2, 18, GEQ_MAXNUMBANDS)
#define  readGEQCntr19Width       readGEQWidthCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQCntr19Width(N)   writeGEQWidthCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr19Width      wroteGEQWidthCh(2, 18, GEQ_MAXNUMBANDS)

#define  readGEQCntr20Freq        readGEQFreqCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQCntr20Freq(N)    writeGEQFreqCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr20Freq       wroteGEQFreqCh(2, 19, GEQ_MAXNUMBANDS)
#define  readGEQCntr20Level       readGEQLevelCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQCntr20Level(N)   writeGEQLevelCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr20Level      wroteGEQLevelCh(2, 19, GEQ_MAXNUMBANDS)
#define  readGEQCntr20Width       readGEQWidthCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQCntr20Width(N)   writeGEQWidthCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr20Width      wroteGEQWidthCh(2, 19, GEQ_MAXNUMBANDS)

#define  readGEQCntr21Freq        readGEQFreqCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQCntr21Freq(N)    writeGEQFreqCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr21Freq       wroteGEQFreqCh(2, 20, GEQ_MAXNUMBANDS)
#define  readGEQCntr21Level       readGEQLevelCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQCntr21Level(N)   writeGEQLevelCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr21Level      wroteGEQLevelCh(2, 20, GEQ_MAXNUMBANDS)
#define  readGEQCntr21Width       readGEQWidthCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQCntr21Width(N)   writeGEQWidthCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr21Width      wroteGEQWidthCh(2, 20, GEQ_MAXNUMBANDS)

#define  readGEQCntr22Freq        readGEQFreqCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQCntr22Freq(N)    writeGEQFreqCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr22Freq       wroteGEQFreqCh(2, 21, GEQ_MAXNUMBANDS)
#define  readGEQCntr22Level       readGEQLevelCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQCntr22Level(N)   writeGEQLevelCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr22Level      wroteGEQLevelCh(2, 21, GEQ_MAXNUMBANDS)
#define  readGEQCntr22Width       readGEQWidthCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQCntr22Width(N)   writeGEQWidthCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr22Width      wroteGEQWidthCh(2, 21, GEQ_MAXNUMBANDS)

#define  readGEQCntr23Freq        readGEQFreqCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQCntr23Freq(N)    writeGEQFreqCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr23Freq       wroteGEQFreqCh(2, 22, GEQ_MAXNUMBANDS)
#define  readGEQCntr23Level       readGEQLevelCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQCntr23Level(N)   writeGEQLevelCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr23Level      wroteGEQLevelCh(2, 22, GEQ_MAXNUMBANDS)
#define  readGEQCntr23Width       readGEQWidthCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQCntr23Width(N)   writeGEQWidthCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr23Width      wroteGEQWidthCh(2, 22, GEQ_MAXNUMBANDS)

#define  readGEQCntr24Freq        readGEQFreqCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQCntr24Freq(N)    writeGEQFreqCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr24Freq       wroteGEQFreqCh(2, 23, GEQ_MAXNUMBANDS)
#define  readGEQCntr24Level       readGEQLevelCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQCntr24Level(N)   writeGEQLevelCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr24Level      wroteGEQLevelCh(2, 23, GEQ_MAXNUMBANDS)
#define  readGEQCntr24Width       readGEQWidthCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQCntr24Width(N)   writeGEQWidthCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr24Width      wroteGEQWidthCh(2, 23, GEQ_MAXNUMBANDS)

#define  readGEQCntr25Freq        readGEQFreqCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQCntr25Freq(N)    writeGEQFreqCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr25Freq       wroteGEQFreqCh(2, 24, GEQ_MAXNUMBANDS)
#define  readGEQCntr25Level       readGEQLevelCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQCntr25Level(N)   writeGEQLevelCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr25Level      wroteGEQLevelCh(2, 24, GEQ_MAXNUMBANDS)
#define  readGEQCntr25Width       readGEQWidthCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQCntr25Width(N)   writeGEQWidthCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr25Width      wroteGEQWidthCh(2, 24, GEQ_MAXNUMBANDS)

#define  readGEQCntr26Freq        readGEQFreqCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQCntr26Freq(N)    writeGEQFreqCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr26Freq       wroteGEQFreqCh(2, 25, GEQ_MAXNUMBANDS)
#define  readGEQCntr26Level       readGEQLevelCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQCntr26Level(N)   writeGEQLevelCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr26Level      wroteGEQLevelCh(2, 25, GEQ_MAXNUMBANDS)
#define  readGEQCntr26Width       readGEQWidthCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQCntr26Width(N)   writeGEQWidthCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr26Width      wroteGEQWidthCh(2, 25, GEQ_MAXNUMBANDS)

#define  readGEQCntr27Freq        readGEQFreqCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQCntr27Freq(N)    writeGEQFreqCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr27Freq       wroteGEQFreqCh(2, 26, GEQ_MAXNUMBANDS)
#define  readGEQCntr27Level       readGEQLevelCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQCntr27Level(N)   writeGEQLevelCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr27Level      wroteGEQLevelCh(2, 26, GEQ_MAXNUMBANDS)
#define  readGEQCntr27Width       readGEQWidthCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQCntr27Width(N)   writeGEQWidthCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr27Width      wroteGEQWidthCh(2, 26, GEQ_MAXNUMBANDS)

#define  readGEQCntr28Freq        readGEQFreqCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQCntr28Freq(N)    writeGEQFreqCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr28Freq       wroteGEQFreqCh(2, 27, GEQ_MAXNUMBANDS)
#define  readGEQCntr28Level       readGEQLevelCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQCntr28Level(N)   writeGEQLevelCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr28Level      wroteGEQLevelCh(2, 27, GEQ_MAXNUMBANDS)
#define  readGEQCntr28Width       readGEQWidthCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQCntr28Width(N)   writeGEQWidthCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr28Width      wroteGEQWidthCh(2, 27, GEQ_MAXNUMBANDS)

#define  readGEQCntr29Freq        readGEQFreqCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQCntr29Freq(N)    writeGEQFreqCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr29Freq       wroteGEQFreqCh(2, 28, GEQ_MAXNUMBANDS)
#define  readGEQCntr29Level       readGEQLevelCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQCntr29Level(N)   writeGEQLevelCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr29Level      wroteGEQLevelCh(2, 28, GEQ_MAXNUMBANDS)
#define  readGEQCntr29Width       readGEQWidthCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQCntr29Width(N)   writeGEQWidthCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr29Width      wroteGEQWidthCh(2, 28, GEQ_MAXNUMBANDS)

#define  readGEQCntr30Freq        readGEQFreqCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQCntr30Freq(N)    writeGEQFreqCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr30Freq       wroteGEQFreqCh(2, 29, GEQ_MAXNUMBANDS)
#define  readGEQCntr30Level       readGEQLevelCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQCntr30Level(N)   writeGEQLevelCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr30Level      wroteGEQLevelCh(2, 29, GEQ_MAXNUMBANDS)
#define  readGEQCntr30Width       readGEQWidthCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQCntr30Width(N)   writeGEQWidthCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr30Width      wroteGEQWidthCh(2, 29, GEQ_MAXNUMBANDS)

#define  readGEQCntr31Freq        readGEQFreqCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQCntr31Freq(N)    writeGEQFreqCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr31Freq       wroteGEQFreqCh(2, 30, GEQ_MAXNUMBANDS)
#define  readGEQCntr31Level       readGEQLevelCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQCntr31Level(N)   writeGEQLevelCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr31Level      wroteGEQLevelCh(2, 30, GEQ_MAXNUMBANDS)
#define  readGEQCntr31Width       readGEQWidthCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQCntr31Width(N)   writeGEQWidthCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr31Width      wroteGEQWidthCh(2, 30, GEQ_MAXNUMBANDS)

#define  readGEQCntr32Freq        readGEQFreqCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQCntr32Freq(N)    writeGEQFreqCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr32Freq       wroteGEQFreqCh(2, 31, GEQ_MAXNUMBANDS)
#define  readGEQCntr32Level       readGEQLevelCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQCntr32Level(N)   writeGEQLevelCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr32Level      wroteGEQLevelCh(2, 31, GEQ_MAXNUMBANDS)
#define  readGEQCntr32Width       readGEQWidthCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQCntr32Width(N)   writeGEQWidthCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCntr32Width      wroteGEQWidthCh(2, 31, GEQ_MAXNUMBANDS)

#define  readGEQLctr1Freq        readGEQFreqCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQLctr1Freq(N)    writeGEQFreqCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr1Freq       wroteGEQFreqCh(2, 0, GEQ_MAXNUMBANDS)
#define  readGEQLctr1Level       readGEQLevelCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQLctr1Level(N)   writeGEQLevelCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr1Level      wroteGEQLevelCh(2, 0, GEQ_MAXNUMBANDS)
#define  readGEQLctr1Width       readGEQWidthCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQLctr1Width(N)   writeGEQWidthCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr1Width      wroteGEQWidthCh(2, 0, GEQ_MAXNUMBANDS)

#define  readGEQLctr2Freq        readGEQFreqCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQLctr2Freq(N)    writeGEQFreqCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr2Freq       wroteGEQFreqCh(2, 1, GEQ_MAXNUMBANDS)
#define  readGEQLctr2Level       readGEQLevelCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQLctr2Level(N)   writeGEQLevelCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr2Level      wroteGEQLevelCh(2, 1, GEQ_MAXNUMBANDS)
#define  readGEQLctr2Width       readGEQWidthCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQLctr2Width(N)   writeGEQWidthCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr2Width      wroteGEQWidthCh(2, 1, GEQ_MAXNUMBANDS)

#define  readGEQLctr3Freq        readGEQFreqCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQLctr3Freq(N)    writeGEQFreqCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr3Freq       wroteGEQFreqCh(2, 2, GEQ_MAXNUMBANDS)
#define  readGEQLctr3Level       readGEQLevelCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQLctr3Level(N)   writeGEQLevelCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr3Level      wroteGEQLevelCh(2, 2, GEQ_MAXNUMBANDS)
#define  readGEQLctr3Width       readGEQWidthCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQLctr3Width(N)   writeGEQWidthCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr3Width      wroteGEQWidthCh(2, 2, GEQ_MAXNUMBANDS)

#define  readGEQLctr4Freq        readGEQFreqCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQLctr4Freq(N)    writeGEQFreqCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr4Freq       wroteGEQFreqCh(2, 3, GEQ_MAXNUMBANDS)
#define  readGEQLctr4Level       readGEQLevelCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQLctr4Level(N)   writeGEQLevelCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr4Level      wroteGEQLevelCh(2, 3, GEQ_MAXNUMBANDS)
#define  readGEQLctr4Width       readGEQWidthCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQLctr4Width(N)   writeGEQWidthCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr4Width      wroteGEQWidthCh(2, 3, GEQ_MAXNUMBANDS)

#define  readGEQLctr5Freq        readGEQFreqCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQLctr5Freq(N)    writeGEQFreqCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr5Freq       wroteGEQFreqCh(2, 4, GEQ_MAXNUMBANDS)
#define  readGEQLctr5Level       readGEQLevelCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQLctr5Level(N)   writeGEQLevelCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr5Level      wroteGEQLevelCh(2, 4, GEQ_MAXNUMBANDS)
#define  readGEQLctr5Width       readGEQWidthCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQLctr5Width(N)   writeGEQWidthCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr5Width      wroteGEQWidthCh(2, 4, GEQ_MAXNUMBANDS)

#define  readGEQLctr6Freq        readGEQFreqCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQLctr6Freq(N)    writeGEQFreqCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr6Freq       wroteGEQFreqCh(2, 5, GEQ_MAXNUMBANDS)
#define  readGEQLctr6Level       readGEQLevelCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQLctr6Level(N)   writeGEQLevelCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr6Level      wroteGEQLevelCh(2, 5, GEQ_MAXNUMBANDS)
#define  readGEQLctr6Width       readGEQWidthCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQLctr6Width(N)   writeGEQWidthCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr6Width      wroteGEQWidthCh(2, 5, GEQ_MAXNUMBANDS)

#define  readGEQLctr7Freq        readGEQFreqCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQLctr7Freq(N)    writeGEQFreqCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr7Freq       wroteGEQFreqCh(2, 6, GEQ_MAXNUMBANDS)
#define  readGEQLctr7Level       readGEQLevelCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQLctr7Level(N)   writeGEQLevelCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr7Level      wroteGEQLevelCh(2, 6, GEQ_MAXNUMBANDS)
#define  readGEQLctr7Width       readGEQWidthCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQLctr7Width(N)   writeGEQWidthCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr7Width      wroteGEQWidthCh(2, 6, GEQ_MAXNUMBANDS)

#define  readGEQLctr8Freq        readGEQFreqCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQLctr8Freq(N)    writeGEQFreqCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr8Freq       wroteGEQFreqCh(2, 7, GEQ_MAXNUMBANDS)
#define  readGEQLctr8Level       readGEQLevelCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQLctr8Level(N)   writeGEQLevelCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr8Level      wroteGEQLevelCh(2, 7, GEQ_MAXNUMBANDS)
#define  readGEQLctr8Width       readGEQWidthCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQLctr8Width(N)   writeGEQWidthCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr8Width      wroteGEQWidthCh(2, 7, GEQ_MAXNUMBANDS)

#define  readGEQLctr9Freq        readGEQFreqCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQLctr9Freq(N)    writeGEQFreqCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr9Freq       wroteGEQFreqCh(2, 8, GEQ_MAXNUMBANDS)
#define  readGEQLctr9Level       readGEQLevelCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQLctr9Level(N)   writeGEQLevelCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr9Level      wroteGEQLevelCh(2, 8, GEQ_MAXNUMBANDS)
#define  readGEQLctr9Width       readGEQWidthCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQLctr9Width(N)   writeGEQWidthCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr9Width      wroteGEQWidthCh(2, 8, GEQ_MAXNUMBANDS)

#define  readGEQLctr10Freq        readGEQFreqCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQLctr10Freq(N)    writeGEQFreqCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr10Freq       wroteGEQFreqCh(2, 9, GEQ_MAXNUMBANDS)
#define  readGEQLctr10Level       readGEQLevelCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQLctr10Level(N)   writeGEQLevelCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr10Level      wroteGEQLevelCh(2, 9, GEQ_MAXNUMBANDS)
#define  readGEQLctr10Width       readGEQWidthCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQLctr10Width(N)   writeGEQWidthCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr10Width      wroteGEQWidthCh(2, 9, GEQ_MAXNUMBANDS)

#define  readGEQLctr11Freq        readGEQFreqCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQLctr11Freq(N)    writeGEQFreqCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr11Freq       wroteGEQFreqCh(2, 10, GEQ_MAXNUMBANDS)
#define  readGEQLctr11Level       readGEQLevelCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQLctr11Level(N)   writeGEQLevelCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr11Level      wroteGEQLevelCh(2, 10, GEQ_MAXNUMBANDS)
#define  readGEQLctr11Width       readGEQWidthCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQLctr11Width(N)   writeGEQWidthCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr11Width      wroteGEQWidthCh(2, 10, GEQ_MAXNUMBANDS)

#define  readGEQLctr12Freq        readGEQFreqCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQLctr12Freq(N)    writeGEQFreqCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr12Freq       wroteGEQFreqCh(2, 11, GEQ_MAXNUMBANDS)
#define  readGEQLctr12Level       readGEQLevelCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQLctr12Level(N)   writeGEQLevelCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr12Level      wroteGEQLevelCh(2, 11, GEQ_MAXNUMBANDS)
#define  readGEQLctr12Width       readGEQWidthCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQLctr12Width(N)   writeGEQWidthCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr12Width      wroteGEQWidthCh(2, 11, GEQ_MAXNUMBANDS)

#define  readGEQLctr13Freq        readGEQFreqCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQLctr13Freq(N)    writeGEQFreqCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr13Freq       wroteGEQFreqCh(2, 12, GEQ_MAXNUMBANDS)
#define  readGEQLctr13Level       readGEQLevelCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQLctr13Level(N)   writeGEQLevelCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr13Level      wroteGEQLevelCh(2, 12, GEQ_MAXNUMBANDS)
#define  readGEQLctr13Width       readGEQWidthCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQLctr13Width(N)   writeGEQWidthCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr13Width      wroteGEQWidthCh(2, 12, GEQ_MAXNUMBANDS)

#define  readGEQLctr14Freq        readGEQFreqCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQLctr14Freq(N)    writeGEQFreqCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr14Freq       wroteGEQFreqCh(2, 13, GEQ_MAXNUMBANDS)
#define  readGEQLctr14Level       readGEQLevelCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQLctr14Level(N)   writeGEQLevelCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr14Level      wroteGEQLevelCh(2, 13, GEQ_MAXNUMBANDS)
#define  readGEQLctr14Width       readGEQWidthCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQLctr14Width(N)   writeGEQWidthCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr14Width      wroteGEQWidthCh(2, 13, GEQ_MAXNUMBANDS)

#define  readGEQLctr15Freq        readGEQFreqCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQLctr15Freq(N)    writeGEQFreqCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr15Freq       wroteGEQFreqCh(2, 14, GEQ_MAXNUMBANDS)
#define  readGEQLctr15Level       readGEQLevelCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQLctr15Level(N)   writeGEQLevelCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr15Level      wroteGEQLevelCh(2, 14, GEQ_MAXNUMBANDS)
#define  readGEQLctr15Width       readGEQWidthCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQLctr15Width(N)   writeGEQWidthCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr15Width      wroteGEQWidthCh(2, 14, GEQ_MAXNUMBANDS)

#define  readGEQLctr16Freq        readGEQFreqCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQLctr16Freq(N)    writeGEQFreqCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr16Freq       wroteGEQFreqCh(2, 15, GEQ_MAXNUMBANDS)
#define  readGEQLctr16Level       readGEQLevelCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQLctr16Level(N)   writeGEQLevelCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr16Level      wroteGEQLevelCh(2, 15, GEQ_MAXNUMBANDS)
#define  readGEQLctr16Width       readGEQWidthCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQLctr16Width(N)   writeGEQWidthCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr16Width      wroteGEQWidthCh(2, 15, GEQ_MAXNUMBANDS)

#define  readGEQLctr17Freq        readGEQFreqCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQLctr17Freq(N)    writeGEQFreqCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr17Freq       wroteGEQFreqCh(2, 16, GEQ_MAXNUMBANDS)
#define  readGEQLctr17Level       readGEQLevelCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQLctr17Level(N)   writeGEQLevelCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr17Level      wroteGEQLevelCh(2, 16, GEQ_MAXNUMBANDS)
#define  readGEQLctr17Width       readGEQWidthCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQLctr17Width(N)   writeGEQWidthCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr17Width      wroteGEQWidthCh(2, 16, GEQ_MAXNUMBANDS)

#define  readGEQLctr18Freq        readGEQFreqCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQLctr18Freq(N)    writeGEQFreqCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr18Freq       wroteGEQFreqCh(2, 17, GEQ_MAXNUMBANDS)
#define  readGEQLctr18Level       readGEQLevelCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQLctr18Level(N)   writeGEQLevelCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr18Level      wroteGEQLevelCh(2, 17, GEQ_MAXNUMBANDS)
#define  readGEQLctr18Width       readGEQWidthCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQLctr18Width(N)   writeGEQWidthCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr18Width      wroteGEQWidthCh(2, 17, GEQ_MAXNUMBANDS)

#define  readGEQLctr19Freq        readGEQFreqCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQLctr19Freq(N)    writeGEQFreqCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr19Freq       wroteGEQFreqCh(2, 18, GEQ_MAXNUMBANDS)
#define  readGEQLctr19Level       readGEQLevelCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQLctr19Level(N)   writeGEQLevelCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr19Level      wroteGEQLevelCh(2, 18, GEQ_MAXNUMBANDS)
#define  readGEQLctr19Width       readGEQWidthCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQLctr19Width(N)   writeGEQWidthCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr19Width      wroteGEQWidthCh(2, 18, GEQ_MAXNUMBANDS)

#define  readGEQLctr20Freq        readGEQFreqCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQLctr20Freq(N)    writeGEQFreqCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr20Freq       wroteGEQFreqCh(2, 19, GEQ_MAXNUMBANDS)
#define  readGEQLctr20Level       readGEQLevelCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQLctr20Level(N)   writeGEQLevelCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr20Level      wroteGEQLevelCh(2, 19, GEQ_MAXNUMBANDS)
#define  readGEQLctr20Width       readGEQWidthCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQLctr20Width(N)   writeGEQWidthCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr20Width      wroteGEQWidthCh(2, 19, GEQ_MAXNUMBANDS)

#define  readGEQLctr21Freq        readGEQFreqCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQLctr21Freq(N)    writeGEQFreqCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr21Freq       wroteGEQFreqCh(2, 20, GEQ_MAXNUMBANDS)
#define  readGEQLctr21Level       readGEQLevelCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQLctr21Level(N)   writeGEQLevelCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr21Level      wroteGEQLevelCh(2, 20, GEQ_MAXNUMBANDS)
#define  readGEQLctr21Width       readGEQWidthCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQLctr21Width(N)   writeGEQWidthCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr21Width      wroteGEQWidthCh(2, 20, GEQ_MAXNUMBANDS)

#define  readGEQLctr22Freq        readGEQFreqCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQLctr22Freq(N)    writeGEQFreqCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr22Freq       wroteGEQFreqCh(2, 21, GEQ_MAXNUMBANDS)
#define  readGEQLctr22Level       readGEQLevelCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQLctr22Level(N)   writeGEQLevelCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr22Level      wroteGEQLevelCh(2, 21, GEQ_MAXNUMBANDS)
#define  readGEQLctr22Width       readGEQWidthCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQLctr22Width(N)   writeGEQWidthCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr22Width      wroteGEQWidthCh(2, 21, GEQ_MAXNUMBANDS)

#define  readGEQLctr23Freq        readGEQFreqCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQLctr23Freq(N)    writeGEQFreqCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr23Freq       wroteGEQFreqCh(2, 22, GEQ_MAXNUMBANDS)
#define  readGEQLctr23Level       readGEQLevelCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQLctr23Level(N)   writeGEQLevelCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr23Level      wroteGEQLevelCh(2, 22, GEQ_MAXNUMBANDS)
#define  readGEQLctr23Width       readGEQWidthCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQLctr23Width(N)   writeGEQWidthCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr23Width      wroteGEQWidthCh(2, 22, GEQ_MAXNUMBANDS)

#define  readGEQLctr24Freq        readGEQFreqCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQLctr24Freq(N)    writeGEQFreqCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr24Freq       wroteGEQFreqCh(2, 23, GEQ_MAXNUMBANDS)
#define  readGEQLctr24Level       readGEQLevelCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQLctr24Level(N)   writeGEQLevelCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr24Level      wroteGEQLevelCh(2, 23, GEQ_MAXNUMBANDS)
#define  readGEQLctr24Width       readGEQWidthCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQLctr24Width(N)   writeGEQWidthCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr24Width      wroteGEQWidthCh(2, 23, GEQ_MAXNUMBANDS)

#define  readGEQLctr25Freq        readGEQFreqCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQLctr25Freq(N)    writeGEQFreqCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr25Freq       wroteGEQFreqCh(2, 24, GEQ_MAXNUMBANDS)
#define  readGEQLctr25Level       readGEQLevelCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQLctr25Level(N)   writeGEQLevelCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr25Level      wroteGEQLevelCh(2, 24, GEQ_MAXNUMBANDS)
#define  readGEQLctr25Width       readGEQWidthCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQLctr25Width(N)   writeGEQWidthCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr25Width      wroteGEQWidthCh(2, 24, GEQ_MAXNUMBANDS)

#define  readGEQLctr26Freq        readGEQFreqCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQLctr26Freq(N)    writeGEQFreqCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr26Freq       wroteGEQFreqCh(2, 25, GEQ_MAXNUMBANDS)
#define  readGEQLctr26Level       readGEQLevelCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQLctr26Level(N)   writeGEQLevelCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr26Level      wroteGEQLevelCh(2, 25, GEQ_MAXNUMBANDS)
#define  readGEQLctr26Width       readGEQWidthCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQLctr26Width(N)   writeGEQWidthCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr26Width      wroteGEQWidthCh(2, 25, GEQ_MAXNUMBANDS)

#define  readGEQLctr27Freq        readGEQFreqCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQLctr27Freq(N)    writeGEQFreqCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr27Freq       wroteGEQFreqCh(2, 26, GEQ_MAXNUMBANDS)
#define  readGEQLctr27Level       readGEQLevelCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQLctr27Level(N)   writeGEQLevelCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr27Level      wroteGEQLevelCh(2, 26, GEQ_MAXNUMBANDS)
#define  readGEQLctr27Width       readGEQWidthCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQLctr27Width(N)   writeGEQWidthCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr27Width      wroteGEQWidthCh(2, 26, GEQ_MAXNUMBANDS)

#define  readGEQLctr28Freq        readGEQFreqCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQLctr28Freq(N)    writeGEQFreqCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr28Freq       wroteGEQFreqCh(2, 27, GEQ_MAXNUMBANDS)
#define  readGEQLctr28Level       readGEQLevelCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQLctr28Level(N)   writeGEQLevelCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr28Level      wroteGEQLevelCh(2, 27, GEQ_MAXNUMBANDS)
#define  readGEQLctr28Width       readGEQWidthCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQLctr28Width(N)   writeGEQWidthCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr28Width      wroteGEQWidthCh(2, 27, GEQ_MAXNUMBANDS)

#define  readGEQLctr29Freq        readGEQFreqCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQLctr29Freq(N)    writeGEQFreqCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr29Freq       wroteGEQFreqCh(2, 28, GEQ_MAXNUMBANDS)
#define  readGEQLctr29Level       readGEQLevelCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQLctr29Level(N)   writeGEQLevelCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr29Level      wroteGEQLevelCh(2, 28, GEQ_MAXNUMBANDS)
#define  readGEQLctr29Width       readGEQWidthCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQLctr29Width(N)   writeGEQWidthCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr29Width      wroteGEQWidthCh(2, 28, GEQ_MAXNUMBANDS)

#define  readGEQLctr30Freq        readGEQFreqCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQLctr30Freq(N)    writeGEQFreqCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr30Freq       wroteGEQFreqCh(2, 29, GEQ_MAXNUMBANDS)
#define  readGEQLctr30Level       readGEQLevelCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQLctr30Level(N)   writeGEQLevelCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr30Level      wroteGEQLevelCh(2, 29, GEQ_MAXNUMBANDS)
#define  readGEQLctr30Width       readGEQWidthCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQLctr30Width(N)   writeGEQWidthCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr30Width      wroteGEQWidthCh(2, 29, GEQ_MAXNUMBANDS)

#define  readGEQLctr31Freq        readGEQFreqCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQLctr31Freq(N)    writeGEQFreqCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr31Freq       wroteGEQFreqCh(2, 30, GEQ_MAXNUMBANDS)
#define  readGEQLctr31Level       readGEQLevelCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQLctr31Level(N)   writeGEQLevelCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr31Level      wroteGEQLevelCh(2, 30, GEQ_MAXNUMBANDS)
#define  readGEQLctr31Width       readGEQWidthCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQLctr31Width(N)   writeGEQWidthCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr31Width      wroteGEQWidthCh(2, 30, GEQ_MAXNUMBANDS)

#define  readGEQLctr32Freq        readGEQFreqCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQLctr32Freq(N)    writeGEQFreqCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr32Freq       wroteGEQFreqCh(2, 31, GEQ_MAXNUMBANDS)
#define  readGEQLctr32Level       readGEQLevelCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQLctr32Level(N)   writeGEQLevelCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr32Level      wroteGEQLevelCh(2, 31, GEQ_MAXNUMBANDS)
#define  readGEQLctr32Width       readGEQWidthCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQLctr32Width(N)   writeGEQWidthCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLctr32Width      wroteGEQWidthCh(2, 31, GEQ_MAXNUMBANDS)

#define  readGEQRctr1Freq        readGEQFreqCh(3, 0, GEQ_MAXNUMBANDS)
#define writeGEQRctr1Freq(N)    writeGEQFreqCh(3, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr1Freq       wroteGEQFreqCh(3, 0, GEQ_MAXNUMBANDS)
#define  readGEQRctr1Level       readGEQLevelCh(3, 0, GEQ_MAXNUMBANDS)
#define writeGEQRctr1Level(N)   writeGEQLevelCh(3, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr1Level      wroteGEQLevelCh(3, 0, GEQ_MAXNUMBANDS)
#define  readGEQRctr1Width       readGEQWidthCh(3, 0, GEQ_MAXNUMBANDS)
#define writeGEQRctr1Width(N)   writeGEQWidthCh(3, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr1Width      wroteGEQWidthCh(3, 0, GEQ_MAXNUMBANDS)

#define  readGEQRctr2Freq        readGEQFreqCh(3, 1, GEQ_MAXNUMBANDS)
#define writeGEQRctr2Freq(N)    writeGEQFreqCh(3, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr2Freq       wroteGEQFreqCh(3, 1, GEQ_MAXNUMBANDS)
#define  readGEQRctr2Level       readGEQLevelCh(3, 1, GEQ_MAXNUMBANDS)
#define writeGEQRctr2Level(N)   writeGEQLevelCh(3, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr2Level      wroteGEQLevelCh(3, 1, GEQ_MAXNUMBANDS)
#define  readGEQRctr2Width       readGEQWidthCh(3, 1, GEQ_MAXNUMBANDS)
#define writeGEQRctr2Width(N)   writeGEQWidthCh(3, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr2Width      wroteGEQWidthCh(3, 1, GEQ_MAXNUMBANDS)

#define  readGEQRctr3Freq        readGEQFreqCh(3, 2, GEQ_MAXNUMBANDS)
#define writeGEQRctr3Freq(N)    writeGEQFreqCh(3, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr3Freq       wroteGEQFreqCh(3, 2, GEQ_MAXNUMBANDS)
#define  readGEQRctr3Level       readGEQLevelCh(3, 2, GEQ_MAXNUMBANDS)
#define writeGEQRctr3Level(N)   writeGEQLevelCh(3, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr3Level      wroteGEQLevelCh(3, 2, GEQ_MAXNUMBANDS)
#define  readGEQRctr3Width       readGEQWidthCh(3, 2, GEQ_MAXNUMBANDS)
#define writeGEQRctr3Width(N)   writeGEQWidthCh(3, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr3Width      wroteGEQWidthCh(3, 2, GEQ_MAXNUMBANDS)

#define  readGEQRctr4Freq        readGEQFreqCh(3, 3, GEQ_MAXNUMBANDS)
#define writeGEQRctr4Freq(N)    writeGEQFreqCh(3, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr4Freq       wroteGEQFreqCh(3, 3, GEQ_MAXNUMBANDS)
#define  readGEQRctr4Level       readGEQLevelCh(3, 3, GEQ_MAXNUMBANDS)
#define writeGEQRctr4Level(N)   writeGEQLevelCh(3, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr4Level      wroteGEQLevelCh(3, 3, GEQ_MAXNUMBANDS)
#define  readGEQRctr4Width       readGEQWidthCh(3, 3, GEQ_MAXNUMBANDS)
#define writeGEQRctr4Width(N)   writeGEQWidthCh(3, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr4Width      wroteGEQWidthCh(3, 3, GEQ_MAXNUMBANDS)

#define  readGEQRctr5Freq        readGEQFreqCh(3, 4, GEQ_MAXNUMBANDS)
#define writeGEQRctr5Freq(N)    writeGEQFreqCh(3, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr5Freq       wroteGEQFreqCh(3, 4, GEQ_MAXNUMBANDS)
#define  readGEQRctr5Level       readGEQLevelCh(3, 4, GEQ_MAXNUMBANDS)
#define writeGEQRctr5Level(N)   writeGEQLevelCh(3, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr5Level      wroteGEQLevelCh(3, 4, GEQ_MAXNUMBANDS)
#define  readGEQRctr5Width       readGEQWidthCh(3, 4, GEQ_MAXNUMBANDS)
#define writeGEQRctr5Width(N)   writeGEQWidthCh(3, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr5Width      wroteGEQWidthCh(3, 4, GEQ_MAXNUMBANDS)

#define  readGEQRctr6Freq        readGEQFreqCh(3, 5, GEQ_MAXNUMBANDS)
#define writeGEQRctr6Freq(N)    writeGEQFreqCh(3, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr6Freq       wroteGEQFreqCh(3, 5, GEQ_MAXNUMBANDS)
#define  readGEQRctr6Level       readGEQLevelCh(3, 5, GEQ_MAXNUMBANDS)
#define writeGEQRctr6Level(N)   writeGEQLevelCh(3, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr6Level      wroteGEQLevelCh(3, 5, GEQ_MAXNUMBANDS)
#define  readGEQRctr6Width       readGEQWidthCh(3, 5, GEQ_MAXNUMBANDS)
#define writeGEQRctr6Width(N)   writeGEQWidthCh(3, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr6Width      wroteGEQWidthCh(3, 5, GEQ_MAXNUMBANDS)

#define  readGEQRctr7Freq        readGEQFreqCh(3, 6, GEQ_MAXNUMBANDS)
#define writeGEQRctr7Freq(N)    writeGEQFreqCh(3, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr7Freq       wroteGEQFreqCh(3, 6, GEQ_MAXNUMBANDS)
#define  readGEQRctr7Level       readGEQLevelCh(3, 6, GEQ_MAXNUMBANDS)
#define writeGEQRctr7Level(N)   writeGEQLevelCh(3, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr7Level      wroteGEQLevelCh(3, 6, GEQ_MAXNUMBANDS)
#define  readGEQRctr7Width       readGEQWidthCh(3, 6, GEQ_MAXNUMBANDS)
#define writeGEQRctr7Width(N)   writeGEQWidthCh(3, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr7Width      wroteGEQWidthCh(3, 6, GEQ_MAXNUMBANDS)

#define  readGEQRctr8Freq        readGEQFreqCh(3, 7, GEQ_MAXNUMBANDS)
#define writeGEQRctr8Freq(N)    writeGEQFreqCh(3, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr8Freq       wroteGEQFreqCh(3, 7, GEQ_MAXNUMBANDS)
#define  readGEQRctr8Level       readGEQLevelCh(3, 7, GEQ_MAXNUMBANDS)
#define writeGEQRctr8Level(N)   writeGEQLevelCh(3, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr8Level      wroteGEQLevelCh(3, 7, GEQ_MAXNUMBANDS)
#define  readGEQRctr8Width       readGEQWidthCh(3, 7, GEQ_MAXNUMBANDS)
#define writeGEQRctr8Width(N)   writeGEQWidthCh(3, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr8Width      wroteGEQWidthCh(3, 7, GEQ_MAXNUMBANDS)

#define  readGEQRctr9Freq        readGEQFreqCh(3, 8, GEQ_MAXNUMBANDS)
#define writeGEQRctr9Freq(N)    writeGEQFreqCh(3, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr9Freq       wroteGEQFreqCh(3, 8, GEQ_MAXNUMBANDS)
#define  readGEQRctr9Level       readGEQLevelCh(3, 8, GEQ_MAXNUMBANDS)
#define writeGEQRctr9Level(N)   writeGEQLevelCh(3, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr9Level      wroteGEQLevelCh(3, 8, GEQ_MAXNUMBANDS)
#define  readGEQRctr9Width       readGEQWidthCh(3, 8, GEQ_MAXNUMBANDS)
#define writeGEQRctr9Width(N)   writeGEQWidthCh(3, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr9Width      wroteGEQWidthCh(3, 8, GEQ_MAXNUMBANDS)

#define  readGEQRctr10Freq        readGEQFreqCh(3, 9, GEQ_MAXNUMBANDS)
#define writeGEQRctr10Freq(N)    writeGEQFreqCh(3, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr10Freq       wroteGEQFreqCh(3, 9, GEQ_MAXNUMBANDS)
#define  readGEQRctr10Level       readGEQLevelCh(3, 9, GEQ_MAXNUMBANDS)
#define writeGEQRctr10Level(N)   writeGEQLevelCh(3, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr10Level      wroteGEQLevelCh(3, 9, GEQ_MAXNUMBANDS)
#define  readGEQRctr10Width       readGEQWidthCh(3, 9, GEQ_MAXNUMBANDS)
#define writeGEQRctr10Width(N)   writeGEQWidthCh(3, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr10Width      wroteGEQWidthCh(3, 9, GEQ_MAXNUMBANDS)

#define  readGEQRctr11Freq        readGEQFreqCh(3, 10, GEQ_MAXNUMBANDS)
#define writeGEQRctr11Freq(N)    writeGEQFreqCh(3, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr11Freq       wroteGEQFreqCh(3, 10, GEQ_MAXNUMBANDS)
#define  readGEQRctr11Level       readGEQLevelCh(3, 10, GEQ_MAXNUMBANDS)
#define writeGEQRctr11Level(N)   writeGEQLevelCh(3, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr11Level      wroteGEQLevelCh(3, 10, GEQ_MAXNUMBANDS)
#define  readGEQRctr11Width       readGEQWidthCh(3, 10, GEQ_MAXNUMBANDS)
#define writeGEQRctr11Width(N)   writeGEQWidthCh(3, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr11Width      wroteGEQWidthCh(3, 10, GEQ_MAXNUMBANDS)

#define  readGEQRctr12Freq        readGEQFreqCh(3, 11, GEQ_MAXNUMBANDS)
#define writeGEQRctr12Freq(N)    writeGEQFreqCh(3, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr12Freq       wroteGEQFreqCh(3, 11, GEQ_MAXNUMBANDS)
#define  readGEQRctr12Level       readGEQLevelCh(3, 11, GEQ_MAXNUMBANDS)
#define writeGEQRctr12Level(N)   writeGEQLevelCh(3, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr12Level      wroteGEQLevelCh(3, 11, GEQ_MAXNUMBANDS)
#define  readGEQRctr12Width       readGEQWidthCh(3, 11, GEQ_MAXNUMBANDS)
#define writeGEQRctr12Width(N)   writeGEQWidthCh(3, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr12Width      wroteGEQWidthCh(3, 11, GEQ_MAXNUMBANDS)

#define  readGEQRctr13Freq        readGEQFreqCh(3, 12, GEQ_MAXNUMBANDS)
#define writeGEQRctr13Freq(N)    writeGEQFreqCh(3, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr13Freq       wroteGEQFreqCh(3, 12, GEQ_MAXNUMBANDS)
#define  readGEQRctr13Level       readGEQLevelCh(3, 12, GEQ_MAXNUMBANDS)
#define writeGEQRctr13Level(N)   writeGEQLevelCh(3, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr13Level      wroteGEQLevelCh(3, 12, GEQ_MAXNUMBANDS)
#define  readGEQRctr13Width       readGEQWidthCh(3, 12, GEQ_MAXNUMBANDS)
#define writeGEQRctr13Width(N)   writeGEQWidthCh(3, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr13Width      wroteGEQWidthCh(3, 12, GEQ_MAXNUMBANDS)

#define  readGEQRctr14Freq        readGEQFreqCh(3, 13, GEQ_MAXNUMBANDS)
#define writeGEQRctr14Freq(N)    writeGEQFreqCh(3, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr14Freq       wroteGEQFreqCh(3, 13, GEQ_MAXNUMBANDS)
#define  readGEQRctr14Level       readGEQLevelCh(3, 13, GEQ_MAXNUMBANDS)
#define writeGEQRctr14Level(N)   writeGEQLevelCh(3, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr14Level      wroteGEQLevelCh(3, 13, GEQ_MAXNUMBANDS)
#define  readGEQRctr14Width       readGEQWidthCh(3, 13, GEQ_MAXNUMBANDS)
#define writeGEQRctr14Width(N)   writeGEQWidthCh(3, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr14Width      wroteGEQWidthCh(3, 13, GEQ_MAXNUMBANDS)

#define  readGEQRctr15Freq        readGEQFreqCh(3, 14, GEQ_MAXNUMBANDS)
#define writeGEQRctr15Freq(N)    writeGEQFreqCh(3, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr15Freq       wroteGEQFreqCh(3, 14, GEQ_MAXNUMBANDS)
#define  readGEQRctr15Level       readGEQLevelCh(3, 14, GEQ_MAXNUMBANDS)
#define writeGEQRctr15Level(N)   writeGEQLevelCh(3, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr15Level      wroteGEQLevelCh(3, 14, GEQ_MAXNUMBANDS)
#define  readGEQRctr15Width       readGEQWidthCh(3, 14, GEQ_MAXNUMBANDS)
#define writeGEQRctr15Width(N)   writeGEQWidthCh(3, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr15Width      wroteGEQWidthCh(3, 14, GEQ_MAXNUMBANDS)

#define  readGEQRctr16Freq        readGEQFreqCh(3, 15, GEQ_MAXNUMBANDS)
#define writeGEQRctr16Freq(N)    writeGEQFreqCh(3, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr16Freq       wroteGEQFreqCh(3, 15, GEQ_MAXNUMBANDS)
#define  readGEQRctr16Level       readGEQLevelCh(3, 15, GEQ_MAXNUMBANDS)
#define writeGEQRctr16Level(N)   writeGEQLevelCh(3, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr16Level      wroteGEQLevelCh(3, 15, GEQ_MAXNUMBANDS)
#define  readGEQRctr16Width       readGEQWidthCh(3, 15, GEQ_MAXNUMBANDS)
#define writeGEQRctr16Width(N)   writeGEQWidthCh(3, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr16Width      wroteGEQWidthCh(3, 15, GEQ_MAXNUMBANDS)

#define  readGEQRctr17Freq        readGEQFreqCh(3, 16, GEQ_MAXNUMBANDS)
#define writeGEQRctr17Freq(N)    writeGEQFreqCh(3, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr17Freq       wroteGEQFreqCh(3, 16, GEQ_MAXNUMBANDS)
#define  readGEQRctr17Level       readGEQLevelCh(3, 16, GEQ_MAXNUMBANDS)
#define writeGEQRctr17Level(N)   writeGEQLevelCh(3, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr17Level      wroteGEQLevelCh(3, 16, GEQ_MAXNUMBANDS)
#define  readGEQRctr17Width       readGEQWidthCh(3, 16, GEQ_MAXNUMBANDS)
#define writeGEQRctr17Width(N)   writeGEQWidthCh(3, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr17Width      wroteGEQWidthCh(3, 16, GEQ_MAXNUMBANDS)

#define  readGEQRctr18Freq        readGEQFreqCh(3, 17, GEQ_MAXNUMBANDS)
#define writeGEQRctr18Freq(N)    writeGEQFreqCh(3, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr18Freq       wroteGEQFreqCh(3, 17, GEQ_MAXNUMBANDS)
#define  readGEQRctr18Level       readGEQLevelCh(3, 17, GEQ_MAXNUMBANDS)
#define writeGEQRctr18Level(N)   writeGEQLevelCh(3, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr18Level      wroteGEQLevelCh(3, 17, GEQ_MAXNUMBANDS)
#define  readGEQRctr18Width       readGEQWidthCh(3, 17, GEQ_MAXNUMBANDS)
#define writeGEQRctr18Width(N)   writeGEQWidthCh(3, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr18Width      wroteGEQWidthCh(3, 17, GEQ_MAXNUMBANDS)

#define  readGEQRctr19Freq        readGEQFreqCh(3, 18, GEQ_MAXNUMBANDS)
#define writeGEQRctr19Freq(N)    writeGEQFreqCh(3, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr19Freq       wroteGEQFreqCh(3, 18, GEQ_MAXNUMBANDS)
#define  readGEQRctr19Level       readGEQLevelCh(3, 18, GEQ_MAXNUMBANDS)
#define writeGEQRctr19Level(N)   writeGEQLevelCh(3, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr19Level      wroteGEQLevelCh(3, 18, GEQ_MAXNUMBANDS)
#define  readGEQRctr19Width       readGEQWidthCh(3, 18, GEQ_MAXNUMBANDS)
#define writeGEQRctr19Width(N)   writeGEQWidthCh(3, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr19Width      wroteGEQWidthCh(3, 18, GEQ_MAXNUMBANDS)

#define  readGEQRctr20Freq        readGEQFreqCh(3, 19, GEQ_MAXNUMBANDS)
#define writeGEQRctr20Freq(N)    writeGEQFreqCh(3, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr20Freq       wroteGEQFreqCh(3, 19, GEQ_MAXNUMBANDS)
#define  readGEQRctr20Level       readGEQLevelCh(3, 19, GEQ_MAXNUMBANDS)
#define writeGEQRctr20Level(N)   writeGEQLevelCh(3, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr20Level      wroteGEQLevelCh(3, 19, GEQ_MAXNUMBANDS)
#define  readGEQRctr20Width       readGEQWidthCh(3, 19, GEQ_MAXNUMBANDS)
#define writeGEQRctr20Width(N)   writeGEQWidthCh(3, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr20Width      wroteGEQWidthCh(3, 19, GEQ_MAXNUMBANDS)

#define  readGEQRctr21Freq        readGEQFreqCh(3, 20, GEQ_MAXNUMBANDS)
#define writeGEQRctr21Freq(N)    writeGEQFreqCh(3, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr21Freq       wroteGEQFreqCh(3, 20, GEQ_MAXNUMBANDS)
#define  readGEQRctr21Level       readGEQLevelCh(3, 20, GEQ_MAXNUMBANDS)
#define writeGEQRctr21Level(N)   writeGEQLevelCh(3, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr21Level      wroteGEQLevelCh(3, 20, GEQ_MAXNUMBANDS)
#define  readGEQRctr21Width       readGEQWidthCh(3, 20, GEQ_MAXNUMBANDS)
#define writeGEQRctr21Width(N)   writeGEQWidthCh(3, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr21Width      wroteGEQWidthCh(3, 20, GEQ_MAXNUMBANDS)

#define  readGEQRctr22Freq        readGEQFreqCh(3, 21, GEQ_MAXNUMBANDS)
#define writeGEQRctr22Freq(N)    writeGEQFreqCh(3, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr22Freq       wroteGEQFreqCh(3, 21, GEQ_MAXNUMBANDS)
#define  readGEQRctr22Level       readGEQLevelCh(3, 21, GEQ_MAXNUMBANDS)
#define writeGEQRctr22Level(N)   writeGEQLevelCh(3, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr22Level      wroteGEQLevelCh(3, 21, GEQ_MAXNUMBANDS)
#define  readGEQRctr22Width       readGEQWidthCh(3, 21, GEQ_MAXNUMBANDS)
#define writeGEQRctr22Width(N)   writeGEQWidthCh(3, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr22Width      wroteGEQWidthCh(3, 21, GEQ_MAXNUMBANDS)

#define  readGEQRctr23Freq        readGEQFreqCh(3, 22, GEQ_MAXNUMBANDS)
#define writeGEQRctr23Freq(N)    writeGEQFreqCh(3, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr23Freq       wroteGEQFreqCh(3, 22, GEQ_MAXNUMBANDS)
#define  readGEQRctr23Level       readGEQLevelCh(3, 22, GEQ_MAXNUMBANDS)
#define writeGEQRctr23Level(N)   writeGEQLevelCh(3, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr23Level      wroteGEQLevelCh(3, 22, GEQ_MAXNUMBANDS)
#define  readGEQRctr23Width       readGEQWidthCh(3, 22, GEQ_MAXNUMBANDS)
#define writeGEQRctr23Width(N)   writeGEQWidthCh(3, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr23Width      wroteGEQWidthCh(3, 22, GEQ_MAXNUMBANDS)

#define  readGEQRctr24Freq        readGEQFreqCh(3, 23, GEQ_MAXNUMBANDS)
#define writeGEQRctr24Freq(N)    writeGEQFreqCh(3, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr24Freq       wroteGEQFreqCh(3, 23, GEQ_MAXNUMBANDS)
#define  readGEQRctr24Level       readGEQLevelCh(3, 23, GEQ_MAXNUMBANDS)
#define writeGEQRctr24Level(N)   writeGEQLevelCh(3, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr24Level      wroteGEQLevelCh(3, 23, GEQ_MAXNUMBANDS)
#define  readGEQRctr24Width       readGEQWidthCh(3, 23, GEQ_MAXNUMBANDS)
#define writeGEQRctr24Width(N)   writeGEQWidthCh(3, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr24Width      wroteGEQWidthCh(3, 23, GEQ_MAXNUMBANDS)

#define  readGEQRctr25Freq        readGEQFreqCh(3, 24, GEQ_MAXNUMBANDS)
#define writeGEQRctr25Freq(N)    writeGEQFreqCh(3, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr25Freq       wroteGEQFreqCh(3, 24, GEQ_MAXNUMBANDS)
#define  readGEQRctr25Level       readGEQLevelCh(3, 24, GEQ_MAXNUMBANDS)
#define writeGEQRctr25Level(N)   writeGEQLevelCh(3, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr25Level      wroteGEQLevelCh(3, 24, GEQ_MAXNUMBANDS)
#define  readGEQRctr25Width       readGEQWidthCh(3, 24, GEQ_MAXNUMBANDS)
#define writeGEQRctr25Width(N)   writeGEQWidthCh(3, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr25Width      wroteGEQWidthCh(3, 24, GEQ_MAXNUMBANDS)

#define  readGEQRctr26Freq        readGEQFreqCh(3, 25, GEQ_MAXNUMBANDS)
#define writeGEQRctr26Freq(N)    writeGEQFreqCh(3, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr26Freq       wroteGEQFreqCh(3, 25, GEQ_MAXNUMBANDS)
#define  readGEQRctr26Level       readGEQLevelCh(3, 25, GEQ_MAXNUMBANDS)
#define writeGEQRctr26Level(N)   writeGEQLevelCh(3, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr26Level      wroteGEQLevelCh(3, 25, GEQ_MAXNUMBANDS)
#define  readGEQRctr26Width       readGEQWidthCh(3, 25, GEQ_MAXNUMBANDS)
#define writeGEQRctr26Width(N)   writeGEQWidthCh(3, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr26Width      wroteGEQWidthCh(3, 25, GEQ_MAXNUMBANDS)

#define  readGEQRctr27Freq        readGEQFreqCh(3, 26, GEQ_MAXNUMBANDS)
#define writeGEQRctr27Freq(N)    writeGEQFreqCh(3, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr27Freq       wroteGEQFreqCh(3, 26, GEQ_MAXNUMBANDS)
#define  readGEQRctr27Level       readGEQLevelCh(3, 26, GEQ_MAXNUMBANDS)
#define writeGEQRctr27Level(N)   writeGEQLevelCh(3, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr27Level      wroteGEQLevelCh(3, 26, GEQ_MAXNUMBANDS)
#define  readGEQRctr27Width       readGEQWidthCh(3, 26, GEQ_MAXNUMBANDS)
#define writeGEQRctr27Width(N)   writeGEQWidthCh(3, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr27Width      wroteGEQWidthCh(3, 26, GEQ_MAXNUMBANDS)

#define  readGEQRctr28Freq        readGEQFreqCh(3, 27, GEQ_MAXNUMBANDS)
#define writeGEQRctr28Freq(N)    writeGEQFreqCh(3, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr28Freq       wroteGEQFreqCh(3, 27, GEQ_MAXNUMBANDS)
#define  readGEQRctr28Level       readGEQLevelCh(3, 27, GEQ_MAXNUMBANDS)
#define writeGEQRctr28Level(N)   writeGEQLevelCh(3, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr28Level      wroteGEQLevelCh(3, 27, GEQ_MAXNUMBANDS)
#define  readGEQRctr28Width       readGEQWidthCh(3, 27, GEQ_MAXNUMBANDS)
#define writeGEQRctr28Width(N)   writeGEQWidthCh(3, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr28Width      wroteGEQWidthCh(3, 27, GEQ_MAXNUMBANDS)

#define  readGEQRctr29Freq        readGEQFreqCh(3, 28, GEQ_MAXNUMBANDS)
#define writeGEQRctr29Freq(N)    writeGEQFreqCh(3, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr29Freq       wroteGEQFreqCh(3, 28, GEQ_MAXNUMBANDS)
#define  readGEQRctr29Level       readGEQLevelCh(3, 28, GEQ_MAXNUMBANDS)
#define writeGEQRctr29Level(N)   writeGEQLevelCh(3, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr29Level      wroteGEQLevelCh(3, 28, GEQ_MAXNUMBANDS)
#define  readGEQRctr29Width       readGEQWidthCh(3, 28, GEQ_MAXNUMBANDS)
#define writeGEQRctr29Width(N)   writeGEQWidthCh(3, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr29Width      wroteGEQWidthCh(3, 28, GEQ_MAXNUMBANDS)

#define  readGEQRctr30Freq        readGEQFreqCh(3, 29, GEQ_MAXNUMBANDS)
#define writeGEQRctr30Freq(N)    writeGEQFreqCh(3, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr30Freq       wroteGEQFreqCh(3, 29, GEQ_MAXNUMBANDS)
#define  readGEQRctr30Level       readGEQLevelCh(3, 29, GEQ_MAXNUMBANDS)
#define writeGEQRctr30Level(N)   writeGEQLevelCh(3, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr30Level      wroteGEQLevelCh(3, 29, GEQ_MAXNUMBANDS)
#define  readGEQRctr30Width       readGEQWidthCh(3, 29, GEQ_MAXNUMBANDS)
#define writeGEQRctr30Width(N)   writeGEQWidthCh(3, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr30Width      wroteGEQWidthCh(3, 29, GEQ_MAXNUMBANDS)

#define  readGEQRctr31Freq        readGEQFreqCh(3, 30, GEQ_MAXNUMBANDS)
#define writeGEQRctr31Freq(N)    writeGEQFreqCh(3, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr31Freq       wroteGEQFreqCh(3, 30, GEQ_MAXNUMBANDS)
#define  readGEQRctr31Level       readGEQLevelCh(3, 30, GEQ_MAXNUMBANDS)
#define writeGEQRctr31Level(N)   writeGEQLevelCh(3, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr31Level      wroteGEQLevelCh(3, 30, GEQ_MAXNUMBANDS)
#define  readGEQRctr31Width       readGEQWidthCh(3, 30, GEQ_MAXNUMBANDS)
#define writeGEQRctr31Width(N)   writeGEQWidthCh(3, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr31Width      wroteGEQWidthCh(3, 30, GEQ_MAXNUMBANDS)

#define  readGEQRctr32Freq        readGEQFreqCh(3, 31, GEQ_MAXNUMBANDS)
#define writeGEQRctr32Freq(N)    writeGEQFreqCh(3, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr32Freq       wroteGEQFreqCh(3, 31, GEQ_MAXNUMBANDS)
#define  readGEQRctr32Level       readGEQLevelCh(3, 31, GEQ_MAXNUMBANDS)
#define writeGEQRctr32Level(N)   writeGEQLevelCh(3, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr32Level      wroteGEQLevelCh(3, 31, GEQ_MAXNUMBANDS)
#define  readGEQRctr32Width       readGEQWidthCh(3, 31, GEQ_MAXNUMBANDS)
#define writeGEQRctr32Width(N)   writeGEQWidthCh(3, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRctr32Width      wroteGEQWidthCh(3, 31, GEQ_MAXNUMBANDS)

#define  readGEQWide1Freq        readGEQFreqCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQWide1Freq(N)    writeGEQFreqCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide1Freq       wroteGEQFreqCh(4, 0, GEQ_MAXNUMBANDS)
#define  readGEQWide1Level       readGEQLevelCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQWide1Level(N)   writeGEQLevelCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide1Level      wroteGEQLevelCh(4, 0, GEQ_MAXNUMBANDS)
#define  readGEQWide1Width       readGEQWidthCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQWide1Width(N)   writeGEQWidthCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide1Width      wroteGEQWidthCh(4, 0, GEQ_MAXNUMBANDS)

#define  readGEQWide2Freq        readGEQFreqCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQWide2Freq(N)    writeGEQFreqCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide2Freq       wroteGEQFreqCh(4, 1, GEQ_MAXNUMBANDS)
#define  readGEQWide2Level       readGEQLevelCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQWide2Level(N)   writeGEQLevelCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide2Level      wroteGEQLevelCh(4, 1, GEQ_MAXNUMBANDS)
#define  readGEQWide2Width       readGEQWidthCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQWide2Width(N)   writeGEQWidthCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide2Width      wroteGEQWidthCh(4, 1, GEQ_MAXNUMBANDS)

#define  readGEQWide3Freq        readGEQFreqCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQWide3Freq(N)    writeGEQFreqCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide3Freq       wroteGEQFreqCh(4, 2, GEQ_MAXNUMBANDS)
#define  readGEQWide3Level       readGEQLevelCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQWide3Level(N)   writeGEQLevelCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide3Level      wroteGEQLevelCh(4, 2, GEQ_MAXNUMBANDS)
#define  readGEQWide3Width       readGEQWidthCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQWide3Width(N)   writeGEQWidthCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide3Width      wroteGEQWidthCh(4, 2, GEQ_MAXNUMBANDS)

#define  readGEQWide4Freq        readGEQFreqCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQWide4Freq(N)    writeGEQFreqCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide4Freq       wroteGEQFreqCh(4, 3, GEQ_MAXNUMBANDS)
#define  readGEQWide4Level       readGEQLevelCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQWide4Level(N)   writeGEQLevelCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide4Level      wroteGEQLevelCh(4, 3, GEQ_MAXNUMBANDS)
#define  readGEQWide4Width       readGEQWidthCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQWide4Width(N)   writeGEQWidthCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide4Width      wroteGEQWidthCh(4, 3, GEQ_MAXNUMBANDS)

#define  readGEQWide5Freq        readGEQFreqCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQWide5Freq(N)    writeGEQFreqCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide5Freq       wroteGEQFreqCh(4, 4, GEQ_MAXNUMBANDS)
#define  readGEQWide5Level       readGEQLevelCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQWide5Level(N)   writeGEQLevelCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide5Level      wroteGEQLevelCh(4, 4, GEQ_MAXNUMBANDS)
#define  readGEQWide5Width       readGEQWidthCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQWide5Width(N)   writeGEQWidthCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide5Width      wroteGEQWidthCh(4, 4, GEQ_MAXNUMBANDS)

#define  readGEQWide6Freq        readGEQFreqCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQWide6Freq(N)    writeGEQFreqCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide6Freq       wroteGEQFreqCh(4, 5, GEQ_MAXNUMBANDS)
#define  readGEQWide6Level       readGEQLevelCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQWide6Level(N)   writeGEQLevelCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide6Level      wroteGEQLevelCh(4, 5, GEQ_MAXNUMBANDS)
#define  readGEQWide6Width       readGEQWidthCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQWide6Width(N)   writeGEQWidthCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide6Width      wroteGEQWidthCh(4, 5, GEQ_MAXNUMBANDS)

#define  readGEQWide7Freq        readGEQFreqCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQWide7Freq(N)    writeGEQFreqCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide7Freq       wroteGEQFreqCh(4, 6, GEQ_MAXNUMBANDS)
#define  readGEQWide7Level       readGEQLevelCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQWide7Level(N)   writeGEQLevelCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide7Level      wroteGEQLevelCh(4, 6, GEQ_MAXNUMBANDS)
#define  readGEQWide7Width       readGEQWidthCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQWide7Width(N)   writeGEQWidthCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide7Width      wroteGEQWidthCh(4, 6, GEQ_MAXNUMBANDS)

#define  readGEQWide8Freq        readGEQFreqCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQWide8Freq(N)    writeGEQFreqCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide8Freq       wroteGEQFreqCh(4, 7, GEQ_MAXNUMBANDS)
#define  readGEQWide8Level       readGEQLevelCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQWide8Level(N)   writeGEQLevelCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide8Level      wroteGEQLevelCh(4, 7, GEQ_MAXNUMBANDS)
#define  readGEQWide8Width       readGEQWidthCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQWide8Width(N)   writeGEQWidthCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide8Width      wroteGEQWidthCh(4, 7, GEQ_MAXNUMBANDS)

#define  readGEQWide9Freq        readGEQFreqCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQWide9Freq(N)    writeGEQFreqCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide9Freq       wroteGEQFreqCh(4, 8, GEQ_MAXNUMBANDS)
#define  readGEQWide9Level       readGEQLevelCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQWide9Level(N)   writeGEQLevelCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide9Level      wroteGEQLevelCh(4, 8, GEQ_MAXNUMBANDS)
#define  readGEQWide9Width       readGEQWidthCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQWide9Width(N)   writeGEQWidthCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide9Width      wroteGEQWidthCh(4, 8, GEQ_MAXNUMBANDS)

#define  readGEQWide10Freq        readGEQFreqCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQWide10Freq(N)    writeGEQFreqCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide10Freq       wroteGEQFreqCh(4, 9, GEQ_MAXNUMBANDS)
#define  readGEQWide10Level       readGEQLevelCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQWide10Level(N)   writeGEQLevelCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide10Level      wroteGEQLevelCh(4, 9, GEQ_MAXNUMBANDS)
#define  readGEQWide10Width       readGEQWidthCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQWide10Width(N)   writeGEQWidthCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide10Width      wroteGEQWidthCh(4, 9, GEQ_MAXNUMBANDS)

#define  readGEQWide11Freq        readGEQFreqCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQWide11Freq(N)    writeGEQFreqCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide11Freq       wroteGEQFreqCh(4, 10, GEQ_MAXNUMBANDS)
#define  readGEQWide11Level       readGEQLevelCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQWide11Level(N)   writeGEQLevelCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide11Level      wroteGEQLevelCh(4, 10, GEQ_MAXNUMBANDS)
#define  readGEQWide11Width       readGEQWidthCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQWide11Width(N)   writeGEQWidthCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide11Width      wroteGEQWidthCh(4, 10, GEQ_MAXNUMBANDS)

#define  readGEQWide12Freq        readGEQFreqCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQWide12Freq(N)    writeGEQFreqCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide12Freq       wroteGEQFreqCh(4, 11, GEQ_MAXNUMBANDS)
#define  readGEQWide12Level       readGEQLevelCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQWide12Level(N)   writeGEQLevelCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide12Level      wroteGEQLevelCh(4, 11, GEQ_MAXNUMBANDS)
#define  readGEQWide12Width       readGEQWidthCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQWide12Width(N)   writeGEQWidthCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide12Width      wroteGEQWidthCh(4, 11, GEQ_MAXNUMBANDS)

#define  readGEQWide13Freq        readGEQFreqCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQWide13Freq(N)    writeGEQFreqCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide13Freq       wroteGEQFreqCh(4, 12, GEQ_MAXNUMBANDS)
#define  readGEQWide13Level       readGEQLevelCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQWide13Level(N)   writeGEQLevelCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide13Level      wroteGEQLevelCh(4, 12, GEQ_MAXNUMBANDS)
#define  readGEQWide13Width       readGEQWidthCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQWide13Width(N)   writeGEQWidthCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide13Width      wroteGEQWidthCh(4, 12, GEQ_MAXNUMBANDS)

#define  readGEQWide14Freq        readGEQFreqCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQWide14Freq(N)    writeGEQFreqCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide14Freq       wroteGEQFreqCh(4, 13, GEQ_MAXNUMBANDS)
#define  readGEQWide14Level       readGEQLevelCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQWide14Level(N)   writeGEQLevelCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide14Level      wroteGEQLevelCh(4, 13, GEQ_MAXNUMBANDS)
#define  readGEQWide14Width       readGEQWidthCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQWide14Width(N)   writeGEQWidthCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide14Width      wroteGEQWidthCh(4, 13, GEQ_MAXNUMBANDS)

#define  readGEQWide15Freq        readGEQFreqCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQWide15Freq(N)    writeGEQFreqCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide15Freq       wroteGEQFreqCh(4, 14, GEQ_MAXNUMBANDS)
#define  readGEQWide15Level       readGEQLevelCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQWide15Level(N)   writeGEQLevelCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide15Level      wroteGEQLevelCh(4, 14, GEQ_MAXNUMBANDS)
#define  readGEQWide15Width       readGEQWidthCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQWide15Width(N)   writeGEQWidthCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide15Width      wroteGEQWidthCh(4, 14, GEQ_MAXNUMBANDS)

#define  readGEQWide16Freq        readGEQFreqCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQWide16Freq(N)    writeGEQFreqCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide16Freq       wroteGEQFreqCh(4, 15, GEQ_MAXNUMBANDS)
#define  readGEQWide16Level       readGEQLevelCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQWide16Level(N)   writeGEQLevelCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide16Level      wroteGEQLevelCh(4, 15, GEQ_MAXNUMBANDS)
#define  readGEQWide16Width       readGEQWidthCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQWide16Width(N)   writeGEQWidthCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide16Width      wroteGEQWidthCh(4, 15, GEQ_MAXNUMBANDS)

#define  readGEQWide17Freq        readGEQFreqCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQWide17Freq(N)    writeGEQFreqCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide17Freq       wroteGEQFreqCh(4, 16, GEQ_MAXNUMBANDS)
#define  readGEQWide17Level       readGEQLevelCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQWide17Level(N)   writeGEQLevelCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide17Level      wroteGEQLevelCh(4, 16, GEQ_MAXNUMBANDS)
#define  readGEQWide17Width       readGEQWidthCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQWide17Width(N)   writeGEQWidthCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide17Width      wroteGEQWidthCh(4, 16, GEQ_MAXNUMBANDS)

#define  readGEQWide18Freq        readGEQFreqCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQWide18Freq(N)    writeGEQFreqCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide18Freq       wroteGEQFreqCh(4, 17, GEQ_MAXNUMBANDS)
#define  readGEQWide18Level       readGEQLevelCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQWide18Level(N)   writeGEQLevelCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide18Level      wroteGEQLevelCh(4, 17, GEQ_MAXNUMBANDS)
#define  readGEQWide18Width       readGEQWidthCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQWide18Width(N)   writeGEQWidthCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide18Width      wroteGEQWidthCh(4, 17, GEQ_MAXNUMBANDS)

#define  readGEQWide19Freq        readGEQFreqCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQWide19Freq(N)    writeGEQFreqCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide19Freq       wroteGEQFreqCh(4, 18, GEQ_MAXNUMBANDS)
#define  readGEQWide19Level       readGEQLevelCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQWide19Level(N)   writeGEQLevelCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide19Level      wroteGEQLevelCh(4, 18, GEQ_MAXNUMBANDS)
#define  readGEQWide19Width       readGEQWidthCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQWide19Width(N)   writeGEQWidthCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide19Width      wroteGEQWidthCh(4, 18, GEQ_MAXNUMBANDS)

#define  readGEQWide20Freq        readGEQFreqCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQWide20Freq(N)    writeGEQFreqCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide20Freq       wroteGEQFreqCh(4, 19, GEQ_MAXNUMBANDS)
#define  readGEQWide20Level       readGEQLevelCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQWide20Level(N)   writeGEQLevelCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide20Level      wroteGEQLevelCh(4, 19, GEQ_MAXNUMBANDS)
#define  readGEQWide20Width       readGEQWidthCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQWide20Width(N)   writeGEQWidthCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide20Width      wroteGEQWidthCh(4, 19, GEQ_MAXNUMBANDS)

#define  readGEQWide21Freq        readGEQFreqCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQWide21Freq(N)    writeGEQFreqCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide21Freq       wroteGEQFreqCh(4, 20, GEQ_MAXNUMBANDS)
#define  readGEQWide21Level       readGEQLevelCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQWide21Level(N)   writeGEQLevelCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide21Level      wroteGEQLevelCh(4, 20, GEQ_MAXNUMBANDS)
#define  readGEQWide21Width       readGEQWidthCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQWide21Width(N)   writeGEQWidthCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide21Width      wroteGEQWidthCh(4, 20, GEQ_MAXNUMBANDS)

#define  readGEQWide22Freq        readGEQFreqCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQWide22Freq(N)    writeGEQFreqCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide22Freq       wroteGEQFreqCh(4, 21, GEQ_MAXNUMBANDS)
#define  readGEQWide22Level       readGEQLevelCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQWide22Level(N)   writeGEQLevelCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide22Level      wroteGEQLevelCh(4, 21, GEQ_MAXNUMBANDS)
#define  readGEQWide22Width       readGEQWidthCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQWide22Width(N)   writeGEQWidthCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide22Width      wroteGEQWidthCh(4, 21, GEQ_MAXNUMBANDS)

#define  readGEQWide23Freq        readGEQFreqCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQWide23Freq(N)    writeGEQFreqCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide23Freq       wroteGEQFreqCh(4, 22, GEQ_MAXNUMBANDS)
#define  readGEQWide23Level       readGEQLevelCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQWide23Level(N)   writeGEQLevelCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide23Level      wroteGEQLevelCh(4, 22, GEQ_MAXNUMBANDS)
#define  readGEQWide23Width       readGEQWidthCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQWide23Width(N)   writeGEQWidthCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide23Width      wroteGEQWidthCh(4, 22, GEQ_MAXNUMBANDS)

#define  readGEQWide24Freq        readGEQFreqCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQWide24Freq(N)    writeGEQFreqCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide24Freq       wroteGEQFreqCh(4, 23, GEQ_MAXNUMBANDS)
#define  readGEQWide24Level       readGEQLevelCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQWide24Level(N)   writeGEQLevelCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide24Level      wroteGEQLevelCh(4, 23, GEQ_MAXNUMBANDS)
#define  readGEQWide24Width       readGEQWidthCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQWide24Width(N)   writeGEQWidthCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide24Width      wroteGEQWidthCh(4, 23, GEQ_MAXNUMBANDS)

#define  readGEQWide25Freq        readGEQFreqCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQWide25Freq(N)    writeGEQFreqCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide25Freq       wroteGEQFreqCh(4, 24, GEQ_MAXNUMBANDS)
#define  readGEQWide25Level       readGEQLevelCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQWide25Level(N)   writeGEQLevelCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide25Level      wroteGEQLevelCh(4, 24, GEQ_MAXNUMBANDS)
#define  readGEQWide25Width       readGEQWidthCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQWide25Width(N)   writeGEQWidthCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide25Width      wroteGEQWidthCh(4, 24, GEQ_MAXNUMBANDS)

#define  readGEQWide26Freq        readGEQFreqCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQWide26Freq(N)    writeGEQFreqCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide26Freq       wroteGEQFreqCh(4, 25, GEQ_MAXNUMBANDS)
#define  readGEQWide26Level       readGEQLevelCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQWide26Level(N)   writeGEQLevelCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide26Level      wroteGEQLevelCh(4, 25, GEQ_MAXNUMBANDS)
#define  readGEQWide26Width       readGEQWidthCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQWide26Width(N)   writeGEQWidthCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide26Width      wroteGEQWidthCh(4, 25, GEQ_MAXNUMBANDS)

#define  readGEQWide27Freq        readGEQFreqCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQWide27Freq(N)    writeGEQFreqCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide27Freq       wroteGEQFreqCh(4, 26, GEQ_MAXNUMBANDS)
#define  readGEQWide27Level       readGEQLevelCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQWide27Level(N)   writeGEQLevelCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide27Level      wroteGEQLevelCh(4, 26, GEQ_MAXNUMBANDS)
#define  readGEQWide27Width       readGEQWidthCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQWide27Width(N)   writeGEQWidthCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide27Width      wroteGEQWidthCh(4, 26, GEQ_MAXNUMBANDS)

#define  readGEQWide28Freq        readGEQFreqCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQWide28Freq(N)    writeGEQFreqCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide28Freq       wroteGEQFreqCh(4, 27, GEQ_MAXNUMBANDS)
#define  readGEQWide28Level       readGEQLevelCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQWide28Level(N)   writeGEQLevelCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide28Level      wroteGEQLevelCh(4, 27, GEQ_MAXNUMBANDS)
#define  readGEQWide28Width       readGEQWidthCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQWide28Width(N)   writeGEQWidthCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide28Width      wroteGEQWidthCh(4, 27, GEQ_MAXNUMBANDS)

#define  readGEQWide29Freq        readGEQFreqCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQWide29Freq(N)    writeGEQFreqCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide29Freq       wroteGEQFreqCh(4, 28, GEQ_MAXNUMBANDS)
#define  readGEQWide29Level       readGEQLevelCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQWide29Level(N)   writeGEQLevelCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide29Level      wroteGEQLevelCh(4, 28, GEQ_MAXNUMBANDS)
#define  readGEQWide29Width       readGEQWidthCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQWide29Width(N)   writeGEQWidthCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide29Width      wroteGEQWidthCh(4, 28, GEQ_MAXNUMBANDS)

#define  readGEQWide30Freq        readGEQFreqCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQWide30Freq(N)    writeGEQFreqCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide30Freq       wroteGEQFreqCh(4, 29, GEQ_MAXNUMBANDS)
#define  readGEQWide30Level       readGEQLevelCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQWide30Level(N)   writeGEQLevelCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide30Level      wroteGEQLevelCh(4, 29, GEQ_MAXNUMBANDS)
#define  readGEQWide30Width       readGEQWidthCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQWide30Width(N)   writeGEQWidthCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide30Width      wroteGEQWidthCh(4, 29, GEQ_MAXNUMBANDS)

#define  readGEQWide31Freq        readGEQFreqCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQWide31Freq(N)    writeGEQFreqCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide31Freq       wroteGEQFreqCh(4, 30, GEQ_MAXNUMBANDS)
#define  readGEQWide31Level       readGEQLevelCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQWide31Level(N)   writeGEQLevelCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide31Level      wroteGEQLevelCh(4, 30, GEQ_MAXNUMBANDS)
#define  readGEQWide31Width       readGEQWidthCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQWide31Width(N)   writeGEQWidthCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide31Width      wroteGEQWidthCh(4, 30, GEQ_MAXNUMBANDS)

#define  readGEQWide32Freq        readGEQFreqCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQWide32Freq(N)    writeGEQFreqCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide32Freq       wroteGEQFreqCh(4, 31, GEQ_MAXNUMBANDS)
#define  readGEQWide32Level       readGEQLevelCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQWide32Level(N)   writeGEQLevelCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide32Level      wroteGEQLevelCh(4, 31, GEQ_MAXNUMBANDS)
#define  readGEQWide32Width       readGEQWidthCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQWide32Width(N)   writeGEQWidthCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQWide32Width      wroteGEQWidthCh(4, 31, GEQ_MAXNUMBANDS)

#define  readGEQLwid1Freq        readGEQFreqCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQLwid1Freq(N)    writeGEQFreqCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid1Freq       wroteGEQFreqCh(4, 0, GEQ_MAXNUMBANDS)
#define  readGEQLwid1Level       readGEQLevelCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQLwid1Level(N)   writeGEQLevelCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid1Level      wroteGEQLevelCh(4, 0, GEQ_MAXNUMBANDS)
#define  readGEQLwid1Width       readGEQWidthCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQLwid1Width(N)   writeGEQWidthCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid1Width      wroteGEQWidthCh(4, 0, GEQ_MAXNUMBANDS)

#define  readGEQLwid2Freq        readGEQFreqCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQLwid2Freq(N)    writeGEQFreqCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid2Freq       wroteGEQFreqCh(4, 1, GEQ_MAXNUMBANDS)
#define  readGEQLwid2Level       readGEQLevelCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQLwid2Level(N)   writeGEQLevelCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid2Level      wroteGEQLevelCh(4, 1, GEQ_MAXNUMBANDS)
#define  readGEQLwid2Width       readGEQWidthCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQLwid2Width(N)   writeGEQWidthCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid2Width      wroteGEQWidthCh(4, 1, GEQ_MAXNUMBANDS)

#define  readGEQLwid3Freq        readGEQFreqCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQLwid3Freq(N)    writeGEQFreqCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid3Freq       wroteGEQFreqCh(4, 2, GEQ_MAXNUMBANDS)
#define  readGEQLwid3Level       readGEQLevelCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQLwid3Level(N)   writeGEQLevelCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid3Level      wroteGEQLevelCh(4, 2, GEQ_MAXNUMBANDS)
#define  readGEQLwid3Width       readGEQWidthCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQLwid3Width(N)   writeGEQWidthCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid3Width      wroteGEQWidthCh(4, 2, GEQ_MAXNUMBANDS)

#define  readGEQLwid4Freq        readGEQFreqCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQLwid4Freq(N)    writeGEQFreqCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid4Freq       wroteGEQFreqCh(4, 3, GEQ_MAXNUMBANDS)
#define  readGEQLwid4Level       readGEQLevelCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQLwid4Level(N)   writeGEQLevelCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid4Level      wroteGEQLevelCh(4, 3, GEQ_MAXNUMBANDS)
#define  readGEQLwid4Width       readGEQWidthCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQLwid4Width(N)   writeGEQWidthCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid4Width      wroteGEQWidthCh(4, 3, GEQ_MAXNUMBANDS)

#define  readGEQLwid5Freq        readGEQFreqCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQLwid5Freq(N)    writeGEQFreqCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid5Freq       wroteGEQFreqCh(4, 4, GEQ_MAXNUMBANDS)
#define  readGEQLwid5Level       readGEQLevelCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQLwid5Level(N)   writeGEQLevelCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid5Level      wroteGEQLevelCh(4, 4, GEQ_MAXNUMBANDS)
#define  readGEQLwid5Width       readGEQWidthCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQLwid5Width(N)   writeGEQWidthCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid5Width      wroteGEQWidthCh(4, 4, GEQ_MAXNUMBANDS)

#define  readGEQLwid6Freq        readGEQFreqCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQLwid6Freq(N)    writeGEQFreqCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid6Freq       wroteGEQFreqCh(4, 5, GEQ_MAXNUMBANDS)
#define  readGEQLwid6Level       readGEQLevelCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQLwid6Level(N)   writeGEQLevelCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid6Level      wroteGEQLevelCh(4, 5, GEQ_MAXNUMBANDS)
#define  readGEQLwid6Width       readGEQWidthCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQLwid6Width(N)   writeGEQWidthCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid6Width      wroteGEQWidthCh(4, 5, GEQ_MAXNUMBANDS)

#define  readGEQLwid7Freq        readGEQFreqCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQLwid7Freq(N)    writeGEQFreqCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid7Freq       wroteGEQFreqCh(4, 6, GEQ_MAXNUMBANDS)
#define  readGEQLwid7Level       readGEQLevelCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQLwid7Level(N)   writeGEQLevelCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid7Level      wroteGEQLevelCh(4, 6, GEQ_MAXNUMBANDS)
#define  readGEQLwid7Width       readGEQWidthCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQLwid7Width(N)   writeGEQWidthCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid7Width      wroteGEQWidthCh(4, 6, GEQ_MAXNUMBANDS)

#define  readGEQLwid8Freq        readGEQFreqCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQLwid8Freq(N)    writeGEQFreqCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid8Freq       wroteGEQFreqCh(4, 7, GEQ_MAXNUMBANDS)
#define  readGEQLwid8Level       readGEQLevelCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQLwid8Level(N)   writeGEQLevelCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid8Level      wroteGEQLevelCh(4, 7, GEQ_MAXNUMBANDS)
#define  readGEQLwid8Width       readGEQWidthCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQLwid8Width(N)   writeGEQWidthCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid8Width      wroteGEQWidthCh(4, 7, GEQ_MAXNUMBANDS)

#define  readGEQLwid9Freq        readGEQFreqCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQLwid9Freq(N)    writeGEQFreqCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid9Freq       wroteGEQFreqCh(4, 8, GEQ_MAXNUMBANDS)
#define  readGEQLwid9Level       readGEQLevelCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQLwid9Level(N)   writeGEQLevelCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid9Level      wroteGEQLevelCh(4, 8, GEQ_MAXNUMBANDS)
#define  readGEQLwid9Width       readGEQWidthCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQLwid9Width(N)   writeGEQWidthCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid9Width      wroteGEQWidthCh(4, 8, GEQ_MAXNUMBANDS)

#define  readGEQLwid10Freq        readGEQFreqCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQLwid10Freq(N)    writeGEQFreqCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid10Freq       wroteGEQFreqCh(4, 9, GEQ_MAXNUMBANDS)
#define  readGEQLwid10Level       readGEQLevelCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQLwid10Level(N)   writeGEQLevelCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid10Level      wroteGEQLevelCh(4, 9, GEQ_MAXNUMBANDS)
#define  readGEQLwid10Width       readGEQWidthCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQLwid10Width(N)   writeGEQWidthCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid10Width      wroteGEQWidthCh(4, 9, GEQ_MAXNUMBANDS)

#define  readGEQLwid11Freq        readGEQFreqCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQLwid11Freq(N)    writeGEQFreqCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid11Freq       wroteGEQFreqCh(4, 10, GEQ_MAXNUMBANDS)
#define  readGEQLwid11Level       readGEQLevelCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQLwid11Level(N)   writeGEQLevelCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid11Level      wroteGEQLevelCh(4, 10, GEQ_MAXNUMBANDS)
#define  readGEQLwid11Width       readGEQWidthCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQLwid11Width(N)   writeGEQWidthCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid11Width      wroteGEQWidthCh(4, 10, GEQ_MAXNUMBANDS)

#define  readGEQLwid12Freq        readGEQFreqCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQLwid12Freq(N)    writeGEQFreqCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid12Freq       wroteGEQFreqCh(4, 11, GEQ_MAXNUMBANDS)
#define  readGEQLwid12Level       readGEQLevelCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQLwid12Level(N)   writeGEQLevelCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid12Level      wroteGEQLevelCh(4, 11, GEQ_MAXNUMBANDS)
#define  readGEQLwid12Width       readGEQWidthCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQLwid12Width(N)   writeGEQWidthCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid12Width      wroteGEQWidthCh(4, 11, GEQ_MAXNUMBANDS)

#define  readGEQLwid13Freq        readGEQFreqCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQLwid13Freq(N)    writeGEQFreqCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid13Freq       wroteGEQFreqCh(4, 12, GEQ_MAXNUMBANDS)
#define  readGEQLwid13Level       readGEQLevelCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQLwid13Level(N)   writeGEQLevelCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid13Level      wroteGEQLevelCh(4, 12, GEQ_MAXNUMBANDS)
#define  readGEQLwid13Width       readGEQWidthCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQLwid13Width(N)   writeGEQWidthCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid13Width      wroteGEQWidthCh(4, 12, GEQ_MAXNUMBANDS)

#define  readGEQLwid14Freq        readGEQFreqCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQLwid14Freq(N)    writeGEQFreqCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid14Freq       wroteGEQFreqCh(4, 13, GEQ_MAXNUMBANDS)
#define  readGEQLwid14Level       readGEQLevelCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQLwid14Level(N)   writeGEQLevelCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid14Level      wroteGEQLevelCh(4, 13, GEQ_MAXNUMBANDS)
#define  readGEQLwid14Width       readGEQWidthCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQLwid14Width(N)   writeGEQWidthCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid14Width      wroteGEQWidthCh(4, 13, GEQ_MAXNUMBANDS)

#define  readGEQLwid15Freq        readGEQFreqCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQLwid15Freq(N)    writeGEQFreqCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid15Freq       wroteGEQFreqCh(4, 14, GEQ_MAXNUMBANDS)
#define  readGEQLwid15Level       readGEQLevelCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQLwid15Level(N)   writeGEQLevelCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid15Level      wroteGEQLevelCh(4, 14, GEQ_MAXNUMBANDS)
#define  readGEQLwid15Width       readGEQWidthCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQLwid15Width(N)   writeGEQWidthCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid15Width      wroteGEQWidthCh(4, 14, GEQ_MAXNUMBANDS)

#define  readGEQLwid16Freq        readGEQFreqCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQLwid16Freq(N)    writeGEQFreqCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid16Freq       wroteGEQFreqCh(4, 15, GEQ_MAXNUMBANDS)
#define  readGEQLwid16Level       readGEQLevelCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQLwid16Level(N)   writeGEQLevelCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid16Level      wroteGEQLevelCh(4, 15, GEQ_MAXNUMBANDS)
#define  readGEQLwid16Width       readGEQWidthCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQLwid16Width(N)   writeGEQWidthCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid16Width      wroteGEQWidthCh(4, 15, GEQ_MAXNUMBANDS)

#define  readGEQLwid17Freq        readGEQFreqCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQLwid17Freq(N)    writeGEQFreqCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid17Freq       wroteGEQFreqCh(4, 16, GEQ_MAXNUMBANDS)
#define  readGEQLwid17Level       readGEQLevelCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQLwid17Level(N)   writeGEQLevelCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid17Level      wroteGEQLevelCh(4, 16, GEQ_MAXNUMBANDS)
#define  readGEQLwid17Width       readGEQWidthCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQLwid17Width(N)   writeGEQWidthCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid17Width      wroteGEQWidthCh(4, 16, GEQ_MAXNUMBANDS)

#define  readGEQLwid18Freq        readGEQFreqCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQLwid18Freq(N)    writeGEQFreqCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid18Freq       wroteGEQFreqCh(4, 17, GEQ_MAXNUMBANDS)
#define  readGEQLwid18Level       readGEQLevelCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQLwid18Level(N)   writeGEQLevelCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid18Level      wroteGEQLevelCh(4, 17, GEQ_MAXNUMBANDS)
#define  readGEQLwid18Width       readGEQWidthCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQLwid18Width(N)   writeGEQWidthCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid18Width      wroteGEQWidthCh(4, 17, GEQ_MAXNUMBANDS)

#define  readGEQLwid19Freq        readGEQFreqCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQLwid19Freq(N)    writeGEQFreqCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid19Freq       wroteGEQFreqCh(4, 18, GEQ_MAXNUMBANDS)
#define  readGEQLwid19Level       readGEQLevelCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQLwid19Level(N)   writeGEQLevelCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid19Level      wroteGEQLevelCh(4, 18, GEQ_MAXNUMBANDS)
#define  readGEQLwid19Width       readGEQWidthCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQLwid19Width(N)   writeGEQWidthCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid19Width      wroteGEQWidthCh(4, 18, GEQ_MAXNUMBANDS)

#define  readGEQLwid20Freq        readGEQFreqCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQLwid20Freq(N)    writeGEQFreqCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid20Freq       wroteGEQFreqCh(4, 19, GEQ_MAXNUMBANDS)
#define  readGEQLwid20Level       readGEQLevelCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQLwid20Level(N)   writeGEQLevelCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid20Level      wroteGEQLevelCh(4, 19, GEQ_MAXNUMBANDS)
#define  readGEQLwid20Width       readGEQWidthCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQLwid20Width(N)   writeGEQWidthCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid20Width      wroteGEQWidthCh(4, 19, GEQ_MAXNUMBANDS)

#define  readGEQLwid21Freq        readGEQFreqCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQLwid21Freq(N)    writeGEQFreqCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid21Freq       wroteGEQFreqCh(4, 20, GEQ_MAXNUMBANDS)
#define  readGEQLwid21Level       readGEQLevelCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQLwid21Level(N)   writeGEQLevelCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid21Level      wroteGEQLevelCh(4, 20, GEQ_MAXNUMBANDS)
#define  readGEQLwid21Width       readGEQWidthCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQLwid21Width(N)   writeGEQWidthCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid21Width      wroteGEQWidthCh(4, 20, GEQ_MAXNUMBANDS)

#define  readGEQLwid22Freq        readGEQFreqCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQLwid22Freq(N)    writeGEQFreqCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid22Freq       wroteGEQFreqCh(4, 21, GEQ_MAXNUMBANDS)
#define  readGEQLwid22Level       readGEQLevelCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQLwid22Level(N)   writeGEQLevelCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid22Level      wroteGEQLevelCh(4, 21, GEQ_MAXNUMBANDS)
#define  readGEQLwid22Width       readGEQWidthCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQLwid22Width(N)   writeGEQWidthCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid22Width      wroteGEQWidthCh(4, 21, GEQ_MAXNUMBANDS)

#define  readGEQLwid23Freq        readGEQFreqCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQLwid23Freq(N)    writeGEQFreqCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid23Freq       wroteGEQFreqCh(4, 22, GEQ_MAXNUMBANDS)
#define  readGEQLwid23Level       readGEQLevelCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQLwid23Level(N)   writeGEQLevelCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid23Level      wroteGEQLevelCh(4, 22, GEQ_MAXNUMBANDS)
#define  readGEQLwid23Width       readGEQWidthCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQLwid23Width(N)   writeGEQWidthCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid23Width      wroteGEQWidthCh(4, 22, GEQ_MAXNUMBANDS)

#define  readGEQLwid24Freq        readGEQFreqCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQLwid24Freq(N)    writeGEQFreqCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid24Freq       wroteGEQFreqCh(4, 23, GEQ_MAXNUMBANDS)
#define  readGEQLwid24Level       readGEQLevelCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQLwid24Level(N)   writeGEQLevelCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid24Level      wroteGEQLevelCh(4, 23, GEQ_MAXNUMBANDS)
#define  readGEQLwid24Width       readGEQWidthCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQLwid24Width(N)   writeGEQWidthCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid24Width      wroteGEQWidthCh(4, 23, GEQ_MAXNUMBANDS)

#define  readGEQLwid25Freq        readGEQFreqCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQLwid25Freq(N)    writeGEQFreqCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid25Freq       wroteGEQFreqCh(4, 24, GEQ_MAXNUMBANDS)
#define  readGEQLwid25Level       readGEQLevelCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQLwid25Level(N)   writeGEQLevelCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid25Level      wroteGEQLevelCh(4, 24, GEQ_MAXNUMBANDS)
#define  readGEQLwid25Width       readGEQWidthCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQLwid25Width(N)   writeGEQWidthCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid25Width      wroteGEQWidthCh(4, 24, GEQ_MAXNUMBANDS)

#define  readGEQLwid26Freq        readGEQFreqCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQLwid26Freq(N)    writeGEQFreqCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid26Freq       wroteGEQFreqCh(4, 25, GEQ_MAXNUMBANDS)
#define  readGEQLwid26Level       readGEQLevelCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQLwid26Level(N)   writeGEQLevelCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid26Level      wroteGEQLevelCh(4, 25, GEQ_MAXNUMBANDS)
#define  readGEQLwid26Width       readGEQWidthCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQLwid26Width(N)   writeGEQWidthCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid26Width      wroteGEQWidthCh(4, 25, GEQ_MAXNUMBANDS)

#define  readGEQLwid27Freq        readGEQFreqCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQLwid27Freq(N)    writeGEQFreqCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid27Freq       wroteGEQFreqCh(4, 26, GEQ_MAXNUMBANDS)
#define  readGEQLwid27Level       readGEQLevelCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQLwid27Level(N)   writeGEQLevelCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid27Level      wroteGEQLevelCh(4, 26, GEQ_MAXNUMBANDS)
#define  readGEQLwid27Width       readGEQWidthCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQLwid27Width(N)   writeGEQWidthCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid27Width      wroteGEQWidthCh(4, 26, GEQ_MAXNUMBANDS)

#define  readGEQLwid28Freq        readGEQFreqCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQLwid28Freq(N)    writeGEQFreqCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid28Freq       wroteGEQFreqCh(4, 27, GEQ_MAXNUMBANDS)
#define  readGEQLwid28Level       readGEQLevelCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQLwid28Level(N)   writeGEQLevelCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid28Level      wroteGEQLevelCh(4, 27, GEQ_MAXNUMBANDS)
#define  readGEQLwid28Width       readGEQWidthCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQLwid28Width(N)   writeGEQWidthCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid28Width      wroteGEQWidthCh(4, 27, GEQ_MAXNUMBANDS)

#define  readGEQLwid29Freq        readGEQFreqCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQLwid29Freq(N)    writeGEQFreqCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid29Freq       wroteGEQFreqCh(4, 28, GEQ_MAXNUMBANDS)
#define  readGEQLwid29Level       readGEQLevelCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQLwid29Level(N)   writeGEQLevelCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid29Level      wroteGEQLevelCh(4, 28, GEQ_MAXNUMBANDS)
#define  readGEQLwid29Width       readGEQWidthCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQLwid29Width(N)   writeGEQWidthCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid29Width      wroteGEQWidthCh(4, 28, GEQ_MAXNUMBANDS)

#define  readGEQLwid30Freq        readGEQFreqCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQLwid30Freq(N)    writeGEQFreqCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid30Freq       wroteGEQFreqCh(4, 29, GEQ_MAXNUMBANDS)
#define  readGEQLwid30Level       readGEQLevelCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQLwid30Level(N)   writeGEQLevelCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid30Level      wroteGEQLevelCh(4, 29, GEQ_MAXNUMBANDS)
#define  readGEQLwid30Width       readGEQWidthCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQLwid30Width(N)   writeGEQWidthCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid30Width      wroteGEQWidthCh(4, 29, GEQ_MAXNUMBANDS)

#define  readGEQLwid31Freq        readGEQFreqCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQLwid31Freq(N)    writeGEQFreqCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid31Freq       wroteGEQFreqCh(4, 30, GEQ_MAXNUMBANDS)
#define  readGEQLwid31Level       readGEQLevelCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQLwid31Level(N)   writeGEQLevelCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid31Level      wroteGEQLevelCh(4, 30, GEQ_MAXNUMBANDS)
#define  readGEQLwid31Width       readGEQWidthCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQLwid31Width(N)   writeGEQWidthCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid31Width      wroteGEQWidthCh(4, 30, GEQ_MAXNUMBANDS)

#define  readGEQLwid32Freq        readGEQFreqCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQLwid32Freq(N)    writeGEQFreqCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid32Freq       wroteGEQFreqCh(4, 31, GEQ_MAXNUMBANDS)
#define  readGEQLwid32Level       readGEQLevelCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQLwid32Level(N)   writeGEQLevelCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid32Level      wroteGEQLevelCh(4, 31, GEQ_MAXNUMBANDS)
#define  readGEQLwid32Width       readGEQWidthCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQLwid32Width(N)   writeGEQWidthCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLwid32Width      wroteGEQWidthCh(4, 31, GEQ_MAXNUMBANDS)

#define  readGEQRwid1Freq        readGEQFreqCh(5, 0, GEQ_MAXNUMBANDS)
#define writeGEQRwid1Freq(N)    writeGEQFreqCh(5, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid1Freq       wroteGEQFreqCh(5, 0, GEQ_MAXNUMBANDS)
#define  readGEQRwid1Level       readGEQLevelCh(5, 0, GEQ_MAXNUMBANDS)
#define writeGEQRwid1Level(N)   writeGEQLevelCh(5, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid1Level      wroteGEQLevelCh(5, 0, GEQ_MAXNUMBANDS)
#define  readGEQRwid1Width       readGEQWidthCh(5, 0, GEQ_MAXNUMBANDS)
#define writeGEQRwid1Width(N)   writeGEQWidthCh(5, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid1Width      wroteGEQWidthCh(5, 0, GEQ_MAXNUMBANDS)

#define  readGEQRwid2Freq        readGEQFreqCh(5, 1, GEQ_MAXNUMBANDS)
#define writeGEQRwid2Freq(N)    writeGEQFreqCh(5, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid2Freq       wroteGEQFreqCh(5, 1, GEQ_MAXNUMBANDS)
#define  readGEQRwid2Level       readGEQLevelCh(5, 1, GEQ_MAXNUMBANDS)
#define writeGEQRwid2Level(N)   writeGEQLevelCh(5, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid2Level      wroteGEQLevelCh(5, 1, GEQ_MAXNUMBANDS)
#define  readGEQRwid2Width       readGEQWidthCh(5, 1, GEQ_MAXNUMBANDS)
#define writeGEQRwid2Width(N)   writeGEQWidthCh(5, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid2Width      wroteGEQWidthCh(5, 1, GEQ_MAXNUMBANDS)

#define  readGEQRwid3Freq        readGEQFreqCh(5, 2, GEQ_MAXNUMBANDS)
#define writeGEQRwid3Freq(N)    writeGEQFreqCh(5, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid3Freq       wroteGEQFreqCh(5, 2, GEQ_MAXNUMBANDS)
#define  readGEQRwid3Level       readGEQLevelCh(5, 2, GEQ_MAXNUMBANDS)
#define writeGEQRwid3Level(N)   writeGEQLevelCh(5, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid3Level      wroteGEQLevelCh(5, 2, GEQ_MAXNUMBANDS)
#define  readGEQRwid3Width       readGEQWidthCh(5, 2, GEQ_MAXNUMBANDS)
#define writeGEQRwid3Width(N)   writeGEQWidthCh(5, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid3Width      wroteGEQWidthCh(5, 2, GEQ_MAXNUMBANDS)

#define  readGEQRwid4Freq        readGEQFreqCh(5, 3, GEQ_MAXNUMBANDS)
#define writeGEQRwid4Freq(N)    writeGEQFreqCh(5, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid4Freq       wroteGEQFreqCh(5, 3, GEQ_MAXNUMBANDS)
#define  readGEQRwid4Level       readGEQLevelCh(5, 3, GEQ_MAXNUMBANDS)
#define writeGEQRwid4Level(N)   writeGEQLevelCh(5, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid4Level      wroteGEQLevelCh(5, 3, GEQ_MAXNUMBANDS)
#define  readGEQRwid4Width       readGEQWidthCh(5, 3, GEQ_MAXNUMBANDS)
#define writeGEQRwid4Width(N)   writeGEQWidthCh(5, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid4Width      wroteGEQWidthCh(5, 3, GEQ_MAXNUMBANDS)

#define  readGEQRwid5Freq        readGEQFreqCh(5, 4, GEQ_MAXNUMBANDS)
#define writeGEQRwid5Freq(N)    writeGEQFreqCh(5, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid5Freq       wroteGEQFreqCh(5, 4, GEQ_MAXNUMBANDS)
#define  readGEQRwid5Level       readGEQLevelCh(5, 4, GEQ_MAXNUMBANDS)
#define writeGEQRwid5Level(N)   writeGEQLevelCh(5, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid5Level      wroteGEQLevelCh(5, 4, GEQ_MAXNUMBANDS)
#define  readGEQRwid5Width       readGEQWidthCh(5, 4, GEQ_MAXNUMBANDS)
#define writeGEQRwid5Width(N)   writeGEQWidthCh(5, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid5Width      wroteGEQWidthCh(5, 4, GEQ_MAXNUMBANDS)

#define  readGEQRwid6Freq        readGEQFreqCh(5, 5, GEQ_MAXNUMBANDS)
#define writeGEQRwid6Freq(N)    writeGEQFreqCh(5, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid6Freq       wroteGEQFreqCh(5, 5, GEQ_MAXNUMBANDS)
#define  readGEQRwid6Level       readGEQLevelCh(5, 5, GEQ_MAXNUMBANDS)
#define writeGEQRwid6Level(N)   writeGEQLevelCh(5, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid6Level      wroteGEQLevelCh(5, 5, GEQ_MAXNUMBANDS)
#define  readGEQRwid6Width       readGEQWidthCh(5, 5, GEQ_MAXNUMBANDS)
#define writeGEQRwid6Width(N)   writeGEQWidthCh(5, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid6Width      wroteGEQWidthCh(5, 5, GEQ_MAXNUMBANDS)

#define  readGEQRwid7Freq        readGEQFreqCh(5, 6, GEQ_MAXNUMBANDS)
#define writeGEQRwid7Freq(N)    writeGEQFreqCh(5, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid7Freq       wroteGEQFreqCh(5, 6, GEQ_MAXNUMBANDS)
#define  readGEQRwid7Level       readGEQLevelCh(5, 6, GEQ_MAXNUMBANDS)
#define writeGEQRwid7Level(N)   writeGEQLevelCh(5, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid7Level      wroteGEQLevelCh(5, 6, GEQ_MAXNUMBANDS)
#define  readGEQRwid7Width       readGEQWidthCh(5, 6, GEQ_MAXNUMBANDS)
#define writeGEQRwid7Width(N)   writeGEQWidthCh(5, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid7Width      wroteGEQWidthCh(5, 6, GEQ_MAXNUMBANDS)

#define  readGEQRwid8Freq        readGEQFreqCh(5, 7, GEQ_MAXNUMBANDS)
#define writeGEQRwid8Freq(N)    writeGEQFreqCh(5, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid8Freq       wroteGEQFreqCh(5, 7, GEQ_MAXNUMBANDS)
#define  readGEQRwid8Level       readGEQLevelCh(5, 7, GEQ_MAXNUMBANDS)
#define writeGEQRwid8Level(N)   writeGEQLevelCh(5, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid8Level      wroteGEQLevelCh(5, 7, GEQ_MAXNUMBANDS)
#define  readGEQRwid8Width       readGEQWidthCh(5, 7, GEQ_MAXNUMBANDS)
#define writeGEQRwid8Width(N)   writeGEQWidthCh(5, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid8Width      wroteGEQWidthCh(5, 7, GEQ_MAXNUMBANDS)

#define  readGEQRwid9Freq        readGEQFreqCh(5, 8, GEQ_MAXNUMBANDS)
#define writeGEQRwid9Freq(N)    writeGEQFreqCh(5, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid9Freq       wroteGEQFreqCh(5, 8, GEQ_MAXNUMBANDS)
#define  readGEQRwid9Level       readGEQLevelCh(5, 8, GEQ_MAXNUMBANDS)
#define writeGEQRwid9Level(N)   writeGEQLevelCh(5, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid9Level      wroteGEQLevelCh(5, 8, GEQ_MAXNUMBANDS)
#define  readGEQRwid9Width       readGEQWidthCh(5, 8, GEQ_MAXNUMBANDS)
#define writeGEQRwid9Width(N)   writeGEQWidthCh(5, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid9Width      wroteGEQWidthCh(5, 8, GEQ_MAXNUMBANDS)

#define  readGEQRwid10Freq        readGEQFreqCh(5, 9, GEQ_MAXNUMBANDS)
#define writeGEQRwid10Freq(N)    writeGEQFreqCh(5, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid10Freq       wroteGEQFreqCh(5, 9, GEQ_MAXNUMBANDS)
#define  readGEQRwid10Level       readGEQLevelCh(5, 9, GEQ_MAXNUMBANDS)
#define writeGEQRwid10Level(N)   writeGEQLevelCh(5, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid10Level      wroteGEQLevelCh(5, 9, GEQ_MAXNUMBANDS)
#define  readGEQRwid10Width       readGEQWidthCh(5, 9, GEQ_MAXNUMBANDS)
#define writeGEQRwid10Width(N)   writeGEQWidthCh(5, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid10Width      wroteGEQWidthCh(5, 9, GEQ_MAXNUMBANDS)

#define  readGEQRwid11Freq        readGEQFreqCh(5, 10, GEQ_MAXNUMBANDS)
#define writeGEQRwid11Freq(N)    writeGEQFreqCh(5, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid11Freq       wroteGEQFreqCh(5, 10, GEQ_MAXNUMBANDS)
#define  readGEQRwid11Level       readGEQLevelCh(5, 10, GEQ_MAXNUMBANDS)
#define writeGEQRwid11Level(N)   writeGEQLevelCh(5, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid11Level      wroteGEQLevelCh(5, 10, GEQ_MAXNUMBANDS)
#define  readGEQRwid11Width       readGEQWidthCh(5, 10, GEQ_MAXNUMBANDS)
#define writeGEQRwid11Width(N)   writeGEQWidthCh(5, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid11Width      wroteGEQWidthCh(5, 10, GEQ_MAXNUMBANDS)

#define  readGEQRwid12Freq        readGEQFreqCh(5, 11, GEQ_MAXNUMBANDS)
#define writeGEQRwid12Freq(N)    writeGEQFreqCh(5, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid12Freq       wroteGEQFreqCh(5, 11, GEQ_MAXNUMBANDS)
#define  readGEQRwid12Level       readGEQLevelCh(5, 11, GEQ_MAXNUMBANDS)
#define writeGEQRwid12Level(N)   writeGEQLevelCh(5, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid12Level      wroteGEQLevelCh(5, 11, GEQ_MAXNUMBANDS)
#define  readGEQRwid12Width       readGEQWidthCh(5, 11, GEQ_MAXNUMBANDS)
#define writeGEQRwid12Width(N)   writeGEQWidthCh(5, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid12Width      wroteGEQWidthCh(5, 11, GEQ_MAXNUMBANDS)

#define  readGEQRwid13Freq        readGEQFreqCh(5, 12, GEQ_MAXNUMBANDS)
#define writeGEQRwid13Freq(N)    writeGEQFreqCh(5, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid13Freq       wroteGEQFreqCh(5, 12, GEQ_MAXNUMBANDS)
#define  readGEQRwid13Level       readGEQLevelCh(5, 12, GEQ_MAXNUMBANDS)
#define writeGEQRwid13Level(N)   writeGEQLevelCh(5, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid13Level      wroteGEQLevelCh(5, 12, GEQ_MAXNUMBANDS)
#define  readGEQRwid13Width       readGEQWidthCh(5, 12, GEQ_MAXNUMBANDS)
#define writeGEQRwid13Width(N)   writeGEQWidthCh(5, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid13Width      wroteGEQWidthCh(5, 12, GEQ_MAXNUMBANDS)

#define  readGEQRwid14Freq        readGEQFreqCh(5, 13, GEQ_MAXNUMBANDS)
#define writeGEQRwid14Freq(N)    writeGEQFreqCh(5, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid14Freq       wroteGEQFreqCh(5, 13, GEQ_MAXNUMBANDS)
#define  readGEQRwid14Level       readGEQLevelCh(5, 13, GEQ_MAXNUMBANDS)
#define writeGEQRwid14Level(N)   writeGEQLevelCh(5, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid14Level      wroteGEQLevelCh(5, 13, GEQ_MAXNUMBANDS)
#define  readGEQRwid14Width       readGEQWidthCh(5, 13, GEQ_MAXNUMBANDS)
#define writeGEQRwid14Width(N)   writeGEQWidthCh(5, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid14Width      wroteGEQWidthCh(5, 13, GEQ_MAXNUMBANDS)

#define  readGEQRwid15Freq        readGEQFreqCh(5, 14, GEQ_MAXNUMBANDS)
#define writeGEQRwid15Freq(N)    writeGEQFreqCh(5, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid15Freq       wroteGEQFreqCh(5, 14, GEQ_MAXNUMBANDS)
#define  readGEQRwid15Level       readGEQLevelCh(5, 14, GEQ_MAXNUMBANDS)
#define writeGEQRwid15Level(N)   writeGEQLevelCh(5, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid15Level      wroteGEQLevelCh(5, 14, GEQ_MAXNUMBANDS)
#define  readGEQRwid15Width       readGEQWidthCh(5, 14, GEQ_MAXNUMBANDS)
#define writeGEQRwid15Width(N)   writeGEQWidthCh(5, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid15Width      wroteGEQWidthCh(5, 14, GEQ_MAXNUMBANDS)

#define  readGEQRwid16Freq        readGEQFreqCh(5, 15, GEQ_MAXNUMBANDS)
#define writeGEQRwid16Freq(N)    writeGEQFreqCh(5, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid16Freq       wroteGEQFreqCh(5, 15, GEQ_MAXNUMBANDS)
#define  readGEQRwid16Level       readGEQLevelCh(5, 15, GEQ_MAXNUMBANDS)
#define writeGEQRwid16Level(N)   writeGEQLevelCh(5, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid16Level      wroteGEQLevelCh(5, 15, GEQ_MAXNUMBANDS)
#define  readGEQRwid16Width       readGEQWidthCh(5, 15, GEQ_MAXNUMBANDS)
#define writeGEQRwid16Width(N)   writeGEQWidthCh(5, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid16Width      wroteGEQWidthCh(5, 15, GEQ_MAXNUMBANDS)

#define  readGEQRwid17Freq        readGEQFreqCh(5, 16, GEQ_MAXNUMBANDS)
#define writeGEQRwid17Freq(N)    writeGEQFreqCh(5, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid17Freq       wroteGEQFreqCh(5, 16, GEQ_MAXNUMBANDS)
#define  readGEQRwid17Level       readGEQLevelCh(5, 16, GEQ_MAXNUMBANDS)
#define writeGEQRwid17Level(N)   writeGEQLevelCh(5, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid17Level      wroteGEQLevelCh(5, 16, GEQ_MAXNUMBANDS)
#define  readGEQRwid17Width       readGEQWidthCh(5, 16, GEQ_MAXNUMBANDS)
#define writeGEQRwid17Width(N)   writeGEQWidthCh(5, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid17Width      wroteGEQWidthCh(5, 16, GEQ_MAXNUMBANDS)

#define  readGEQRwid18Freq        readGEQFreqCh(5, 17, GEQ_MAXNUMBANDS)
#define writeGEQRwid18Freq(N)    writeGEQFreqCh(5, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid18Freq       wroteGEQFreqCh(5, 17, GEQ_MAXNUMBANDS)
#define  readGEQRwid18Level       readGEQLevelCh(5, 17, GEQ_MAXNUMBANDS)
#define writeGEQRwid18Level(N)   writeGEQLevelCh(5, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid18Level      wroteGEQLevelCh(5, 17, GEQ_MAXNUMBANDS)
#define  readGEQRwid18Width       readGEQWidthCh(5, 17, GEQ_MAXNUMBANDS)
#define writeGEQRwid18Width(N)   writeGEQWidthCh(5, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid18Width      wroteGEQWidthCh(5, 17, GEQ_MAXNUMBANDS)

#define  readGEQRwid19Freq        readGEQFreqCh(5, 18, GEQ_MAXNUMBANDS)
#define writeGEQRwid19Freq(N)    writeGEQFreqCh(5, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid19Freq       wroteGEQFreqCh(5, 18, GEQ_MAXNUMBANDS)
#define  readGEQRwid19Level       readGEQLevelCh(5, 18, GEQ_MAXNUMBANDS)
#define writeGEQRwid19Level(N)   writeGEQLevelCh(5, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid19Level      wroteGEQLevelCh(5, 18, GEQ_MAXNUMBANDS)
#define  readGEQRwid19Width       readGEQWidthCh(5, 18, GEQ_MAXNUMBANDS)
#define writeGEQRwid19Width(N)   writeGEQWidthCh(5, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid19Width      wroteGEQWidthCh(5, 18, GEQ_MAXNUMBANDS)

#define  readGEQRwid20Freq        readGEQFreqCh(5, 19, GEQ_MAXNUMBANDS)
#define writeGEQRwid20Freq(N)    writeGEQFreqCh(5, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid20Freq       wroteGEQFreqCh(5, 19, GEQ_MAXNUMBANDS)
#define  readGEQRwid20Level       readGEQLevelCh(5, 19, GEQ_MAXNUMBANDS)
#define writeGEQRwid20Level(N)   writeGEQLevelCh(5, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid20Level      wroteGEQLevelCh(5, 19, GEQ_MAXNUMBANDS)
#define  readGEQRwid20Width       readGEQWidthCh(5, 19, GEQ_MAXNUMBANDS)
#define writeGEQRwid20Width(N)   writeGEQWidthCh(5, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid20Width      wroteGEQWidthCh(5, 19, GEQ_MAXNUMBANDS)

#define  readGEQRwid21Freq        readGEQFreqCh(5, 20, GEQ_MAXNUMBANDS)
#define writeGEQRwid21Freq(N)    writeGEQFreqCh(5, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid21Freq       wroteGEQFreqCh(5, 20, GEQ_MAXNUMBANDS)
#define  readGEQRwid21Level       readGEQLevelCh(5, 20, GEQ_MAXNUMBANDS)
#define writeGEQRwid21Level(N)   writeGEQLevelCh(5, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid21Level      wroteGEQLevelCh(5, 20, GEQ_MAXNUMBANDS)
#define  readGEQRwid21Width       readGEQWidthCh(5, 20, GEQ_MAXNUMBANDS)
#define writeGEQRwid21Width(N)   writeGEQWidthCh(5, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid21Width      wroteGEQWidthCh(5, 20, GEQ_MAXNUMBANDS)

#define  readGEQRwid22Freq        readGEQFreqCh(5, 21, GEQ_MAXNUMBANDS)
#define writeGEQRwid22Freq(N)    writeGEQFreqCh(5, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid22Freq       wroteGEQFreqCh(5, 21, GEQ_MAXNUMBANDS)
#define  readGEQRwid22Level       readGEQLevelCh(5, 21, GEQ_MAXNUMBANDS)
#define writeGEQRwid22Level(N)   writeGEQLevelCh(5, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid22Level      wroteGEQLevelCh(5, 21, GEQ_MAXNUMBANDS)
#define  readGEQRwid22Width       readGEQWidthCh(5, 21, GEQ_MAXNUMBANDS)
#define writeGEQRwid22Width(N)   writeGEQWidthCh(5, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid22Width      wroteGEQWidthCh(5, 21, GEQ_MAXNUMBANDS)

#define  readGEQRwid23Freq        readGEQFreqCh(5, 22, GEQ_MAXNUMBANDS)
#define writeGEQRwid23Freq(N)    writeGEQFreqCh(5, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid23Freq       wroteGEQFreqCh(5, 22, GEQ_MAXNUMBANDS)
#define  readGEQRwid23Level       readGEQLevelCh(5, 22, GEQ_MAXNUMBANDS)
#define writeGEQRwid23Level(N)   writeGEQLevelCh(5, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid23Level      wroteGEQLevelCh(5, 22, GEQ_MAXNUMBANDS)
#define  readGEQRwid23Width       readGEQWidthCh(5, 22, GEQ_MAXNUMBANDS)
#define writeGEQRwid23Width(N)   writeGEQWidthCh(5, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid23Width      wroteGEQWidthCh(5, 22, GEQ_MAXNUMBANDS)

#define  readGEQRwid24Freq        readGEQFreqCh(5, 23, GEQ_MAXNUMBANDS)
#define writeGEQRwid24Freq(N)    writeGEQFreqCh(5, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid24Freq       wroteGEQFreqCh(5, 23, GEQ_MAXNUMBANDS)
#define  readGEQRwid24Level       readGEQLevelCh(5, 23, GEQ_MAXNUMBANDS)
#define writeGEQRwid24Level(N)   writeGEQLevelCh(5, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid24Level      wroteGEQLevelCh(5, 23, GEQ_MAXNUMBANDS)
#define  readGEQRwid24Width       readGEQWidthCh(5, 23, GEQ_MAXNUMBANDS)
#define writeGEQRwid24Width(N)   writeGEQWidthCh(5, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid24Width      wroteGEQWidthCh(5, 23, GEQ_MAXNUMBANDS)

#define  readGEQRwid25Freq        readGEQFreqCh(5, 24, GEQ_MAXNUMBANDS)
#define writeGEQRwid25Freq(N)    writeGEQFreqCh(5, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid25Freq       wroteGEQFreqCh(5, 24, GEQ_MAXNUMBANDS)
#define  readGEQRwid25Level       readGEQLevelCh(5, 24, GEQ_MAXNUMBANDS)
#define writeGEQRwid25Level(N)   writeGEQLevelCh(5, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid25Level      wroteGEQLevelCh(5, 24, GEQ_MAXNUMBANDS)
#define  readGEQRwid25Width       readGEQWidthCh(5, 24, GEQ_MAXNUMBANDS)
#define writeGEQRwid25Width(N)   writeGEQWidthCh(5, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid25Width      wroteGEQWidthCh(5, 24, GEQ_MAXNUMBANDS)

#define  readGEQRwid26Freq        readGEQFreqCh(5, 25, GEQ_MAXNUMBANDS)
#define writeGEQRwid26Freq(N)    writeGEQFreqCh(5, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid26Freq       wroteGEQFreqCh(5, 25, GEQ_MAXNUMBANDS)
#define  readGEQRwid26Level       readGEQLevelCh(5, 25, GEQ_MAXNUMBANDS)
#define writeGEQRwid26Level(N)   writeGEQLevelCh(5, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid26Level      wroteGEQLevelCh(5, 25, GEQ_MAXNUMBANDS)
#define  readGEQRwid26Width       readGEQWidthCh(5, 25, GEQ_MAXNUMBANDS)
#define writeGEQRwid26Width(N)   writeGEQWidthCh(5, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid26Width      wroteGEQWidthCh(5, 25, GEQ_MAXNUMBANDS)

#define  readGEQRwid27Freq        readGEQFreqCh(5, 26, GEQ_MAXNUMBANDS)
#define writeGEQRwid27Freq(N)    writeGEQFreqCh(5, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid27Freq       wroteGEQFreqCh(5, 26, GEQ_MAXNUMBANDS)
#define  readGEQRwid27Level       readGEQLevelCh(5, 26, GEQ_MAXNUMBANDS)
#define writeGEQRwid27Level(N)   writeGEQLevelCh(5, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid27Level      wroteGEQLevelCh(5, 26, GEQ_MAXNUMBANDS)
#define  readGEQRwid27Width       readGEQWidthCh(5, 26, GEQ_MAXNUMBANDS)
#define writeGEQRwid27Width(N)   writeGEQWidthCh(5, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid27Width      wroteGEQWidthCh(5, 26, GEQ_MAXNUMBANDS)

#define  readGEQRwid28Freq        readGEQFreqCh(5, 27, GEQ_MAXNUMBANDS)
#define writeGEQRwid28Freq(N)    writeGEQFreqCh(5, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid28Freq       wroteGEQFreqCh(5, 27, GEQ_MAXNUMBANDS)
#define  readGEQRwid28Level       readGEQLevelCh(5, 27, GEQ_MAXNUMBANDS)
#define writeGEQRwid28Level(N)   writeGEQLevelCh(5, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid28Level      wroteGEQLevelCh(5, 27, GEQ_MAXNUMBANDS)
#define  readGEQRwid28Width       readGEQWidthCh(5, 27, GEQ_MAXNUMBANDS)
#define writeGEQRwid28Width(N)   writeGEQWidthCh(5, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid28Width      wroteGEQWidthCh(5, 27, GEQ_MAXNUMBANDS)

#define  readGEQRwid29Freq        readGEQFreqCh(5, 28, GEQ_MAXNUMBANDS)
#define writeGEQRwid29Freq(N)    writeGEQFreqCh(5, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid29Freq       wroteGEQFreqCh(5, 28, GEQ_MAXNUMBANDS)
#define  readGEQRwid29Level       readGEQLevelCh(5, 28, GEQ_MAXNUMBANDS)
#define writeGEQRwid29Level(N)   writeGEQLevelCh(5, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid29Level      wroteGEQLevelCh(5, 28, GEQ_MAXNUMBANDS)
#define  readGEQRwid29Width       readGEQWidthCh(5, 28, GEQ_MAXNUMBANDS)
#define writeGEQRwid29Width(N)   writeGEQWidthCh(5, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid29Width      wroteGEQWidthCh(5, 28, GEQ_MAXNUMBANDS)

#define  readGEQRwid30Freq        readGEQFreqCh(5, 29, GEQ_MAXNUMBANDS)
#define writeGEQRwid30Freq(N)    writeGEQFreqCh(5, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid30Freq       wroteGEQFreqCh(5, 29, GEQ_MAXNUMBANDS)
#define  readGEQRwid30Level       readGEQLevelCh(5, 29, GEQ_MAXNUMBANDS)
#define writeGEQRwid30Level(N)   writeGEQLevelCh(5, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid30Level      wroteGEQLevelCh(5, 29, GEQ_MAXNUMBANDS)
#define  readGEQRwid30Width       readGEQWidthCh(5, 29, GEQ_MAXNUMBANDS)
#define writeGEQRwid30Width(N)   writeGEQWidthCh(5, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid30Width      wroteGEQWidthCh(5, 29, GEQ_MAXNUMBANDS)

#define  readGEQRwid31Freq        readGEQFreqCh(5, 30, GEQ_MAXNUMBANDS)
#define writeGEQRwid31Freq(N)    writeGEQFreqCh(5, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid31Freq       wroteGEQFreqCh(5, 30, GEQ_MAXNUMBANDS)
#define  readGEQRwid31Level       readGEQLevelCh(5, 30, GEQ_MAXNUMBANDS)
#define writeGEQRwid31Level(N)   writeGEQLevelCh(5, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid31Level      wroteGEQLevelCh(5, 30, GEQ_MAXNUMBANDS)
#define  readGEQRwid31Width       readGEQWidthCh(5, 30, GEQ_MAXNUMBANDS)
#define writeGEQRwid31Width(N)   writeGEQWidthCh(5, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid31Width      wroteGEQWidthCh(5, 30, GEQ_MAXNUMBANDS)

#define  readGEQRwid32Freq        readGEQFreqCh(5, 31, GEQ_MAXNUMBANDS)
#define writeGEQRwid32Freq(N)    writeGEQFreqCh(5, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid32Freq       wroteGEQFreqCh(5, 31, GEQ_MAXNUMBANDS)
#define  readGEQRwid32Level       readGEQLevelCh(5, 31, GEQ_MAXNUMBANDS)
#define writeGEQRwid32Level(N)   writeGEQLevelCh(5, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid32Level      wroteGEQLevelCh(5, 31, GEQ_MAXNUMBANDS)
#define  readGEQRwid32Width       readGEQWidthCh(5, 31, GEQ_MAXNUMBANDS)
#define writeGEQRwid32Width(N)   writeGEQWidthCh(5, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRwid32Width      wroteGEQWidthCh(5, 31, GEQ_MAXNUMBANDS)

#define  readGEQOver1Freq        readGEQFreqCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQOver1Freq(N)    writeGEQFreqCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver1Freq       wroteGEQFreqCh(6, 0, GEQ_MAXNUMBANDS)
#define  readGEQOver1Level       readGEQLevelCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQOver1Level(N)   writeGEQLevelCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver1Level      wroteGEQLevelCh(6, 0, GEQ_MAXNUMBANDS)
#define  readGEQOver1Width       readGEQWidthCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQOver1Width(N)   writeGEQWidthCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver1Width      wroteGEQWidthCh(6, 0, GEQ_MAXNUMBANDS)

#define  readGEQOver2Freq        readGEQFreqCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQOver2Freq(N)    writeGEQFreqCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver2Freq       wroteGEQFreqCh(6, 1, GEQ_MAXNUMBANDS)
#define  readGEQOver2Level       readGEQLevelCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQOver2Level(N)   writeGEQLevelCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver2Level      wroteGEQLevelCh(6, 1, GEQ_MAXNUMBANDS)
#define  readGEQOver2Width       readGEQWidthCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQOver2Width(N)   writeGEQWidthCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver2Width      wroteGEQWidthCh(6, 1, GEQ_MAXNUMBANDS)

#define  readGEQOver3Freq        readGEQFreqCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQOver3Freq(N)    writeGEQFreqCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver3Freq       wroteGEQFreqCh(6, 2, GEQ_MAXNUMBANDS)
#define  readGEQOver3Level       readGEQLevelCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQOver3Level(N)   writeGEQLevelCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver3Level      wroteGEQLevelCh(6, 2, GEQ_MAXNUMBANDS)
#define  readGEQOver3Width       readGEQWidthCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQOver3Width(N)   writeGEQWidthCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver3Width      wroteGEQWidthCh(6, 2, GEQ_MAXNUMBANDS)

#define  readGEQOver4Freq        readGEQFreqCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQOver4Freq(N)    writeGEQFreqCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver4Freq       wroteGEQFreqCh(6, 3, GEQ_MAXNUMBANDS)
#define  readGEQOver4Level       readGEQLevelCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQOver4Level(N)   writeGEQLevelCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver4Level      wroteGEQLevelCh(6, 3, GEQ_MAXNUMBANDS)
#define  readGEQOver4Width       readGEQWidthCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQOver4Width(N)   writeGEQWidthCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver4Width      wroteGEQWidthCh(6, 3, GEQ_MAXNUMBANDS)

#define  readGEQOver5Freq        readGEQFreqCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQOver5Freq(N)    writeGEQFreqCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver5Freq       wroteGEQFreqCh(6, 4, GEQ_MAXNUMBANDS)
#define  readGEQOver5Level       readGEQLevelCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQOver5Level(N)   writeGEQLevelCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver5Level      wroteGEQLevelCh(6, 4, GEQ_MAXNUMBANDS)
#define  readGEQOver5Width       readGEQWidthCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQOver5Width(N)   writeGEQWidthCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver5Width      wroteGEQWidthCh(6, 4, GEQ_MAXNUMBANDS)

#define  readGEQOver6Freq        readGEQFreqCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQOver6Freq(N)    writeGEQFreqCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver6Freq       wroteGEQFreqCh(6, 5, GEQ_MAXNUMBANDS)
#define  readGEQOver6Level       readGEQLevelCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQOver6Level(N)   writeGEQLevelCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver6Level      wroteGEQLevelCh(6, 5, GEQ_MAXNUMBANDS)
#define  readGEQOver6Width       readGEQWidthCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQOver6Width(N)   writeGEQWidthCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver6Width      wroteGEQWidthCh(6, 5, GEQ_MAXNUMBANDS)

#define  readGEQOver7Freq        readGEQFreqCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQOver7Freq(N)    writeGEQFreqCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver7Freq       wroteGEQFreqCh(6, 6, GEQ_MAXNUMBANDS)
#define  readGEQOver7Level       readGEQLevelCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQOver7Level(N)   writeGEQLevelCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver7Level      wroteGEQLevelCh(6, 6, GEQ_MAXNUMBANDS)
#define  readGEQOver7Width       readGEQWidthCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQOver7Width(N)   writeGEQWidthCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver7Width      wroteGEQWidthCh(6, 6, GEQ_MAXNUMBANDS)

#define  readGEQOver8Freq        readGEQFreqCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQOver8Freq(N)    writeGEQFreqCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver8Freq       wroteGEQFreqCh(6, 7, GEQ_MAXNUMBANDS)
#define  readGEQOver8Level       readGEQLevelCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQOver8Level(N)   writeGEQLevelCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver8Level      wroteGEQLevelCh(6, 7, GEQ_MAXNUMBANDS)
#define  readGEQOver8Width       readGEQWidthCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQOver8Width(N)   writeGEQWidthCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver8Width      wroteGEQWidthCh(6, 7, GEQ_MAXNUMBANDS)

#define  readGEQOver9Freq        readGEQFreqCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQOver9Freq(N)    writeGEQFreqCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver9Freq       wroteGEQFreqCh(6, 8, GEQ_MAXNUMBANDS)
#define  readGEQOver9Level       readGEQLevelCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQOver9Level(N)   writeGEQLevelCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver9Level      wroteGEQLevelCh(6, 8, GEQ_MAXNUMBANDS)
#define  readGEQOver9Width       readGEQWidthCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQOver9Width(N)   writeGEQWidthCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver9Width      wroteGEQWidthCh(6, 8, GEQ_MAXNUMBANDS)

#define  readGEQOver10Freq        readGEQFreqCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQOver10Freq(N)    writeGEQFreqCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver10Freq       wroteGEQFreqCh(6, 9, GEQ_MAXNUMBANDS)
#define  readGEQOver10Level       readGEQLevelCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQOver10Level(N)   writeGEQLevelCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver10Level      wroteGEQLevelCh(6, 9, GEQ_MAXNUMBANDS)
#define  readGEQOver10Width       readGEQWidthCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQOver10Width(N)   writeGEQWidthCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver10Width      wroteGEQWidthCh(6, 9, GEQ_MAXNUMBANDS)

#define  readGEQOver11Freq        readGEQFreqCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQOver11Freq(N)    writeGEQFreqCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver11Freq       wroteGEQFreqCh(6, 10, GEQ_MAXNUMBANDS)
#define  readGEQOver11Level       readGEQLevelCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQOver11Level(N)   writeGEQLevelCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver11Level      wroteGEQLevelCh(6, 10, GEQ_MAXNUMBANDS)
#define  readGEQOver11Width       readGEQWidthCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQOver11Width(N)   writeGEQWidthCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver11Width      wroteGEQWidthCh(6, 10, GEQ_MAXNUMBANDS)

#define  readGEQOver12Freq        readGEQFreqCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQOver12Freq(N)    writeGEQFreqCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver12Freq       wroteGEQFreqCh(6, 11, GEQ_MAXNUMBANDS)
#define  readGEQOver12Level       readGEQLevelCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQOver12Level(N)   writeGEQLevelCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver12Level      wroteGEQLevelCh(6, 11, GEQ_MAXNUMBANDS)
#define  readGEQOver12Width       readGEQWidthCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQOver12Width(N)   writeGEQWidthCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver12Width      wroteGEQWidthCh(6, 11, GEQ_MAXNUMBANDS)

#define  readGEQOver13Freq        readGEQFreqCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQOver13Freq(N)    writeGEQFreqCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver13Freq       wroteGEQFreqCh(6, 12, GEQ_MAXNUMBANDS)
#define  readGEQOver13Level       readGEQLevelCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQOver13Level(N)   writeGEQLevelCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver13Level      wroteGEQLevelCh(6, 12, GEQ_MAXNUMBANDS)
#define  readGEQOver13Width       readGEQWidthCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQOver13Width(N)   writeGEQWidthCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver13Width      wroteGEQWidthCh(6, 12, GEQ_MAXNUMBANDS)

#define  readGEQOver14Freq        readGEQFreqCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQOver14Freq(N)    writeGEQFreqCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver14Freq       wroteGEQFreqCh(6, 13, GEQ_MAXNUMBANDS)
#define  readGEQOver14Level       readGEQLevelCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQOver14Level(N)   writeGEQLevelCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver14Level      wroteGEQLevelCh(6, 13, GEQ_MAXNUMBANDS)
#define  readGEQOver14Width       readGEQWidthCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQOver14Width(N)   writeGEQWidthCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver14Width      wroteGEQWidthCh(6, 13, GEQ_MAXNUMBANDS)

#define  readGEQOver15Freq        readGEQFreqCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQOver15Freq(N)    writeGEQFreqCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver15Freq       wroteGEQFreqCh(6, 14, GEQ_MAXNUMBANDS)
#define  readGEQOver15Level       readGEQLevelCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQOver15Level(N)   writeGEQLevelCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver15Level      wroteGEQLevelCh(6, 14, GEQ_MAXNUMBANDS)
#define  readGEQOver15Width       readGEQWidthCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQOver15Width(N)   writeGEQWidthCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver15Width      wroteGEQWidthCh(6, 14, GEQ_MAXNUMBANDS)

#define  readGEQOver16Freq        readGEQFreqCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQOver16Freq(N)    writeGEQFreqCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver16Freq       wroteGEQFreqCh(6, 15, GEQ_MAXNUMBANDS)
#define  readGEQOver16Level       readGEQLevelCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQOver16Level(N)   writeGEQLevelCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver16Level      wroteGEQLevelCh(6, 15, GEQ_MAXNUMBANDS)
#define  readGEQOver16Width       readGEQWidthCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQOver16Width(N)   writeGEQWidthCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver16Width      wroteGEQWidthCh(6, 15, GEQ_MAXNUMBANDS)

#define  readGEQOver17Freq        readGEQFreqCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQOver17Freq(N)    writeGEQFreqCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver17Freq       wroteGEQFreqCh(6, 16, GEQ_MAXNUMBANDS)
#define  readGEQOver17Level       readGEQLevelCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQOver17Level(N)   writeGEQLevelCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver17Level      wroteGEQLevelCh(6, 16, GEQ_MAXNUMBANDS)
#define  readGEQOver17Width       readGEQWidthCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQOver17Width(N)   writeGEQWidthCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver17Width      wroteGEQWidthCh(6, 16, GEQ_MAXNUMBANDS)

#define  readGEQOver18Freq        readGEQFreqCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQOver18Freq(N)    writeGEQFreqCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver18Freq       wroteGEQFreqCh(6, 17, GEQ_MAXNUMBANDS)
#define  readGEQOver18Level       readGEQLevelCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQOver18Level(N)   writeGEQLevelCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver18Level      wroteGEQLevelCh(6, 17, GEQ_MAXNUMBANDS)
#define  readGEQOver18Width       readGEQWidthCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQOver18Width(N)   writeGEQWidthCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver18Width      wroteGEQWidthCh(6, 17, GEQ_MAXNUMBANDS)

#define  readGEQOver19Freq        readGEQFreqCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQOver19Freq(N)    writeGEQFreqCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver19Freq       wroteGEQFreqCh(6, 18, GEQ_MAXNUMBANDS)
#define  readGEQOver19Level       readGEQLevelCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQOver19Level(N)   writeGEQLevelCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver19Level      wroteGEQLevelCh(6, 18, GEQ_MAXNUMBANDS)
#define  readGEQOver19Width       readGEQWidthCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQOver19Width(N)   writeGEQWidthCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver19Width      wroteGEQWidthCh(6, 18, GEQ_MAXNUMBANDS)

#define  readGEQOver20Freq        readGEQFreqCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQOver20Freq(N)    writeGEQFreqCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver20Freq       wroteGEQFreqCh(6, 19, GEQ_MAXNUMBANDS)
#define  readGEQOver20Level       readGEQLevelCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQOver20Level(N)   writeGEQLevelCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver20Level      wroteGEQLevelCh(6, 19, GEQ_MAXNUMBANDS)
#define  readGEQOver20Width       readGEQWidthCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQOver20Width(N)   writeGEQWidthCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver20Width      wroteGEQWidthCh(6, 19, GEQ_MAXNUMBANDS)

#define  readGEQOver21Freq        readGEQFreqCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQOver21Freq(N)    writeGEQFreqCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver21Freq       wroteGEQFreqCh(6, 20, GEQ_MAXNUMBANDS)
#define  readGEQOver21Level       readGEQLevelCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQOver21Level(N)   writeGEQLevelCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver21Level      wroteGEQLevelCh(6, 20, GEQ_MAXNUMBANDS)
#define  readGEQOver21Width       readGEQWidthCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQOver21Width(N)   writeGEQWidthCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver21Width      wroteGEQWidthCh(6, 20, GEQ_MAXNUMBANDS)

#define  readGEQOver22Freq        readGEQFreqCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQOver22Freq(N)    writeGEQFreqCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver22Freq       wroteGEQFreqCh(6, 21, GEQ_MAXNUMBANDS)
#define  readGEQOver22Level       readGEQLevelCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQOver22Level(N)   writeGEQLevelCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver22Level      wroteGEQLevelCh(6, 21, GEQ_MAXNUMBANDS)
#define  readGEQOver22Width       readGEQWidthCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQOver22Width(N)   writeGEQWidthCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver22Width      wroteGEQWidthCh(6, 21, GEQ_MAXNUMBANDS)

#define  readGEQOver23Freq        readGEQFreqCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQOver23Freq(N)    writeGEQFreqCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver23Freq       wroteGEQFreqCh(6, 22, GEQ_MAXNUMBANDS)
#define  readGEQOver23Level       readGEQLevelCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQOver23Level(N)   writeGEQLevelCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver23Level      wroteGEQLevelCh(6, 22, GEQ_MAXNUMBANDS)
#define  readGEQOver23Width       readGEQWidthCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQOver23Width(N)   writeGEQWidthCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver23Width      wroteGEQWidthCh(6, 22, GEQ_MAXNUMBANDS)

#define  readGEQOver24Freq        readGEQFreqCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQOver24Freq(N)    writeGEQFreqCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver24Freq       wroteGEQFreqCh(6, 23, GEQ_MAXNUMBANDS)
#define  readGEQOver24Level       readGEQLevelCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQOver24Level(N)   writeGEQLevelCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver24Level      wroteGEQLevelCh(6, 23, GEQ_MAXNUMBANDS)
#define  readGEQOver24Width       readGEQWidthCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQOver24Width(N)   writeGEQWidthCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver24Width      wroteGEQWidthCh(6, 23, GEQ_MAXNUMBANDS)

#define  readGEQOver25Freq        readGEQFreqCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQOver25Freq(N)    writeGEQFreqCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver25Freq       wroteGEQFreqCh(6, 24, GEQ_MAXNUMBANDS)
#define  readGEQOver25Level       readGEQLevelCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQOver25Level(N)   writeGEQLevelCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver25Level      wroteGEQLevelCh(6, 24, GEQ_MAXNUMBANDS)
#define  readGEQOver25Width       readGEQWidthCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQOver25Width(N)   writeGEQWidthCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver25Width      wroteGEQWidthCh(6, 24, GEQ_MAXNUMBANDS)

#define  readGEQOver26Freq        readGEQFreqCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQOver26Freq(N)    writeGEQFreqCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver26Freq       wroteGEQFreqCh(6, 25, GEQ_MAXNUMBANDS)
#define  readGEQOver26Level       readGEQLevelCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQOver26Level(N)   writeGEQLevelCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver26Level      wroteGEQLevelCh(6, 25, GEQ_MAXNUMBANDS)
#define  readGEQOver26Width       readGEQWidthCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQOver26Width(N)   writeGEQWidthCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver26Width      wroteGEQWidthCh(6, 25, GEQ_MAXNUMBANDS)

#define  readGEQOver27Freq        readGEQFreqCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQOver27Freq(N)    writeGEQFreqCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver27Freq       wroteGEQFreqCh(6, 26, GEQ_MAXNUMBANDS)
#define  readGEQOver27Level       readGEQLevelCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQOver27Level(N)   writeGEQLevelCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver27Level      wroteGEQLevelCh(6, 26, GEQ_MAXNUMBANDS)
#define  readGEQOver27Width       readGEQWidthCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQOver27Width(N)   writeGEQWidthCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver27Width      wroteGEQWidthCh(6, 26, GEQ_MAXNUMBANDS)

#define  readGEQOver28Freq        readGEQFreqCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQOver28Freq(N)    writeGEQFreqCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver28Freq       wroteGEQFreqCh(6, 27, GEQ_MAXNUMBANDS)
#define  readGEQOver28Level       readGEQLevelCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQOver28Level(N)   writeGEQLevelCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver28Level      wroteGEQLevelCh(6, 27, GEQ_MAXNUMBANDS)
#define  readGEQOver28Width       readGEQWidthCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQOver28Width(N)   writeGEQWidthCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver28Width      wroteGEQWidthCh(6, 27, GEQ_MAXNUMBANDS)

#define  readGEQOver29Freq        readGEQFreqCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQOver29Freq(N)    writeGEQFreqCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver29Freq       wroteGEQFreqCh(6, 28, GEQ_MAXNUMBANDS)
#define  readGEQOver29Level       readGEQLevelCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQOver29Level(N)   writeGEQLevelCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver29Level      wroteGEQLevelCh(6, 28, GEQ_MAXNUMBANDS)
#define  readGEQOver29Width       readGEQWidthCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQOver29Width(N)   writeGEQWidthCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver29Width      wroteGEQWidthCh(6, 28, GEQ_MAXNUMBANDS)

#define  readGEQOver30Freq        readGEQFreqCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQOver30Freq(N)    writeGEQFreqCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver30Freq       wroteGEQFreqCh(6, 29, GEQ_MAXNUMBANDS)
#define  readGEQOver30Level       readGEQLevelCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQOver30Level(N)   writeGEQLevelCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver30Level      wroteGEQLevelCh(6, 29, GEQ_MAXNUMBANDS)
#define  readGEQOver30Width       readGEQWidthCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQOver30Width(N)   writeGEQWidthCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver30Width      wroteGEQWidthCh(6, 29, GEQ_MAXNUMBANDS)

#define  readGEQOver31Freq        readGEQFreqCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQOver31Freq(N)    writeGEQFreqCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver31Freq       wroteGEQFreqCh(6, 30, GEQ_MAXNUMBANDS)
#define  readGEQOver31Level       readGEQLevelCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQOver31Level(N)   writeGEQLevelCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver31Level      wroteGEQLevelCh(6, 30, GEQ_MAXNUMBANDS)
#define  readGEQOver31Width       readGEQWidthCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQOver31Width(N)   writeGEQWidthCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver31Width      wroteGEQWidthCh(6, 30, GEQ_MAXNUMBANDS)

#define  readGEQOver32Freq        readGEQFreqCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQOver32Freq(N)    writeGEQFreqCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver32Freq       wroteGEQFreqCh(6, 31, GEQ_MAXNUMBANDS)
#define  readGEQOver32Level       readGEQLevelCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQOver32Level(N)   writeGEQLevelCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver32Level      wroteGEQLevelCh(6, 31, GEQ_MAXNUMBANDS)
#define  readGEQOver32Width       readGEQWidthCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQOver32Width(N)   writeGEQWidthCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQOver32Width      wroteGEQWidthCh(6, 31, GEQ_MAXNUMBANDS)

#define  readGEQLovr1Freq        readGEQFreqCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQLovr1Freq(N)    writeGEQFreqCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr1Freq       wroteGEQFreqCh(6, 0, GEQ_MAXNUMBANDS)
#define  readGEQLovr1Level       readGEQLevelCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQLovr1Level(N)   writeGEQLevelCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr1Level      wroteGEQLevelCh(6, 0, GEQ_MAXNUMBANDS)
#define  readGEQLovr1Width       readGEQWidthCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQLovr1Width(N)   writeGEQWidthCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr1Width      wroteGEQWidthCh(6, 0, GEQ_MAXNUMBANDS)

#define  readGEQLovr2Freq        readGEQFreqCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQLovr2Freq(N)    writeGEQFreqCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr2Freq       wroteGEQFreqCh(6, 1, GEQ_MAXNUMBANDS)
#define  readGEQLovr2Level       readGEQLevelCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQLovr2Level(N)   writeGEQLevelCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr2Level      wroteGEQLevelCh(6, 1, GEQ_MAXNUMBANDS)
#define  readGEQLovr2Width       readGEQWidthCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQLovr2Width(N)   writeGEQWidthCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr2Width      wroteGEQWidthCh(6, 1, GEQ_MAXNUMBANDS)

#define  readGEQLovr3Freq        readGEQFreqCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQLovr3Freq(N)    writeGEQFreqCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr3Freq       wroteGEQFreqCh(6, 2, GEQ_MAXNUMBANDS)
#define  readGEQLovr3Level       readGEQLevelCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQLovr3Level(N)   writeGEQLevelCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr3Level      wroteGEQLevelCh(6, 2, GEQ_MAXNUMBANDS)
#define  readGEQLovr3Width       readGEQWidthCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQLovr3Width(N)   writeGEQWidthCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr3Width      wroteGEQWidthCh(6, 2, GEQ_MAXNUMBANDS)

#define  readGEQLovr4Freq        readGEQFreqCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQLovr4Freq(N)    writeGEQFreqCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr4Freq       wroteGEQFreqCh(6, 3, GEQ_MAXNUMBANDS)
#define  readGEQLovr4Level       readGEQLevelCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQLovr4Level(N)   writeGEQLevelCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr4Level      wroteGEQLevelCh(6, 3, GEQ_MAXNUMBANDS)
#define  readGEQLovr4Width       readGEQWidthCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQLovr4Width(N)   writeGEQWidthCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr4Width      wroteGEQWidthCh(6, 3, GEQ_MAXNUMBANDS)

#define  readGEQLovr5Freq        readGEQFreqCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQLovr5Freq(N)    writeGEQFreqCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr5Freq       wroteGEQFreqCh(6, 4, GEQ_MAXNUMBANDS)
#define  readGEQLovr5Level       readGEQLevelCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQLovr5Level(N)   writeGEQLevelCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr5Level      wroteGEQLevelCh(6, 4, GEQ_MAXNUMBANDS)
#define  readGEQLovr5Width       readGEQWidthCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQLovr5Width(N)   writeGEQWidthCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr5Width      wroteGEQWidthCh(6, 4, GEQ_MAXNUMBANDS)

#define  readGEQLovr6Freq        readGEQFreqCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQLovr6Freq(N)    writeGEQFreqCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr6Freq       wroteGEQFreqCh(6, 5, GEQ_MAXNUMBANDS)
#define  readGEQLovr6Level       readGEQLevelCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQLovr6Level(N)   writeGEQLevelCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr6Level      wroteGEQLevelCh(6, 5, GEQ_MAXNUMBANDS)
#define  readGEQLovr6Width       readGEQWidthCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQLovr6Width(N)   writeGEQWidthCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr6Width      wroteGEQWidthCh(6, 5, GEQ_MAXNUMBANDS)

#define  readGEQLovr7Freq        readGEQFreqCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQLovr7Freq(N)    writeGEQFreqCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr7Freq       wroteGEQFreqCh(6, 6, GEQ_MAXNUMBANDS)
#define  readGEQLovr7Level       readGEQLevelCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQLovr7Level(N)   writeGEQLevelCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr7Level      wroteGEQLevelCh(6, 6, GEQ_MAXNUMBANDS)
#define  readGEQLovr7Width       readGEQWidthCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQLovr7Width(N)   writeGEQWidthCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr7Width      wroteGEQWidthCh(6, 6, GEQ_MAXNUMBANDS)

#define  readGEQLovr8Freq        readGEQFreqCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQLovr8Freq(N)    writeGEQFreqCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr8Freq       wroteGEQFreqCh(6, 7, GEQ_MAXNUMBANDS)
#define  readGEQLovr8Level       readGEQLevelCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQLovr8Level(N)   writeGEQLevelCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr8Level      wroteGEQLevelCh(6, 7, GEQ_MAXNUMBANDS)
#define  readGEQLovr8Width       readGEQWidthCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQLovr8Width(N)   writeGEQWidthCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr8Width      wroteGEQWidthCh(6, 7, GEQ_MAXNUMBANDS)

#define  readGEQLovr9Freq        readGEQFreqCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQLovr9Freq(N)    writeGEQFreqCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr9Freq       wroteGEQFreqCh(6, 8, GEQ_MAXNUMBANDS)
#define  readGEQLovr9Level       readGEQLevelCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQLovr9Level(N)   writeGEQLevelCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr9Level      wroteGEQLevelCh(6, 8, GEQ_MAXNUMBANDS)
#define  readGEQLovr9Width       readGEQWidthCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQLovr9Width(N)   writeGEQWidthCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr9Width      wroteGEQWidthCh(6, 8, GEQ_MAXNUMBANDS)

#define  readGEQLovr10Freq        readGEQFreqCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQLovr10Freq(N)    writeGEQFreqCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr10Freq       wroteGEQFreqCh(6, 9, GEQ_MAXNUMBANDS)
#define  readGEQLovr10Level       readGEQLevelCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQLovr10Level(N)   writeGEQLevelCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr10Level      wroteGEQLevelCh(6, 9, GEQ_MAXNUMBANDS)
#define  readGEQLovr10Width       readGEQWidthCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQLovr10Width(N)   writeGEQWidthCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr10Width      wroteGEQWidthCh(6, 9, GEQ_MAXNUMBANDS)

#define  readGEQLovr11Freq        readGEQFreqCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQLovr11Freq(N)    writeGEQFreqCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr11Freq       wroteGEQFreqCh(6, 10, GEQ_MAXNUMBANDS)
#define  readGEQLovr11Level       readGEQLevelCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQLovr11Level(N)   writeGEQLevelCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr11Level      wroteGEQLevelCh(6, 10, GEQ_MAXNUMBANDS)
#define  readGEQLovr11Width       readGEQWidthCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQLovr11Width(N)   writeGEQWidthCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr11Width      wroteGEQWidthCh(6, 10, GEQ_MAXNUMBANDS)

#define  readGEQLovr12Freq        readGEQFreqCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQLovr12Freq(N)    writeGEQFreqCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr12Freq       wroteGEQFreqCh(6, 11, GEQ_MAXNUMBANDS)
#define  readGEQLovr12Level       readGEQLevelCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQLovr12Level(N)   writeGEQLevelCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr12Level      wroteGEQLevelCh(6, 11, GEQ_MAXNUMBANDS)
#define  readGEQLovr12Width       readGEQWidthCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQLovr12Width(N)   writeGEQWidthCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr12Width      wroteGEQWidthCh(6, 11, GEQ_MAXNUMBANDS)

#define  readGEQLovr13Freq        readGEQFreqCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQLovr13Freq(N)    writeGEQFreqCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr13Freq       wroteGEQFreqCh(6, 12, GEQ_MAXNUMBANDS)
#define  readGEQLovr13Level       readGEQLevelCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQLovr13Level(N)   writeGEQLevelCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr13Level      wroteGEQLevelCh(6, 12, GEQ_MAXNUMBANDS)
#define  readGEQLovr13Width       readGEQWidthCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQLovr13Width(N)   writeGEQWidthCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr13Width      wroteGEQWidthCh(6, 12, GEQ_MAXNUMBANDS)

#define  readGEQLovr14Freq        readGEQFreqCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQLovr14Freq(N)    writeGEQFreqCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr14Freq       wroteGEQFreqCh(6, 13, GEQ_MAXNUMBANDS)
#define  readGEQLovr14Level       readGEQLevelCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQLovr14Level(N)   writeGEQLevelCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr14Level      wroteGEQLevelCh(6, 13, GEQ_MAXNUMBANDS)
#define  readGEQLovr14Width       readGEQWidthCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQLovr14Width(N)   writeGEQWidthCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr14Width      wroteGEQWidthCh(6, 13, GEQ_MAXNUMBANDS)

#define  readGEQLovr15Freq        readGEQFreqCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQLovr15Freq(N)    writeGEQFreqCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr15Freq       wroteGEQFreqCh(6, 14, GEQ_MAXNUMBANDS)
#define  readGEQLovr15Level       readGEQLevelCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQLovr15Level(N)   writeGEQLevelCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr15Level      wroteGEQLevelCh(6, 14, GEQ_MAXNUMBANDS)
#define  readGEQLovr15Width       readGEQWidthCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQLovr15Width(N)   writeGEQWidthCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr15Width      wroteGEQWidthCh(6, 14, GEQ_MAXNUMBANDS)

#define  readGEQLovr16Freq        readGEQFreqCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQLovr16Freq(N)    writeGEQFreqCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr16Freq       wroteGEQFreqCh(6, 15, GEQ_MAXNUMBANDS)
#define  readGEQLovr16Level       readGEQLevelCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQLovr16Level(N)   writeGEQLevelCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr16Level      wroteGEQLevelCh(6, 15, GEQ_MAXNUMBANDS)
#define  readGEQLovr16Width       readGEQWidthCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQLovr16Width(N)   writeGEQWidthCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr16Width      wroteGEQWidthCh(6, 15, GEQ_MAXNUMBANDS)

#define  readGEQLovr17Freq        readGEQFreqCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQLovr17Freq(N)    writeGEQFreqCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr17Freq       wroteGEQFreqCh(6, 16, GEQ_MAXNUMBANDS)
#define  readGEQLovr17Level       readGEQLevelCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQLovr17Level(N)   writeGEQLevelCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr17Level      wroteGEQLevelCh(6, 16, GEQ_MAXNUMBANDS)
#define  readGEQLovr17Width       readGEQWidthCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQLovr17Width(N)   writeGEQWidthCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr17Width      wroteGEQWidthCh(6, 16, GEQ_MAXNUMBANDS)

#define  readGEQLovr18Freq        readGEQFreqCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQLovr18Freq(N)    writeGEQFreqCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr18Freq       wroteGEQFreqCh(6, 17, GEQ_MAXNUMBANDS)
#define  readGEQLovr18Level       readGEQLevelCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQLovr18Level(N)   writeGEQLevelCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr18Level      wroteGEQLevelCh(6, 17, GEQ_MAXNUMBANDS)
#define  readGEQLovr18Width       readGEQWidthCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQLovr18Width(N)   writeGEQWidthCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr18Width      wroteGEQWidthCh(6, 17, GEQ_MAXNUMBANDS)

#define  readGEQLovr19Freq        readGEQFreqCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQLovr19Freq(N)    writeGEQFreqCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr19Freq       wroteGEQFreqCh(6, 18, GEQ_MAXNUMBANDS)
#define  readGEQLovr19Level       readGEQLevelCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQLovr19Level(N)   writeGEQLevelCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr19Level      wroteGEQLevelCh(6, 18, GEQ_MAXNUMBANDS)
#define  readGEQLovr19Width       readGEQWidthCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQLovr19Width(N)   writeGEQWidthCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr19Width      wroteGEQWidthCh(6, 18, GEQ_MAXNUMBANDS)

#define  readGEQLovr20Freq        readGEQFreqCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQLovr20Freq(N)    writeGEQFreqCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr20Freq       wroteGEQFreqCh(6, 19, GEQ_MAXNUMBANDS)
#define  readGEQLovr20Level       readGEQLevelCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQLovr20Level(N)   writeGEQLevelCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr20Level      wroteGEQLevelCh(6, 19, GEQ_MAXNUMBANDS)
#define  readGEQLovr20Width       readGEQWidthCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQLovr20Width(N)   writeGEQWidthCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr20Width      wroteGEQWidthCh(6, 19, GEQ_MAXNUMBANDS)

#define  readGEQLovr21Freq        readGEQFreqCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQLovr21Freq(N)    writeGEQFreqCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr21Freq       wroteGEQFreqCh(6, 20, GEQ_MAXNUMBANDS)
#define  readGEQLovr21Level       readGEQLevelCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQLovr21Level(N)   writeGEQLevelCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr21Level      wroteGEQLevelCh(6, 20, GEQ_MAXNUMBANDS)
#define  readGEQLovr21Width       readGEQWidthCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQLovr21Width(N)   writeGEQWidthCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr21Width      wroteGEQWidthCh(6, 20, GEQ_MAXNUMBANDS)

#define  readGEQLovr22Freq        readGEQFreqCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQLovr22Freq(N)    writeGEQFreqCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr22Freq       wroteGEQFreqCh(6, 21, GEQ_MAXNUMBANDS)
#define  readGEQLovr22Level       readGEQLevelCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQLovr22Level(N)   writeGEQLevelCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr22Level      wroteGEQLevelCh(6, 21, GEQ_MAXNUMBANDS)
#define  readGEQLovr22Width       readGEQWidthCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQLovr22Width(N)   writeGEQWidthCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr22Width      wroteGEQWidthCh(6, 21, GEQ_MAXNUMBANDS)

#define  readGEQLovr23Freq        readGEQFreqCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQLovr23Freq(N)    writeGEQFreqCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr23Freq       wroteGEQFreqCh(6, 22, GEQ_MAXNUMBANDS)
#define  readGEQLovr23Level       readGEQLevelCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQLovr23Level(N)   writeGEQLevelCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr23Level      wroteGEQLevelCh(6, 22, GEQ_MAXNUMBANDS)
#define  readGEQLovr23Width       readGEQWidthCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQLovr23Width(N)   writeGEQWidthCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr23Width      wroteGEQWidthCh(6, 22, GEQ_MAXNUMBANDS)

#define  readGEQLovr24Freq        readGEQFreqCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQLovr24Freq(N)    writeGEQFreqCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr24Freq       wroteGEQFreqCh(6, 23, GEQ_MAXNUMBANDS)
#define  readGEQLovr24Level       readGEQLevelCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQLovr24Level(N)   writeGEQLevelCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr24Level      wroteGEQLevelCh(6, 23, GEQ_MAXNUMBANDS)
#define  readGEQLovr24Width       readGEQWidthCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQLovr24Width(N)   writeGEQWidthCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr24Width      wroteGEQWidthCh(6, 23, GEQ_MAXNUMBANDS)

#define  readGEQLovr25Freq        readGEQFreqCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQLovr25Freq(N)    writeGEQFreqCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr25Freq       wroteGEQFreqCh(6, 24, GEQ_MAXNUMBANDS)
#define  readGEQLovr25Level       readGEQLevelCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQLovr25Level(N)   writeGEQLevelCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr25Level      wroteGEQLevelCh(6, 24, GEQ_MAXNUMBANDS)
#define  readGEQLovr25Width       readGEQWidthCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQLovr25Width(N)   writeGEQWidthCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr25Width      wroteGEQWidthCh(6, 24, GEQ_MAXNUMBANDS)

#define  readGEQLovr26Freq        readGEQFreqCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQLovr26Freq(N)    writeGEQFreqCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr26Freq       wroteGEQFreqCh(6, 25, GEQ_MAXNUMBANDS)
#define  readGEQLovr26Level       readGEQLevelCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQLovr26Level(N)   writeGEQLevelCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr26Level      wroteGEQLevelCh(6, 25, GEQ_MAXNUMBANDS)
#define  readGEQLovr26Width       readGEQWidthCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQLovr26Width(N)   writeGEQWidthCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr26Width      wroteGEQWidthCh(6, 25, GEQ_MAXNUMBANDS)

#define  readGEQLovr27Freq        readGEQFreqCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQLovr27Freq(N)    writeGEQFreqCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr27Freq       wroteGEQFreqCh(6, 26, GEQ_MAXNUMBANDS)
#define  readGEQLovr27Level       readGEQLevelCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQLovr27Level(N)   writeGEQLevelCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr27Level      wroteGEQLevelCh(6, 26, GEQ_MAXNUMBANDS)
#define  readGEQLovr27Width       readGEQWidthCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQLovr27Width(N)   writeGEQWidthCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr27Width      wroteGEQWidthCh(6, 26, GEQ_MAXNUMBANDS)

#define  readGEQLovr28Freq        readGEQFreqCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQLovr28Freq(N)    writeGEQFreqCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr28Freq       wroteGEQFreqCh(6, 27, GEQ_MAXNUMBANDS)
#define  readGEQLovr28Level       readGEQLevelCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQLovr28Level(N)   writeGEQLevelCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr28Level      wroteGEQLevelCh(6, 27, GEQ_MAXNUMBANDS)
#define  readGEQLovr28Width       readGEQWidthCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQLovr28Width(N)   writeGEQWidthCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr28Width      wroteGEQWidthCh(6, 27, GEQ_MAXNUMBANDS)

#define  readGEQLovr29Freq        readGEQFreqCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQLovr29Freq(N)    writeGEQFreqCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr29Freq       wroteGEQFreqCh(6, 28, GEQ_MAXNUMBANDS)
#define  readGEQLovr29Level       readGEQLevelCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQLovr29Level(N)   writeGEQLevelCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr29Level      wroteGEQLevelCh(6, 28, GEQ_MAXNUMBANDS)
#define  readGEQLovr29Width       readGEQWidthCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQLovr29Width(N)   writeGEQWidthCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr29Width      wroteGEQWidthCh(6, 28, GEQ_MAXNUMBANDS)

#define  readGEQLovr30Freq        readGEQFreqCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQLovr30Freq(N)    writeGEQFreqCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr30Freq       wroteGEQFreqCh(6, 29, GEQ_MAXNUMBANDS)
#define  readGEQLovr30Level       readGEQLevelCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQLovr30Level(N)   writeGEQLevelCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr30Level      wroteGEQLevelCh(6, 29, GEQ_MAXNUMBANDS)
#define  readGEQLovr30Width       readGEQWidthCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQLovr30Width(N)   writeGEQWidthCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr30Width      wroteGEQWidthCh(6, 29, GEQ_MAXNUMBANDS)

#define  readGEQLovr31Freq        readGEQFreqCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQLovr31Freq(N)    writeGEQFreqCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr31Freq       wroteGEQFreqCh(6, 30, GEQ_MAXNUMBANDS)
#define  readGEQLovr31Level       readGEQLevelCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQLovr31Level(N)   writeGEQLevelCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr31Level      wroteGEQLevelCh(6, 30, GEQ_MAXNUMBANDS)
#define  readGEQLovr31Width       readGEQWidthCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQLovr31Width(N)   writeGEQWidthCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr31Width      wroteGEQWidthCh(6, 30, GEQ_MAXNUMBANDS)

#define  readGEQLovr32Freq        readGEQFreqCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQLovr32Freq(N)    writeGEQFreqCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr32Freq       wroteGEQFreqCh(6, 31, GEQ_MAXNUMBANDS)
#define  readGEQLovr32Level       readGEQLevelCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQLovr32Level(N)   writeGEQLevelCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr32Level      wroteGEQLevelCh(6, 31, GEQ_MAXNUMBANDS)
#define  readGEQLovr32Width       readGEQWidthCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQLovr32Width(N)   writeGEQWidthCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLovr32Width      wroteGEQWidthCh(6, 31, GEQ_MAXNUMBANDS)

#define  readGEQRovr1Freq        readGEQFreqCh(7, 0, GEQ_MAXNUMBANDS)
#define writeGEQRovr1Freq(N)    writeGEQFreqCh(7, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr1Freq       wroteGEQFreqCh(7, 0, GEQ_MAXNUMBANDS)
#define  readGEQRovr1Level       readGEQLevelCh(7, 0, GEQ_MAXNUMBANDS)
#define writeGEQRovr1Level(N)   writeGEQLevelCh(7, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr1Level      wroteGEQLevelCh(7, 0, GEQ_MAXNUMBANDS)
#define  readGEQRovr1Width       readGEQWidthCh(7, 0, GEQ_MAXNUMBANDS)
#define writeGEQRovr1Width(N)   writeGEQWidthCh(7, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr1Width      wroteGEQWidthCh(7, 0, GEQ_MAXNUMBANDS)

#define  readGEQRovr2Freq        readGEQFreqCh(7, 1, GEQ_MAXNUMBANDS)
#define writeGEQRovr2Freq(N)    writeGEQFreqCh(7, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr2Freq       wroteGEQFreqCh(7, 1, GEQ_MAXNUMBANDS)
#define  readGEQRovr2Level       readGEQLevelCh(7, 1, GEQ_MAXNUMBANDS)
#define writeGEQRovr2Level(N)   writeGEQLevelCh(7, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr2Level      wroteGEQLevelCh(7, 1, GEQ_MAXNUMBANDS)
#define  readGEQRovr2Width       readGEQWidthCh(7, 1, GEQ_MAXNUMBANDS)
#define writeGEQRovr2Width(N)   writeGEQWidthCh(7, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr2Width      wroteGEQWidthCh(7, 1, GEQ_MAXNUMBANDS)

#define  readGEQRovr3Freq        readGEQFreqCh(7, 2, GEQ_MAXNUMBANDS)
#define writeGEQRovr3Freq(N)    writeGEQFreqCh(7, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr3Freq       wroteGEQFreqCh(7, 2, GEQ_MAXNUMBANDS)
#define  readGEQRovr3Level       readGEQLevelCh(7, 2, GEQ_MAXNUMBANDS)
#define writeGEQRovr3Level(N)   writeGEQLevelCh(7, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr3Level      wroteGEQLevelCh(7, 2, GEQ_MAXNUMBANDS)
#define  readGEQRovr3Width       readGEQWidthCh(7, 2, GEQ_MAXNUMBANDS)
#define writeGEQRovr3Width(N)   writeGEQWidthCh(7, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr3Width      wroteGEQWidthCh(7, 2, GEQ_MAXNUMBANDS)

#define  readGEQRovr4Freq        readGEQFreqCh(7, 3, GEQ_MAXNUMBANDS)
#define writeGEQRovr4Freq(N)    writeGEQFreqCh(7, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr4Freq       wroteGEQFreqCh(7, 3, GEQ_MAXNUMBANDS)
#define  readGEQRovr4Level       readGEQLevelCh(7, 3, GEQ_MAXNUMBANDS)
#define writeGEQRovr4Level(N)   writeGEQLevelCh(7, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr4Level      wroteGEQLevelCh(7, 3, GEQ_MAXNUMBANDS)
#define  readGEQRovr4Width       readGEQWidthCh(7, 3, GEQ_MAXNUMBANDS)
#define writeGEQRovr4Width(N)   writeGEQWidthCh(7, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr4Width      wroteGEQWidthCh(7, 3, GEQ_MAXNUMBANDS)

#define  readGEQRovr5Freq        readGEQFreqCh(7, 4, GEQ_MAXNUMBANDS)
#define writeGEQRovr5Freq(N)    writeGEQFreqCh(7, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr5Freq       wroteGEQFreqCh(7, 4, GEQ_MAXNUMBANDS)
#define  readGEQRovr5Level       readGEQLevelCh(7, 4, GEQ_MAXNUMBANDS)
#define writeGEQRovr5Level(N)   writeGEQLevelCh(7, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr5Level      wroteGEQLevelCh(7, 4, GEQ_MAXNUMBANDS)
#define  readGEQRovr5Width       readGEQWidthCh(7, 4, GEQ_MAXNUMBANDS)
#define writeGEQRovr5Width(N)   writeGEQWidthCh(7, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr5Width      wroteGEQWidthCh(7, 4, GEQ_MAXNUMBANDS)

#define  readGEQRovr6Freq        readGEQFreqCh(7, 5, GEQ_MAXNUMBANDS)
#define writeGEQRovr6Freq(N)    writeGEQFreqCh(7, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr6Freq       wroteGEQFreqCh(7, 5, GEQ_MAXNUMBANDS)
#define  readGEQRovr6Level       readGEQLevelCh(7, 5, GEQ_MAXNUMBANDS)
#define writeGEQRovr6Level(N)   writeGEQLevelCh(7, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr6Level      wroteGEQLevelCh(7, 5, GEQ_MAXNUMBANDS)
#define  readGEQRovr6Width       readGEQWidthCh(7, 5, GEQ_MAXNUMBANDS)
#define writeGEQRovr6Width(N)   writeGEQWidthCh(7, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr6Width      wroteGEQWidthCh(7, 5, GEQ_MAXNUMBANDS)

#define  readGEQRovr7Freq        readGEQFreqCh(7, 6, GEQ_MAXNUMBANDS)
#define writeGEQRovr7Freq(N)    writeGEQFreqCh(7, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr7Freq       wroteGEQFreqCh(7, 6, GEQ_MAXNUMBANDS)
#define  readGEQRovr7Level       readGEQLevelCh(7, 6, GEQ_MAXNUMBANDS)
#define writeGEQRovr7Level(N)   writeGEQLevelCh(7, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr7Level      wroteGEQLevelCh(7, 6, GEQ_MAXNUMBANDS)
#define  readGEQRovr7Width       readGEQWidthCh(7, 6, GEQ_MAXNUMBANDS)
#define writeGEQRovr7Width(N)   writeGEQWidthCh(7, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr7Width      wroteGEQWidthCh(7, 6, GEQ_MAXNUMBANDS)

#define  readGEQRovr8Freq        readGEQFreqCh(7, 7, GEQ_MAXNUMBANDS)
#define writeGEQRovr8Freq(N)    writeGEQFreqCh(7, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr8Freq       wroteGEQFreqCh(7, 7, GEQ_MAXNUMBANDS)
#define  readGEQRovr8Level       readGEQLevelCh(7, 7, GEQ_MAXNUMBANDS)
#define writeGEQRovr8Level(N)   writeGEQLevelCh(7, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr8Level      wroteGEQLevelCh(7, 7, GEQ_MAXNUMBANDS)
#define  readGEQRovr8Width       readGEQWidthCh(7, 7, GEQ_MAXNUMBANDS)
#define writeGEQRovr8Width(N)   writeGEQWidthCh(7, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr8Width      wroteGEQWidthCh(7, 7, GEQ_MAXNUMBANDS)

#define  readGEQRovr9Freq        readGEQFreqCh(7, 8, GEQ_MAXNUMBANDS)
#define writeGEQRovr9Freq(N)    writeGEQFreqCh(7, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr9Freq       wroteGEQFreqCh(7, 8, GEQ_MAXNUMBANDS)
#define  readGEQRovr9Level       readGEQLevelCh(7, 8, GEQ_MAXNUMBANDS)
#define writeGEQRovr9Level(N)   writeGEQLevelCh(7, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr9Level      wroteGEQLevelCh(7, 8, GEQ_MAXNUMBANDS)
#define  readGEQRovr9Width       readGEQWidthCh(7, 8, GEQ_MAXNUMBANDS)
#define writeGEQRovr9Width(N)   writeGEQWidthCh(7, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr9Width      wroteGEQWidthCh(7, 8, GEQ_MAXNUMBANDS)

#define  readGEQRovr10Freq        readGEQFreqCh(7, 9, GEQ_MAXNUMBANDS)
#define writeGEQRovr10Freq(N)    writeGEQFreqCh(7, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr10Freq       wroteGEQFreqCh(7, 9, GEQ_MAXNUMBANDS)
#define  readGEQRovr10Level       readGEQLevelCh(7, 9, GEQ_MAXNUMBANDS)
#define writeGEQRovr10Level(N)   writeGEQLevelCh(7, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr10Level      wroteGEQLevelCh(7, 9, GEQ_MAXNUMBANDS)
#define  readGEQRovr10Width       readGEQWidthCh(7, 9, GEQ_MAXNUMBANDS)
#define writeGEQRovr10Width(N)   writeGEQWidthCh(7, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr10Width      wroteGEQWidthCh(7, 9, GEQ_MAXNUMBANDS)

#define  readGEQRovr11Freq        readGEQFreqCh(7, 10, GEQ_MAXNUMBANDS)
#define writeGEQRovr11Freq(N)    writeGEQFreqCh(7, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr11Freq       wroteGEQFreqCh(7, 10, GEQ_MAXNUMBANDS)
#define  readGEQRovr11Level       readGEQLevelCh(7, 10, GEQ_MAXNUMBANDS)
#define writeGEQRovr11Level(N)   writeGEQLevelCh(7, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr11Level      wroteGEQLevelCh(7, 10, GEQ_MAXNUMBANDS)
#define  readGEQRovr11Width       readGEQWidthCh(7, 10, GEQ_MAXNUMBANDS)
#define writeGEQRovr11Width(N)   writeGEQWidthCh(7, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr11Width      wroteGEQWidthCh(7, 10, GEQ_MAXNUMBANDS)

#define  readGEQRovr12Freq        readGEQFreqCh(7, 11, GEQ_MAXNUMBANDS)
#define writeGEQRovr12Freq(N)    writeGEQFreqCh(7, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr12Freq       wroteGEQFreqCh(7, 11, GEQ_MAXNUMBANDS)
#define  readGEQRovr12Level       readGEQLevelCh(7, 11, GEQ_MAXNUMBANDS)
#define writeGEQRovr12Level(N)   writeGEQLevelCh(7, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr12Level      wroteGEQLevelCh(7, 11, GEQ_MAXNUMBANDS)
#define  readGEQRovr12Width       readGEQWidthCh(7, 11, GEQ_MAXNUMBANDS)
#define writeGEQRovr12Width(N)   writeGEQWidthCh(7, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr12Width      wroteGEQWidthCh(7, 11, GEQ_MAXNUMBANDS)

#define  readGEQRovr13Freq        readGEQFreqCh(7, 12, GEQ_MAXNUMBANDS)
#define writeGEQRovr13Freq(N)    writeGEQFreqCh(7, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr13Freq       wroteGEQFreqCh(7, 12, GEQ_MAXNUMBANDS)
#define  readGEQRovr13Level       readGEQLevelCh(7, 12, GEQ_MAXNUMBANDS)
#define writeGEQRovr13Level(N)   writeGEQLevelCh(7, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr13Level      wroteGEQLevelCh(7, 12, GEQ_MAXNUMBANDS)
#define  readGEQRovr13Width       readGEQWidthCh(7, 12, GEQ_MAXNUMBANDS)
#define writeGEQRovr13Width(N)   writeGEQWidthCh(7, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr13Width      wroteGEQWidthCh(7, 12, GEQ_MAXNUMBANDS)

#define  readGEQRovr14Freq        readGEQFreqCh(7, 13, GEQ_MAXNUMBANDS)
#define writeGEQRovr14Freq(N)    writeGEQFreqCh(7, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr14Freq       wroteGEQFreqCh(7, 13, GEQ_MAXNUMBANDS)
#define  readGEQRovr14Level       readGEQLevelCh(7, 13, GEQ_MAXNUMBANDS)
#define writeGEQRovr14Level(N)   writeGEQLevelCh(7, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr14Level      wroteGEQLevelCh(7, 13, GEQ_MAXNUMBANDS)
#define  readGEQRovr14Width       readGEQWidthCh(7, 13, GEQ_MAXNUMBANDS)
#define writeGEQRovr14Width(N)   writeGEQWidthCh(7, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr14Width      wroteGEQWidthCh(7, 13, GEQ_MAXNUMBANDS)

#define  readGEQRovr15Freq        readGEQFreqCh(7, 14, GEQ_MAXNUMBANDS)
#define writeGEQRovr15Freq(N)    writeGEQFreqCh(7, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr15Freq       wroteGEQFreqCh(7, 14, GEQ_MAXNUMBANDS)
#define  readGEQRovr15Level       readGEQLevelCh(7, 14, GEQ_MAXNUMBANDS)
#define writeGEQRovr15Level(N)   writeGEQLevelCh(7, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr15Level      wroteGEQLevelCh(7, 14, GEQ_MAXNUMBANDS)
#define  readGEQRovr15Width       readGEQWidthCh(7, 14, GEQ_MAXNUMBANDS)
#define writeGEQRovr15Width(N)   writeGEQWidthCh(7, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr15Width      wroteGEQWidthCh(7, 14, GEQ_MAXNUMBANDS)

#define  readGEQRovr16Freq        readGEQFreqCh(7, 15, GEQ_MAXNUMBANDS)
#define writeGEQRovr16Freq(N)    writeGEQFreqCh(7, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr16Freq       wroteGEQFreqCh(7, 15, GEQ_MAXNUMBANDS)
#define  readGEQRovr16Level       readGEQLevelCh(7, 15, GEQ_MAXNUMBANDS)
#define writeGEQRovr16Level(N)   writeGEQLevelCh(7, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr16Level      wroteGEQLevelCh(7, 15, GEQ_MAXNUMBANDS)
#define  readGEQRovr16Width       readGEQWidthCh(7, 15, GEQ_MAXNUMBANDS)
#define writeGEQRovr16Width(N)   writeGEQWidthCh(7, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr16Width      wroteGEQWidthCh(7, 15, GEQ_MAXNUMBANDS)

#define  readGEQRovr17Freq        readGEQFreqCh(7, 16, GEQ_MAXNUMBANDS)
#define writeGEQRovr17Freq(N)    writeGEQFreqCh(7, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr17Freq       wroteGEQFreqCh(7, 16, GEQ_MAXNUMBANDS)
#define  readGEQRovr17Level       readGEQLevelCh(7, 16, GEQ_MAXNUMBANDS)
#define writeGEQRovr17Level(N)   writeGEQLevelCh(7, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr17Level      wroteGEQLevelCh(7, 16, GEQ_MAXNUMBANDS)
#define  readGEQRovr17Width       readGEQWidthCh(7, 16, GEQ_MAXNUMBANDS)
#define writeGEQRovr17Width(N)   writeGEQWidthCh(7, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr17Width      wroteGEQWidthCh(7, 16, GEQ_MAXNUMBANDS)

#define  readGEQRovr18Freq        readGEQFreqCh(7, 17, GEQ_MAXNUMBANDS)
#define writeGEQRovr18Freq(N)    writeGEQFreqCh(7, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr18Freq       wroteGEQFreqCh(7, 17, GEQ_MAXNUMBANDS)
#define  readGEQRovr18Level       readGEQLevelCh(7, 17, GEQ_MAXNUMBANDS)
#define writeGEQRovr18Level(N)   writeGEQLevelCh(7, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr18Level      wroteGEQLevelCh(7, 17, GEQ_MAXNUMBANDS)
#define  readGEQRovr18Width       readGEQWidthCh(7, 17, GEQ_MAXNUMBANDS)
#define writeGEQRovr18Width(N)   writeGEQWidthCh(7, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr18Width      wroteGEQWidthCh(7, 17, GEQ_MAXNUMBANDS)

#define  readGEQRovr19Freq        readGEQFreqCh(7, 18, GEQ_MAXNUMBANDS)
#define writeGEQRovr19Freq(N)    writeGEQFreqCh(7, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr19Freq       wroteGEQFreqCh(7, 18, GEQ_MAXNUMBANDS)
#define  readGEQRovr19Level       readGEQLevelCh(7, 18, GEQ_MAXNUMBANDS)
#define writeGEQRovr19Level(N)   writeGEQLevelCh(7, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr19Level      wroteGEQLevelCh(7, 18, GEQ_MAXNUMBANDS)
#define  readGEQRovr19Width       readGEQWidthCh(7, 18, GEQ_MAXNUMBANDS)
#define writeGEQRovr19Width(N)   writeGEQWidthCh(7, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr19Width      wroteGEQWidthCh(7, 18, GEQ_MAXNUMBANDS)

#define  readGEQRovr20Freq        readGEQFreqCh(7, 19, GEQ_MAXNUMBANDS)
#define writeGEQRovr20Freq(N)    writeGEQFreqCh(7, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr20Freq       wroteGEQFreqCh(7, 19, GEQ_MAXNUMBANDS)
#define  readGEQRovr20Level       readGEQLevelCh(7, 19, GEQ_MAXNUMBANDS)
#define writeGEQRovr20Level(N)   writeGEQLevelCh(7, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr20Level      wroteGEQLevelCh(7, 19, GEQ_MAXNUMBANDS)
#define  readGEQRovr20Width       readGEQWidthCh(7, 19, GEQ_MAXNUMBANDS)
#define writeGEQRovr20Width(N)   writeGEQWidthCh(7, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr20Width      wroteGEQWidthCh(7, 19, GEQ_MAXNUMBANDS)

#define  readGEQRovr21Freq        readGEQFreqCh(7, 20, GEQ_MAXNUMBANDS)
#define writeGEQRovr21Freq(N)    writeGEQFreqCh(7, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr21Freq       wroteGEQFreqCh(7, 20, GEQ_MAXNUMBANDS)
#define  readGEQRovr21Level       readGEQLevelCh(7, 20, GEQ_MAXNUMBANDS)
#define writeGEQRovr21Level(N)   writeGEQLevelCh(7, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr21Level      wroteGEQLevelCh(7, 20, GEQ_MAXNUMBANDS)
#define  readGEQRovr21Width       readGEQWidthCh(7, 20, GEQ_MAXNUMBANDS)
#define writeGEQRovr21Width(N)   writeGEQWidthCh(7, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr21Width      wroteGEQWidthCh(7, 20, GEQ_MAXNUMBANDS)

#define  readGEQRovr22Freq        readGEQFreqCh(7, 21, GEQ_MAXNUMBANDS)
#define writeGEQRovr22Freq(N)    writeGEQFreqCh(7, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr22Freq       wroteGEQFreqCh(7, 21, GEQ_MAXNUMBANDS)
#define  readGEQRovr22Level       readGEQLevelCh(7, 21, GEQ_MAXNUMBANDS)
#define writeGEQRovr22Level(N)   writeGEQLevelCh(7, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr22Level      wroteGEQLevelCh(7, 21, GEQ_MAXNUMBANDS)
#define  readGEQRovr22Width       readGEQWidthCh(7, 21, GEQ_MAXNUMBANDS)
#define writeGEQRovr22Width(N)   writeGEQWidthCh(7, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr22Width      wroteGEQWidthCh(7, 21, GEQ_MAXNUMBANDS)

#define  readGEQRovr23Freq        readGEQFreqCh(7, 22, GEQ_MAXNUMBANDS)
#define writeGEQRovr23Freq(N)    writeGEQFreqCh(7, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr23Freq       wroteGEQFreqCh(7, 22, GEQ_MAXNUMBANDS)
#define  readGEQRovr23Level       readGEQLevelCh(7, 22, GEQ_MAXNUMBANDS)
#define writeGEQRovr23Level(N)   writeGEQLevelCh(7, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr23Level      wroteGEQLevelCh(7, 22, GEQ_MAXNUMBANDS)
#define  readGEQRovr23Width       readGEQWidthCh(7, 22, GEQ_MAXNUMBANDS)
#define writeGEQRovr23Width(N)   writeGEQWidthCh(7, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr23Width      wroteGEQWidthCh(7, 22, GEQ_MAXNUMBANDS)

#define  readGEQRovr24Freq        readGEQFreqCh(7, 23, GEQ_MAXNUMBANDS)
#define writeGEQRovr24Freq(N)    writeGEQFreqCh(7, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr24Freq       wroteGEQFreqCh(7, 23, GEQ_MAXNUMBANDS)
#define  readGEQRovr24Level       readGEQLevelCh(7, 23, GEQ_MAXNUMBANDS)
#define writeGEQRovr24Level(N)   writeGEQLevelCh(7, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr24Level      wroteGEQLevelCh(7, 23, GEQ_MAXNUMBANDS)
#define  readGEQRovr24Width       readGEQWidthCh(7, 23, GEQ_MAXNUMBANDS)
#define writeGEQRovr24Width(N)   writeGEQWidthCh(7, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr24Width      wroteGEQWidthCh(7, 23, GEQ_MAXNUMBANDS)

#define  readGEQRovr25Freq        readGEQFreqCh(7, 24, GEQ_MAXNUMBANDS)
#define writeGEQRovr25Freq(N)    writeGEQFreqCh(7, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr25Freq       wroteGEQFreqCh(7, 24, GEQ_MAXNUMBANDS)
#define  readGEQRovr25Level       readGEQLevelCh(7, 24, GEQ_MAXNUMBANDS)
#define writeGEQRovr25Level(N)   writeGEQLevelCh(7, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr25Level      wroteGEQLevelCh(7, 24, GEQ_MAXNUMBANDS)
#define  readGEQRovr25Width       readGEQWidthCh(7, 24, GEQ_MAXNUMBANDS)
#define writeGEQRovr25Width(N)   writeGEQWidthCh(7, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr25Width      wroteGEQWidthCh(7, 24, GEQ_MAXNUMBANDS)

#define  readGEQRovr26Freq        readGEQFreqCh(7, 25, GEQ_MAXNUMBANDS)
#define writeGEQRovr26Freq(N)    writeGEQFreqCh(7, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr26Freq       wroteGEQFreqCh(7, 25, GEQ_MAXNUMBANDS)
#define  readGEQRovr26Level       readGEQLevelCh(7, 25, GEQ_MAXNUMBANDS)
#define writeGEQRovr26Level(N)   writeGEQLevelCh(7, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr26Level      wroteGEQLevelCh(7, 25, GEQ_MAXNUMBANDS)
#define  readGEQRovr26Width       readGEQWidthCh(7, 25, GEQ_MAXNUMBANDS)
#define writeGEQRovr26Width(N)   writeGEQWidthCh(7, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr26Width      wroteGEQWidthCh(7, 25, GEQ_MAXNUMBANDS)

#define  readGEQRovr27Freq        readGEQFreqCh(7, 26, GEQ_MAXNUMBANDS)
#define writeGEQRovr27Freq(N)    writeGEQFreqCh(7, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr27Freq       wroteGEQFreqCh(7, 26, GEQ_MAXNUMBANDS)
#define  readGEQRovr27Level       readGEQLevelCh(7, 26, GEQ_MAXNUMBANDS)
#define writeGEQRovr27Level(N)   writeGEQLevelCh(7, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr27Level      wroteGEQLevelCh(7, 26, GEQ_MAXNUMBANDS)
#define  readGEQRovr27Width       readGEQWidthCh(7, 26, GEQ_MAXNUMBANDS)
#define writeGEQRovr27Width(N)   writeGEQWidthCh(7, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr27Width      wroteGEQWidthCh(7, 26, GEQ_MAXNUMBANDS)

#define  readGEQRovr28Freq        readGEQFreqCh(7, 27, GEQ_MAXNUMBANDS)
#define writeGEQRovr28Freq(N)    writeGEQFreqCh(7, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr28Freq       wroteGEQFreqCh(7, 27, GEQ_MAXNUMBANDS)
#define  readGEQRovr28Level       readGEQLevelCh(7, 27, GEQ_MAXNUMBANDS)
#define writeGEQRovr28Level(N)   writeGEQLevelCh(7, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr28Level      wroteGEQLevelCh(7, 27, GEQ_MAXNUMBANDS)
#define  readGEQRovr28Width       readGEQWidthCh(7, 27, GEQ_MAXNUMBANDS)
#define writeGEQRovr28Width(N)   writeGEQWidthCh(7, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr28Width      wroteGEQWidthCh(7, 27, GEQ_MAXNUMBANDS)

#define  readGEQRovr29Freq        readGEQFreqCh(7, 28, GEQ_MAXNUMBANDS)
#define writeGEQRovr29Freq(N)    writeGEQFreqCh(7, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr29Freq       wroteGEQFreqCh(7, 28, GEQ_MAXNUMBANDS)
#define  readGEQRovr29Level       readGEQLevelCh(7, 28, GEQ_MAXNUMBANDS)
#define writeGEQRovr29Level(N)   writeGEQLevelCh(7, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr29Level      wroteGEQLevelCh(7, 28, GEQ_MAXNUMBANDS)
#define  readGEQRovr29Width       readGEQWidthCh(7, 28, GEQ_MAXNUMBANDS)
#define writeGEQRovr29Width(N)   writeGEQWidthCh(7, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr29Width      wroteGEQWidthCh(7, 28, GEQ_MAXNUMBANDS)

#define  readGEQRovr30Freq        readGEQFreqCh(7, 29, GEQ_MAXNUMBANDS)
#define writeGEQRovr30Freq(N)    writeGEQFreqCh(7, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr30Freq       wroteGEQFreqCh(7, 29, GEQ_MAXNUMBANDS)
#define  readGEQRovr30Level       readGEQLevelCh(7, 29, GEQ_MAXNUMBANDS)
#define writeGEQRovr30Level(N)   writeGEQLevelCh(7, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr30Level      wroteGEQLevelCh(7, 29, GEQ_MAXNUMBANDS)
#define  readGEQRovr30Width       readGEQWidthCh(7, 29, GEQ_MAXNUMBANDS)
#define writeGEQRovr30Width(N)   writeGEQWidthCh(7, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr30Width      wroteGEQWidthCh(7, 29, GEQ_MAXNUMBANDS)

#define  readGEQRovr31Freq        readGEQFreqCh(7, 30, GEQ_MAXNUMBANDS)
#define writeGEQRovr31Freq(N)    writeGEQFreqCh(7, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr31Freq       wroteGEQFreqCh(7, 30, GEQ_MAXNUMBANDS)
#define  readGEQRovr31Level       readGEQLevelCh(7, 30, GEQ_MAXNUMBANDS)
#define writeGEQRovr31Level(N)   writeGEQLevelCh(7, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr31Level      wroteGEQLevelCh(7, 30, GEQ_MAXNUMBANDS)
#define  readGEQRovr31Width       readGEQWidthCh(7, 30, GEQ_MAXNUMBANDS)
#define writeGEQRovr31Width(N)   writeGEQWidthCh(7, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr31Width      wroteGEQWidthCh(7, 30, GEQ_MAXNUMBANDS)

#define  readGEQRovr32Freq        readGEQFreqCh(7, 31, GEQ_MAXNUMBANDS)
#define writeGEQRovr32Freq(N)    writeGEQFreqCh(7, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr32Freq       wroteGEQFreqCh(7, 31, GEQ_MAXNUMBANDS)
#define  readGEQRovr32Level       readGEQLevelCh(7, 31, GEQ_MAXNUMBANDS)
#define writeGEQRovr32Level(N)   writeGEQLevelCh(7, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr32Level      wroteGEQLevelCh(7, 31, GEQ_MAXNUMBANDS)
#define  readGEQRovr32Width       readGEQWidthCh(7, 31, GEQ_MAXNUMBANDS)
#define writeGEQRovr32Width(N)   writeGEQWidthCh(7, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRovr32Width      wroteGEQWidthCh(7, 31, GEQ_MAXNUMBANDS)

#define  readGEQSurr1Freq        readGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQSurr1Freq(N)    writeGEQFreqCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr1Freq       wroteGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQSurr1Level       readGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQSurr1Level(N)   writeGEQLevelCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr1Level      wroteGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQSurr1Width       readGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQSurr1Width(N)   writeGEQWidthCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr1Width      wroteGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)

#define  readGEQSurr2Freq        readGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQSurr2Freq(N)    writeGEQFreqCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr2Freq       wroteGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQSurr2Level       readGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQSurr2Level(N)   writeGEQLevelCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr2Level      wroteGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQSurr2Width       readGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQSurr2Width(N)   writeGEQWidthCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr2Width      wroteGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)

#define  readGEQSurr3Freq        readGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQSurr3Freq(N)    writeGEQFreqCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr3Freq       wroteGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQSurr3Level       readGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQSurr3Level(N)   writeGEQLevelCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr3Level      wroteGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQSurr3Width       readGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQSurr3Width(N)   writeGEQWidthCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr3Width      wroteGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)

#define  readGEQSurr4Freq        readGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQSurr4Freq(N)    writeGEQFreqCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr4Freq       wroteGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQSurr4Level       readGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQSurr4Level(N)   writeGEQLevelCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr4Level      wroteGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQSurr4Width       readGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQSurr4Width(N)   writeGEQWidthCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr4Width      wroteGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)

#define  readGEQSurr5Freq        readGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQSurr5Freq(N)    writeGEQFreqCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr5Freq       wroteGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQSurr5Level       readGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQSurr5Level(N)   writeGEQLevelCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr5Level      wroteGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQSurr5Width       readGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQSurr5Width(N)   writeGEQWidthCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr5Width      wroteGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)

#define  readGEQSurr6Freq        readGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQSurr6Freq(N)    writeGEQFreqCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr6Freq       wroteGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQSurr6Level       readGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQSurr6Level(N)   writeGEQLevelCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr6Level      wroteGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQSurr6Width       readGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQSurr6Width(N)   writeGEQWidthCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr6Width      wroteGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)

#define  readGEQSurr7Freq        readGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQSurr7Freq(N)    writeGEQFreqCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr7Freq       wroteGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQSurr7Level       readGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQSurr7Level(N)   writeGEQLevelCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr7Level      wroteGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQSurr7Width       readGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQSurr7Width(N)   writeGEQWidthCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr7Width      wroteGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)

#define  readGEQSurr8Freq        readGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQSurr8Freq(N)    writeGEQFreqCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr8Freq       wroteGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQSurr8Level       readGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQSurr8Level(N)   writeGEQLevelCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr8Level      wroteGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQSurr8Width       readGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQSurr8Width(N)   writeGEQWidthCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr8Width      wroteGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)

#define  readGEQSurr9Freq        readGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQSurr9Freq(N)    writeGEQFreqCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr9Freq       wroteGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQSurr9Level       readGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQSurr9Level(N)   writeGEQLevelCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr9Level      wroteGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQSurr9Width       readGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQSurr9Width(N)   writeGEQWidthCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr9Width      wroteGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)

#define  readGEQSurr10Freq        readGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQSurr10Freq(N)    writeGEQFreqCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr10Freq       wroteGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQSurr10Level       readGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQSurr10Level(N)   writeGEQLevelCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr10Level      wroteGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQSurr10Width       readGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQSurr10Width(N)   writeGEQWidthCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr10Width      wroteGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)

#define  readGEQSurr11Freq        readGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQSurr11Freq(N)    writeGEQFreqCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr11Freq       wroteGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQSurr11Level       readGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQSurr11Level(N)   writeGEQLevelCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr11Level      wroteGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQSurr11Width       readGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQSurr11Width(N)   writeGEQWidthCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr11Width      wroteGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)

#define  readGEQSurr12Freq        readGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQSurr12Freq(N)    writeGEQFreqCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr12Freq       wroteGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQSurr12Level       readGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQSurr12Level(N)   writeGEQLevelCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr12Level      wroteGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQSurr12Width       readGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQSurr12Width(N)   writeGEQWidthCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr12Width      wroteGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)

#define  readGEQSurr13Freq        readGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQSurr13Freq(N)    writeGEQFreqCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr13Freq       wroteGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQSurr13Level       readGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQSurr13Level(N)   writeGEQLevelCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr13Level      wroteGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQSurr13Width       readGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQSurr13Width(N)   writeGEQWidthCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr13Width      wroteGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)

#define  readGEQSurr14Freq        readGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQSurr14Freq(N)    writeGEQFreqCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr14Freq       wroteGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQSurr14Level       readGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQSurr14Level(N)   writeGEQLevelCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr14Level      wroteGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQSurr14Width       readGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQSurr14Width(N)   writeGEQWidthCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr14Width      wroteGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)

#define  readGEQSurr15Freq        readGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQSurr15Freq(N)    writeGEQFreqCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr15Freq       wroteGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQSurr15Level       readGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQSurr15Level(N)   writeGEQLevelCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr15Level      wroteGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQSurr15Width       readGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQSurr15Width(N)   writeGEQWidthCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr15Width      wroteGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)

#define  readGEQSurr16Freq        readGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQSurr16Freq(N)    writeGEQFreqCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr16Freq       wroteGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQSurr16Level       readGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQSurr16Level(N)   writeGEQLevelCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr16Level      wroteGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQSurr16Width       readGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQSurr16Width(N)   writeGEQWidthCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr16Width      wroteGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)

#define  readGEQSurr17Freq        readGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQSurr17Freq(N)    writeGEQFreqCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr17Freq       wroteGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQSurr17Level       readGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQSurr17Level(N)   writeGEQLevelCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr17Level      wroteGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQSurr17Width       readGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQSurr17Width(N)   writeGEQWidthCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr17Width      wroteGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)

#define  readGEQSurr18Freq        readGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQSurr18Freq(N)    writeGEQFreqCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr18Freq       wroteGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQSurr18Level       readGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQSurr18Level(N)   writeGEQLevelCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr18Level      wroteGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQSurr18Width       readGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQSurr18Width(N)   writeGEQWidthCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr18Width      wroteGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)

#define  readGEQSurr19Freq        readGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQSurr19Freq(N)    writeGEQFreqCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr19Freq       wroteGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQSurr19Level       readGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQSurr19Level(N)   writeGEQLevelCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr19Level      wroteGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQSurr19Width       readGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQSurr19Width(N)   writeGEQWidthCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr19Width      wroteGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)

#define  readGEQSurr20Freq        readGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQSurr20Freq(N)    writeGEQFreqCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr20Freq       wroteGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQSurr20Level       readGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQSurr20Level(N)   writeGEQLevelCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr20Level      wroteGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQSurr20Width       readGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQSurr20Width(N)   writeGEQWidthCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr20Width      wroteGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)

#define  readGEQSurr21Freq        readGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQSurr21Freq(N)    writeGEQFreqCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr21Freq       wroteGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQSurr21Level       readGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQSurr21Level(N)   writeGEQLevelCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr21Level      wroteGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQSurr21Width       readGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQSurr21Width(N)   writeGEQWidthCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr21Width      wroteGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)

#define  readGEQSurr22Freq        readGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQSurr22Freq(N)    writeGEQFreqCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr22Freq       wroteGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQSurr22Level       readGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQSurr22Level(N)   writeGEQLevelCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr22Level      wroteGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQSurr22Width       readGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQSurr22Width(N)   writeGEQWidthCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr22Width      wroteGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)

#define  readGEQSurr23Freq        readGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQSurr23Freq(N)    writeGEQFreqCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr23Freq       wroteGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQSurr23Level       readGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQSurr23Level(N)   writeGEQLevelCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr23Level      wroteGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQSurr23Width       readGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQSurr23Width(N)   writeGEQWidthCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr23Width      wroteGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)

#define  readGEQSurr24Freq        readGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQSurr24Freq(N)    writeGEQFreqCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr24Freq       wroteGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQSurr24Level       readGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQSurr24Level(N)   writeGEQLevelCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr24Level      wroteGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQSurr24Width       readGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQSurr24Width(N)   writeGEQWidthCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr24Width      wroteGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)

#define  readGEQSurr25Freq        readGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQSurr25Freq(N)    writeGEQFreqCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr25Freq       wroteGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQSurr25Level       readGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQSurr25Level(N)   writeGEQLevelCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr25Level      wroteGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQSurr25Width       readGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQSurr25Width(N)   writeGEQWidthCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr25Width      wroteGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)

#define  readGEQSurr26Freq        readGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQSurr26Freq(N)    writeGEQFreqCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr26Freq       wroteGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQSurr26Level       readGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQSurr26Level(N)   writeGEQLevelCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr26Level      wroteGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQSurr26Width       readGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQSurr26Width(N)   writeGEQWidthCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr26Width      wroteGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)

#define  readGEQSurr27Freq        readGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQSurr27Freq(N)    writeGEQFreqCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr27Freq       wroteGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQSurr27Level       readGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQSurr27Level(N)   writeGEQLevelCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr27Level      wroteGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQSurr27Width       readGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQSurr27Width(N)   writeGEQWidthCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr27Width      wroteGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)

#define  readGEQSurr28Freq        readGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQSurr28Freq(N)    writeGEQFreqCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr28Freq       wroteGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQSurr28Level       readGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQSurr28Level(N)   writeGEQLevelCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr28Level      wroteGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQSurr28Width       readGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQSurr28Width(N)   writeGEQWidthCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr28Width      wroteGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)

#define  readGEQSurr29Freq        readGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQSurr29Freq(N)    writeGEQFreqCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr29Freq       wroteGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQSurr29Level       readGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQSurr29Level(N)   writeGEQLevelCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr29Level      wroteGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQSurr29Width       readGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQSurr29Width(N)   writeGEQWidthCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr29Width      wroteGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)

#define  readGEQSurr30Freq        readGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQSurr30Freq(N)    writeGEQFreqCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr30Freq       wroteGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQSurr30Level       readGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQSurr30Level(N)   writeGEQLevelCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr30Level      wroteGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQSurr30Width       readGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQSurr30Width(N)   writeGEQWidthCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr30Width      wroteGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)

#define  readGEQSurr31Freq        readGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQSurr31Freq(N)    writeGEQFreqCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr31Freq       wroteGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQSurr31Level       readGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQSurr31Level(N)   writeGEQLevelCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr31Level      wroteGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQSurr31Width       readGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQSurr31Width(N)   writeGEQWidthCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr31Width      wroteGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)

#define  readGEQSurr32Freq        readGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQSurr32Freq(N)    writeGEQFreqCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr32Freq       wroteGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQSurr32Level       readGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQSurr32Level(N)   writeGEQLevelCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr32Level      wroteGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQSurr32Width       readGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQSurr32Width(N)   writeGEQWidthCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQSurr32Width      wroteGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)

#define  readGEQLsur1Freq        readGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQLsur1Freq(N)    writeGEQFreqCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur1Freq       wroteGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQLsur1Level       readGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQLsur1Level(N)   writeGEQLevelCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur1Level      wroteGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQLsur1Width       readGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQLsur1Width(N)   writeGEQWidthCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur1Width      wroteGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)

#define  readGEQLsur2Freq        readGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQLsur2Freq(N)    writeGEQFreqCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur2Freq       wroteGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQLsur2Level       readGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQLsur2Level(N)   writeGEQLevelCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur2Level      wroteGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQLsur2Width       readGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQLsur2Width(N)   writeGEQWidthCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur2Width      wroteGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)

#define  readGEQLsur3Freq        readGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQLsur3Freq(N)    writeGEQFreqCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur3Freq       wroteGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQLsur3Level       readGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQLsur3Level(N)   writeGEQLevelCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur3Level      wroteGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQLsur3Width       readGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQLsur3Width(N)   writeGEQWidthCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur3Width      wroteGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)

#define  readGEQLsur4Freq        readGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQLsur4Freq(N)    writeGEQFreqCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur4Freq       wroteGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQLsur4Level       readGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQLsur4Level(N)   writeGEQLevelCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur4Level      wroteGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQLsur4Width       readGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQLsur4Width(N)   writeGEQWidthCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur4Width      wroteGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)

#define  readGEQLsur5Freq        readGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQLsur5Freq(N)    writeGEQFreqCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur5Freq       wroteGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQLsur5Level       readGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQLsur5Level(N)   writeGEQLevelCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur5Level      wroteGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQLsur5Width       readGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQLsur5Width(N)   writeGEQWidthCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur5Width      wroteGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)

#define  readGEQLsur6Freq        readGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQLsur6Freq(N)    writeGEQFreqCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur6Freq       wroteGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQLsur6Level       readGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQLsur6Level(N)   writeGEQLevelCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur6Level      wroteGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQLsur6Width       readGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQLsur6Width(N)   writeGEQWidthCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur6Width      wroteGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)

#define  readGEQLsur7Freq        readGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQLsur7Freq(N)    writeGEQFreqCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur7Freq       wroteGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQLsur7Level       readGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQLsur7Level(N)   writeGEQLevelCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur7Level      wroteGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQLsur7Width       readGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQLsur7Width(N)   writeGEQWidthCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur7Width      wroteGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)

#define  readGEQLsur8Freq        readGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQLsur8Freq(N)    writeGEQFreqCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur8Freq       wroteGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQLsur8Level       readGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQLsur8Level(N)   writeGEQLevelCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur8Level      wroteGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQLsur8Width       readGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQLsur8Width(N)   writeGEQWidthCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur8Width      wroteGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)

#define  readGEQLsur9Freq        readGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQLsur9Freq(N)    writeGEQFreqCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur9Freq       wroteGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQLsur9Level       readGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQLsur9Level(N)   writeGEQLevelCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur9Level      wroteGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQLsur9Width       readGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQLsur9Width(N)   writeGEQWidthCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur9Width      wroteGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)

#define  readGEQLsur10Freq        readGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQLsur10Freq(N)    writeGEQFreqCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur10Freq       wroteGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQLsur10Level       readGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQLsur10Level(N)   writeGEQLevelCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur10Level      wroteGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQLsur10Width       readGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQLsur10Width(N)   writeGEQWidthCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur10Width      wroteGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)

#define  readGEQLsur11Freq        readGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQLsur11Freq(N)    writeGEQFreqCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur11Freq       wroteGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQLsur11Level       readGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQLsur11Level(N)   writeGEQLevelCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur11Level      wroteGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQLsur11Width       readGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQLsur11Width(N)   writeGEQWidthCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur11Width      wroteGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)

#define  readGEQLsur12Freq        readGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQLsur12Freq(N)    writeGEQFreqCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur12Freq       wroteGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQLsur12Level       readGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQLsur12Level(N)   writeGEQLevelCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur12Level      wroteGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQLsur12Width       readGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQLsur12Width(N)   writeGEQWidthCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur12Width      wroteGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)

#define  readGEQLsur13Freq        readGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQLsur13Freq(N)    writeGEQFreqCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur13Freq       wroteGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQLsur13Level       readGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQLsur13Level(N)   writeGEQLevelCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur13Level      wroteGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQLsur13Width       readGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQLsur13Width(N)   writeGEQWidthCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur13Width      wroteGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)

#define  readGEQLsur14Freq        readGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQLsur14Freq(N)    writeGEQFreqCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur14Freq       wroteGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQLsur14Level       readGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQLsur14Level(N)   writeGEQLevelCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur14Level      wroteGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQLsur14Width       readGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQLsur14Width(N)   writeGEQWidthCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur14Width      wroteGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)

#define  readGEQLsur15Freq        readGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQLsur15Freq(N)    writeGEQFreqCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur15Freq       wroteGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQLsur15Level       readGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQLsur15Level(N)   writeGEQLevelCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur15Level      wroteGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQLsur15Width       readGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQLsur15Width(N)   writeGEQWidthCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur15Width      wroteGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)

#define  readGEQLsur16Freq        readGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQLsur16Freq(N)    writeGEQFreqCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur16Freq       wroteGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQLsur16Level       readGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQLsur16Level(N)   writeGEQLevelCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur16Level      wroteGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQLsur16Width       readGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQLsur16Width(N)   writeGEQWidthCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur16Width      wroteGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)

#define  readGEQLsur17Freq        readGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQLsur17Freq(N)    writeGEQFreqCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur17Freq       wroteGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQLsur17Level       readGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQLsur17Level(N)   writeGEQLevelCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur17Level      wroteGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQLsur17Width       readGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQLsur17Width(N)   writeGEQWidthCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur17Width      wroteGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)

#define  readGEQLsur18Freq        readGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQLsur18Freq(N)    writeGEQFreqCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur18Freq       wroteGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQLsur18Level       readGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQLsur18Level(N)   writeGEQLevelCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur18Level      wroteGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQLsur18Width       readGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQLsur18Width(N)   writeGEQWidthCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur18Width      wroteGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)

#define  readGEQLsur19Freq        readGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQLsur19Freq(N)    writeGEQFreqCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur19Freq       wroteGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQLsur19Level       readGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQLsur19Level(N)   writeGEQLevelCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur19Level      wroteGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQLsur19Width       readGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQLsur19Width(N)   writeGEQWidthCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur19Width      wroteGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)

#define  readGEQLsur20Freq        readGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQLsur20Freq(N)    writeGEQFreqCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur20Freq       wroteGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQLsur20Level       readGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQLsur20Level(N)   writeGEQLevelCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur20Level      wroteGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQLsur20Width       readGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQLsur20Width(N)   writeGEQWidthCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur20Width      wroteGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)

#define  readGEQLsur21Freq        readGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQLsur21Freq(N)    writeGEQFreqCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur21Freq       wroteGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQLsur21Level       readGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQLsur21Level(N)   writeGEQLevelCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur21Level      wroteGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQLsur21Width       readGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQLsur21Width(N)   writeGEQWidthCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur21Width      wroteGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)

#define  readGEQLsur22Freq        readGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQLsur22Freq(N)    writeGEQFreqCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur22Freq       wroteGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQLsur22Level       readGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQLsur22Level(N)   writeGEQLevelCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur22Level      wroteGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQLsur22Width       readGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQLsur22Width(N)   writeGEQWidthCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur22Width      wroteGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)

#define  readGEQLsur23Freq        readGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQLsur23Freq(N)    writeGEQFreqCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur23Freq       wroteGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQLsur23Level       readGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQLsur23Level(N)   writeGEQLevelCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur23Level      wroteGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQLsur23Width       readGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQLsur23Width(N)   writeGEQWidthCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur23Width      wroteGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)

#define  readGEQLsur24Freq        readGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQLsur24Freq(N)    writeGEQFreqCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur24Freq       wroteGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQLsur24Level       readGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQLsur24Level(N)   writeGEQLevelCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur24Level      wroteGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQLsur24Width       readGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQLsur24Width(N)   writeGEQWidthCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur24Width      wroteGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)

#define  readGEQLsur25Freq        readGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQLsur25Freq(N)    writeGEQFreqCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur25Freq       wroteGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQLsur25Level       readGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQLsur25Level(N)   writeGEQLevelCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur25Level      wroteGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQLsur25Width       readGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQLsur25Width(N)   writeGEQWidthCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur25Width      wroteGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)

#define  readGEQLsur26Freq        readGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQLsur26Freq(N)    writeGEQFreqCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur26Freq       wroteGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQLsur26Level       readGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQLsur26Level(N)   writeGEQLevelCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur26Level      wroteGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQLsur26Width       readGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQLsur26Width(N)   writeGEQWidthCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur26Width      wroteGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)

#define  readGEQLsur27Freq        readGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQLsur27Freq(N)    writeGEQFreqCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur27Freq       wroteGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQLsur27Level       readGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQLsur27Level(N)   writeGEQLevelCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur27Level      wroteGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQLsur27Width       readGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQLsur27Width(N)   writeGEQWidthCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur27Width      wroteGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)

#define  readGEQLsur28Freq        readGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQLsur28Freq(N)    writeGEQFreqCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur28Freq       wroteGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQLsur28Level       readGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQLsur28Level(N)   writeGEQLevelCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur28Level      wroteGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQLsur28Width       readGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQLsur28Width(N)   writeGEQWidthCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur28Width      wroteGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)

#define  readGEQLsur29Freq        readGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQLsur29Freq(N)    writeGEQFreqCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur29Freq       wroteGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQLsur29Level       readGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQLsur29Level(N)   writeGEQLevelCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur29Level      wroteGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQLsur29Width       readGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQLsur29Width(N)   writeGEQWidthCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur29Width      wroteGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)

#define  readGEQLsur30Freq        readGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQLsur30Freq(N)    writeGEQFreqCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur30Freq       wroteGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQLsur30Level       readGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQLsur30Level(N)   writeGEQLevelCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur30Level      wroteGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQLsur30Width       readGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQLsur30Width(N)   writeGEQWidthCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur30Width      wroteGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)

#define  readGEQLsur31Freq        readGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQLsur31Freq(N)    writeGEQFreqCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur31Freq       wroteGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQLsur31Level       readGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQLsur31Level(N)   writeGEQLevelCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur31Level      wroteGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQLsur31Width       readGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQLsur31Width(N)   writeGEQWidthCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur31Width      wroteGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)

#define  readGEQLsur32Freq        readGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQLsur32Freq(N)    writeGEQFreqCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur32Freq       wroteGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQLsur32Level       readGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQLsur32Level(N)   writeGEQLevelCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur32Level      wroteGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQLsur32Width       readGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQLsur32Width(N)   writeGEQWidthCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsur32Width      wroteGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)

#define  readGEQRsur1Freq        readGEQFreqCh(9, 0, GEQ_MAXNUMBANDS)
#define writeGEQRsur1Freq(N)    writeGEQFreqCh(9, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur1Freq       wroteGEQFreqCh(9, 0, GEQ_MAXNUMBANDS)
#define  readGEQRsur1Level       readGEQLevelCh(9, 0, GEQ_MAXNUMBANDS)
#define writeGEQRsur1Level(N)   writeGEQLevelCh(9, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur1Level      wroteGEQLevelCh(9, 0, GEQ_MAXNUMBANDS)
#define  readGEQRsur1Width       readGEQWidthCh(9, 0, GEQ_MAXNUMBANDS)
#define writeGEQRsur1Width(N)   writeGEQWidthCh(9, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur1Width      wroteGEQWidthCh(9, 0, GEQ_MAXNUMBANDS)

#define  readGEQRsur2Freq        readGEQFreqCh(9, 1, GEQ_MAXNUMBANDS)
#define writeGEQRsur2Freq(N)    writeGEQFreqCh(9, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur2Freq       wroteGEQFreqCh(9, 1, GEQ_MAXNUMBANDS)
#define  readGEQRsur2Level       readGEQLevelCh(9, 1, GEQ_MAXNUMBANDS)
#define writeGEQRsur2Level(N)   writeGEQLevelCh(9, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur2Level      wroteGEQLevelCh(9, 1, GEQ_MAXNUMBANDS)
#define  readGEQRsur2Width       readGEQWidthCh(9, 1, GEQ_MAXNUMBANDS)
#define writeGEQRsur2Width(N)   writeGEQWidthCh(9, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur2Width      wroteGEQWidthCh(9, 1, GEQ_MAXNUMBANDS)

#define  readGEQRsur3Freq        readGEQFreqCh(9, 2, GEQ_MAXNUMBANDS)
#define writeGEQRsur3Freq(N)    writeGEQFreqCh(9, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur3Freq       wroteGEQFreqCh(9, 2, GEQ_MAXNUMBANDS)
#define  readGEQRsur3Level       readGEQLevelCh(9, 2, GEQ_MAXNUMBANDS)
#define writeGEQRsur3Level(N)   writeGEQLevelCh(9, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur3Level      wroteGEQLevelCh(9, 2, GEQ_MAXNUMBANDS)
#define  readGEQRsur3Width       readGEQWidthCh(9, 2, GEQ_MAXNUMBANDS)
#define writeGEQRsur3Width(N)   writeGEQWidthCh(9, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur3Width      wroteGEQWidthCh(9, 2, GEQ_MAXNUMBANDS)

#define  readGEQRsur4Freq        readGEQFreqCh(9, 3, GEQ_MAXNUMBANDS)
#define writeGEQRsur4Freq(N)    writeGEQFreqCh(9, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur4Freq       wroteGEQFreqCh(9, 3, GEQ_MAXNUMBANDS)
#define  readGEQRsur4Level       readGEQLevelCh(9, 3, GEQ_MAXNUMBANDS)
#define writeGEQRsur4Level(N)   writeGEQLevelCh(9, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur4Level      wroteGEQLevelCh(9, 3, GEQ_MAXNUMBANDS)
#define  readGEQRsur4Width       readGEQWidthCh(9, 3, GEQ_MAXNUMBANDS)
#define writeGEQRsur4Width(N)   writeGEQWidthCh(9, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur4Width      wroteGEQWidthCh(9, 3, GEQ_MAXNUMBANDS)

#define  readGEQRsur5Freq        readGEQFreqCh(9, 4, GEQ_MAXNUMBANDS)
#define writeGEQRsur5Freq(N)    writeGEQFreqCh(9, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur5Freq       wroteGEQFreqCh(9, 4, GEQ_MAXNUMBANDS)
#define  readGEQRsur5Level       readGEQLevelCh(9, 4, GEQ_MAXNUMBANDS)
#define writeGEQRsur5Level(N)   writeGEQLevelCh(9, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur5Level      wroteGEQLevelCh(9, 4, GEQ_MAXNUMBANDS)
#define  readGEQRsur5Width       readGEQWidthCh(9, 4, GEQ_MAXNUMBANDS)
#define writeGEQRsur5Width(N)   writeGEQWidthCh(9, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur5Width      wroteGEQWidthCh(9, 4, GEQ_MAXNUMBANDS)

#define  readGEQRsur6Freq        readGEQFreqCh(9, 5, GEQ_MAXNUMBANDS)
#define writeGEQRsur6Freq(N)    writeGEQFreqCh(9, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur6Freq       wroteGEQFreqCh(9, 5, GEQ_MAXNUMBANDS)
#define  readGEQRsur6Level       readGEQLevelCh(9, 5, GEQ_MAXNUMBANDS)
#define writeGEQRsur6Level(N)   writeGEQLevelCh(9, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur6Level      wroteGEQLevelCh(9, 5, GEQ_MAXNUMBANDS)
#define  readGEQRsur6Width       readGEQWidthCh(9, 5, GEQ_MAXNUMBANDS)
#define writeGEQRsur6Width(N)   writeGEQWidthCh(9, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur6Width      wroteGEQWidthCh(9, 5, GEQ_MAXNUMBANDS)

#define  readGEQRsur7Freq        readGEQFreqCh(9, 6, GEQ_MAXNUMBANDS)
#define writeGEQRsur7Freq(N)    writeGEQFreqCh(9, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur7Freq       wroteGEQFreqCh(9, 6, GEQ_MAXNUMBANDS)
#define  readGEQRsur7Level       readGEQLevelCh(9, 6, GEQ_MAXNUMBANDS)
#define writeGEQRsur7Level(N)   writeGEQLevelCh(9, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur7Level      wroteGEQLevelCh(9, 6, GEQ_MAXNUMBANDS)
#define  readGEQRsur7Width       readGEQWidthCh(9, 6, GEQ_MAXNUMBANDS)
#define writeGEQRsur7Width(N)   writeGEQWidthCh(9, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur7Width      wroteGEQWidthCh(9, 6, GEQ_MAXNUMBANDS)

#define  readGEQRsur8Freq        readGEQFreqCh(9, 7, GEQ_MAXNUMBANDS)
#define writeGEQRsur8Freq(N)    writeGEQFreqCh(9, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur8Freq       wroteGEQFreqCh(9, 7, GEQ_MAXNUMBANDS)
#define  readGEQRsur8Level       readGEQLevelCh(9, 7, GEQ_MAXNUMBANDS)
#define writeGEQRsur8Level(N)   writeGEQLevelCh(9, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur8Level      wroteGEQLevelCh(9, 7, GEQ_MAXNUMBANDS)
#define  readGEQRsur8Width       readGEQWidthCh(9, 7, GEQ_MAXNUMBANDS)
#define writeGEQRsur8Width(N)   writeGEQWidthCh(9, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur8Width      wroteGEQWidthCh(9, 7, GEQ_MAXNUMBANDS)

#define  readGEQRsur9Freq        readGEQFreqCh(9, 8, GEQ_MAXNUMBANDS)
#define writeGEQRsur9Freq(N)    writeGEQFreqCh(9, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur9Freq       wroteGEQFreqCh(9, 8, GEQ_MAXNUMBANDS)
#define  readGEQRsur9Level       readGEQLevelCh(9, 8, GEQ_MAXNUMBANDS)
#define writeGEQRsur9Level(N)   writeGEQLevelCh(9, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur9Level      wroteGEQLevelCh(9, 8, GEQ_MAXNUMBANDS)
#define  readGEQRsur9Width       readGEQWidthCh(9, 8, GEQ_MAXNUMBANDS)
#define writeGEQRsur9Width(N)   writeGEQWidthCh(9, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur9Width      wroteGEQWidthCh(9, 8, GEQ_MAXNUMBANDS)

#define  readGEQRsur10Freq        readGEQFreqCh(9, 9, GEQ_MAXNUMBANDS)
#define writeGEQRsur10Freq(N)    writeGEQFreqCh(9, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur10Freq       wroteGEQFreqCh(9, 9, GEQ_MAXNUMBANDS)
#define  readGEQRsur10Level       readGEQLevelCh(9, 9, GEQ_MAXNUMBANDS)
#define writeGEQRsur10Level(N)   writeGEQLevelCh(9, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur10Level      wroteGEQLevelCh(9, 9, GEQ_MAXNUMBANDS)
#define  readGEQRsur10Width       readGEQWidthCh(9, 9, GEQ_MAXNUMBANDS)
#define writeGEQRsur10Width(N)   writeGEQWidthCh(9, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur10Width      wroteGEQWidthCh(9, 9, GEQ_MAXNUMBANDS)

#define  readGEQRsur11Freq        readGEQFreqCh(9, 10, GEQ_MAXNUMBANDS)
#define writeGEQRsur11Freq(N)    writeGEQFreqCh(9, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur11Freq       wroteGEQFreqCh(9, 10, GEQ_MAXNUMBANDS)
#define  readGEQRsur11Level       readGEQLevelCh(9, 10, GEQ_MAXNUMBANDS)
#define writeGEQRsur11Level(N)   writeGEQLevelCh(9, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur11Level      wroteGEQLevelCh(9, 10, GEQ_MAXNUMBANDS)
#define  readGEQRsur11Width       readGEQWidthCh(9, 10, GEQ_MAXNUMBANDS)
#define writeGEQRsur11Width(N)   writeGEQWidthCh(9, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur11Width      wroteGEQWidthCh(9, 10, GEQ_MAXNUMBANDS)

#define  readGEQRsur12Freq        readGEQFreqCh(9, 11, GEQ_MAXNUMBANDS)
#define writeGEQRsur12Freq(N)    writeGEQFreqCh(9, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur12Freq       wroteGEQFreqCh(9, 11, GEQ_MAXNUMBANDS)
#define  readGEQRsur12Level       readGEQLevelCh(9, 11, GEQ_MAXNUMBANDS)
#define writeGEQRsur12Level(N)   writeGEQLevelCh(9, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur12Level      wroteGEQLevelCh(9, 11, GEQ_MAXNUMBANDS)
#define  readGEQRsur12Width       readGEQWidthCh(9, 11, GEQ_MAXNUMBANDS)
#define writeGEQRsur12Width(N)   writeGEQWidthCh(9, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur12Width      wroteGEQWidthCh(9, 11, GEQ_MAXNUMBANDS)

#define  readGEQRsur13Freq        readGEQFreqCh(9, 12, GEQ_MAXNUMBANDS)
#define writeGEQRsur13Freq(N)    writeGEQFreqCh(9, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur13Freq       wroteGEQFreqCh(9, 12, GEQ_MAXNUMBANDS)
#define  readGEQRsur13Level       readGEQLevelCh(9, 12, GEQ_MAXNUMBANDS)
#define writeGEQRsur13Level(N)   writeGEQLevelCh(9, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur13Level      wroteGEQLevelCh(9, 12, GEQ_MAXNUMBANDS)
#define  readGEQRsur13Width       readGEQWidthCh(9, 12, GEQ_MAXNUMBANDS)
#define writeGEQRsur13Width(N)   writeGEQWidthCh(9, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur13Width      wroteGEQWidthCh(9, 12, GEQ_MAXNUMBANDS)

#define  readGEQRsur14Freq        readGEQFreqCh(9, 13, GEQ_MAXNUMBANDS)
#define writeGEQRsur14Freq(N)    writeGEQFreqCh(9, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur14Freq       wroteGEQFreqCh(9, 13, GEQ_MAXNUMBANDS)
#define  readGEQRsur14Level       readGEQLevelCh(9, 13, GEQ_MAXNUMBANDS)
#define writeGEQRsur14Level(N)   writeGEQLevelCh(9, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur14Level      wroteGEQLevelCh(9, 13, GEQ_MAXNUMBANDS)
#define  readGEQRsur14Width       readGEQWidthCh(9, 13, GEQ_MAXNUMBANDS)
#define writeGEQRsur14Width(N)   writeGEQWidthCh(9, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur14Width      wroteGEQWidthCh(9, 13, GEQ_MAXNUMBANDS)

#define  readGEQRsur15Freq        readGEQFreqCh(9, 14, GEQ_MAXNUMBANDS)
#define writeGEQRsur15Freq(N)    writeGEQFreqCh(9, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur15Freq       wroteGEQFreqCh(9, 14, GEQ_MAXNUMBANDS)
#define  readGEQRsur15Level       readGEQLevelCh(9, 14, GEQ_MAXNUMBANDS)
#define writeGEQRsur15Level(N)   writeGEQLevelCh(9, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur15Level      wroteGEQLevelCh(9, 14, GEQ_MAXNUMBANDS)
#define  readGEQRsur15Width       readGEQWidthCh(9, 14, GEQ_MAXNUMBANDS)
#define writeGEQRsur15Width(N)   writeGEQWidthCh(9, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur15Width      wroteGEQWidthCh(9, 14, GEQ_MAXNUMBANDS)

#define  readGEQRsur16Freq        readGEQFreqCh(9, 15, GEQ_MAXNUMBANDS)
#define writeGEQRsur16Freq(N)    writeGEQFreqCh(9, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur16Freq       wroteGEQFreqCh(9, 15, GEQ_MAXNUMBANDS)
#define  readGEQRsur16Level       readGEQLevelCh(9, 15, GEQ_MAXNUMBANDS)
#define writeGEQRsur16Level(N)   writeGEQLevelCh(9, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur16Level      wroteGEQLevelCh(9, 15, GEQ_MAXNUMBANDS)
#define  readGEQRsur16Width       readGEQWidthCh(9, 15, GEQ_MAXNUMBANDS)
#define writeGEQRsur16Width(N)   writeGEQWidthCh(9, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur16Width      wroteGEQWidthCh(9, 15, GEQ_MAXNUMBANDS)

#define  readGEQRsur17Freq        readGEQFreqCh(9, 16, GEQ_MAXNUMBANDS)
#define writeGEQRsur17Freq(N)    writeGEQFreqCh(9, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur17Freq       wroteGEQFreqCh(9, 16, GEQ_MAXNUMBANDS)
#define  readGEQRsur17Level       readGEQLevelCh(9, 16, GEQ_MAXNUMBANDS)
#define writeGEQRsur17Level(N)   writeGEQLevelCh(9, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur17Level      wroteGEQLevelCh(9, 16, GEQ_MAXNUMBANDS)
#define  readGEQRsur17Width       readGEQWidthCh(9, 16, GEQ_MAXNUMBANDS)
#define writeGEQRsur17Width(N)   writeGEQWidthCh(9, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur17Width      wroteGEQWidthCh(9, 16, GEQ_MAXNUMBANDS)

#define  readGEQRsur18Freq        readGEQFreqCh(9, 17, GEQ_MAXNUMBANDS)
#define writeGEQRsur18Freq(N)    writeGEQFreqCh(9, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur18Freq       wroteGEQFreqCh(9, 17, GEQ_MAXNUMBANDS)
#define  readGEQRsur18Level       readGEQLevelCh(9, 17, GEQ_MAXNUMBANDS)
#define writeGEQRsur18Level(N)   writeGEQLevelCh(9, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur18Level      wroteGEQLevelCh(9, 17, GEQ_MAXNUMBANDS)
#define  readGEQRsur18Width       readGEQWidthCh(9, 17, GEQ_MAXNUMBANDS)
#define writeGEQRsur18Width(N)   writeGEQWidthCh(9, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur18Width      wroteGEQWidthCh(9, 17, GEQ_MAXNUMBANDS)

#define  readGEQRsur19Freq        readGEQFreqCh(9, 18, GEQ_MAXNUMBANDS)
#define writeGEQRsur19Freq(N)    writeGEQFreqCh(9, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur19Freq       wroteGEQFreqCh(9, 18, GEQ_MAXNUMBANDS)
#define  readGEQRsur19Level       readGEQLevelCh(9, 18, GEQ_MAXNUMBANDS)
#define writeGEQRsur19Level(N)   writeGEQLevelCh(9, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur19Level      wroteGEQLevelCh(9, 18, GEQ_MAXNUMBANDS)
#define  readGEQRsur19Width       readGEQWidthCh(9, 18, GEQ_MAXNUMBANDS)
#define writeGEQRsur19Width(N)   writeGEQWidthCh(9, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur19Width      wroteGEQWidthCh(9, 18, GEQ_MAXNUMBANDS)

#define  readGEQRsur20Freq        readGEQFreqCh(9, 19, GEQ_MAXNUMBANDS)
#define writeGEQRsur20Freq(N)    writeGEQFreqCh(9, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur20Freq       wroteGEQFreqCh(9, 19, GEQ_MAXNUMBANDS)
#define  readGEQRsur20Level       readGEQLevelCh(9, 19, GEQ_MAXNUMBANDS)
#define writeGEQRsur20Level(N)   writeGEQLevelCh(9, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur20Level      wroteGEQLevelCh(9, 19, GEQ_MAXNUMBANDS)
#define  readGEQRsur20Width       readGEQWidthCh(9, 19, GEQ_MAXNUMBANDS)
#define writeGEQRsur20Width(N)   writeGEQWidthCh(9, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur20Width      wroteGEQWidthCh(9, 19, GEQ_MAXNUMBANDS)

#define  readGEQRsur21Freq        readGEQFreqCh(9, 20, GEQ_MAXNUMBANDS)
#define writeGEQRsur21Freq(N)    writeGEQFreqCh(9, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur21Freq       wroteGEQFreqCh(9, 20, GEQ_MAXNUMBANDS)
#define  readGEQRsur21Level       readGEQLevelCh(9, 20, GEQ_MAXNUMBANDS)
#define writeGEQRsur21Level(N)   writeGEQLevelCh(9, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur21Level      wroteGEQLevelCh(9, 20, GEQ_MAXNUMBANDS)
#define  readGEQRsur21Width       readGEQWidthCh(9, 20, GEQ_MAXNUMBANDS)
#define writeGEQRsur21Width(N)   writeGEQWidthCh(9, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur21Width      wroteGEQWidthCh(9, 20, GEQ_MAXNUMBANDS)

#define  readGEQRsur22Freq        readGEQFreqCh(9, 21, GEQ_MAXNUMBANDS)
#define writeGEQRsur22Freq(N)    writeGEQFreqCh(9, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur22Freq       wroteGEQFreqCh(9, 21, GEQ_MAXNUMBANDS)
#define  readGEQRsur22Level       readGEQLevelCh(9, 21, GEQ_MAXNUMBANDS)
#define writeGEQRsur22Level(N)   writeGEQLevelCh(9, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur22Level      wroteGEQLevelCh(9, 21, GEQ_MAXNUMBANDS)
#define  readGEQRsur22Width       readGEQWidthCh(9, 21, GEQ_MAXNUMBANDS)
#define writeGEQRsur22Width(N)   writeGEQWidthCh(9, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur22Width      wroteGEQWidthCh(9, 21, GEQ_MAXNUMBANDS)

#define  readGEQRsur23Freq        readGEQFreqCh(9, 22, GEQ_MAXNUMBANDS)
#define writeGEQRsur23Freq(N)    writeGEQFreqCh(9, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur23Freq       wroteGEQFreqCh(9, 22, GEQ_MAXNUMBANDS)
#define  readGEQRsur23Level       readGEQLevelCh(9, 22, GEQ_MAXNUMBANDS)
#define writeGEQRsur23Level(N)   writeGEQLevelCh(9, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur23Level      wroteGEQLevelCh(9, 22, GEQ_MAXNUMBANDS)
#define  readGEQRsur23Width       readGEQWidthCh(9, 22, GEQ_MAXNUMBANDS)
#define writeGEQRsur23Width(N)   writeGEQWidthCh(9, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur23Width      wroteGEQWidthCh(9, 22, GEQ_MAXNUMBANDS)

#define  readGEQRsur24Freq        readGEQFreqCh(9, 23, GEQ_MAXNUMBANDS)
#define writeGEQRsur24Freq(N)    writeGEQFreqCh(9, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur24Freq       wroteGEQFreqCh(9, 23, GEQ_MAXNUMBANDS)
#define  readGEQRsur24Level       readGEQLevelCh(9, 23, GEQ_MAXNUMBANDS)
#define writeGEQRsur24Level(N)   writeGEQLevelCh(9, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur24Level      wroteGEQLevelCh(9, 23, GEQ_MAXNUMBANDS)
#define  readGEQRsur24Width       readGEQWidthCh(9, 23, GEQ_MAXNUMBANDS)
#define writeGEQRsur24Width(N)   writeGEQWidthCh(9, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur24Width      wroteGEQWidthCh(9, 23, GEQ_MAXNUMBANDS)

#define  readGEQRsur25Freq        readGEQFreqCh(9, 24, GEQ_MAXNUMBANDS)
#define writeGEQRsur25Freq(N)    writeGEQFreqCh(9, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur25Freq       wroteGEQFreqCh(9, 24, GEQ_MAXNUMBANDS)
#define  readGEQRsur25Level       readGEQLevelCh(9, 24, GEQ_MAXNUMBANDS)
#define writeGEQRsur25Level(N)   writeGEQLevelCh(9, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur25Level      wroteGEQLevelCh(9, 24, GEQ_MAXNUMBANDS)
#define  readGEQRsur25Width       readGEQWidthCh(9, 24, GEQ_MAXNUMBANDS)
#define writeGEQRsur25Width(N)   writeGEQWidthCh(9, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur25Width      wroteGEQWidthCh(9, 24, GEQ_MAXNUMBANDS)

#define  readGEQRsur26Freq        readGEQFreqCh(9, 25, GEQ_MAXNUMBANDS)
#define writeGEQRsur26Freq(N)    writeGEQFreqCh(9, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur26Freq       wroteGEQFreqCh(9, 25, GEQ_MAXNUMBANDS)
#define  readGEQRsur26Level       readGEQLevelCh(9, 25, GEQ_MAXNUMBANDS)
#define writeGEQRsur26Level(N)   writeGEQLevelCh(9, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur26Level      wroteGEQLevelCh(9, 25, GEQ_MAXNUMBANDS)
#define  readGEQRsur26Width       readGEQWidthCh(9, 25, GEQ_MAXNUMBANDS)
#define writeGEQRsur26Width(N)   writeGEQWidthCh(9, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur26Width      wroteGEQWidthCh(9, 25, GEQ_MAXNUMBANDS)

#define  readGEQRsur27Freq        readGEQFreqCh(9, 26, GEQ_MAXNUMBANDS)
#define writeGEQRsur27Freq(N)    writeGEQFreqCh(9, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur27Freq       wroteGEQFreqCh(9, 26, GEQ_MAXNUMBANDS)
#define  readGEQRsur27Level       readGEQLevelCh(9, 26, GEQ_MAXNUMBANDS)
#define writeGEQRsur27Level(N)   writeGEQLevelCh(9, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur27Level      wroteGEQLevelCh(9, 26, GEQ_MAXNUMBANDS)
#define  readGEQRsur27Width       readGEQWidthCh(9, 26, GEQ_MAXNUMBANDS)
#define writeGEQRsur27Width(N)   writeGEQWidthCh(9, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur27Width      wroteGEQWidthCh(9, 26, GEQ_MAXNUMBANDS)

#define  readGEQRsur28Freq        readGEQFreqCh(9, 27, GEQ_MAXNUMBANDS)
#define writeGEQRsur28Freq(N)    writeGEQFreqCh(9, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur28Freq       wroteGEQFreqCh(9, 27, GEQ_MAXNUMBANDS)
#define  readGEQRsur28Level       readGEQLevelCh(9, 27, GEQ_MAXNUMBANDS)
#define writeGEQRsur28Level(N)   writeGEQLevelCh(9, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur28Level      wroteGEQLevelCh(9, 27, GEQ_MAXNUMBANDS)
#define  readGEQRsur28Width       readGEQWidthCh(9, 27, GEQ_MAXNUMBANDS)
#define writeGEQRsur28Width(N)   writeGEQWidthCh(9, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur28Width      wroteGEQWidthCh(9, 27, GEQ_MAXNUMBANDS)

#define  readGEQRsur29Freq        readGEQFreqCh(9, 28, GEQ_MAXNUMBANDS)
#define writeGEQRsur29Freq(N)    writeGEQFreqCh(9, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur29Freq       wroteGEQFreqCh(9, 28, GEQ_MAXNUMBANDS)
#define  readGEQRsur29Level       readGEQLevelCh(9, 28, GEQ_MAXNUMBANDS)
#define writeGEQRsur29Level(N)   writeGEQLevelCh(9, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur29Level      wroteGEQLevelCh(9, 28, GEQ_MAXNUMBANDS)
#define  readGEQRsur29Width       readGEQWidthCh(9, 28, GEQ_MAXNUMBANDS)
#define writeGEQRsur29Width(N)   writeGEQWidthCh(9, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur29Width      wroteGEQWidthCh(9, 28, GEQ_MAXNUMBANDS)

#define  readGEQRsur30Freq        readGEQFreqCh(9, 29, GEQ_MAXNUMBANDS)
#define writeGEQRsur30Freq(N)    writeGEQFreqCh(9, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur30Freq       wroteGEQFreqCh(9, 29, GEQ_MAXNUMBANDS)
#define  readGEQRsur30Level       readGEQLevelCh(9, 29, GEQ_MAXNUMBANDS)
#define writeGEQRsur30Level(N)   writeGEQLevelCh(9, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur30Level      wroteGEQLevelCh(9, 29, GEQ_MAXNUMBANDS)
#define  readGEQRsur30Width       readGEQWidthCh(9, 29, GEQ_MAXNUMBANDS)
#define writeGEQRsur30Width(N)   writeGEQWidthCh(9, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur30Width      wroteGEQWidthCh(9, 29, GEQ_MAXNUMBANDS)

#define  readGEQRsur31Freq        readGEQFreqCh(9, 30, GEQ_MAXNUMBANDS)
#define writeGEQRsur31Freq(N)    writeGEQFreqCh(9, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur31Freq       wroteGEQFreqCh(9, 30, GEQ_MAXNUMBANDS)
#define  readGEQRsur31Level       readGEQLevelCh(9, 30, GEQ_MAXNUMBANDS)
#define writeGEQRsur31Level(N)   writeGEQLevelCh(9, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur31Level      wroteGEQLevelCh(9, 30, GEQ_MAXNUMBANDS)
#define  readGEQRsur31Width       readGEQWidthCh(9, 30, GEQ_MAXNUMBANDS)
#define writeGEQRsur31Width(N)   writeGEQWidthCh(9, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur31Width      wroteGEQWidthCh(9, 30, GEQ_MAXNUMBANDS)

#define  readGEQRsur32Freq        readGEQFreqCh(9, 31, GEQ_MAXNUMBANDS)
#define writeGEQRsur32Freq(N)    writeGEQFreqCh(9, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur32Freq       wroteGEQFreqCh(9, 31, GEQ_MAXNUMBANDS)
#define  readGEQRsur32Level       readGEQLevelCh(9, 31, GEQ_MAXNUMBANDS)
#define writeGEQRsur32Level(N)   writeGEQLevelCh(9, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur32Level      wroteGEQLevelCh(9, 31, GEQ_MAXNUMBANDS)
#define  readGEQRsur32Width       readGEQWidthCh(9, 31, GEQ_MAXNUMBANDS)
#define writeGEQRsur32Width(N)   writeGEQWidthCh(9, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsur32Width      wroteGEQWidthCh(9, 31, GEQ_MAXNUMBANDS)

#define  readGEQBack1Freq        readGEQFreqCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQBack1Freq(N)    writeGEQFreqCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack1Freq       wroteGEQFreqCh(10, 0, GEQ_MAXNUMBANDS)
#define  readGEQBack1Level       readGEQLevelCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQBack1Level(N)   writeGEQLevelCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack1Level      wroteGEQLevelCh(10, 0, GEQ_MAXNUMBANDS)
#define  readGEQBack1Width       readGEQWidthCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQBack1Width(N)   writeGEQWidthCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack1Width      wroteGEQWidthCh(10, 0, GEQ_MAXNUMBANDS)

#define  readGEQBack2Freq        readGEQFreqCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQBack2Freq(N)    writeGEQFreqCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack2Freq       wroteGEQFreqCh(10, 1, GEQ_MAXNUMBANDS)
#define  readGEQBack2Level       readGEQLevelCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQBack2Level(N)   writeGEQLevelCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack2Level      wroteGEQLevelCh(10, 1, GEQ_MAXNUMBANDS)
#define  readGEQBack2Width       readGEQWidthCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQBack2Width(N)   writeGEQWidthCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack2Width      wroteGEQWidthCh(10, 1, GEQ_MAXNUMBANDS)

#define  readGEQBack3Freq        readGEQFreqCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQBack3Freq(N)    writeGEQFreqCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack3Freq       wroteGEQFreqCh(10, 2, GEQ_MAXNUMBANDS)
#define  readGEQBack3Level       readGEQLevelCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQBack3Level(N)   writeGEQLevelCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack3Level      wroteGEQLevelCh(10, 2, GEQ_MAXNUMBANDS)
#define  readGEQBack3Width       readGEQWidthCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQBack3Width(N)   writeGEQWidthCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack3Width      wroteGEQWidthCh(10, 2, GEQ_MAXNUMBANDS)

#define  readGEQBack4Freq        readGEQFreqCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQBack4Freq(N)    writeGEQFreqCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack4Freq       wroteGEQFreqCh(10, 3, GEQ_MAXNUMBANDS)
#define  readGEQBack4Level       readGEQLevelCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQBack4Level(N)   writeGEQLevelCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack4Level      wroteGEQLevelCh(10, 3, GEQ_MAXNUMBANDS)
#define  readGEQBack4Width       readGEQWidthCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQBack4Width(N)   writeGEQWidthCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack4Width      wroteGEQWidthCh(10, 3, GEQ_MAXNUMBANDS)

#define  readGEQBack5Freq        readGEQFreqCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQBack5Freq(N)    writeGEQFreqCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack5Freq       wroteGEQFreqCh(10, 4, GEQ_MAXNUMBANDS)
#define  readGEQBack5Level       readGEQLevelCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQBack5Level(N)   writeGEQLevelCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack5Level      wroteGEQLevelCh(10, 4, GEQ_MAXNUMBANDS)
#define  readGEQBack5Width       readGEQWidthCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQBack5Width(N)   writeGEQWidthCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack5Width      wroteGEQWidthCh(10, 4, GEQ_MAXNUMBANDS)

#define  readGEQBack6Freq        readGEQFreqCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQBack6Freq(N)    writeGEQFreqCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack6Freq       wroteGEQFreqCh(10, 5, GEQ_MAXNUMBANDS)
#define  readGEQBack6Level       readGEQLevelCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQBack6Level(N)   writeGEQLevelCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack6Level      wroteGEQLevelCh(10, 5, GEQ_MAXNUMBANDS)
#define  readGEQBack6Width       readGEQWidthCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQBack6Width(N)   writeGEQWidthCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack6Width      wroteGEQWidthCh(10, 5, GEQ_MAXNUMBANDS)

#define  readGEQBack7Freq        readGEQFreqCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQBack7Freq(N)    writeGEQFreqCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack7Freq       wroteGEQFreqCh(10, 6, GEQ_MAXNUMBANDS)
#define  readGEQBack7Level       readGEQLevelCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQBack7Level(N)   writeGEQLevelCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack7Level      wroteGEQLevelCh(10, 6, GEQ_MAXNUMBANDS)
#define  readGEQBack7Width       readGEQWidthCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQBack7Width(N)   writeGEQWidthCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack7Width      wroteGEQWidthCh(10, 6, GEQ_MAXNUMBANDS)

#define  readGEQBack8Freq        readGEQFreqCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQBack8Freq(N)    writeGEQFreqCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack8Freq       wroteGEQFreqCh(10, 7, GEQ_MAXNUMBANDS)
#define  readGEQBack8Level       readGEQLevelCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQBack8Level(N)   writeGEQLevelCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack8Level      wroteGEQLevelCh(10, 7, GEQ_MAXNUMBANDS)
#define  readGEQBack8Width       readGEQWidthCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQBack8Width(N)   writeGEQWidthCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack8Width      wroteGEQWidthCh(10, 7, GEQ_MAXNUMBANDS)

#define  readGEQBack9Freq        readGEQFreqCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQBack9Freq(N)    writeGEQFreqCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack9Freq       wroteGEQFreqCh(10, 8, GEQ_MAXNUMBANDS)
#define  readGEQBack9Level       readGEQLevelCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQBack9Level(N)   writeGEQLevelCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack9Level      wroteGEQLevelCh(10, 8, GEQ_MAXNUMBANDS)
#define  readGEQBack9Width       readGEQWidthCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQBack9Width(N)   writeGEQWidthCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack9Width      wroteGEQWidthCh(10, 8, GEQ_MAXNUMBANDS)

#define  readGEQBack10Freq        readGEQFreqCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQBack10Freq(N)    writeGEQFreqCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack10Freq       wroteGEQFreqCh(10, 9, GEQ_MAXNUMBANDS)
#define  readGEQBack10Level       readGEQLevelCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQBack10Level(N)   writeGEQLevelCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack10Level      wroteGEQLevelCh(10, 9, GEQ_MAXNUMBANDS)
#define  readGEQBack10Width       readGEQWidthCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQBack10Width(N)   writeGEQWidthCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack10Width      wroteGEQWidthCh(10, 9, GEQ_MAXNUMBANDS)

#define  readGEQBack11Freq        readGEQFreqCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQBack11Freq(N)    writeGEQFreqCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack11Freq       wroteGEQFreqCh(10, 10, GEQ_MAXNUMBANDS)
#define  readGEQBack11Level       readGEQLevelCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQBack11Level(N)   writeGEQLevelCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack11Level      wroteGEQLevelCh(10, 10, GEQ_MAXNUMBANDS)
#define  readGEQBack11Width       readGEQWidthCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQBack11Width(N)   writeGEQWidthCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack11Width      wroteGEQWidthCh(10, 10, GEQ_MAXNUMBANDS)

#define  readGEQBack12Freq        readGEQFreqCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQBack12Freq(N)    writeGEQFreqCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack12Freq       wroteGEQFreqCh(10, 11, GEQ_MAXNUMBANDS)
#define  readGEQBack12Level       readGEQLevelCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQBack12Level(N)   writeGEQLevelCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack12Level      wroteGEQLevelCh(10, 11, GEQ_MAXNUMBANDS)
#define  readGEQBack12Width       readGEQWidthCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQBack12Width(N)   writeGEQWidthCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack12Width      wroteGEQWidthCh(10, 11, GEQ_MAXNUMBANDS)

#define  readGEQBack13Freq        readGEQFreqCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQBack13Freq(N)    writeGEQFreqCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack13Freq       wroteGEQFreqCh(10, 12, GEQ_MAXNUMBANDS)
#define  readGEQBack13Level       readGEQLevelCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQBack13Level(N)   writeGEQLevelCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack13Level      wroteGEQLevelCh(10, 12, GEQ_MAXNUMBANDS)
#define  readGEQBack13Width       readGEQWidthCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQBack13Width(N)   writeGEQWidthCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack13Width      wroteGEQWidthCh(10, 12, GEQ_MAXNUMBANDS)

#define  readGEQBack14Freq        readGEQFreqCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQBack14Freq(N)    writeGEQFreqCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack14Freq       wroteGEQFreqCh(10, 13, GEQ_MAXNUMBANDS)
#define  readGEQBack14Level       readGEQLevelCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQBack14Level(N)   writeGEQLevelCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack14Level      wroteGEQLevelCh(10, 13, GEQ_MAXNUMBANDS)
#define  readGEQBack14Width       readGEQWidthCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQBack14Width(N)   writeGEQWidthCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack14Width      wroteGEQWidthCh(10, 13, GEQ_MAXNUMBANDS)

#define  readGEQBack15Freq        readGEQFreqCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQBack15Freq(N)    writeGEQFreqCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack15Freq       wroteGEQFreqCh(10, 14, GEQ_MAXNUMBANDS)
#define  readGEQBack15Level       readGEQLevelCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQBack15Level(N)   writeGEQLevelCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack15Level      wroteGEQLevelCh(10, 14, GEQ_MAXNUMBANDS)
#define  readGEQBack15Width       readGEQWidthCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQBack15Width(N)   writeGEQWidthCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack15Width      wroteGEQWidthCh(10, 14, GEQ_MAXNUMBANDS)

#define  readGEQBack16Freq        readGEQFreqCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQBack16Freq(N)    writeGEQFreqCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack16Freq       wroteGEQFreqCh(10, 15, GEQ_MAXNUMBANDS)
#define  readGEQBack16Level       readGEQLevelCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQBack16Level(N)   writeGEQLevelCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack16Level      wroteGEQLevelCh(10, 15, GEQ_MAXNUMBANDS)
#define  readGEQBack16Width       readGEQWidthCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQBack16Width(N)   writeGEQWidthCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack16Width      wroteGEQWidthCh(10, 15, GEQ_MAXNUMBANDS)

#define  readGEQBack17Freq        readGEQFreqCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQBack17Freq(N)    writeGEQFreqCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack17Freq       wroteGEQFreqCh(10, 16, GEQ_MAXNUMBANDS)
#define  readGEQBack17Level       readGEQLevelCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQBack17Level(N)   writeGEQLevelCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack17Level      wroteGEQLevelCh(10, 16, GEQ_MAXNUMBANDS)
#define  readGEQBack17Width       readGEQWidthCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQBack17Width(N)   writeGEQWidthCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack17Width      wroteGEQWidthCh(10, 16, GEQ_MAXNUMBANDS)

#define  readGEQBack18Freq        readGEQFreqCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQBack18Freq(N)    writeGEQFreqCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack18Freq       wroteGEQFreqCh(10, 17, GEQ_MAXNUMBANDS)
#define  readGEQBack18Level       readGEQLevelCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQBack18Level(N)   writeGEQLevelCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack18Level      wroteGEQLevelCh(10, 17, GEQ_MAXNUMBANDS)
#define  readGEQBack18Width       readGEQWidthCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQBack18Width(N)   writeGEQWidthCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack18Width      wroteGEQWidthCh(10, 17, GEQ_MAXNUMBANDS)

#define  readGEQBack19Freq        readGEQFreqCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQBack19Freq(N)    writeGEQFreqCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack19Freq       wroteGEQFreqCh(10, 18, GEQ_MAXNUMBANDS)
#define  readGEQBack19Level       readGEQLevelCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQBack19Level(N)   writeGEQLevelCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack19Level      wroteGEQLevelCh(10, 18, GEQ_MAXNUMBANDS)
#define  readGEQBack19Width       readGEQWidthCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQBack19Width(N)   writeGEQWidthCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack19Width      wroteGEQWidthCh(10, 18, GEQ_MAXNUMBANDS)

#define  readGEQBack20Freq        readGEQFreqCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQBack20Freq(N)    writeGEQFreqCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack20Freq       wroteGEQFreqCh(10, 19, GEQ_MAXNUMBANDS)
#define  readGEQBack20Level       readGEQLevelCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQBack20Level(N)   writeGEQLevelCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack20Level      wroteGEQLevelCh(10, 19, GEQ_MAXNUMBANDS)
#define  readGEQBack20Width       readGEQWidthCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQBack20Width(N)   writeGEQWidthCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack20Width      wroteGEQWidthCh(10, 19, GEQ_MAXNUMBANDS)

#define  readGEQBack21Freq        readGEQFreqCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQBack21Freq(N)    writeGEQFreqCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack21Freq       wroteGEQFreqCh(10, 20, GEQ_MAXNUMBANDS)
#define  readGEQBack21Level       readGEQLevelCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQBack21Level(N)   writeGEQLevelCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack21Level      wroteGEQLevelCh(10, 20, GEQ_MAXNUMBANDS)
#define  readGEQBack21Width       readGEQWidthCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQBack21Width(N)   writeGEQWidthCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack21Width      wroteGEQWidthCh(10, 20, GEQ_MAXNUMBANDS)

#define  readGEQBack22Freq        readGEQFreqCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQBack22Freq(N)    writeGEQFreqCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack22Freq       wroteGEQFreqCh(10, 21, GEQ_MAXNUMBANDS)
#define  readGEQBack22Level       readGEQLevelCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQBack22Level(N)   writeGEQLevelCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack22Level      wroteGEQLevelCh(10, 21, GEQ_MAXNUMBANDS)
#define  readGEQBack22Width       readGEQWidthCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQBack22Width(N)   writeGEQWidthCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack22Width      wroteGEQWidthCh(10, 21, GEQ_MAXNUMBANDS)

#define  readGEQBack23Freq        readGEQFreqCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQBack23Freq(N)    writeGEQFreqCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack23Freq       wroteGEQFreqCh(10, 22, GEQ_MAXNUMBANDS)
#define  readGEQBack23Level       readGEQLevelCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQBack23Level(N)   writeGEQLevelCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack23Level      wroteGEQLevelCh(10, 22, GEQ_MAXNUMBANDS)
#define  readGEQBack23Width       readGEQWidthCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQBack23Width(N)   writeGEQWidthCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack23Width      wroteGEQWidthCh(10, 22, GEQ_MAXNUMBANDS)

#define  readGEQBack24Freq        readGEQFreqCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQBack24Freq(N)    writeGEQFreqCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack24Freq       wroteGEQFreqCh(10, 23, GEQ_MAXNUMBANDS)
#define  readGEQBack24Level       readGEQLevelCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQBack24Level(N)   writeGEQLevelCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack24Level      wroteGEQLevelCh(10, 23, GEQ_MAXNUMBANDS)
#define  readGEQBack24Width       readGEQWidthCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQBack24Width(N)   writeGEQWidthCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack24Width      wroteGEQWidthCh(10, 23, GEQ_MAXNUMBANDS)

#define  readGEQBack25Freq        readGEQFreqCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQBack25Freq(N)    writeGEQFreqCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack25Freq       wroteGEQFreqCh(10, 24, GEQ_MAXNUMBANDS)
#define  readGEQBack25Level       readGEQLevelCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQBack25Level(N)   writeGEQLevelCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack25Level      wroteGEQLevelCh(10, 24, GEQ_MAXNUMBANDS)
#define  readGEQBack25Width       readGEQWidthCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQBack25Width(N)   writeGEQWidthCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack25Width      wroteGEQWidthCh(10, 24, GEQ_MAXNUMBANDS)

#define  readGEQBack26Freq        readGEQFreqCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQBack26Freq(N)    writeGEQFreqCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack26Freq       wroteGEQFreqCh(10, 25, GEQ_MAXNUMBANDS)
#define  readGEQBack26Level       readGEQLevelCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQBack26Level(N)   writeGEQLevelCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack26Level      wroteGEQLevelCh(10, 25, GEQ_MAXNUMBANDS)
#define  readGEQBack26Width       readGEQWidthCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQBack26Width(N)   writeGEQWidthCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack26Width      wroteGEQWidthCh(10, 25, GEQ_MAXNUMBANDS)

#define  readGEQBack27Freq        readGEQFreqCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQBack27Freq(N)    writeGEQFreqCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack27Freq       wroteGEQFreqCh(10, 26, GEQ_MAXNUMBANDS)
#define  readGEQBack27Level       readGEQLevelCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQBack27Level(N)   writeGEQLevelCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack27Level      wroteGEQLevelCh(10, 26, GEQ_MAXNUMBANDS)
#define  readGEQBack27Width       readGEQWidthCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQBack27Width(N)   writeGEQWidthCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack27Width      wroteGEQWidthCh(10, 26, GEQ_MAXNUMBANDS)

#define  readGEQBack28Freq        readGEQFreqCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQBack28Freq(N)    writeGEQFreqCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack28Freq       wroteGEQFreqCh(10, 27, GEQ_MAXNUMBANDS)
#define  readGEQBack28Level       readGEQLevelCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQBack28Level(N)   writeGEQLevelCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack28Level      wroteGEQLevelCh(10, 27, GEQ_MAXNUMBANDS)
#define  readGEQBack28Width       readGEQWidthCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQBack28Width(N)   writeGEQWidthCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack28Width      wroteGEQWidthCh(10, 27, GEQ_MAXNUMBANDS)

#define  readGEQBack29Freq        readGEQFreqCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQBack29Freq(N)    writeGEQFreqCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack29Freq       wroteGEQFreqCh(10, 28, GEQ_MAXNUMBANDS)
#define  readGEQBack29Level       readGEQLevelCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQBack29Level(N)   writeGEQLevelCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack29Level      wroteGEQLevelCh(10, 28, GEQ_MAXNUMBANDS)
#define  readGEQBack29Width       readGEQWidthCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQBack29Width(N)   writeGEQWidthCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack29Width      wroteGEQWidthCh(10, 28, GEQ_MAXNUMBANDS)

#define  readGEQBack30Freq        readGEQFreqCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQBack30Freq(N)    writeGEQFreqCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack30Freq       wroteGEQFreqCh(10, 29, GEQ_MAXNUMBANDS)
#define  readGEQBack30Level       readGEQLevelCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQBack30Level(N)   writeGEQLevelCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack30Level      wroteGEQLevelCh(10, 29, GEQ_MAXNUMBANDS)
#define  readGEQBack30Width       readGEQWidthCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQBack30Width(N)   writeGEQWidthCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack30Width      wroteGEQWidthCh(10, 29, GEQ_MAXNUMBANDS)

#define  readGEQBack31Freq        readGEQFreqCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQBack31Freq(N)    writeGEQFreqCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack31Freq       wroteGEQFreqCh(10, 30, GEQ_MAXNUMBANDS)
#define  readGEQBack31Level       readGEQLevelCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQBack31Level(N)   writeGEQLevelCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack31Level      wroteGEQLevelCh(10, 30, GEQ_MAXNUMBANDS)
#define  readGEQBack31Width       readGEQWidthCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQBack31Width(N)   writeGEQWidthCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack31Width      wroteGEQWidthCh(10, 30, GEQ_MAXNUMBANDS)

#define  readGEQBack32Freq        readGEQFreqCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQBack32Freq(N)    writeGEQFreqCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack32Freq       wroteGEQFreqCh(10, 31, GEQ_MAXNUMBANDS)
#define  readGEQBack32Level       readGEQLevelCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQBack32Level(N)   writeGEQLevelCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack32Level      wroteGEQLevelCh(10, 31, GEQ_MAXNUMBANDS)
#define  readGEQBack32Width       readGEQWidthCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQBack32Width(N)   writeGEQWidthCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBack32Width      wroteGEQWidthCh(10, 31, GEQ_MAXNUMBANDS)

#define  readGEQLbak1Freq        readGEQFreqCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQLbak1Freq(N)    writeGEQFreqCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak1Freq       wroteGEQFreqCh(10, 0, GEQ_MAXNUMBANDS)
#define  readGEQLbak1Level       readGEQLevelCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQLbak1Level(N)   writeGEQLevelCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak1Level      wroteGEQLevelCh(10, 0, GEQ_MAXNUMBANDS)
#define  readGEQLbak1Width       readGEQWidthCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQLbak1Width(N)   writeGEQWidthCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak1Width      wroteGEQWidthCh(10, 0, GEQ_MAXNUMBANDS)

#define  readGEQLbak2Freq        readGEQFreqCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQLbak2Freq(N)    writeGEQFreqCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak2Freq       wroteGEQFreqCh(10, 1, GEQ_MAXNUMBANDS)
#define  readGEQLbak2Level       readGEQLevelCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQLbak2Level(N)   writeGEQLevelCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak2Level      wroteGEQLevelCh(10, 1, GEQ_MAXNUMBANDS)
#define  readGEQLbak2Width       readGEQWidthCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQLbak2Width(N)   writeGEQWidthCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak2Width      wroteGEQWidthCh(10, 1, GEQ_MAXNUMBANDS)

#define  readGEQLbak3Freq        readGEQFreqCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQLbak3Freq(N)    writeGEQFreqCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak3Freq       wroteGEQFreqCh(10, 2, GEQ_MAXNUMBANDS)
#define  readGEQLbak3Level       readGEQLevelCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQLbak3Level(N)   writeGEQLevelCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak3Level      wroteGEQLevelCh(10, 2, GEQ_MAXNUMBANDS)
#define  readGEQLbak3Width       readGEQWidthCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQLbak3Width(N)   writeGEQWidthCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak3Width      wroteGEQWidthCh(10, 2, GEQ_MAXNUMBANDS)

#define  readGEQLbak4Freq        readGEQFreqCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQLbak4Freq(N)    writeGEQFreqCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak4Freq       wroteGEQFreqCh(10, 3, GEQ_MAXNUMBANDS)
#define  readGEQLbak4Level       readGEQLevelCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQLbak4Level(N)   writeGEQLevelCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak4Level      wroteGEQLevelCh(10, 3, GEQ_MAXNUMBANDS)
#define  readGEQLbak4Width       readGEQWidthCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQLbak4Width(N)   writeGEQWidthCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak4Width      wroteGEQWidthCh(10, 3, GEQ_MAXNUMBANDS)

#define  readGEQLbak5Freq        readGEQFreqCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQLbak5Freq(N)    writeGEQFreqCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak5Freq       wroteGEQFreqCh(10, 4, GEQ_MAXNUMBANDS)
#define  readGEQLbak5Level       readGEQLevelCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQLbak5Level(N)   writeGEQLevelCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak5Level      wroteGEQLevelCh(10, 4, GEQ_MAXNUMBANDS)
#define  readGEQLbak5Width       readGEQWidthCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQLbak5Width(N)   writeGEQWidthCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak5Width      wroteGEQWidthCh(10, 4, GEQ_MAXNUMBANDS)

#define  readGEQLbak6Freq        readGEQFreqCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQLbak6Freq(N)    writeGEQFreqCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak6Freq       wroteGEQFreqCh(10, 5, GEQ_MAXNUMBANDS)
#define  readGEQLbak6Level       readGEQLevelCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQLbak6Level(N)   writeGEQLevelCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak6Level      wroteGEQLevelCh(10, 5, GEQ_MAXNUMBANDS)
#define  readGEQLbak6Width       readGEQWidthCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQLbak6Width(N)   writeGEQWidthCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak6Width      wroteGEQWidthCh(10, 5, GEQ_MAXNUMBANDS)

#define  readGEQLbak7Freq        readGEQFreqCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQLbak7Freq(N)    writeGEQFreqCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak7Freq       wroteGEQFreqCh(10, 6, GEQ_MAXNUMBANDS)
#define  readGEQLbak7Level       readGEQLevelCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQLbak7Level(N)   writeGEQLevelCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak7Level      wroteGEQLevelCh(10, 6, GEQ_MAXNUMBANDS)
#define  readGEQLbak7Width       readGEQWidthCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQLbak7Width(N)   writeGEQWidthCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak7Width      wroteGEQWidthCh(10, 6, GEQ_MAXNUMBANDS)

#define  readGEQLbak8Freq        readGEQFreqCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQLbak8Freq(N)    writeGEQFreqCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak8Freq       wroteGEQFreqCh(10, 7, GEQ_MAXNUMBANDS)
#define  readGEQLbak8Level       readGEQLevelCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQLbak8Level(N)   writeGEQLevelCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak8Level      wroteGEQLevelCh(10, 7, GEQ_MAXNUMBANDS)
#define  readGEQLbak8Width       readGEQWidthCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQLbak8Width(N)   writeGEQWidthCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak8Width      wroteGEQWidthCh(10, 7, GEQ_MAXNUMBANDS)

#define  readGEQLbak9Freq        readGEQFreqCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQLbak9Freq(N)    writeGEQFreqCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak9Freq       wroteGEQFreqCh(10, 8, GEQ_MAXNUMBANDS)
#define  readGEQLbak9Level       readGEQLevelCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQLbak9Level(N)   writeGEQLevelCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak9Level      wroteGEQLevelCh(10, 8, GEQ_MAXNUMBANDS)
#define  readGEQLbak9Width       readGEQWidthCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQLbak9Width(N)   writeGEQWidthCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak9Width      wroteGEQWidthCh(10, 8, GEQ_MAXNUMBANDS)

#define  readGEQLbak10Freq        readGEQFreqCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQLbak10Freq(N)    writeGEQFreqCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak10Freq       wroteGEQFreqCh(10, 9, GEQ_MAXNUMBANDS)
#define  readGEQLbak10Level       readGEQLevelCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQLbak10Level(N)   writeGEQLevelCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak10Level      wroteGEQLevelCh(10, 9, GEQ_MAXNUMBANDS)
#define  readGEQLbak10Width       readGEQWidthCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQLbak10Width(N)   writeGEQWidthCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak10Width      wroteGEQWidthCh(10, 9, GEQ_MAXNUMBANDS)

#define  readGEQLbak11Freq        readGEQFreqCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQLbak11Freq(N)    writeGEQFreqCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak11Freq       wroteGEQFreqCh(10, 10, GEQ_MAXNUMBANDS)
#define  readGEQLbak11Level       readGEQLevelCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQLbak11Level(N)   writeGEQLevelCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak11Level      wroteGEQLevelCh(10, 10, GEQ_MAXNUMBANDS)
#define  readGEQLbak11Width       readGEQWidthCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQLbak11Width(N)   writeGEQWidthCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak11Width      wroteGEQWidthCh(10, 10, GEQ_MAXNUMBANDS)

#define  readGEQLbak12Freq        readGEQFreqCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQLbak12Freq(N)    writeGEQFreqCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak12Freq       wroteGEQFreqCh(10, 11, GEQ_MAXNUMBANDS)
#define  readGEQLbak12Level       readGEQLevelCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQLbak12Level(N)   writeGEQLevelCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak12Level      wroteGEQLevelCh(10, 11, GEQ_MAXNUMBANDS)
#define  readGEQLbak12Width       readGEQWidthCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQLbak12Width(N)   writeGEQWidthCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak12Width      wroteGEQWidthCh(10, 11, GEQ_MAXNUMBANDS)

#define  readGEQLbak13Freq        readGEQFreqCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQLbak13Freq(N)    writeGEQFreqCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak13Freq       wroteGEQFreqCh(10, 12, GEQ_MAXNUMBANDS)
#define  readGEQLbak13Level       readGEQLevelCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQLbak13Level(N)   writeGEQLevelCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak13Level      wroteGEQLevelCh(10, 12, GEQ_MAXNUMBANDS)
#define  readGEQLbak13Width       readGEQWidthCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQLbak13Width(N)   writeGEQWidthCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak13Width      wroteGEQWidthCh(10, 12, GEQ_MAXNUMBANDS)

#define  readGEQLbak14Freq        readGEQFreqCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQLbak14Freq(N)    writeGEQFreqCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak14Freq       wroteGEQFreqCh(10, 13, GEQ_MAXNUMBANDS)
#define  readGEQLbak14Level       readGEQLevelCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQLbak14Level(N)   writeGEQLevelCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak14Level      wroteGEQLevelCh(10, 13, GEQ_MAXNUMBANDS)
#define  readGEQLbak14Width       readGEQWidthCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQLbak14Width(N)   writeGEQWidthCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak14Width      wroteGEQWidthCh(10, 13, GEQ_MAXNUMBANDS)

#define  readGEQLbak15Freq        readGEQFreqCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQLbak15Freq(N)    writeGEQFreqCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak15Freq       wroteGEQFreqCh(10, 14, GEQ_MAXNUMBANDS)
#define  readGEQLbak15Level       readGEQLevelCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQLbak15Level(N)   writeGEQLevelCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak15Level      wroteGEQLevelCh(10, 14, GEQ_MAXNUMBANDS)
#define  readGEQLbak15Width       readGEQWidthCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQLbak15Width(N)   writeGEQWidthCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak15Width      wroteGEQWidthCh(10, 14, GEQ_MAXNUMBANDS)

#define  readGEQLbak16Freq        readGEQFreqCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQLbak16Freq(N)    writeGEQFreqCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak16Freq       wroteGEQFreqCh(10, 15, GEQ_MAXNUMBANDS)
#define  readGEQLbak16Level       readGEQLevelCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQLbak16Level(N)   writeGEQLevelCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak16Level      wroteGEQLevelCh(10, 15, GEQ_MAXNUMBANDS)
#define  readGEQLbak16Width       readGEQWidthCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQLbak16Width(N)   writeGEQWidthCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak16Width      wroteGEQWidthCh(10, 15, GEQ_MAXNUMBANDS)

#define  readGEQLbak17Freq        readGEQFreqCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQLbak17Freq(N)    writeGEQFreqCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak17Freq       wroteGEQFreqCh(10, 16, GEQ_MAXNUMBANDS)
#define  readGEQLbak17Level       readGEQLevelCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQLbak17Level(N)   writeGEQLevelCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak17Level      wroteGEQLevelCh(10, 16, GEQ_MAXNUMBANDS)
#define  readGEQLbak17Width       readGEQWidthCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQLbak17Width(N)   writeGEQWidthCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak17Width      wroteGEQWidthCh(10, 16, GEQ_MAXNUMBANDS)

#define  readGEQLbak18Freq        readGEQFreqCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQLbak18Freq(N)    writeGEQFreqCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak18Freq       wroteGEQFreqCh(10, 17, GEQ_MAXNUMBANDS)
#define  readGEQLbak18Level       readGEQLevelCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQLbak18Level(N)   writeGEQLevelCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak18Level      wroteGEQLevelCh(10, 17, GEQ_MAXNUMBANDS)
#define  readGEQLbak18Width       readGEQWidthCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQLbak18Width(N)   writeGEQWidthCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak18Width      wroteGEQWidthCh(10, 17, GEQ_MAXNUMBANDS)

#define  readGEQLbak19Freq        readGEQFreqCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQLbak19Freq(N)    writeGEQFreqCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak19Freq       wroteGEQFreqCh(10, 18, GEQ_MAXNUMBANDS)
#define  readGEQLbak19Level       readGEQLevelCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQLbak19Level(N)   writeGEQLevelCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak19Level      wroteGEQLevelCh(10, 18, GEQ_MAXNUMBANDS)
#define  readGEQLbak19Width       readGEQWidthCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQLbak19Width(N)   writeGEQWidthCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak19Width      wroteGEQWidthCh(10, 18, GEQ_MAXNUMBANDS)

#define  readGEQLbak20Freq        readGEQFreqCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQLbak20Freq(N)    writeGEQFreqCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak20Freq       wroteGEQFreqCh(10, 19, GEQ_MAXNUMBANDS)
#define  readGEQLbak20Level       readGEQLevelCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQLbak20Level(N)   writeGEQLevelCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak20Level      wroteGEQLevelCh(10, 19, GEQ_MAXNUMBANDS)
#define  readGEQLbak20Width       readGEQWidthCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQLbak20Width(N)   writeGEQWidthCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak20Width      wroteGEQWidthCh(10, 19, GEQ_MAXNUMBANDS)

#define  readGEQLbak21Freq        readGEQFreqCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQLbak21Freq(N)    writeGEQFreqCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak21Freq       wroteGEQFreqCh(10, 20, GEQ_MAXNUMBANDS)
#define  readGEQLbak21Level       readGEQLevelCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQLbak21Level(N)   writeGEQLevelCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak21Level      wroteGEQLevelCh(10, 20, GEQ_MAXNUMBANDS)
#define  readGEQLbak21Width       readGEQWidthCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQLbak21Width(N)   writeGEQWidthCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak21Width      wroteGEQWidthCh(10, 20, GEQ_MAXNUMBANDS)

#define  readGEQLbak22Freq        readGEQFreqCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQLbak22Freq(N)    writeGEQFreqCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak22Freq       wroteGEQFreqCh(10, 21, GEQ_MAXNUMBANDS)
#define  readGEQLbak22Level       readGEQLevelCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQLbak22Level(N)   writeGEQLevelCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak22Level      wroteGEQLevelCh(10, 21, GEQ_MAXNUMBANDS)
#define  readGEQLbak22Width       readGEQWidthCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQLbak22Width(N)   writeGEQWidthCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak22Width      wroteGEQWidthCh(10, 21, GEQ_MAXNUMBANDS)

#define  readGEQLbak23Freq        readGEQFreqCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQLbak23Freq(N)    writeGEQFreqCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak23Freq       wroteGEQFreqCh(10, 22, GEQ_MAXNUMBANDS)
#define  readGEQLbak23Level       readGEQLevelCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQLbak23Level(N)   writeGEQLevelCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak23Level      wroteGEQLevelCh(10, 22, GEQ_MAXNUMBANDS)
#define  readGEQLbak23Width       readGEQWidthCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQLbak23Width(N)   writeGEQWidthCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak23Width      wroteGEQWidthCh(10, 22, GEQ_MAXNUMBANDS)

#define  readGEQLbak24Freq        readGEQFreqCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQLbak24Freq(N)    writeGEQFreqCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak24Freq       wroteGEQFreqCh(10, 23, GEQ_MAXNUMBANDS)
#define  readGEQLbak24Level       readGEQLevelCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQLbak24Level(N)   writeGEQLevelCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak24Level      wroteGEQLevelCh(10, 23, GEQ_MAXNUMBANDS)
#define  readGEQLbak24Width       readGEQWidthCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQLbak24Width(N)   writeGEQWidthCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak24Width      wroteGEQWidthCh(10, 23, GEQ_MAXNUMBANDS)

#define  readGEQLbak25Freq        readGEQFreqCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQLbak25Freq(N)    writeGEQFreqCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak25Freq       wroteGEQFreqCh(10, 24, GEQ_MAXNUMBANDS)
#define  readGEQLbak25Level       readGEQLevelCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQLbak25Level(N)   writeGEQLevelCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak25Level      wroteGEQLevelCh(10, 24, GEQ_MAXNUMBANDS)
#define  readGEQLbak25Width       readGEQWidthCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQLbak25Width(N)   writeGEQWidthCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak25Width      wroteGEQWidthCh(10, 24, GEQ_MAXNUMBANDS)

#define  readGEQLbak26Freq        readGEQFreqCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQLbak26Freq(N)    writeGEQFreqCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak26Freq       wroteGEQFreqCh(10, 25, GEQ_MAXNUMBANDS)
#define  readGEQLbak26Level       readGEQLevelCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQLbak26Level(N)   writeGEQLevelCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak26Level      wroteGEQLevelCh(10, 25, GEQ_MAXNUMBANDS)
#define  readGEQLbak26Width       readGEQWidthCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQLbak26Width(N)   writeGEQWidthCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak26Width      wroteGEQWidthCh(10, 25, GEQ_MAXNUMBANDS)

#define  readGEQLbak27Freq        readGEQFreqCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQLbak27Freq(N)    writeGEQFreqCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak27Freq       wroteGEQFreqCh(10, 26, GEQ_MAXNUMBANDS)
#define  readGEQLbak27Level       readGEQLevelCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQLbak27Level(N)   writeGEQLevelCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak27Level      wroteGEQLevelCh(10, 26, GEQ_MAXNUMBANDS)
#define  readGEQLbak27Width       readGEQWidthCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQLbak27Width(N)   writeGEQWidthCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak27Width      wroteGEQWidthCh(10, 26, GEQ_MAXNUMBANDS)

#define  readGEQLbak28Freq        readGEQFreqCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQLbak28Freq(N)    writeGEQFreqCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak28Freq       wroteGEQFreqCh(10, 27, GEQ_MAXNUMBANDS)
#define  readGEQLbak28Level       readGEQLevelCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQLbak28Level(N)   writeGEQLevelCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak28Level      wroteGEQLevelCh(10, 27, GEQ_MAXNUMBANDS)
#define  readGEQLbak28Width       readGEQWidthCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQLbak28Width(N)   writeGEQWidthCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak28Width      wroteGEQWidthCh(10, 27, GEQ_MAXNUMBANDS)

#define  readGEQLbak29Freq        readGEQFreqCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQLbak29Freq(N)    writeGEQFreqCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak29Freq       wroteGEQFreqCh(10, 28, GEQ_MAXNUMBANDS)
#define  readGEQLbak29Level       readGEQLevelCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQLbak29Level(N)   writeGEQLevelCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak29Level      wroteGEQLevelCh(10, 28, GEQ_MAXNUMBANDS)
#define  readGEQLbak29Width       readGEQWidthCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQLbak29Width(N)   writeGEQWidthCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak29Width      wroteGEQWidthCh(10, 28, GEQ_MAXNUMBANDS)

#define  readGEQLbak30Freq        readGEQFreqCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQLbak30Freq(N)    writeGEQFreqCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak30Freq       wroteGEQFreqCh(10, 29, GEQ_MAXNUMBANDS)
#define  readGEQLbak30Level       readGEQLevelCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQLbak30Level(N)   writeGEQLevelCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak30Level      wroteGEQLevelCh(10, 29, GEQ_MAXNUMBANDS)
#define  readGEQLbak30Width       readGEQWidthCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQLbak30Width(N)   writeGEQWidthCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak30Width      wroteGEQWidthCh(10, 29, GEQ_MAXNUMBANDS)

#define  readGEQLbak31Freq        readGEQFreqCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQLbak31Freq(N)    writeGEQFreqCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak31Freq       wroteGEQFreqCh(10, 30, GEQ_MAXNUMBANDS)
#define  readGEQLbak31Level       readGEQLevelCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQLbak31Level(N)   writeGEQLevelCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak31Level      wroteGEQLevelCh(10, 30, GEQ_MAXNUMBANDS)
#define  readGEQLbak31Width       readGEQWidthCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQLbak31Width(N)   writeGEQWidthCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak31Width      wroteGEQWidthCh(10, 30, GEQ_MAXNUMBANDS)

#define  readGEQLbak32Freq        readGEQFreqCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQLbak32Freq(N)    writeGEQFreqCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak32Freq       wroteGEQFreqCh(10, 31, GEQ_MAXNUMBANDS)
#define  readGEQLbak32Level       readGEQLevelCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQLbak32Level(N)   writeGEQLevelCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak32Level      wroteGEQLevelCh(10, 31, GEQ_MAXNUMBANDS)
#define  readGEQLbak32Width       readGEQWidthCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQLbak32Width(N)   writeGEQWidthCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLbak32Width      wroteGEQWidthCh(10, 31, GEQ_MAXNUMBANDS)

#define  readGEQRbak1Freq        readGEQFreqCh(11, 0, GEQ_MAXNUMBANDS)
#define writeGEQRbak1Freq(N)    writeGEQFreqCh(11, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak1Freq       wroteGEQFreqCh(11, 0, GEQ_MAXNUMBANDS)
#define  readGEQRbak1Level       readGEQLevelCh(11, 0, GEQ_MAXNUMBANDS)
#define writeGEQRbak1Level(N)   writeGEQLevelCh(11, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak1Level      wroteGEQLevelCh(11, 0, GEQ_MAXNUMBANDS)
#define  readGEQRbak1Width       readGEQWidthCh(11, 0, GEQ_MAXNUMBANDS)
#define writeGEQRbak1Width(N)   writeGEQWidthCh(11, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak1Width      wroteGEQWidthCh(11, 0, GEQ_MAXNUMBANDS)

#define  readGEQRbak2Freq        readGEQFreqCh(11, 1, GEQ_MAXNUMBANDS)
#define writeGEQRbak2Freq(N)    writeGEQFreqCh(11, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak2Freq       wroteGEQFreqCh(11, 1, GEQ_MAXNUMBANDS)
#define  readGEQRbak2Level       readGEQLevelCh(11, 1, GEQ_MAXNUMBANDS)
#define writeGEQRbak2Level(N)   writeGEQLevelCh(11, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak2Level      wroteGEQLevelCh(11, 1, GEQ_MAXNUMBANDS)
#define  readGEQRbak2Width       readGEQWidthCh(11, 1, GEQ_MAXNUMBANDS)
#define writeGEQRbak2Width(N)   writeGEQWidthCh(11, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak2Width      wroteGEQWidthCh(11, 1, GEQ_MAXNUMBANDS)

#define  readGEQRbak3Freq        readGEQFreqCh(11, 2, GEQ_MAXNUMBANDS)
#define writeGEQRbak3Freq(N)    writeGEQFreqCh(11, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak3Freq       wroteGEQFreqCh(11, 2, GEQ_MAXNUMBANDS)
#define  readGEQRbak3Level       readGEQLevelCh(11, 2, GEQ_MAXNUMBANDS)
#define writeGEQRbak3Level(N)   writeGEQLevelCh(11, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak3Level      wroteGEQLevelCh(11, 2, GEQ_MAXNUMBANDS)
#define  readGEQRbak3Width       readGEQWidthCh(11, 2, GEQ_MAXNUMBANDS)
#define writeGEQRbak3Width(N)   writeGEQWidthCh(11, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak3Width      wroteGEQWidthCh(11, 2, GEQ_MAXNUMBANDS)

#define  readGEQRbak4Freq        readGEQFreqCh(11, 3, GEQ_MAXNUMBANDS)
#define writeGEQRbak4Freq(N)    writeGEQFreqCh(11, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak4Freq       wroteGEQFreqCh(11, 3, GEQ_MAXNUMBANDS)
#define  readGEQRbak4Level       readGEQLevelCh(11, 3, GEQ_MAXNUMBANDS)
#define writeGEQRbak4Level(N)   writeGEQLevelCh(11, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak4Level      wroteGEQLevelCh(11, 3, GEQ_MAXNUMBANDS)
#define  readGEQRbak4Width       readGEQWidthCh(11, 3, GEQ_MAXNUMBANDS)
#define writeGEQRbak4Width(N)   writeGEQWidthCh(11, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak4Width      wroteGEQWidthCh(11, 3, GEQ_MAXNUMBANDS)

#define  readGEQRbak5Freq        readGEQFreqCh(11, 4, GEQ_MAXNUMBANDS)
#define writeGEQRbak5Freq(N)    writeGEQFreqCh(11, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak5Freq       wroteGEQFreqCh(11, 4, GEQ_MAXNUMBANDS)
#define  readGEQRbak5Level       readGEQLevelCh(11, 4, GEQ_MAXNUMBANDS)
#define writeGEQRbak5Level(N)   writeGEQLevelCh(11, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak5Level      wroteGEQLevelCh(11, 4, GEQ_MAXNUMBANDS)
#define  readGEQRbak5Width       readGEQWidthCh(11, 4, GEQ_MAXNUMBANDS)
#define writeGEQRbak5Width(N)   writeGEQWidthCh(11, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak5Width      wroteGEQWidthCh(11, 4, GEQ_MAXNUMBANDS)

#define  readGEQRbak6Freq        readGEQFreqCh(11, 5, GEQ_MAXNUMBANDS)
#define writeGEQRbak6Freq(N)    writeGEQFreqCh(11, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak6Freq       wroteGEQFreqCh(11, 5, GEQ_MAXNUMBANDS)
#define  readGEQRbak6Level       readGEQLevelCh(11, 5, GEQ_MAXNUMBANDS)
#define writeGEQRbak6Level(N)   writeGEQLevelCh(11, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak6Level      wroteGEQLevelCh(11, 5, GEQ_MAXNUMBANDS)
#define  readGEQRbak6Width       readGEQWidthCh(11, 5, GEQ_MAXNUMBANDS)
#define writeGEQRbak6Width(N)   writeGEQWidthCh(11, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak6Width      wroteGEQWidthCh(11, 5, GEQ_MAXNUMBANDS)

#define  readGEQRbak7Freq        readGEQFreqCh(11, 6, GEQ_MAXNUMBANDS)
#define writeGEQRbak7Freq(N)    writeGEQFreqCh(11, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak7Freq       wroteGEQFreqCh(11, 6, GEQ_MAXNUMBANDS)
#define  readGEQRbak7Level       readGEQLevelCh(11, 6, GEQ_MAXNUMBANDS)
#define writeGEQRbak7Level(N)   writeGEQLevelCh(11, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak7Level      wroteGEQLevelCh(11, 6, GEQ_MAXNUMBANDS)
#define  readGEQRbak7Width       readGEQWidthCh(11, 6, GEQ_MAXNUMBANDS)
#define writeGEQRbak7Width(N)   writeGEQWidthCh(11, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak7Width      wroteGEQWidthCh(11, 6, GEQ_MAXNUMBANDS)

#define  readGEQRbak8Freq        readGEQFreqCh(11, 7, GEQ_MAXNUMBANDS)
#define writeGEQRbak8Freq(N)    writeGEQFreqCh(11, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak8Freq       wroteGEQFreqCh(11, 7, GEQ_MAXNUMBANDS)
#define  readGEQRbak8Level       readGEQLevelCh(11, 7, GEQ_MAXNUMBANDS)
#define writeGEQRbak8Level(N)   writeGEQLevelCh(11, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak8Level      wroteGEQLevelCh(11, 7, GEQ_MAXNUMBANDS)
#define  readGEQRbak8Width       readGEQWidthCh(11, 7, GEQ_MAXNUMBANDS)
#define writeGEQRbak8Width(N)   writeGEQWidthCh(11, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak8Width      wroteGEQWidthCh(11, 7, GEQ_MAXNUMBANDS)

#define  readGEQRbak9Freq        readGEQFreqCh(11, 8, GEQ_MAXNUMBANDS)
#define writeGEQRbak9Freq(N)    writeGEQFreqCh(11, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak9Freq       wroteGEQFreqCh(11, 8, GEQ_MAXNUMBANDS)
#define  readGEQRbak9Level       readGEQLevelCh(11, 8, GEQ_MAXNUMBANDS)
#define writeGEQRbak9Level(N)   writeGEQLevelCh(11, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak9Level      wroteGEQLevelCh(11, 8, GEQ_MAXNUMBANDS)
#define  readGEQRbak9Width       readGEQWidthCh(11, 8, GEQ_MAXNUMBANDS)
#define writeGEQRbak9Width(N)   writeGEQWidthCh(11, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak9Width      wroteGEQWidthCh(11, 8, GEQ_MAXNUMBANDS)

#define  readGEQRbak10Freq        readGEQFreqCh(11, 9, GEQ_MAXNUMBANDS)
#define writeGEQRbak10Freq(N)    writeGEQFreqCh(11, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak10Freq       wroteGEQFreqCh(11, 9, GEQ_MAXNUMBANDS)
#define  readGEQRbak10Level       readGEQLevelCh(11, 9, GEQ_MAXNUMBANDS)
#define writeGEQRbak10Level(N)   writeGEQLevelCh(11, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak10Level      wroteGEQLevelCh(11, 9, GEQ_MAXNUMBANDS)
#define  readGEQRbak10Width       readGEQWidthCh(11, 9, GEQ_MAXNUMBANDS)
#define writeGEQRbak10Width(N)   writeGEQWidthCh(11, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak10Width      wroteGEQWidthCh(11, 9, GEQ_MAXNUMBANDS)

#define  readGEQRbak11Freq        readGEQFreqCh(11, 10, GEQ_MAXNUMBANDS)
#define writeGEQRbak11Freq(N)    writeGEQFreqCh(11, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak11Freq       wroteGEQFreqCh(11, 10, GEQ_MAXNUMBANDS)
#define  readGEQRbak11Level       readGEQLevelCh(11, 10, GEQ_MAXNUMBANDS)
#define writeGEQRbak11Level(N)   writeGEQLevelCh(11, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak11Level      wroteGEQLevelCh(11, 10, GEQ_MAXNUMBANDS)
#define  readGEQRbak11Width       readGEQWidthCh(11, 10, GEQ_MAXNUMBANDS)
#define writeGEQRbak11Width(N)   writeGEQWidthCh(11, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak11Width      wroteGEQWidthCh(11, 10, GEQ_MAXNUMBANDS)

#define  readGEQRbak12Freq        readGEQFreqCh(11, 11, GEQ_MAXNUMBANDS)
#define writeGEQRbak12Freq(N)    writeGEQFreqCh(11, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak12Freq       wroteGEQFreqCh(11, 11, GEQ_MAXNUMBANDS)
#define  readGEQRbak12Level       readGEQLevelCh(11, 11, GEQ_MAXNUMBANDS)
#define writeGEQRbak12Level(N)   writeGEQLevelCh(11, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak12Level      wroteGEQLevelCh(11, 11, GEQ_MAXNUMBANDS)
#define  readGEQRbak12Width       readGEQWidthCh(11, 11, GEQ_MAXNUMBANDS)
#define writeGEQRbak12Width(N)   writeGEQWidthCh(11, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak12Width      wroteGEQWidthCh(11, 11, GEQ_MAXNUMBANDS)

#define  readGEQRbak13Freq        readGEQFreqCh(11, 12, GEQ_MAXNUMBANDS)
#define writeGEQRbak13Freq(N)    writeGEQFreqCh(11, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak13Freq       wroteGEQFreqCh(11, 12, GEQ_MAXNUMBANDS)
#define  readGEQRbak13Level       readGEQLevelCh(11, 12, GEQ_MAXNUMBANDS)
#define writeGEQRbak13Level(N)   writeGEQLevelCh(11, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak13Level      wroteGEQLevelCh(11, 12, GEQ_MAXNUMBANDS)
#define  readGEQRbak13Width       readGEQWidthCh(11, 12, GEQ_MAXNUMBANDS)
#define writeGEQRbak13Width(N)   writeGEQWidthCh(11, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak13Width      wroteGEQWidthCh(11, 12, GEQ_MAXNUMBANDS)

#define  readGEQRbak14Freq        readGEQFreqCh(11, 13, GEQ_MAXNUMBANDS)
#define writeGEQRbak14Freq(N)    writeGEQFreqCh(11, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak14Freq       wroteGEQFreqCh(11, 13, GEQ_MAXNUMBANDS)
#define  readGEQRbak14Level       readGEQLevelCh(11, 13, GEQ_MAXNUMBANDS)
#define writeGEQRbak14Level(N)   writeGEQLevelCh(11, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak14Level      wroteGEQLevelCh(11, 13, GEQ_MAXNUMBANDS)
#define  readGEQRbak14Width       readGEQWidthCh(11, 13, GEQ_MAXNUMBANDS)
#define writeGEQRbak14Width(N)   writeGEQWidthCh(11, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak14Width      wroteGEQWidthCh(11, 13, GEQ_MAXNUMBANDS)

#define  readGEQRbak15Freq        readGEQFreqCh(11, 14, GEQ_MAXNUMBANDS)
#define writeGEQRbak15Freq(N)    writeGEQFreqCh(11, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak15Freq       wroteGEQFreqCh(11, 14, GEQ_MAXNUMBANDS)
#define  readGEQRbak15Level       readGEQLevelCh(11, 14, GEQ_MAXNUMBANDS)
#define writeGEQRbak15Level(N)   writeGEQLevelCh(11, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak15Level      wroteGEQLevelCh(11, 14, GEQ_MAXNUMBANDS)
#define  readGEQRbak15Width       readGEQWidthCh(11, 14, GEQ_MAXNUMBANDS)
#define writeGEQRbak15Width(N)   writeGEQWidthCh(11, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak15Width      wroteGEQWidthCh(11, 14, GEQ_MAXNUMBANDS)

#define  readGEQRbak16Freq        readGEQFreqCh(11, 15, GEQ_MAXNUMBANDS)
#define writeGEQRbak16Freq(N)    writeGEQFreqCh(11, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak16Freq       wroteGEQFreqCh(11, 15, GEQ_MAXNUMBANDS)
#define  readGEQRbak16Level       readGEQLevelCh(11, 15, GEQ_MAXNUMBANDS)
#define writeGEQRbak16Level(N)   writeGEQLevelCh(11, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak16Level      wroteGEQLevelCh(11, 15, GEQ_MAXNUMBANDS)
#define  readGEQRbak16Width       readGEQWidthCh(11, 15, GEQ_MAXNUMBANDS)
#define writeGEQRbak16Width(N)   writeGEQWidthCh(11, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak16Width      wroteGEQWidthCh(11, 15, GEQ_MAXNUMBANDS)

#define  readGEQRbak17Freq        readGEQFreqCh(11, 16, GEQ_MAXNUMBANDS)
#define writeGEQRbak17Freq(N)    writeGEQFreqCh(11, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak17Freq       wroteGEQFreqCh(11, 16, GEQ_MAXNUMBANDS)
#define  readGEQRbak17Level       readGEQLevelCh(11, 16, GEQ_MAXNUMBANDS)
#define writeGEQRbak17Level(N)   writeGEQLevelCh(11, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak17Level      wroteGEQLevelCh(11, 16, GEQ_MAXNUMBANDS)
#define  readGEQRbak17Width       readGEQWidthCh(11, 16, GEQ_MAXNUMBANDS)
#define writeGEQRbak17Width(N)   writeGEQWidthCh(11, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak17Width      wroteGEQWidthCh(11, 16, GEQ_MAXNUMBANDS)

#define  readGEQRbak18Freq        readGEQFreqCh(11, 17, GEQ_MAXNUMBANDS)
#define writeGEQRbak18Freq(N)    writeGEQFreqCh(11, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak18Freq       wroteGEQFreqCh(11, 17, GEQ_MAXNUMBANDS)
#define  readGEQRbak18Level       readGEQLevelCh(11, 17, GEQ_MAXNUMBANDS)
#define writeGEQRbak18Level(N)   writeGEQLevelCh(11, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak18Level      wroteGEQLevelCh(11, 17, GEQ_MAXNUMBANDS)
#define  readGEQRbak18Width       readGEQWidthCh(11, 17, GEQ_MAXNUMBANDS)
#define writeGEQRbak18Width(N)   writeGEQWidthCh(11, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak18Width      wroteGEQWidthCh(11, 17, GEQ_MAXNUMBANDS)

#define  readGEQRbak19Freq        readGEQFreqCh(11, 18, GEQ_MAXNUMBANDS)
#define writeGEQRbak19Freq(N)    writeGEQFreqCh(11, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak19Freq       wroteGEQFreqCh(11, 18, GEQ_MAXNUMBANDS)
#define  readGEQRbak19Level       readGEQLevelCh(11, 18, GEQ_MAXNUMBANDS)
#define writeGEQRbak19Level(N)   writeGEQLevelCh(11, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak19Level      wroteGEQLevelCh(11, 18, GEQ_MAXNUMBANDS)
#define  readGEQRbak19Width       readGEQWidthCh(11, 18, GEQ_MAXNUMBANDS)
#define writeGEQRbak19Width(N)   writeGEQWidthCh(11, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak19Width      wroteGEQWidthCh(11, 18, GEQ_MAXNUMBANDS)

#define  readGEQRbak20Freq        readGEQFreqCh(11, 19, GEQ_MAXNUMBANDS)
#define writeGEQRbak20Freq(N)    writeGEQFreqCh(11, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak20Freq       wroteGEQFreqCh(11, 19, GEQ_MAXNUMBANDS)
#define  readGEQRbak20Level       readGEQLevelCh(11, 19, GEQ_MAXNUMBANDS)
#define writeGEQRbak20Level(N)   writeGEQLevelCh(11, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak20Level      wroteGEQLevelCh(11, 19, GEQ_MAXNUMBANDS)
#define  readGEQRbak20Width       readGEQWidthCh(11, 19, GEQ_MAXNUMBANDS)
#define writeGEQRbak20Width(N)   writeGEQWidthCh(11, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak20Width      wroteGEQWidthCh(11, 19, GEQ_MAXNUMBANDS)

#define  readGEQRbak21Freq        readGEQFreqCh(11, 20, GEQ_MAXNUMBANDS)
#define writeGEQRbak21Freq(N)    writeGEQFreqCh(11, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak21Freq       wroteGEQFreqCh(11, 20, GEQ_MAXNUMBANDS)
#define  readGEQRbak21Level       readGEQLevelCh(11, 20, GEQ_MAXNUMBANDS)
#define writeGEQRbak21Level(N)   writeGEQLevelCh(11, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak21Level      wroteGEQLevelCh(11, 20, GEQ_MAXNUMBANDS)
#define  readGEQRbak21Width       readGEQWidthCh(11, 20, GEQ_MAXNUMBANDS)
#define writeGEQRbak21Width(N)   writeGEQWidthCh(11, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak21Width      wroteGEQWidthCh(11, 20, GEQ_MAXNUMBANDS)

#define  readGEQRbak22Freq        readGEQFreqCh(11, 21, GEQ_MAXNUMBANDS)
#define writeGEQRbak22Freq(N)    writeGEQFreqCh(11, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak22Freq       wroteGEQFreqCh(11, 21, GEQ_MAXNUMBANDS)
#define  readGEQRbak22Level       readGEQLevelCh(11, 21, GEQ_MAXNUMBANDS)
#define writeGEQRbak22Level(N)   writeGEQLevelCh(11, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak22Level      wroteGEQLevelCh(11, 21, GEQ_MAXNUMBANDS)
#define  readGEQRbak22Width       readGEQWidthCh(11, 21, GEQ_MAXNUMBANDS)
#define writeGEQRbak22Width(N)   writeGEQWidthCh(11, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak22Width      wroteGEQWidthCh(11, 21, GEQ_MAXNUMBANDS)

#define  readGEQRbak23Freq        readGEQFreqCh(11, 22, GEQ_MAXNUMBANDS)
#define writeGEQRbak23Freq(N)    writeGEQFreqCh(11, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak23Freq       wroteGEQFreqCh(11, 22, GEQ_MAXNUMBANDS)
#define  readGEQRbak23Level       readGEQLevelCh(11, 22, GEQ_MAXNUMBANDS)
#define writeGEQRbak23Level(N)   writeGEQLevelCh(11, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak23Level      wroteGEQLevelCh(11, 22, GEQ_MAXNUMBANDS)
#define  readGEQRbak23Width       readGEQWidthCh(11, 22, GEQ_MAXNUMBANDS)
#define writeGEQRbak23Width(N)   writeGEQWidthCh(11, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak23Width      wroteGEQWidthCh(11, 22, GEQ_MAXNUMBANDS)

#define  readGEQRbak24Freq        readGEQFreqCh(11, 23, GEQ_MAXNUMBANDS)
#define writeGEQRbak24Freq(N)    writeGEQFreqCh(11, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak24Freq       wroteGEQFreqCh(11, 23, GEQ_MAXNUMBANDS)
#define  readGEQRbak24Level       readGEQLevelCh(11, 23, GEQ_MAXNUMBANDS)
#define writeGEQRbak24Level(N)   writeGEQLevelCh(11, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak24Level      wroteGEQLevelCh(11, 23, GEQ_MAXNUMBANDS)
#define  readGEQRbak24Width       readGEQWidthCh(11, 23, GEQ_MAXNUMBANDS)
#define writeGEQRbak24Width(N)   writeGEQWidthCh(11, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak24Width      wroteGEQWidthCh(11, 23, GEQ_MAXNUMBANDS)

#define  readGEQRbak25Freq        readGEQFreqCh(11, 24, GEQ_MAXNUMBANDS)
#define writeGEQRbak25Freq(N)    writeGEQFreqCh(11, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak25Freq       wroteGEQFreqCh(11, 24, GEQ_MAXNUMBANDS)
#define  readGEQRbak25Level       readGEQLevelCh(11, 24, GEQ_MAXNUMBANDS)
#define writeGEQRbak25Level(N)   writeGEQLevelCh(11, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak25Level      wroteGEQLevelCh(11, 24, GEQ_MAXNUMBANDS)
#define  readGEQRbak25Width       readGEQWidthCh(11, 24, GEQ_MAXNUMBANDS)
#define writeGEQRbak25Width(N)   writeGEQWidthCh(11, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak25Width      wroteGEQWidthCh(11, 24, GEQ_MAXNUMBANDS)

#define  readGEQRbak26Freq        readGEQFreqCh(11, 25, GEQ_MAXNUMBANDS)
#define writeGEQRbak26Freq(N)    writeGEQFreqCh(11, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak26Freq       wroteGEQFreqCh(11, 25, GEQ_MAXNUMBANDS)
#define  readGEQRbak26Level       readGEQLevelCh(11, 25, GEQ_MAXNUMBANDS)
#define writeGEQRbak26Level(N)   writeGEQLevelCh(11, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak26Level      wroteGEQLevelCh(11, 25, GEQ_MAXNUMBANDS)
#define  readGEQRbak26Width       readGEQWidthCh(11, 25, GEQ_MAXNUMBANDS)
#define writeGEQRbak26Width(N)   writeGEQWidthCh(11, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak26Width      wroteGEQWidthCh(11, 25, GEQ_MAXNUMBANDS)

#define  readGEQRbak27Freq        readGEQFreqCh(11, 26, GEQ_MAXNUMBANDS)
#define writeGEQRbak27Freq(N)    writeGEQFreqCh(11, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak27Freq       wroteGEQFreqCh(11, 26, GEQ_MAXNUMBANDS)
#define  readGEQRbak27Level       readGEQLevelCh(11, 26, GEQ_MAXNUMBANDS)
#define writeGEQRbak27Level(N)   writeGEQLevelCh(11, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak27Level      wroteGEQLevelCh(11, 26, GEQ_MAXNUMBANDS)
#define  readGEQRbak27Width       readGEQWidthCh(11, 26, GEQ_MAXNUMBANDS)
#define writeGEQRbak27Width(N)   writeGEQWidthCh(11, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak27Width      wroteGEQWidthCh(11, 26, GEQ_MAXNUMBANDS)

#define  readGEQRbak28Freq        readGEQFreqCh(11, 27, GEQ_MAXNUMBANDS)
#define writeGEQRbak28Freq(N)    writeGEQFreqCh(11, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak28Freq       wroteGEQFreqCh(11, 27, GEQ_MAXNUMBANDS)
#define  readGEQRbak28Level       readGEQLevelCh(11, 27, GEQ_MAXNUMBANDS)
#define writeGEQRbak28Level(N)   writeGEQLevelCh(11, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak28Level      wroteGEQLevelCh(11, 27, GEQ_MAXNUMBANDS)
#define  readGEQRbak28Width       readGEQWidthCh(11, 27, GEQ_MAXNUMBANDS)
#define writeGEQRbak28Width(N)   writeGEQWidthCh(11, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak28Width      wroteGEQWidthCh(11, 27, GEQ_MAXNUMBANDS)

#define  readGEQRbak29Freq        readGEQFreqCh(11, 28, GEQ_MAXNUMBANDS)
#define writeGEQRbak29Freq(N)    writeGEQFreqCh(11, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak29Freq       wroteGEQFreqCh(11, 28, GEQ_MAXNUMBANDS)
#define  readGEQRbak29Level       readGEQLevelCh(11, 28, GEQ_MAXNUMBANDS)
#define writeGEQRbak29Level(N)   writeGEQLevelCh(11, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak29Level      wroteGEQLevelCh(11, 28, GEQ_MAXNUMBANDS)
#define  readGEQRbak29Width       readGEQWidthCh(11, 28, GEQ_MAXNUMBANDS)
#define writeGEQRbak29Width(N)   writeGEQWidthCh(11, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak29Width      wroteGEQWidthCh(11, 28, GEQ_MAXNUMBANDS)

#define  readGEQRbak30Freq        readGEQFreqCh(11, 29, GEQ_MAXNUMBANDS)
#define writeGEQRbak30Freq(N)    writeGEQFreqCh(11, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak30Freq       wroteGEQFreqCh(11, 29, GEQ_MAXNUMBANDS)
#define  readGEQRbak30Level       readGEQLevelCh(11, 29, GEQ_MAXNUMBANDS)
#define writeGEQRbak30Level(N)   writeGEQLevelCh(11, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak30Level      wroteGEQLevelCh(11, 29, GEQ_MAXNUMBANDS)
#define  readGEQRbak30Width       readGEQWidthCh(11, 29, GEQ_MAXNUMBANDS)
#define writeGEQRbak30Width(N)   writeGEQWidthCh(11, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak30Width      wroteGEQWidthCh(11, 29, GEQ_MAXNUMBANDS)

#define  readGEQRbak31Freq        readGEQFreqCh(11, 30, GEQ_MAXNUMBANDS)
#define writeGEQRbak31Freq(N)    writeGEQFreqCh(11, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak31Freq       wroteGEQFreqCh(11, 30, GEQ_MAXNUMBANDS)
#define  readGEQRbak31Level       readGEQLevelCh(11, 30, GEQ_MAXNUMBANDS)
#define writeGEQRbak31Level(N)   writeGEQLevelCh(11, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak31Level      wroteGEQLevelCh(11, 30, GEQ_MAXNUMBANDS)
#define  readGEQRbak31Width       readGEQWidthCh(11, 30, GEQ_MAXNUMBANDS)
#define writeGEQRbak31Width(N)   writeGEQWidthCh(11, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak31Width      wroteGEQWidthCh(11, 30, GEQ_MAXNUMBANDS)

#define  readGEQRbak32Freq        readGEQFreqCh(11, 31, GEQ_MAXNUMBANDS)
#define writeGEQRbak32Freq(N)    writeGEQFreqCh(11, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak32Freq       wroteGEQFreqCh(11, 31, GEQ_MAXNUMBANDS)
#define  readGEQRbak32Level       readGEQLevelCh(11, 31, GEQ_MAXNUMBANDS)
#define writeGEQRbak32Level(N)   writeGEQLevelCh(11, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak32Level      wroteGEQLevelCh(11, 31, GEQ_MAXNUMBANDS)
#define  readGEQRbak32Width       readGEQWidthCh(11, 31, GEQ_MAXNUMBANDS)
#define writeGEQRbak32Width(N)   writeGEQWidthCh(11, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRbak32Width      wroteGEQWidthCh(11, 31, GEQ_MAXNUMBANDS)

#define  readGEQSubw1Freq        readGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQSubw1Freq(N)    writeGEQFreqCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw1Freq       wroteGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQSubw1Level       readGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQSubw1Level(N)   writeGEQLevelCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw1Level      wroteGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQSubw1Width       readGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQSubw1Width(N)   writeGEQWidthCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw1Width      wroteGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)

#define  readGEQSubw2Freq        readGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQSubw2Freq(N)    writeGEQFreqCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw2Freq       wroteGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQSubw2Level       readGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQSubw2Level(N)   writeGEQLevelCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw2Level      wroteGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQSubw2Width       readGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQSubw2Width(N)   writeGEQWidthCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw2Width      wroteGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)

#define  readGEQSubw3Freq        readGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQSubw3Freq(N)    writeGEQFreqCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw3Freq       wroteGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQSubw3Level       readGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQSubw3Level(N)   writeGEQLevelCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw3Level      wroteGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQSubw3Width       readGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQSubw3Width(N)   writeGEQWidthCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw3Width      wroteGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)

#define  readGEQSubw4Freq        readGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQSubw4Freq(N)    writeGEQFreqCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw4Freq       wroteGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQSubw4Level       readGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQSubw4Level(N)   writeGEQLevelCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw4Level      wroteGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQSubw4Width       readGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQSubw4Width(N)   writeGEQWidthCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw4Width      wroteGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)

#define  readGEQSubw5Freq        readGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQSubw5Freq(N)    writeGEQFreqCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw5Freq       wroteGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQSubw5Level       readGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQSubw5Level(N)   writeGEQLevelCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw5Level      wroteGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQSubw5Width       readGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQSubw5Width(N)   writeGEQWidthCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw5Width      wroteGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)

#define  readGEQSubw6Freq        readGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQSubw6Freq(N)    writeGEQFreqCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw6Freq       wroteGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQSubw6Level       readGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQSubw6Level(N)   writeGEQLevelCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw6Level      wroteGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQSubw6Width       readGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQSubw6Width(N)   writeGEQWidthCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw6Width      wroteGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)

#define  readGEQSubw7Freq        readGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQSubw7Freq(N)    writeGEQFreqCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw7Freq       wroteGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQSubw7Level       readGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQSubw7Level(N)   writeGEQLevelCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw7Level      wroteGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQSubw7Width       readGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQSubw7Width(N)   writeGEQWidthCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw7Width      wroteGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)

#define  readGEQSubw8Freq        readGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQSubw8Freq(N)    writeGEQFreqCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw8Freq       wroteGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQSubw8Level       readGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQSubw8Level(N)   writeGEQLevelCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw8Level      wroteGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQSubw8Width       readGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQSubw8Width(N)   writeGEQWidthCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw8Width      wroteGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)

#define  readGEQSubw9Freq        readGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQSubw9Freq(N)    writeGEQFreqCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw9Freq       wroteGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQSubw9Level       readGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQSubw9Level(N)   writeGEQLevelCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw9Level      wroteGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQSubw9Width       readGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQSubw9Width(N)   writeGEQWidthCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw9Width      wroteGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)

#define  readGEQSubw10Freq        readGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQSubw10Freq(N)    writeGEQFreqCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw10Freq       wroteGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQSubw10Level       readGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQSubw10Level(N)   writeGEQLevelCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw10Level      wroteGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQSubw10Width       readGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQSubw10Width(N)   writeGEQWidthCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw10Width      wroteGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)

#define  readGEQSubw11Freq        readGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQSubw11Freq(N)    writeGEQFreqCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw11Freq       wroteGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQSubw11Level       readGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQSubw11Level(N)   writeGEQLevelCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw11Level      wroteGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQSubw11Width       readGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQSubw11Width(N)   writeGEQWidthCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw11Width      wroteGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)

#define  readGEQSubw12Freq        readGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQSubw12Freq(N)    writeGEQFreqCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw12Freq       wroteGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQSubw12Level       readGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQSubw12Level(N)   writeGEQLevelCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw12Level      wroteGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQSubw12Width       readGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQSubw12Width(N)   writeGEQWidthCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw12Width      wroteGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)

#define  readGEQSubw13Freq        readGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQSubw13Freq(N)    writeGEQFreqCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw13Freq       wroteGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQSubw13Level       readGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQSubw13Level(N)   writeGEQLevelCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw13Level      wroteGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQSubw13Width       readGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQSubw13Width(N)   writeGEQWidthCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw13Width      wroteGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)

#define  readGEQSubw14Freq        readGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQSubw14Freq(N)    writeGEQFreqCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw14Freq       wroteGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQSubw14Level       readGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQSubw14Level(N)   writeGEQLevelCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw14Level      wroteGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQSubw14Width       readGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQSubw14Width(N)   writeGEQWidthCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw14Width      wroteGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)

#define  readGEQSubw15Freq        readGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQSubw15Freq(N)    writeGEQFreqCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw15Freq       wroteGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQSubw15Level       readGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQSubw15Level(N)   writeGEQLevelCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw15Level      wroteGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQSubw15Width       readGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQSubw15Width(N)   writeGEQWidthCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw15Width      wroteGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)

#define  readGEQSubw16Freq        readGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQSubw16Freq(N)    writeGEQFreqCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw16Freq       wroteGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQSubw16Level       readGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQSubw16Level(N)   writeGEQLevelCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw16Level      wroteGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQSubw16Width       readGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQSubw16Width(N)   writeGEQWidthCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw16Width      wroteGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)

#define  readGEQSubw17Freq        readGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQSubw17Freq(N)    writeGEQFreqCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw17Freq       wroteGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQSubw17Level       readGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQSubw17Level(N)   writeGEQLevelCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw17Level      wroteGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQSubw17Width       readGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQSubw17Width(N)   writeGEQWidthCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw17Width      wroteGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)

#define  readGEQSubw18Freq        readGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQSubw18Freq(N)    writeGEQFreqCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw18Freq       wroteGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQSubw18Level       readGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQSubw18Level(N)   writeGEQLevelCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw18Level      wroteGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQSubw18Width       readGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQSubw18Width(N)   writeGEQWidthCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw18Width      wroteGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)

#define  readGEQSubw19Freq        readGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQSubw19Freq(N)    writeGEQFreqCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw19Freq       wroteGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQSubw19Level       readGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQSubw19Level(N)   writeGEQLevelCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw19Level      wroteGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQSubw19Width       readGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQSubw19Width(N)   writeGEQWidthCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw19Width      wroteGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)

#define  readGEQSubw20Freq        readGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQSubw20Freq(N)    writeGEQFreqCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw20Freq       wroteGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQSubw20Level       readGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQSubw20Level(N)   writeGEQLevelCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw20Level      wroteGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQSubw20Width       readGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQSubw20Width(N)   writeGEQWidthCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw20Width      wroteGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)

#define  readGEQSubw21Freq        readGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQSubw21Freq(N)    writeGEQFreqCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw21Freq       wroteGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQSubw21Level       readGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQSubw21Level(N)   writeGEQLevelCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw21Level      wroteGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQSubw21Width       readGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQSubw21Width(N)   writeGEQWidthCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw21Width      wroteGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)

#define  readGEQSubw22Freq        readGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQSubw22Freq(N)    writeGEQFreqCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw22Freq       wroteGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQSubw22Level       readGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQSubw22Level(N)   writeGEQLevelCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw22Level      wroteGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQSubw22Width       readGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQSubw22Width(N)   writeGEQWidthCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw22Width      wroteGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)

#define  readGEQSubw23Freq        readGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQSubw23Freq(N)    writeGEQFreqCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw23Freq       wroteGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQSubw23Level       readGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQSubw23Level(N)   writeGEQLevelCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw23Level      wroteGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQSubw23Width       readGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQSubw23Width(N)   writeGEQWidthCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw23Width      wroteGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)

#define  readGEQSubw24Freq        readGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQSubw24Freq(N)    writeGEQFreqCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw24Freq       wroteGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQSubw24Level       readGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQSubw24Level(N)   writeGEQLevelCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw24Level      wroteGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQSubw24Width       readGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQSubw24Width(N)   writeGEQWidthCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw24Width      wroteGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)

#define  readGEQSubw25Freq        readGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQSubw25Freq(N)    writeGEQFreqCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw25Freq       wroteGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQSubw25Level       readGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQSubw25Level(N)   writeGEQLevelCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw25Level      wroteGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQSubw25Width       readGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQSubw25Width(N)   writeGEQWidthCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw25Width      wroteGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)

#define  readGEQSubw26Freq        readGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQSubw26Freq(N)    writeGEQFreqCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw26Freq       wroteGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQSubw26Level       readGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQSubw26Level(N)   writeGEQLevelCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw26Level      wroteGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQSubw26Width       readGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQSubw26Width(N)   writeGEQWidthCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw26Width      wroteGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)

#define  readGEQSubw27Freq        readGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQSubw27Freq(N)    writeGEQFreqCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw27Freq       wroteGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQSubw27Level       readGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQSubw27Level(N)   writeGEQLevelCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw27Level      wroteGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQSubw27Width       readGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQSubw27Width(N)   writeGEQWidthCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw27Width      wroteGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)

#define  readGEQSubw28Freq        readGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQSubw28Freq(N)    writeGEQFreqCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw28Freq       wroteGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQSubw28Level       readGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQSubw28Level(N)   writeGEQLevelCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw28Level      wroteGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQSubw28Width       readGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQSubw28Width(N)   writeGEQWidthCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw28Width      wroteGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)

#define  readGEQSubw29Freq        readGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQSubw29Freq(N)    writeGEQFreqCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw29Freq       wroteGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQSubw29Level       readGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQSubw29Level(N)   writeGEQLevelCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw29Level      wroteGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQSubw29Width       readGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQSubw29Width(N)   writeGEQWidthCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw29Width      wroteGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)

#define  readGEQSubw30Freq        readGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQSubw30Freq(N)    writeGEQFreqCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw30Freq       wroteGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQSubw30Level       readGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQSubw30Level(N)   writeGEQLevelCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw30Level      wroteGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQSubw30Width       readGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQSubw30Width(N)   writeGEQWidthCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw30Width      wroteGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)

#define  readGEQSubw31Freq        readGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQSubw31Freq(N)    writeGEQFreqCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw31Freq       wroteGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQSubw31Level       readGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQSubw31Level(N)   writeGEQLevelCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw31Level      wroteGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQSubw31Width       readGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQSubw31Width(N)   writeGEQWidthCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw31Width      wroteGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)

#define  readGEQSubw32Freq        readGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQSubw32Freq(N)    writeGEQFreqCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw32Freq       wroteGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQSubw32Level       readGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQSubw32Level(N)   writeGEQLevelCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw32Level      wroteGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQSubw32Width       readGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQSubw32Width(N)   writeGEQWidthCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQSubw32Width      wroteGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)

#define  readGEQLsub1Freq        readGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQLsub1Freq(N)    writeGEQFreqCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub1Freq       wroteGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQLsub1Level       readGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQLsub1Level(N)   writeGEQLevelCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub1Level      wroteGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQLsub1Width       readGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQLsub1Width(N)   writeGEQWidthCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub1Width      wroteGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)

#define  readGEQLsub2Freq        readGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQLsub2Freq(N)    writeGEQFreqCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub2Freq       wroteGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQLsub2Level       readGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQLsub2Level(N)   writeGEQLevelCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub2Level      wroteGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQLsub2Width       readGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQLsub2Width(N)   writeGEQWidthCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub2Width      wroteGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)

#define  readGEQLsub3Freq        readGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQLsub3Freq(N)    writeGEQFreqCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub3Freq       wroteGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQLsub3Level       readGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQLsub3Level(N)   writeGEQLevelCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub3Level      wroteGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQLsub3Width       readGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQLsub3Width(N)   writeGEQWidthCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub3Width      wroteGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)

#define  readGEQLsub4Freq        readGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQLsub4Freq(N)    writeGEQFreqCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub4Freq       wroteGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQLsub4Level       readGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQLsub4Level(N)   writeGEQLevelCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub4Level      wroteGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQLsub4Width       readGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQLsub4Width(N)   writeGEQWidthCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub4Width      wroteGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)

#define  readGEQLsub5Freq        readGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQLsub5Freq(N)    writeGEQFreqCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub5Freq       wroteGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQLsub5Level       readGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQLsub5Level(N)   writeGEQLevelCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub5Level      wroteGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQLsub5Width       readGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQLsub5Width(N)   writeGEQWidthCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub5Width      wroteGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)

#define  readGEQLsub6Freq        readGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQLsub6Freq(N)    writeGEQFreqCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub6Freq       wroteGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQLsub6Level       readGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQLsub6Level(N)   writeGEQLevelCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub6Level      wroteGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQLsub6Width       readGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQLsub6Width(N)   writeGEQWidthCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub6Width      wroteGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)

#define  readGEQLsub7Freq        readGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQLsub7Freq(N)    writeGEQFreqCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub7Freq       wroteGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQLsub7Level       readGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQLsub7Level(N)   writeGEQLevelCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub7Level      wroteGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQLsub7Width       readGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQLsub7Width(N)   writeGEQWidthCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub7Width      wroteGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)

#define  readGEQLsub8Freq        readGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQLsub8Freq(N)    writeGEQFreqCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub8Freq       wroteGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQLsub8Level       readGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQLsub8Level(N)   writeGEQLevelCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub8Level      wroteGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQLsub8Width       readGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQLsub8Width(N)   writeGEQWidthCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub8Width      wroteGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)

#define  readGEQLsub9Freq        readGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQLsub9Freq(N)    writeGEQFreqCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub9Freq       wroteGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQLsub9Level       readGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQLsub9Level(N)   writeGEQLevelCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub9Level      wroteGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQLsub9Width       readGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQLsub9Width(N)   writeGEQWidthCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub9Width      wroteGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)

#define  readGEQLsub10Freq        readGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQLsub10Freq(N)    writeGEQFreqCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub10Freq       wroteGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQLsub10Level       readGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQLsub10Level(N)   writeGEQLevelCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub10Level      wroteGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQLsub10Width       readGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQLsub10Width(N)   writeGEQWidthCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub10Width      wroteGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)

#define  readGEQLsub11Freq        readGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQLsub11Freq(N)    writeGEQFreqCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub11Freq       wroteGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQLsub11Level       readGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQLsub11Level(N)   writeGEQLevelCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub11Level      wroteGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQLsub11Width       readGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQLsub11Width(N)   writeGEQWidthCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub11Width      wroteGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)

#define  readGEQLsub12Freq        readGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQLsub12Freq(N)    writeGEQFreqCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub12Freq       wroteGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQLsub12Level       readGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQLsub12Level(N)   writeGEQLevelCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub12Level      wroteGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQLsub12Width       readGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQLsub12Width(N)   writeGEQWidthCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub12Width      wroteGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)

#define  readGEQLsub13Freq        readGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQLsub13Freq(N)    writeGEQFreqCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub13Freq       wroteGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQLsub13Level       readGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQLsub13Level(N)   writeGEQLevelCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub13Level      wroteGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQLsub13Width       readGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQLsub13Width(N)   writeGEQWidthCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub13Width      wroteGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)

#define  readGEQLsub14Freq        readGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQLsub14Freq(N)    writeGEQFreqCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub14Freq       wroteGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQLsub14Level       readGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQLsub14Level(N)   writeGEQLevelCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub14Level      wroteGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQLsub14Width       readGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQLsub14Width(N)   writeGEQWidthCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub14Width      wroteGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)

#define  readGEQLsub15Freq        readGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQLsub15Freq(N)    writeGEQFreqCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub15Freq       wroteGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQLsub15Level       readGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQLsub15Level(N)   writeGEQLevelCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub15Level      wroteGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQLsub15Width       readGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQLsub15Width(N)   writeGEQWidthCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub15Width      wroteGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)

#define  readGEQLsub16Freq        readGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQLsub16Freq(N)    writeGEQFreqCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub16Freq       wroteGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQLsub16Level       readGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQLsub16Level(N)   writeGEQLevelCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub16Level      wroteGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQLsub16Width       readGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQLsub16Width(N)   writeGEQWidthCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub16Width      wroteGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)

#define  readGEQLsub17Freq        readGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQLsub17Freq(N)    writeGEQFreqCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub17Freq       wroteGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQLsub17Level       readGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQLsub17Level(N)   writeGEQLevelCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub17Level      wroteGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQLsub17Width       readGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQLsub17Width(N)   writeGEQWidthCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub17Width      wroteGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)

#define  readGEQLsub18Freq        readGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQLsub18Freq(N)    writeGEQFreqCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub18Freq       wroteGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQLsub18Level       readGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQLsub18Level(N)   writeGEQLevelCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub18Level      wroteGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQLsub18Width       readGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQLsub18Width(N)   writeGEQWidthCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub18Width      wroteGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)

#define  readGEQLsub19Freq        readGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQLsub19Freq(N)    writeGEQFreqCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub19Freq       wroteGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQLsub19Level       readGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQLsub19Level(N)   writeGEQLevelCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub19Level      wroteGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQLsub19Width       readGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQLsub19Width(N)   writeGEQWidthCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub19Width      wroteGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)

#define  readGEQLsub20Freq        readGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQLsub20Freq(N)    writeGEQFreqCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub20Freq       wroteGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQLsub20Level       readGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQLsub20Level(N)   writeGEQLevelCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub20Level      wroteGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQLsub20Width       readGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQLsub20Width(N)   writeGEQWidthCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub20Width      wroteGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)

#define  readGEQLsub21Freq        readGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQLsub21Freq(N)    writeGEQFreqCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub21Freq       wroteGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQLsub21Level       readGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQLsub21Level(N)   writeGEQLevelCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub21Level      wroteGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQLsub21Width       readGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQLsub21Width(N)   writeGEQWidthCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub21Width      wroteGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)

#define  readGEQLsub22Freq        readGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQLsub22Freq(N)    writeGEQFreqCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub22Freq       wroteGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQLsub22Level       readGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQLsub22Level(N)   writeGEQLevelCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub22Level      wroteGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQLsub22Width       readGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQLsub22Width(N)   writeGEQWidthCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub22Width      wroteGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)

#define  readGEQLsub23Freq        readGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQLsub23Freq(N)    writeGEQFreqCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub23Freq       wroteGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQLsub23Level       readGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQLsub23Level(N)   writeGEQLevelCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub23Level      wroteGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQLsub23Width       readGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQLsub23Width(N)   writeGEQWidthCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub23Width      wroteGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)

#define  readGEQLsub24Freq        readGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQLsub24Freq(N)    writeGEQFreqCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub24Freq       wroteGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQLsub24Level       readGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQLsub24Level(N)   writeGEQLevelCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub24Level      wroteGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQLsub24Width       readGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQLsub24Width(N)   writeGEQWidthCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub24Width      wroteGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)

#define  readGEQLsub25Freq        readGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQLsub25Freq(N)    writeGEQFreqCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub25Freq       wroteGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQLsub25Level       readGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQLsub25Level(N)   writeGEQLevelCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub25Level      wroteGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQLsub25Width       readGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQLsub25Width(N)   writeGEQWidthCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub25Width      wroteGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)

#define  readGEQLsub26Freq        readGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQLsub26Freq(N)    writeGEQFreqCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub26Freq       wroteGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQLsub26Level       readGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQLsub26Level(N)   writeGEQLevelCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub26Level      wroteGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQLsub26Width       readGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQLsub26Width(N)   writeGEQWidthCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub26Width      wroteGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)

#define  readGEQLsub27Freq        readGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQLsub27Freq(N)    writeGEQFreqCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub27Freq       wroteGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQLsub27Level       readGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQLsub27Level(N)   writeGEQLevelCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub27Level      wroteGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQLsub27Width       readGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQLsub27Width(N)   writeGEQWidthCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub27Width      wroteGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)

#define  readGEQLsub28Freq        readGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQLsub28Freq(N)    writeGEQFreqCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub28Freq       wroteGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQLsub28Level       readGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQLsub28Level(N)   writeGEQLevelCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub28Level      wroteGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQLsub28Width       readGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQLsub28Width(N)   writeGEQWidthCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub28Width      wroteGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)

#define  readGEQLsub29Freq        readGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQLsub29Freq(N)    writeGEQFreqCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub29Freq       wroteGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQLsub29Level       readGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQLsub29Level(N)   writeGEQLevelCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub29Level      wroteGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQLsub29Width       readGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQLsub29Width(N)   writeGEQWidthCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub29Width      wroteGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)

#define  readGEQLsub30Freq        readGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQLsub30Freq(N)    writeGEQFreqCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub30Freq       wroteGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQLsub30Level       readGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQLsub30Level(N)   writeGEQLevelCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub30Level      wroteGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQLsub30Width       readGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQLsub30Width(N)   writeGEQWidthCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub30Width      wroteGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)

#define  readGEQLsub31Freq        readGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQLsub31Freq(N)    writeGEQFreqCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub31Freq       wroteGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQLsub31Level       readGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQLsub31Level(N)   writeGEQLevelCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub31Level      wroteGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQLsub31Width       readGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQLsub31Width(N)   writeGEQWidthCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub31Width      wroteGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)

#define  readGEQLsub32Freq        readGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQLsub32Freq(N)    writeGEQFreqCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub32Freq       wroteGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQLsub32Level       readGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQLsub32Level(N)   writeGEQLevelCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub32Level      wroteGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQLsub32Width       readGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQLsub32Width(N)   writeGEQWidthCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLsub32Width      wroteGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)

#define  readGEQRsub1Freq        readGEQFreqCh(13, 0, GEQ_MAXNUMBANDS)
#define writeGEQRsub1Freq(N)    writeGEQFreqCh(13, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub1Freq       wroteGEQFreqCh(13, 0, GEQ_MAXNUMBANDS)
#define  readGEQRsub1Level       readGEQLevelCh(13, 0, GEQ_MAXNUMBANDS)
#define writeGEQRsub1Level(N)   writeGEQLevelCh(13, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub1Level      wroteGEQLevelCh(13, 0, GEQ_MAXNUMBANDS)
#define  readGEQRsub1Width       readGEQWidthCh(13, 0, GEQ_MAXNUMBANDS)
#define writeGEQRsub1Width(N)   writeGEQWidthCh(13, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub1Width      wroteGEQWidthCh(13, 0, GEQ_MAXNUMBANDS)

#define  readGEQRsub2Freq        readGEQFreqCh(13, 1, GEQ_MAXNUMBANDS)
#define writeGEQRsub2Freq(N)    writeGEQFreqCh(13, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub2Freq       wroteGEQFreqCh(13, 1, GEQ_MAXNUMBANDS)
#define  readGEQRsub2Level       readGEQLevelCh(13, 1, GEQ_MAXNUMBANDS)
#define writeGEQRsub2Level(N)   writeGEQLevelCh(13, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub2Level      wroteGEQLevelCh(13, 1, GEQ_MAXNUMBANDS)
#define  readGEQRsub2Width       readGEQWidthCh(13, 1, GEQ_MAXNUMBANDS)
#define writeGEQRsub2Width(N)   writeGEQWidthCh(13, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub2Width      wroteGEQWidthCh(13, 1, GEQ_MAXNUMBANDS)

#define  readGEQRsub3Freq        readGEQFreqCh(13, 2, GEQ_MAXNUMBANDS)
#define writeGEQRsub3Freq(N)    writeGEQFreqCh(13, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub3Freq       wroteGEQFreqCh(13, 2, GEQ_MAXNUMBANDS)
#define  readGEQRsub3Level       readGEQLevelCh(13, 2, GEQ_MAXNUMBANDS)
#define writeGEQRsub3Level(N)   writeGEQLevelCh(13, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub3Level      wroteGEQLevelCh(13, 2, GEQ_MAXNUMBANDS)
#define  readGEQRsub3Width       readGEQWidthCh(13, 2, GEQ_MAXNUMBANDS)
#define writeGEQRsub3Width(N)   writeGEQWidthCh(13, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub3Width      wroteGEQWidthCh(13, 2, GEQ_MAXNUMBANDS)

#define  readGEQRsub4Freq        readGEQFreqCh(13, 3, GEQ_MAXNUMBANDS)
#define writeGEQRsub4Freq(N)    writeGEQFreqCh(13, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub4Freq       wroteGEQFreqCh(13, 3, GEQ_MAXNUMBANDS)
#define  readGEQRsub4Level       readGEQLevelCh(13, 3, GEQ_MAXNUMBANDS)
#define writeGEQRsub4Level(N)   writeGEQLevelCh(13, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub4Level      wroteGEQLevelCh(13, 3, GEQ_MAXNUMBANDS)
#define  readGEQRsub4Width       readGEQWidthCh(13, 3, GEQ_MAXNUMBANDS)
#define writeGEQRsub4Width(N)   writeGEQWidthCh(13, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub4Width      wroteGEQWidthCh(13, 3, GEQ_MAXNUMBANDS)

#define  readGEQRsub5Freq        readGEQFreqCh(13, 4, GEQ_MAXNUMBANDS)
#define writeGEQRsub5Freq(N)    writeGEQFreqCh(13, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub5Freq       wroteGEQFreqCh(13, 4, GEQ_MAXNUMBANDS)
#define  readGEQRsub5Level       readGEQLevelCh(13, 4, GEQ_MAXNUMBANDS)
#define writeGEQRsub5Level(N)   writeGEQLevelCh(13, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub5Level      wroteGEQLevelCh(13, 4, GEQ_MAXNUMBANDS)
#define  readGEQRsub5Width       readGEQWidthCh(13, 4, GEQ_MAXNUMBANDS)
#define writeGEQRsub5Width(N)   writeGEQWidthCh(13, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub5Width      wroteGEQWidthCh(13, 4, GEQ_MAXNUMBANDS)

#define  readGEQRsub6Freq        readGEQFreqCh(13, 5, GEQ_MAXNUMBANDS)
#define writeGEQRsub6Freq(N)    writeGEQFreqCh(13, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub6Freq       wroteGEQFreqCh(13, 5, GEQ_MAXNUMBANDS)
#define  readGEQRsub6Level       readGEQLevelCh(13, 5, GEQ_MAXNUMBANDS)
#define writeGEQRsub6Level(N)   writeGEQLevelCh(13, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub6Level      wroteGEQLevelCh(13, 5, GEQ_MAXNUMBANDS)
#define  readGEQRsub6Width       readGEQWidthCh(13, 5, GEQ_MAXNUMBANDS)
#define writeGEQRsub6Width(N)   writeGEQWidthCh(13, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub6Width      wroteGEQWidthCh(13, 5, GEQ_MAXNUMBANDS)

#define  readGEQRsub7Freq        readGEQFreqCh(13, 6, GEQ_MAXNUMBANDS)
#define writeGEQRsub7Freq(N)    writeGEQFreqCh(13, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub7Freq       wroteGEQFreqCh(13, 6, GEQ_MAXNUMBANDS)
#define  readGEQRsub7Level       readGEQLevelCh(13, 6, GEQ_MAXNUMBANDS)
#define writeGEQRsub7Level(N)   writeGEQLevelCh(13, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub7Level      wroteGEQLevelCh(13, 6, GEQ_MAXNUMBANDS)
#define  readGEQRsub7Width       readGEQWidthCh(13, 6, GEQ_MAXNUMBANDS)
#define writeGEQRsub7Width(N)   writeGEQWidthCh(13, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub7Width      wroteGEQWidthCh(13, 6, GEQ_MAXNUMBANDS)

#define  readGEQRsub8Freq        readGEQFreqCh(13, 7, GEQ_MAXNUMBANDS)
#define writeGEQRsub8Freq(N)    writeGEQFreqCh(13, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub8Freq       wroteGEQFreqCh(13, 7, GEQ_MAXNUMBANDS)
#define  readGEQRsub8Level       readGEQLevelCh(13, 7, GEQ_MAXNUMBANDS)
#define writeGEQRsub8Level(N)   writeGEQLevelCh(13, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub8Level      wroteGEQLevelCh(13, 7, GEQ_MAXNUMBANDS)
#define  readGEQRsub8Width       readGEQWidthCh(13, 7, GEQ_MAXNUMBANDS)
#define writeGEQRsub8Width(N)   writeGEQWidthCh(13, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub8Width      wroteGEQWidthCh(13, 7, GEQ_MAXNUMBANDS)

#define  readGEQRsub9Freq        readGEQFreqCh(13, 8, GEQ_MAXNUMBANDS)
#define writeGEQRsub9Freq(N)    writeGEQFreqCh(13, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub9Freq       wroteGEQFreqCh(13, 8, GEQ_MAXNUMBANDS)
#define  readGEQRsub9Level       readGEQLevelCh(13, 8, GEQ_MAXNUMBANDS)
#define writeGEQRsub9Level(N)   writeGEQLevelCh(13, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub9Level      wroteGEQLevelCh(13, 8, GEQ_MAXNUMBANDS)
#define  readGEQRsub9Width       readGEQWidthCh(13, 8, GEQ_MAXNUMBANDS)
#define writeGEQRsub9Width(N)   writeGEQWidthCh(13, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub9Width      wroteGEQWidthCh(13, 8, GEQ_MAXNUMBANDS)

#define  readGEQRsub10Freq        readGEQFreqCh(13, 9, GEQ_MAXNUMBANDS)
#define writeGEQRsub10Freq(N)    writeGEQFreqCh(13, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub10Freq       wroteGEQFreqCh(13, 9, GEQ_MAXNUMBANDS)
#define  readGEQRsub10Level       readGEQLevelCh(13, 9, GEQ_MAXNUMBANDS)
#define writeGEQRsub10Level(N)   writeGEQLevelCh(13, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub10Level      wroteGEQLevelCh(13, 9, GEQ_MAXNUMBANDS)
#define  readGEQRsub10Width       readGEQWidthCh(13, 9, GEQ_MAXNUMBANDS)
#define writeGEQRsub10Width(N)   writeGEQWidthCh(13, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub10Width      wroteGEQWidthCh(13, 9, GEQ_MAXNUMBANDS)

#define  readGEQRsub11Freq        readGEQFreqCh(13, 10, GEQ_MAXNUMBANDS)
#define writeGEQRsub11Freq(N)    writeGEQFreqCh(13, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub11Freq       wroteGEQFreqCh(13, 10, GEQ_MAXNUMBANDS)
#define  readGEQRsub11Level       readGEQLevelCh(13, 10, GEQ_MAXNUMBANDS)
#define writeGEQRsub11Level(N)   writeGEQLevelCh(13, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub11Level      wroteGEQLevelCh(13, 10, GEQ_MAXNUMBANDS)
#define  readGEQRsub11Width       readGEQWidthCh(13, 10, GEQ_MAXNUMBANDS)
#define writeGEQRsub11Width(N)   writeGEQWidthCh(13, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub11Width      wroteGEQWidthCh(13, 10, GEQ_MAXNUMBANDS)

#define  readGEQRsub12Freq        readGEQFreqCh(13, 11, GEQ_MAXNUMBANDS)
#define writeGEQRsub12Freq(N)    writeGEQFreqCh(13, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub12Freq       wroteGEQFreqCh(13, 11, GEQ_MAXNUMBANDS)
#define  readGEQRsub12Level       readGEQLevelCh(13, 11, GEQ_MAXNUMBANDS)
#define writeGEQRsub12Level(N)   writeGEQLevelCh(13, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub12Level      wroteGEQLevelCh(13, 11, GEQ_MAXNUMBANDS)
#define  readGEQRsub12Width       readGEQWidthCh(13, 11, GEQ_MAXNUMBANDS)
#define writeGEQRsub12Width(N)   writeGEQWidthCh(13, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub12Width      wroteGEQWidthCh(13, 11, GEQ_MAXNUMBANDS)

#define  readGEQRsub13Freq        readGEQFreqCh(13, 12, GEQ_MAXNUMBANDS)
#define writeGEQRsub13Freq(N)    writeGEQFreqCh(13, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub13Freq       wroteGEQFreqCh(13, 12, GEQ_MAXNUMBANDS)
#define  readGEQRsub13Level       readGEQLevelCh(13, 12, GEQ_MAXNUMBANDS)
#define writeGEQRsub13Level(N)   writeGEQLevelCh(13, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub13Level      wroteGEQLevelCh(13, 12, GEQ_MAXNUMBANDS)
#define  readGEQRsub13Width       readGEQWidthCh(13, 12, GEQ_MAXNUMBANDS)
#define writeGEQRsub13Width(N)   writeGEQWidthCh(13, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub13Width      wroteGEQWidthCh(13, 12, GEQ_MAXNUMBANDS)

#define  readGEQRsub14Freq        readGEQFreqCh(13, 13, GEQ_MAXNUMBANDS)
#define writeGEQRsub14Freq(N)    writeGEQFreqCh(13, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub14Freq       wroteGEQFreqCh(13, 13, GEQ_MAXNUMBANDS)
#define  readGEQRsub14Level       readGEQLevelCh(13, 13, GEQ_MAXNUMBANDS)
#define writeGEQRsub14Level(N)   writeGEQLevelCh(13, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub14Level      wroteGEQLevelCh(13, 13, GEQ_MAXNUMBANDS)
#define  readGEQRsub14Width       readGEQWidthCh(13, 13, GEQ_MAXNUMBANDS)
#define writeGEQRsub14Width(N)   writeGEQWidthCh(13, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub14Width      wroteGEQWidthCh(13, 13, GEQ_MAXNUMBANDS)

#define  readGEQRsub15Freq        readGEQFreqCh(13, 14, GEQ_MAXNUMBANDS)
#define writeGEQRsub15Freq(N)    writeGEQFreqCh(13, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub15Freq       wroteGEQFreqCh(13, 14, GEQ_MAXNUMBANDS)
#define  readGEQRsub15Level       readGEQLevelCh(13, 14, GEQ_MAXNUMBANDS)
#define writeGEQRsub15Level(N)   writeGEQLevelCh(13, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub15Level      wroteGEQLevelCh(13, 14, GEQ_MAXNUMBANDS)
#define  readGEQRsub15Width       readGEQWidthCh(13, 14, GEQ_MAXNUMBANDS)
#define writeGEQRsub15Width(N)   writeGEQWidthCh(13, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub15Width      wroteGEQWidthCh(13, 14, GEQ_MAXNUMBANDS)

#define  readGEQRsub16Freq        readGEQFreqCh(13, 15, GEQ_MAXNUMBANDS)
#define writeGEQRsub16Freq(N)    writeGEQFreqCh(13, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub16Freq       wroteGEQFreqCh(13, 15, GEQ_MAXNUMBANDS)
#define  readGEQRsub16Level       readGEQLevelCh(13, 15, GEQ_MAXNUMBANDS)
#define writeGEQRsub16Level(N)   writeGEQLevelCh(13, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub16Level      wroteGEQLevelCh(13, 15, GEQ_MAXNUMBANDS)
#define  readGEQRsub16Width       readGEQWidthCh(13, 15, GEQ_MAXNUMBANDS)
#define writeGEQRsub16Width(N)   writeGEQWidthCh(13, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub16Width      wroteGEQWidthCh(13, 15, GEQ_MAXNUMBANDS)

#define  readGEQRsub17Freq        readGEQFreqCh(13, 16, GEQ_MAXNUMBANDS)
#define writeGEQRsub17Freq(N)    writeGEQFreqCh(13, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub17Freq       wroteGEQFreqCh(13, 16, GEQ_MAXNUMBANDS)
#define  readGEQRsub17Level       readGEQLevelCh(13, 16, GEQ_MAXNUMBANDS)
#define writeGEQRsub17Level(N)   writeGEQLevelCh(13, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub17Level      wroteGEQLevelCh(13, 16, GEQ_MAXNUMBANDS)
#define  readGEQRsub17Width       readGEQWidthCh(13, 16, GEQ_MAXNUMBANDS)
#define writeGEQRsub17Width(N)   writeGEQWidthCh(13, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub17Width      wroteGEQWidthCh(13, 16, GEQ_MAXNUMBANDS)

#define  readGEQRsub18Freq        readGEQFreqCh(13, 17, GEQ_MAXNUMBANDS)
#define writeGEQRsub18Freq(N)    writeGEQFreqCh(13, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub18Freq       wroteGEQFreqCh(13, 17, GEQ_MAXNUMBANDS)
#define  readGEQRsub18Level       readGEQLevelCh(13, 17, GEQ_MAXNUMBANDS)
#define writeGEQRsub18Level(N)   writeGEQLevelCh(13, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub18Level      wroteGEQLevelCh(13, 17, GEQ_MAXNUMBANDS)
#define  readGEQRsub18Width       readGEQWidthCh(13, 17, GEQ_MAXNUMBANDS)
#define writeGEQRsub18Width(N)   writeGEQWidthCh(13, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub18Width      wroteGEQWidthCh(13, 17, GEQ_MAXNUMBANDS)

#define  readGEQRsub19Freq        readGEQFreqCh(13, 18, GEQ_MAXNUMBANDS)
#define writeGEQRsub19Freq(N)    writeGEQFreqCh(13, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub19Freq       wroteGEQFreqCh(13, 18, GEQ_MAXNUMBANDS)
#define  readGEQRsub19Level       readGEQLevelCh(13, 18, GEQ_MAXNUMBANDS)
#define writeGEQRsub19Level(N)   writeGEQLevelCh(13, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub19Level      wroteGEQLevelCh(13, 18, GEQ_MAXNUMBANDS)
#define  readGEQRsub19Width       readGEQWidthCh(13, 18, GEQ_MAXNUMBANDS)
#define writeGEQRsub19Width(N)   writeGEQWidthCh(13, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub19Width      wroteGEQWidthCh(13, 18, GEQ_MAXNUMBANDS)

#define  readGEQRsub20Freq        readGEQFreqCh(13, 19, GEQ_MAXNUMBANDS)
#define writeGEQRsub20Freq(N)    writeGEQFreqCh(13, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub20Freq       wroteGEQFreqCh(13, 19, GEQ_MAXNUMBANDS)
#define  readGEQRsub20Level       readGEQLevelCh(13, 19, GEQ_MAXNUMBANDS)
#define writeGEQRsub20Level(N)   writeGEQLevelCh(13, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub20Level      wroteGEQLevelCh(13, 19, GEQ_MAXNUMBANDS)
#define  readGEQRsub20Width       readGEQWidthCh(13, 19, GEQ_MAXNUMBANDS)
#define writeGEQRsub20Width(N)   writeGEQWidthCh(13, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub20Width      wroteGEQWidthCh(13, 19, GEQ_MAXNUMBANDS)

#define  readGEQRsub21Freq        readGEQFreqCh(13, 20, GEQ_MAXNUMBANDS)
#define writeGEQRsub21Freq(N)    writeGEQFreqCh(13, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub21Freq       wroteGEQFreqCh(13, 20, GEQ_MAXNUMBANDS)
#define  readGEQRsub21Level       readGEQLevelCh(13, 20, GEQ_MAXNUMBANDS)
#define writeGEQRsub21Level(N)   writeGEQLevelCh(13, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub21Level      wroteGEQLevelCh(13, 20, GEQ_MAXNUMBANDS)
#define  readGEQRsub21Width       readGEQWidthCh(13, 20, GEQ_MAXNUMBANDS)
#define writeGEQRsub21Width(N)   writeGEQWidthCh(13, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub21Width      wroteGEQWidthCh(13, 20, GEQ_MAXNUMBANDS)

#define  readGEQRsub22Freq        readGEQFreqCh(13, 21, GEQ_MAXNUMBANDS)
#define writeGEQRsub22Freq(N)    writeGEQFreqCh(13, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub22Freq       wroteGEQFreqCh(13, 21, GEQ_MAXNUMBANDS)
#define  readGEQRsub22Level       readGEQLevelCh(13, 21, GEQ_MAXNUMBANDS)
#define writeGEQRsub22Level(N)   writeGEQLevelCh(13, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub22Level      wroteGEQLevelCh(13, 21, GEQ_MAXNUMBANDS)
#define  readGEQRsub22Width       readGEQWidthCh(13, 21, GEQ_MAXNUMBANDS)
#define writeGEQRsub22Width(N)   writeGEQWidthCh(13, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub22Width      wroteGEQWidthCh(13, 21, GEQ_MAXNUMBANDS)

#define  readGEQRsub23Freq        readGEQFreqCh(13, 22, GEQ_MAXNUMBANDS)
#define writeGEQRsub23Freq(N)    writeGEQFreqCh(13, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub23Freq       wroteGEQFreqCh(13, 22, GEQ_MAXNUMBANDS)
#define  readGEQRsub23Level       readGEQLevelCh(13, 22, GEQ_MAXNUMBANDS)
#define writeGEQRsub23Level(N)   writeGEQLevelCh(13, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub23Level      wroteGEQLevelCh(13, 22, GEQ_MAXNUMBANDS)
#define  readGEQRsub23Width       readGEQWidthCh(13, 22, GEQ_MAXNUMBANDS)
#define writeGEQRsub23Width(N)   writeGEQWidthCh(13, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub23Width      wroteGEQWidthCh(13, 22, GEQ_MAXNUMBANDS)

#define  readGEQRsub24Freq        readGEQFreqCh(13, 23, GEQ_MAXNUMBANDS)
#define writeGEQRsub24Freq(N)    writeGEQFreqCh(13, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub24Freq       wroteGEQFreqCh(13, 23, GEQ_MAXNUMBANDS)
#define  readGEQRsub24Level       readGEQLevelCh(13, 23, GEQ_MAXNUMBANDS)
#define writeGEQRsub24Level(N)   writeGEQLevelCh(13, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub24Level      wroteGEQLevelCh(13, 23, GEQ_MAXNUMBANDS)
#define  readGEQRsub24Width       readGEQWidthCh(13, 23, GEQ_MAXNUMBANDS)
#define writeGEQRsub24Width(N)   writeGEQWidthCh(13, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub24Width      wroteGEQWidthCh(13, 23, GEQ_MAXNUMBANDS)

#define  readGEQRsub25Freq        readGEQFreqCh(13, 24, GEQ_MAXNUMBANDS)
#define writeGEQRsub25Freq(N)    writeGEQFreqCh(13, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub25Freq       wroteGEQFreqCh(13, 24, GEQ_MAXNUMBANDS)
#define  readGEQRsub25Level       readGEQLevelCh(13, 24, GEQ_MAXNUMBANDS)
#define writeGEQRsub25Level(N)   writeGEQLevelCh(13, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub25Level      wroteGEQLevelCh(13, 24, GEQ_MAXNUMBANDS)
#define  readGEQRsub25Width       readGEQWidthCh(13, 24, GEQ_MAXNUMBANDS)
#define writeGEQRsub25Width(N)   writeGEQWidthCh(13, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub25Width      wroteGEQWidthCh(13, 24, GEQ_MAXNUMBANDS)

#define  readGEQRsub26Freq        readGEQFreqCh(13, 25, GEQ_MAXNUMBANDS)
#define writeGEQRsub26Freq(N)    writeGEQFreqCh(13, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub26Freq       wroteGEQFreqCh(13, 25, GEQ_MAXNUMBANDS)
#define  readGEQRsub26Level       readGEQLevelCh(13, 25, GEQ_MAXNUMBANDS)
#define writeGEQRsub26Level(N)   writeGEQLevelCh(13, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub26Level      wroteGEQLevelCh(13, 25, GEQ_MAXNUMBANDS)
#define  readGEQRsub26Width       readGEQWidthCh(13, 25, GEQ_MAXNUMBANDS)
#define writeGEQRsub26Width(N)   writeGEQWidthCh(13, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub26Width      wroteGEQWidthCh(13, 25, GEQ_MAXNUMBANDS)

#define  readGEQRsub27Freq        readGEQFreqCh(13, 26, GEQ_MAXNUMBANDS)
#define writeGEQRsub27Freq(N)    writeGEQFreqCh(13, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub27Freq       wroteGEQFreqCh(13, 26, GEQ_MAXNUMBANDS)
#define  readGEQRsub27Level       readGEQLevelCh(13, 26, GEQ_MAXNUMBANDS)
#define writeGEQRsub27Level(N)   writeGEQLevelCh(13, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub27Level      wroteGEQLevelCh(13, 26, GEQ_MAXNUMBANDS)
#define  readGEQRsub27Width       readGEQWidthCh(13, 26, GEQ_MAXNUMBANDS)
#define writeGEQRsub27Width(N)   writeGEQWidthCh(13, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub27Width      wroteGEQWidthCh(13, 26, GEQ_MAXNUMBANDS)

#define  readGEQRsub28Freq        readGEQFreqCh(13, 27, GEQ_MAXNUMBANDS)
#define writeGEQRsub28Freq(N)    writeGEQFreqCh(13, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub28Freq       wroteGEQFreqCh(13, 27, GEQ_MAXNUMBANDS)
#define  readGEQRsub28Level       readGEQLevelCh(13, 27, GEQ_MAXNUMBANDS)
#define writeGEQRsub28Level(N)   writeGEQLevelCh(13, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub28Level      wroteGEQLevelCh(13, 27, GEQ_MAXNUMBANDS)
#define  readGEQRsub28Width       readGEQWidthCh(13, 27, GEQ_MAXNUMBANDS)
#define writeGEQRsub28Width(N)   writeGEQWidthCh(13, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub28Width      wroteGEQWidthCh(13, 27, GEQ_MAXNUMBANDS)

#define  readGEQRsub29Freq        readGEQFreqCh(13, 28, GEQ_MAXNUMBANDS)
#define writeGEQRsub29Freq(N)    writeGEQFreqCh(13, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub29Freq       wroteGEQFreqCh(13, 28, GEQ_MAXNUMBANDS)
#define  readGEQRsub29Level       readGEQLevelCh(13, 28, GEQ_MAXNUMBANDS)
#define writeGEQRsub29Level(N)   writeGEQLevelCh(13, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub29Level      wroteGEQLevelCh(13, 28, GEQ_MAXNUMBANDS)
#define  readGEQRsub29Width       readGEQWidthCh(13, 28, GEQ_MAXNUMBANDS)
#define writeGEQRsub29Width(N)   writeGEQWidthCh(13, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub29Width      wroteGEQWidthCh(13, 28, GEQ_MAXNUMBANDS)

#define  readGEQRsub30Freq        readGEQFreqCh(13, 29, GEQ_MAXNUMBANDS)
#define writeGEQRsub30Freq(N)    writeGEQFreqCh(13, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub30Freq       wroteGEQFreqCh(13, 29, GEQ_MAXNUMBANDS)
#define  readGEQRsub30Level       readGEQLevelCh(13, 29, GEQ_MAXNUMBANDS)
#define writeGEQRsub30Level(N)   writeGEQLevelCh(13, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub30Level      wroteGEQLevelCh(13, 29, GEQ_MAXNUMBANDS)
#define  readGEQRsub30Width       readGEQWidthCh(13, 29, GEQ_MAXNUMBANDS)
#define writeGEQRsub30Width(N)   writeGEQWidthCh(13, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub30Width      wroteGEQWidthCh(13, 29, GEQ_MAXNUMBANDS)

#define  readGEQRsub31Freq        readGEQFreqCh(13, 30, GEQ_MAXNUMBANDS)
#define writeGEQRsub31Freq(N)    writeGEQFreqCh(13, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub31Freq       wroteGEQFreqCh(13, 30, GEQ_MAXNUMBANDS)
#define  readGEQRsub31Level       readGEQLevelCh(13, 30, GEQ_MAXNUMBANDS)
#define writeGEQRsub31Level(N)   writeGEQLevelCh(13, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub31Level      wroteGEQLevelCh(13, 30, GEQ_MAXNUMBANDS)
#define  readGEQRsub31Width       readGEQWidthCh(13, 30, GEQ_MAXNUMBANDS)
#define writeGEQRsub31Width(N)   writeGEQWidthCh(13, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub31Width      wroteGEQWidthCh(13, 30, GEQ_MAXNUMBANDS)

#define  readGEQRsub32Freq        readGEQFreqCh(13, 31, GEQ_MAXNUMBANDS)
#define writeGEQRsub32Freq(N)    writeGEQFreqCh(13, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub32Freq       wroteGEQFreqCh(13, 31, GEQ_MAXNUMBANDS)
#define  readGEQRsub32Level       readGEQLevelCh(13, 31, GEQ_MAXNUMBANDS)
#define writeGEQRsub32Level(N)   writeGEQLevelCh(13, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub32Level      wroteGEQLevelCh(13, 31, GEQ_MAXNUMBANDS)
#define  readGEQRsub32Width       readGEQWidthCh(13, 31, GEQ_MAXNUMBANDS)
#define writeGEQRsub32Width(N)   writeGEQWidthCh(13, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRsub32Width      wroteGEQWidthCh(13, 31, GEQ_MAXNUMBANDS)

#define  readGEQHead1Freq        readGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQHead1Freq(N)    writeGEQFreqCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead1Freq       wroteGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQHead1Level       readGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQHead1Level(N)   writeGEQLevelCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead1Level      wroteGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQHead1Width       readGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQHead1Width(N)   writeGEQWidthCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead1Width      wroteGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)

#define  readGEQHead2Freq        readGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQHead2Freq(N)    writeGEQFreqCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead2Freq       wroteGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQHead2Level       readGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQHead2Level(N)   writeGEQLevelCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead2Level      wroteGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQHead2Width       readGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQHead2Width(N)   writeGEQWidthCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead2Width      wroteGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)

#define  readGEQHead3Freq        readGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQHead3Freq(N)    writeGEQFreqCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead3Freq       wroteGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQHead3Level       readGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQHead3Level(N)   writeGEQLevelCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead3Level      wroteGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQHead3Width       readGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQHead3Width(N)   writeGEQWidthCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead3Width      wroteGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)

#define  readGEQHead4Freq        readGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQHead4Freq(N)    writeGEQFreqCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead4Freq       wroteGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQHead4Level       readGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQHead4Level(N)   writeGEQLevelCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead4Level      wroteGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQHead4Width       readGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQHead4Width(N)   writeGEQWidthCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead4Width      wroteGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)

#define  readGEQHead5Freq        readGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQHead5Freq(N)    writeGEQFreqCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead5Freq       wroteGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQHead5Level       readGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQHead5Level(N)   writeGEQLevelCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead5Level      wroteGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQHead5Width       readGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQHead5Width(N)   writeGEQWidthCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead5Width      wroteGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)

#define  readGEQHead6Freq        readGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQHead6Freq(N)    writeGEQFreqCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead6Freq       wroteGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQHead6Level       readGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQHead6Level(N)   writeGEQLevelCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead6Level      wroteGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQHead6Width       readGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQHead6Width(N)   writeGEQWidthCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead6Width      wroteGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)

#define  readGEQHead7Freq        readGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQHead7Freq(N)    writeGEQFreqCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead7Freq       wroteGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQHead7Level       readGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQHead7Level(N)   writeGEQLevelCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead7Level      wroteGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQHead7Width       readGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQHead7Width(N)   writeGEQWidthCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead7Width      wroteGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)

#define  readGEQHead8Freq        readGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQHead8Freq(N)    writeGEQFreqCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead8Freq       wroteGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQHead8Level       readGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQHead8Level(N)   writeGEQLevelCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead8Level      wroteGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQHead8Width       readGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQHead8Width(N)   writeGEQWidthCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead8Width      wroteGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)

#define  readGEQHead9Freq        readGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQHead9Freq(N)    writeGEQFreqCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead9Freq       wroteGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQHead9Level       readGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQHead9Level(N)   writeGEQLevelCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead9Level      wroteGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQHead9Width       readGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQHead9Width(N)   writeGEQWidthCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead9Width      wroteGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)

#define  readGEQHead10Freq        readGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQHead10Freq(N)    writeGEQFreqCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead10Freq       wroteGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQHead10Level       readGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQHead10Level(N)   writeGEQLevelCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead10Level      wroteGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQHead10Width       readGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQHead10Width(N)   writeGEQWidthCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead10Width      wroteGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)

#define  readGEQHead11Freq        readGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQHead11Freq(N)    writeGEQFreqCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead11Freq       wroteGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQHead11Level       readGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQHead11Level(N)   writeGEQLevelCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead11Level      wroteGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQHead11Width       readGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQHead11Width(N)   writeGEQWidthCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead11Width      wroteGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)

#define  readGEQHead12Freq        readGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQHead12Freq(N)    writeGEQFreqCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead12Freq       wroteGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQHead12Level       readGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQHead12Level(N)   writeGEQLevelCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead12Level      wroteGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQHead12Width       readGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQHead12Width(N)   writeGEQWidthCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead12Width      wroteGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)

#define  readGEQHead13Freq        readGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQHead13Freq(N)    writeGEQFreqCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead13Freq       wroteGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQHead13Level       readGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQHead13Level(N)   writeGEQLevelCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead13Level      wroteGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQHead13Width       readGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQHead13Width(N)   writeGEQWidthCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead13Width      wroteGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)

#define  readGEQHead14Freq        readGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQHead14Freq(N)    writeGEQFreqCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead14Freq       wroteGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQHead14Level       readGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQHead14Level(N)   writeGEQLevelCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead14Level      wroteGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQHead14Width       readGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQHead14Width(N)   writeGEQWidthCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead14Width      wroteGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)

#define  readGEQHead15Freq        readGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQHead15Freq(N)    writeGEQFreqCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead15Freq       wroteGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQHead15Level       readGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQHead15Level(N)   writeGEQLevelCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead15Level      wroteGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQHead15Width       readGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQHead15Width(N)   writeGEQWidthCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead15Width      wroteGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)

#define  readGEQHead16Freq        readGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQHead16Freq(N)    writeGEQFreqCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead16Freq       wroteGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQHead16Level       readGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQHead16Level(N)   writeGEQLevelCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead16Level      wroteGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQHead16Width       readGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQHead16Width(N)   writeGEQWidthCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead16Width      wroteGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)

#define  readGEQHead17Freq        readGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQHead17Freq(N)    writeGEQFreqCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead17Freq       wroteGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQHead17Level       readGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQHead17Level(N)   writeGEQLevelCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead17Level      wroteGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQHead17Width       readGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQHead17Width(N)   writeGEQWidthCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead17Width      wroteGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)

#define  readGEQHead18Freq        readGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQHead18Freq(N)    writeGEQFreqCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead18Freq       wroteGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQHead18Level       readGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQHead18Level(N)   writeGEQLevelCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead18Level      wroteGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQHead18Width       readGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQHead18Width(N)   writeGEQWidthCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead18Width      wroteGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)

#define  readGEQHead19Freq        readGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQHead19Freq(N)    writeGEQFreqCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead19Freq       wroteGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQHead19Level       readGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQHead19Level(N)   writeGEQLevelCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead19Level      wroteGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQHead19Width       readGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQHead19Width(N)   writeGEQWidthCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead19Width      wroteGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)

#define  readGEQHead20Freq        readGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQHead20Freq(N)    writeGEQFreqCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead20Freq       wroteGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQHead20Level       readGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQHead20Level(N)   writeGEQLevelCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead20Level      wroteGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQHead20Width       readGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQHead20Width(N)   writeGEQWidthCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead20Width      wroteGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)

#define  readGEQHead21Freq        readGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQHead21Freq(N)    writeGEQFreqCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead21Freq       wroteGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQHead21Level       readGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQHead21Level(N)   writeGEQLevelCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead21Level      wroteGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQHead21Width       readGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQHead21Width(N)   writeGEQWidthCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead21Width      wroteGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)

#define  readGEQHead22Freq        readGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQHead22Freq(N)    writeGEQFreqCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead22Freq       wroteGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQHead22Level       readGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQHead22Level(N)   writeGEQLevelCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead22Level      wroteGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQHead22Width       readGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQHead22Width(N)   writeGEQWidthCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead22Width      wroteGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)

#define  readGEQHead23Freq        readGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQHead23Freq(N)    writeGEQFreqCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead23Freq       wroteGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQHead23Level       readGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQHead23Level(N)   writeGEQLevelCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead23Level      wroteGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQHead23Width       readGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQHead23Width(N)   writeGEQWidthCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead23Width      wroteGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)

#define  readGEQHead24Freq        readGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQHead24Freq(N)    writeGEQFreqCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead24Freq       wroteGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQHead24Level       readGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQHead24Level(N)   writeGEQLevelCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead24Level      wroteGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQHead24Width       readGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQHead24Width(N)   writeGEQWidthCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead24Width      wroteGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)

#define  readGEQHead25Freq        readGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQHead25Freq(N)    writeGEQFreqCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead25Freq       wroteGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQHead25Level       readGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQHead25Level(N)   writeGEQLevelCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead25Level      wroteGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQHead25Width       readGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQHead25Width(N)   writeGEQWidthCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead25Width      wroteGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)

#define  readGEQHead26Freq        readGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQHead26Freq(N)    writeGEQFreqCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead26Freq       wroteGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQHead26Level       readGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQHead26Level(N)   writeGEQLevelCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead26Level      wroteGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQHead26Width       readGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQHead26Width(N)   writeGEQWidthCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead26Width      wroteGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)

#define  readGEQHead27Freq        readGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQHead27Freq(N)    writeGEQFreqCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead27Freq       wroteGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQHead27Level       readGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQHead27Level(N)   writeGEQLevelCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead27Level      wroteGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQHead27Width       readGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQHead27Width(N)   writeGEQWidthCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead27Width      wroteGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)

#define  readGEQHead28Freq        readGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQHead28Freq(N)    writeGEQFreqCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead28Freq       wroteGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQHead28Level       readGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQHead28Level(N)   writeGEQLevelCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead28Level      wroteGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQHead28Width       readGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQHead28Width(N)   writeGEQWidthCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead28Width      wroteGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)

#define  readGEQHead29Freq        readGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQHead29Freq(N)    writeGEQFreqCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead29Freq       wroteGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQHead29Level       readGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQHead29Level(N)   writeGEQLevelCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead29Level      wroteGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQHead29Width       readGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQHead29Width(N)   writeGEQWidthCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead29Width      wroteGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)

#define  readGEQHead30Freq        readGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQHead30Freq(N)    writeGEQFreqCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead30Freq       wroteGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQHead30Level       readGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQHead30Level(N)   writeGEQLevelCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead30Level      wroteGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQHead30Width       readGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQHead30Width(N)   writeGEQWidthCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead30Width      wroteGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)

#define  readGEQHead31Freq        readGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQHead31Freq(N)    writeGEQFreqCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead31Freq       wroteGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQHead31Level       readGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQHead31Level(N)   writeGEQLevelCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead31Level      wroteGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQHead31Width       readGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQHead31Width(N)   writeGEQWidthCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead31Width      wroteGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)

#define  readGEQHead32Freq        readGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQHead32Freq(N)    writeGEQFreqCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead32Freq       wroteGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQHead32Level       readGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQHead32Level(N)   writeGEQLevelCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead32Level      wroteGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQHead32Width       readGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQHead32Width(N)   writeGEQWidthCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead32Width      wroteGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)

#define  readGEQLhed1Freq        readGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQLhed1Freq(N)    writeGEQFreqCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed1Freq       wroteGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQLhed1Level       readGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQLhed1Level(N)   writeGEQLevelCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed1Level      wroteGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQLhed1Width       readGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQLhed1Width(N)   writeGEQWidthCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed1Width      wroteGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)

#define  readGEQLhed2Freq        readGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQLhed2Freq(N)    writeGEQFreqCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed2Freq       wroteGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQLhed2Level       readGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQLhed2Level(N)   writeGEQLevelCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed2Level      wroteGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQLhed2Width       readGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQLhed2Width(N)   writeGEQWidthCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed2Width      wroteGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)

#define  readGEQLhed3Freq        readGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQLhed3Freq(N)    writeGEQFreqCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed3Freq       wroteGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQLhed3Level       readGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQLhed3Level(N)   writeGEQLevelCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed3Level      wroteGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQLhed3Width       readGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQLhed3Width(N)   writeGEQWidthCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed3Width      wroteGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)

#define  readGEQLhed4Freq        readGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQLhed4Freq(N)    writeGEQFreqCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed4Freq       wroteGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQLhed4Level       readGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQLhed4Level(N)   writeGEQLevelCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed4Level      wroteGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQLhed4Width       readGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQLhed4Width(N)   writeGEQWidthCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed4Width      wroteGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)

#define  readGEQLhed5Freq        readGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQLhed5Freq(N)    writeGEQFreqCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed5Freq       wroteGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQLhed5Level       readGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQLhed5Level(N)   writeGEQLevelCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed5Level      wroteGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQLhed5Width       readGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQLhed5Width(N)   writeGEQWidthCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed5Width      wroteGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)

#define  readGEQLhed6Freq        readGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQLhed6Freq(N)    writeGEQFreqCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed6Freq       wroteGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQLhed6Level       readGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQLhed6Level(N)   writeGEQLevelCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed6Level      wroteGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQLhed6Width       readGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQLhed6Width(N)   writeGEQWidthCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed6Width      wroteGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)

#define  readGEQLhed7Freq        readGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQLhed7Freq(N)    writeGEQFreqCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed7Freq       wroteGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQLhed7Level       readGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQLhed7Level(N)   writeGEQLevelCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed7Level      wroteGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQLhed7Width       readGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQLhed7Width(N)   writeGEQWidthCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed7Width      wroteGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)

#define  readGEQLhed8Freq        readGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQLhed8Freq(N)    writeGEQFreqCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed8Freq       wroteGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQLhed8Level       readGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQLhed8Level(N)   writeGEQLevelCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed8Level      wroteGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQLhed8Width       readGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQLhed8Width(N)   writeGEQWidthCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed8Width      wroteGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)

#define  readGEQLhed9Freq        readGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQLhed9Freq(N)    writeGEQFreqCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed9Freq       wroteGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQLhed9Level       readGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQLhed9Level(N)   writeGEQLevelCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed9Level      wroteGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQLhed9Width       readGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQLhed9Width(N)   writeGEQWidthCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed9Width      wroteGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)

#define  readGEQLhed10Freq        readGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQLhed10Freq(N)    writeGEQFreqCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed10Freq       wroteGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQLhed10Level       readGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQLhed10Level(N)   writeGEQLevelCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed10Level      wroteGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQLhed10Width       readGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQLhed10Width(N)   writeGEQWidthCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed10Width      wroteGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)

#define  readGEQLhed11Freq        readGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQLhed11Freq(N)    writeGEQFreqCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed11Freq       wroteGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQLhed11Level       readGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQLhed11Level(N)   writeGEQLevelCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed11Level      wroteGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQLhed11Width       readGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQLhed11Width(N)   writeGEQWidthCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed11Width      wroteGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)

#define  readGEQLhed12Freq        readGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQLhed12Freq(N)    writeGEQFreqCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed12Freq       wroteGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQLhed12Level       readGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQLhed12Level(N)   writeGEQLevelCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed12Level      wroteGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQLhed12Width       readGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQLhed12Width(N)   writeGEQWidthCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed12Width      wroteGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)

#define  readGEQLhed13Freq        readGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQLhed13Freq(N)    writeGEQFreqCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed13Freq       wroteGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQLhed13Level       readGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQLhed13Level(N)   writeGEQLevelCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed13Level      wroteGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQLhed13Width       readGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQLhed13Width(N)   writeGEQWidthCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed13Width      wroteGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)

#define  readGEQLhed14Freq        readGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQLhed14Freq(N)    writeGEQFreqCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed14Freq       wroteGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQLhed14Level       readGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQLhed14Level(N)   writeGEQLevelCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed14Level      wroteGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQLhed14Width       readGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQLhed14Width(N)   writeGEQWidthCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed14Width      wroteGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)

#define  readGEQLhed15Freq        readGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQLhed15Freq(N)    writeGEQFreqCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed15Freq       wroteGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQLhed15Level       readGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQLhed15Level(N)   writeGEQLevelCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed15Level      wroteGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQLhed15Width       readGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQLhed15Width(N)   writeGEQWidthCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed15Width      wroteGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)

#define  readGEQLhed16Freq        readGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQLhed16Freq(N)    writeGEQFreqCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed16Freq       wroteGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQLhed16Level       readGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQLhed16Level(N)   writeGEQLevelCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed16Level      wroteGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQLhed16Width       readGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQLhed16Width(N)   writeGEQWidthCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed16Width      wroteGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)

#define  readGEQLhed17Freq        readGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQLhed17Freq(N)    writeGEQFreqCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed17Freq       wroteGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQLhed17Level       readGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQLhed17Level(N)   writeGEQLevelCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed17Level      wroteGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQLhed17Width       readGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQLhed17Width(N)   writeGEQWidthCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed17Width      wroteGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)

#define  readGEQLhed18Freq        readGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQLhed18Freq(N)    writeGEQFreqCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed18Freq       wroteGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQLhed18Level       readGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQLhed18Level(N)   writeGEQLevelCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed18Level      wroteGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQLhed18Width       readGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQLhed18Width(N)   writeGEQWidthCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed18Width      wroteGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)

#define  readGEQLhed19Freq        readGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQLhed19Freq(N)    writeGEQFreqCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed19Freq       wroteGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQLhed19Level       readGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQLhed19Level(N)   writeGEQLevelCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed19Level      wroteGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQLhed19Width       readGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQLhed19Width(N)   writeGEQWidthCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed19Width      wroteGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)

#define  readGEQLhed20Freq        readGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQLhed20Freq(N)    writeGEQFreqCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed20Freq       wroteGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQLhed20Level       readGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQLhed20Level(N)   writeGEQLevelCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed20Level      wroteGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQLhed20Width       readGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQLhed20Width(N)   writeGEQWidthCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed20Width      wroteGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)

#define  readGEQLhed21Freq        readGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQLhed21Freq(N)    writeGEQFreqCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed21Freq       wroteGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQLhed21Level       readGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQLhed21Level(N)   writeGEQLevelCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed21Level      wroteGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQLhed21Width       readGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQLhed21Width(N)   writeGEQWidthCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed21Width      wroteGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)

#define  readGEQLhed22Freq        readGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQLhed22Freq(N)    writeGEQFreqCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed22Freq       wroteGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQLhed22Level       readGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQLhed22Level(N)   writeGEQLevelCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed22Level      wroteGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQLhed22Width       readGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQLhed22Width(N)   writeGEQWidthCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed22Width      wroteGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)

#define  readGEQLhed23Freq        readGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQLhed23Freq(N)    writeGEQFreqCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed23Freq       wroteGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQLhed23Level       readGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQLhed23Level(N)   writeGEQLevelCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed23Level      wroteGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQLhed23Width       readGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQLhed23Width(N)   writeGEQWidthCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed23Width      wroteGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)

#define  readGEQLhed24Freq        readGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQLhed24Freq(N)    writeGEQFreqCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed24Freq       wroteGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQLhed24Level       readGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQLhed24Level(N)   writeGEQLevelCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed24Level      wroteGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQLhed24Width       readGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQLhed24Width(N)   writeGEQWidthCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed24Width      wroteGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)

#define  readGEQLhed25Freq        readGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQLhed25Freq(N)    writeGEQFreqCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed25Freq       wroteGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQLhed25Level       readGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQLhed25Level(N)   writeGEQLevelCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed25Level      wroteGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQLhed25Width       readGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQLhed25Width(N)   writeGEQWidthCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed25Width      wroteGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)

#define  readGEQLhed26Freq        readGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQLhed26Freq(N)    writeGEQFreqCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed26Freq       wroteGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQLhed26Level       readGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQLhed26Level(N)   writeGEQLevelCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed26Level      wroteGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQLhed26Width       readGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQLhed26Width(N)   writeGEQWidthCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed26Width      wroteGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)

#define  readGEQLhed27Freq        readGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQLhed27Freq(N)    writeGEQFreqCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed27Freq       wroteGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQLhed27Level       readGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQLhed27Level(N)   writeGEQLevelCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed27Level      wroteGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQLhed27Width       readGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQLhed27Width(N)   writeGEQWidthCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed27Width      wroteGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)

#define  readGEQLhed28Freq        readGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQLhed28Freq(N)    writeGEQFreqCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed28Freq       wroteGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQLhed28Level       readGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQLhed28Level(N)   writeGEQLevelCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed28Level      wroteGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQLhed28Width       readGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQLhed28Width(N)   writeGEQWidthCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed28Width      wroteGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)

#define  readGEQLhed29Freq        readGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQLhed29Freq(N)    writeGEQFreqCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed29Freq       wroteGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQLhed29Level       readGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQLhed29Level(N)   writeGEQLevelCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed29Level      wroteGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQLhed29Width       readGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQLhed29Width(N)   writeGEQWidthCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed29Width      wroteGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)

#define  readGEQLhed30Freq        readGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQLhed30Freq(N)    writeGEQFreqCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed30Freq       wroteGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQLhed30Level       readGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQLhed30Level(N)   writeGEQLevelCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed30Level      wroteGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQLhed30Width       readGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQLhed30Width(N)   writeGEQWidthCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed30Width      wroteGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)

#define  readGEQLhed31Freq        readGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQLhed31Freq(N)    writeGEQFreqCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed31Freq       wroteGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQLhed31Level       readGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQLhed31Level(N)   writeGEQLevelCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed31Level      wroteGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQLhed31Width       readGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQLhed31Width(N)   writeGEQWidthCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed31Width      wroteGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)

#define  readGEQLhed32Freq        readGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQLhed32Freq(N)    writeGEQFreqCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed32Freq       wroteGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQLhed32Level       readGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQLhed32Level(N)   writeGEQLevelCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed32Level      wroteGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQLhed32Width       readGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQLhed32Width(N)   writeGEQWidthCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQLhed32Width      wroteGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)

#define  readGEQRhed1Freq        readGEQFreqCh(15, 0, GEQ_MAXNUMBANDS)
#define writeGEQRhed1Freq(N)    writeGEQFreqCh(15, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed1Freq       wroteGEQFreqCh(15, 0, GEQ_MAXNUMBANDS)
#define  readGEQRhed1Level       readGEQLevelCh(15, 0, GEQ_MAXNUMBANDS)
#define writeGEQRhed1Level(N)   writeGEQLevelCh(15, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed1Level      wroteGEQLevelCh(15, 0, GEQ_MAXNUMBANDS)
#define  readGEQRhed1Width       readGEQWidthCh(15, 0, GEQ_MAXNUMBANDS)
#define writeGEQRhed1Width(N)   writeGEQWidthCh(15, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed1Width      wroteGEQWidthCh(15, 0, GEQ_MAXNUMBANDS)

#define  readGEQRhed2Freq        readGEQFreqCh(15, 1, GEQ_MAXNUMBANDS)
#define writeGEQRhed2Freq(N)    writeGEQFreqCh(15, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed2Freq       wroteGEQFreqCh(15, 1, GEQ_MAXNUMBANDS)
#define  readGEQRhed2Level       readGEQLevelCh(15, 1, GEQ_MAXNUMBANDS)
#define writeGEQRhed2Level(N)   writeGEQLevelCh(15, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed2Level      wroteGEQLevelCh(15, 1, GEQ_MAXNUMBANDS)
#define  readGEQRhed2Width       readGEQWidthCh(15, 1, GEQ_MAXNUMBANDS)
#define writeGEQRhed2Width(N)   writeGEQWidthCh(15, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed2Width      wroteGEQWidthCh(15, 1, GEQ_MAXNUMBANDS)

#define  readGEQRhed3Freq        readGEQFreqCh(15, 2, GEQ_MAXNUMBANDS)
#define writeGEQRhed3Freq(N)    writeGEQFreqCh(15, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed3Freq       wroteGEQFreqCh(15, 2, GEQ_MAXNUMBANDS)
#define  readGEQRhed3Level       readGEQLevelCh(15, 2, GEQ_MAXNUMBANDS)
#define writeGEQRhed3Level(N)   writeGEQLevelCh(15, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed3Level      wroteGEQLevelCh(15, 2, GEQ_MAXNUMBANDS)
#define  readGEQRhed3Width       readGEQWidthCh(15, 2, GEQ_MAXNUMBANDS)
#define writeGEQRhed3Width(N)   writeGEQWidthCh(15, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed3Width      wroteGEQWidthCh(15, 2, GEQ_MAXNUMBANDS)

#define  readGEQRhed4Freq        readGEQFreqCh(15, 3, GEQ_MAXNUMBANDS)
#define writeGEQRhed4Freq(N)    writeGEQFreqCh(15, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed4Freq       wroteGEQFreqCh(15, 3, GEQ_MAXNUMBANDS)
#define  readGEQRhed4Level       readGEQLevelCh(15, 3, GEQ_MAXNUMBANDS)
#define writeGEQRhed4Level(N)   writeGEQLevelCh(15, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed4Level      wroteGEQLevelCh(15, 3, GEQ_MAXNUMBANDS)
#define  readGEQRhed4Width       readGEQWidthCh(15, 3, GEQ_MAXNUMBANDS)
#define writeGEQRhed4Width(N)   writeGEQWidthCh(15, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed4Width      wroteGEQWidthCh(15, 3, GEQ_MAXNUMBANDS)

#define  readGEQRhed5Freq        readGEQFreqCh(15, 4, GEQ_MAXNUMBANDS)
#define writeGEQRhed5Freq(N)    writeGEQFreqCh(15, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed5Freq       wroteGEQFreqCh(15, 4, GEQ_MAXNUMBANDS)
#define  readGEQRhed5Level       readGEQLevelCh(15, 4, GEQ_MAXNUMBANDS)
#define writeGEQRhed5Level(N)   writeGEQLevelCh(15, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed5Level      wroteGEQLevelCh(15, 4, GEQ_MAXNUMBANDS)
#define  readGEQRhed5Width       readGEQWidthCh(15, 4, GEQ_MAXNUMBANDS)
#define writeGEQRhed5Width(N)   writeGEQWidthCh(15, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed5Width      wroteGEQWidthCh(15, 4, GEQ_MAXNUMBANDS)

#define  readGEQRhed6Freq        readGEQFreqCh(15, 5, GEQ_MAXNUMBANDS)
#define writeGEQRhed6Freq(N)    writeGEQFreqCh(15, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed6Freq       wroteGEQFreqCh(15, 5, GEQ_MAXNUMBANDS)
#define  readGEQRhed6Level       readGEQLevelCh(15, 5, GEQ_MAXNUMBANDS)
#define writeGEQRhed6Level(N)   writeGEQLevelCh(15, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed6Level      wroteGEQLevelCh(15, 5, GEQ_MAXNUMBANDS)
#define  readGEQRhed6Width       readGEQWidthCh(15, 5, GEQ_MAXNUMBANDS)
#define writeGEQRhed6Width(N)   writeGEQWidthCh(15, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed6Width      wroteGEQWidthCh(15, 5, GEQ_MAXNUMBANDS)

#define  readGEQRhed7Freq        readGEQFreqCh(15, 6, GEQ_MAXNUMBANDS)
#define writeGEQRhed7Freq(N)    writeGEQFreqCh(15, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed7Freq       wroteGEQFreqCh(15, 6, GEQ_MAXNUMBANDS)
#define  readGEQRhed7Level       readGEQLevelCh(15, 6, GEQ_MAXNUMBANDS)
#define writeGEQRhed7Level(N)   writeGEQLevelCh(15, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed7Level      wroteGEQLevelCh(15, 6, GEQ_MAXNUMBANDS)
#define  readGEQRhed7Width       readGEQWidthCh(15, 6, GEQ_MAXNUMBANDS)
#define writeGEQRhed7Width(N)   writeGEQWidthCh(15, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed7Width      wroteGEQWidthCh(15, 6, GEQ_MAXNUMBANDS)

#define  readGEQRhed8Freq        readGEQFreqCh(15, 7, GEQ_MAXNUMBANDS)
#define writeGEQRhed8Freq(N)    writeGEQFreqCh(15, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed8Freq       wroteGEQFreqCh(15, 7, GEQ_MAXNUMBANDS)
#define  readGEQRhed8Level       readGEQLevelCh(15, 7, GEQ_MAXNUMBANDS)
#define writeGEQRhed8Level(N)   writeGEQLevelCh(15, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed8Level      wroteGEQLevelCh(15, 7, GEQ_MAXNUMBANDS)
#define  readGEQRhed8Width       readGEQWidthCh(15, 7, GEQ_MAXNUMBANDS)
#define writeGEQRhed8Width(N)   writeGEQWidthCh(15, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed8Width      wroteGEQWidthCh(15, 7, GEQ_MAXNUMBANDS)

#define  readGEQRhed9Freq        readGEQFreqCh(15, 8, GEQ_MAXNUMBANDS)
#define writeGEQRhed9Freq(N)    writeGEQFreqCh(15, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed9Freq       wroteGEQFreqCh(15, 8, GEQ_MAXNUMBANDS)
#define  readGEQRhed9Level       readGEQLevelCh(15, 8, GEQ_MAXNUMBANDS)
#define writeGEQRhed9Level(N)   writeGEQLevelCh(15, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed9Level      wroteGEQLevelCh(15, 8, GEQ_MAXNUMBANDS)
#define  readGEQRhed9Width       readGEQWidthCh(15, 8, GEQ_MAXNUMBANDS)
#define writeGEQRhed9Width(N)   writeGEQWidthCh(15, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed9Width      wroteGEQWidthCh(15, 8, GEQ_MAXNUMBANDS)

#define  readGEQRhed10Freq        readGEQFreqCh(15, 9, GEQ_MAXNUMBANDS)
#define writeGEQRhed10Freq(N)    writeGEQFreqCh(15, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed10Freq       wroteGEQFreqCh(15, 9, GEQ_MAXNUMBANDS)
#define  readGEQRhed10Level       readGEQLevelCh(15, 9, GEQ_MAXNUMBANDS)
#define writeGEQRhed10Level(N)   writeGEQLevelCh(15, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed10Level      wroteGEQLevelCh(15, 9, GEQ_MAXNUMBANDS)
#define  readGEQRhed10Width       readGEQWidthCh(15, 9, GEQ_MAXNUMBANDS)
#define writeGEQRhed10Width(N)   writeGEQWidthCh(15, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed10Width      wroteGEQWidthCh(15, 9, GEQ_MAXNUMBANDS)

#define  readGEQRhed11Freq        readGEQFreqCh(15, 10, GEQ_MAXNUMBANDS)
#define writeGEQRhed11Freq(N)    writeGEQFreqCh(15, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed11Freq       wroteGEQFreqCh(15, 10, GEQ_MAXNUMBANDS)
#define  readGEQRhed11Level       readGEQLevelCh(15, 10, GEQ_MAXNUMBANDS)
#define writeGEQRhed11Level(N)   writeGEQLevelCh(15, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed11Level      wroteGEQLevelCh(15, 10, GEQ_MAXNUMBANDS)
#define  readGEQRhed11Width       readGEQWidthCh(15, 10, GEQ_MAXNUMBANDS)
#define writeGEQRhed11Width(N)   writeGEQWidthCh(15, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed11Width      wroteGEQWidthCh(15, 10, GEQ_MAXNUMBANDS)

#define  readGEQRhed12Freq        readGEQFreqCh(15, 11, GEQ_MAXNUMBANDS)
#define writeGEQRhed12Freq(N)    writeGEQFreqCh(15, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed12Freq       wroteGEQFreqCh(15, 11, GEQ_MAXNUMBANDS)
#define  readGEQRhed12Level       readGEQLevelCh(15, 11, GEQ_MAXNUMBANDS)
#define writeGEQRhed12Level(N)   writeGEQLevelCh(15, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed12Level      wroteGEQLevelCh(15, 11, GEQ_MAXNUMBANDS)
#define  readGEQRhed12Width       readGEQWidthCh(15, 11, GEQ_MAXNUMBANDS)
#define writeGEQRhed12Width(N)   writeGEQWidthCh(15, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed12Width      wroteGEQWidthCh(15, 11, GEQ_MAXNUMBANDS)

#define  readGEQRhed13Freq        readGEQFreqCh(15, 12, GEQ_MAXNUMBANDS)
#define writeGEQRhed13Freq(N)    writeGEQFreqCh(15, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed13Freq       wroteGEQFreqCh(15, 12, GEQ_MAXNUMBANDS)
#define  readGEQRhed13Level       readGEQLevelCh(15, 12, GEQ_MAXNUMBANDS)
#define writeGEQRhed13Level(N)   writeGEQLevelCh(15, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed13Level      wroteGEQLevelCh(15, 12, GEQ_MAXNUMBANDS)
#define  readGEQRhed13Width       readGEQWidthCh(15, 12, GEQ_MAXNUMBANDS)
#define writeGEQRhed13Width(N)   writeGEQWidthCh(15, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed13Width      wroteGEQWidthCh(15, 12, GEQ_MAXNUMBANDS)

#define  readGEQRhed14Freq        readGEQFreqCh(15, 13, GEQ_MAXNUMBANDS)
#define writeGEQRhed14Freq(N)    writeGEQFreqCh(15, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed14Freq       wroteGEQFreqCh(15, 13, GEQ_MAXNUMBANDS)
#define  readGEQRhed14Level       readGEQLevelCh(15, 13, GEQ_MAXNUMBANDS)
#define writeGEQRhed14Level(N)   writeGEQLevelCh(15, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed14Level      wroteGEQLevelCh(15, 13, GEQ_MAXNUMBANDS)
#define  readGEQRhed14Width       readGEQWidthCh(15, 13, GEQ_MAXNUMBANDS)
#define writeGEQRhed14Width(N)   writeGEQWidthCh(15, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed14Width      wroteGEQWidthCh(15, 13, GEQ_MAXNUMBANDS)

#define  readGEQRhed15Freq        readGEQFreqCh(15, 14, GEQ_MAXNUMBANDS)
#define writeGEQRhed15Freq(N)    writeGEQFreqCh(15, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed15Freq       wroteGEQFreqCh(15, 14, GEQ_MAXNUMBANDS)
#define  readGEQRhed15Level       readGEQLevelCh(15, 14, GEQ_MAXNUMBANDS)
#define writeGEQRhed15Level(N)   writeGEQLevelCh(15, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed15Level      wroteGEQLevelCh(15, 14, GEQ_MAXNUMBANDS)
#define  readGEQRhed15Width       readGEQWidthCh(15, 14, GEQ_MAXNUMBANDS)
#define writeGEQRhed15Width(N)   writeGEQWidthCh(15, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed15Width      wroteGEQWidthCh(15, 14, GEQ_MAXNUMBANDS)

#define  readGEQRhed16Freq        readGEQFreqCh(15, 15, GEQ_MAXNUMBANDS)
#define writeGEQRhed16Freq(N)    writeGEQFreqCh(15, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed16Freq       wroteGEQFreqCh(15, 15, GEQ_MAXNUMBANDS)
#define  readGEQRhed16Level       readGEQLevelCh(15, 15, GEQ_MAXNUMBANDS)
#define writeGEQRhed16Level(N)   writeGEQLevelCh(15, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed16Level      wroteGEQLevelCh(15, 15, GEQ_MAXNUMBANDS)
#define  readGEQRhed16Width       readGEQWidthCh(15, 15, GEQ_MAXNUMBANDS)
#define writeGEQRhed16Width(N)   writeGEQWidthCh(15, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed16Width      wroteGEQWidthCh(15, 15, GEQ_MAXNUMBANDS)

#define  readGEQRhed17Freq        readGEQFreqCh(15, 16, GEQ_MAXNUMBANDS)
#define writeGEQRhed17Freq(N)    writeGEQFreqCh(15, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed17Freq       wroteGEQFreqCh(15, 16, GEQ_MAXNUMBANDS)
#define  readGEQRhed17Level       readGEQLevelCh(15, 16, GEQ_MAXNUMBANDS)
#define writeGEQRhed17Level(N)   writeGEQLevelCh(15, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed17Level      wroteGEQLevelCh(15, 16, GEQ_MAXNUMBANDS)
#define  readGEQRhed17Width       readGEQWidthCh(15, 16, GEQ_MAXNUMBANDS)
#define writeGEQRhed17Width(N)   writeGEQWidthCh(15, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed17Width      wroteGEQWidthCh(15, 16, GEQ_MAXNUMBANDS)

#define  readGEQRhed18Freq        readGEQFreqCh(15, 17, GEQ_MAXNUMBANDS)
#define writeGEQRhed18Freq(N)    writeGEQFreqCh(15, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed18Freq       wroteGEQFreqCh(15, 17, GEQ_MAXNUMBANDS)
#define  readGEQRhed18Level       readGEQLevelCh(15, 17, GEQ_MAXNUMBANDS)
#define writeGEQRhed18Level(N)   writeGEQLevelCh(15, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed18Level      wroteGEQLevelCh(15, 17, GEQ_MAXNUMBANDS)
#define  readGEQRhed18Width       readGEQWidthCh(15, 17, GEQ_MAXNUMBANDS)
#define writeGEQRhed18Width(N)   writeGEQWidthCh(15, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed18Width      wroteGEQWidthCh(15, 17, GEQ_MAXNUMBANDS)

#define  readGEQRhed19Freq        readGEQFreqCh(15, 18, GEQ_MAXNUMBANDS)
#define writeGEQRhed19Freq(N)    writeGEQFreqCh(15, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed19Freq       wroteGEQFreqCh(15, 18, GEQ_MAXNUMBANDS)
#define  readGEQRhed19Level       readGEQLevelCh(15, 18, GEQ_MAXNUMBANDS)
#define writeGEQRhed19Level(N)   writeGEQLevelCh(15, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed19Level      wroteGEQLevelCh(15, 18, GEQ_MAXNUMBANDS)
#define  readGEQRhed19Width       readGEQWidthCh(15, 18, GEQ_MAXNUMBANDS)
#define writeGEQRhed19Width(N)   writeGEQWidthCh(15, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed19Width      wroteGEQWidthCh(15, 18, GEQ_MAXNUMBANDS)

#define  readGEQRhed20Freq        readGEQFreqCh(15, 19, GEQ_MAXNUMBANDS)
#define writeGEQRhed20Freq(N)    writeGEQFreqCh(15, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed20Freq       wroteGEQFreqCh(15, 19, GEQ_MAXNUMBANDS)
#define  readGEQRhed20Level       readGEQLevelCh(15, 19, GEQ_MAXNUMBANDS)
#define writeGEQRhed20Level(N)   writeGEQLevelCh(15, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed20Level      wroteGEQLevelCh(15, 19, GEQ_MAXNUMBANDS)
#define  readGEQRhed20Width       readGEQWidthCh(15, 19, GEQ_MAXNUMBANDS)
#define writeGEQRhed20Width(N)   writeGEQWidthCh(15, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed20Width      wroteGEQWidthCh(15, 19, GEQ_MAXNUMBANDS)

#define  readGEQRhed21Freq        readGEQFreqCh(15, 20, GEQ_MAXNUMBANDS)
#define writeGEQRhed21Freq(N)    writeGEQFreqCh(15, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed21Freq       wroteGEQFreqCh(15, 20, GEQ_MAXNUMBANDS)
#define  readGEQRhed21Level       readGEQLevelCh(15, 20, GEQ_MAXNUMBANDS)
#define writeGEQRhed21Level(N)   writeGEQLevelCh(15, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed21Level      wroteGEQLevelCh(15, 20, GEQ_MAXNUMBANDS)
#define  readGEQRhed21Width       readGEQWidthCh(15, 20, GEQ_MAXNUMBANDS)
#define writeGEQRhed21Width(N)   writeGEQWidthCh(15, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed21Width      wroteGEQWidthCh(15, 20, GEQ_MAXNUMBANDS)

#define  readGEQRhed22Freq        readGEQFreqCh(15, 21, GEQ_MAXNUMBANDS)
#define writeGEQRhed22Freq(N)    writeGEQFreqCh(15, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed22Freq       wroteGEQFreqCh(15, 21, GEQ_MAXNUMBANDS)
#define  readGEQRhed22Level       readGEQLevelCh(15, 21, GEQ_MAXNUMBANDS)
#define writeGEQRhed22Level(N)   writeGEQLevelCh(15, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed22Level      wroteGEQLevelCh(15, 21, GEQ_MAXNUMBANDS)
#define  readGEQRhed22Width       readGEQWidthCh(15, 21, GEQ_MAXNUMBANDS)
#define writeGEQRhed22Width(N)   writeGEQWidthCh(15, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed22Width      wroteGEQWidthCh(15, 21, GEQ_MAXNUMBANDS)

#define  readGEQRhed23Freq        readGEQFreqCh(15, 22, GEQ_MAXNUMBANDS)
#define writeGEQRhed23Freq(N)    writeGEQFreqCh(15, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed23Freq       wroteGEQFreqCh(15, 22, GEQ_MAXNUMBANDS)
#define  readGEQRhed23Level       readGEQLevelCh(15, 22, GEQ_MAXNUMBANDS)
#define writeGEQRhed23Level(N)   writeGEQLevelCh(15, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed23Level      wroteGEQLevelCh(15, 22, GEQ_MAXNUMBANDS)
#define  readGEQRhed23Width       readGEQWidthCh(15, 22, GEQ_MAXNUMBANDS)
#define writeGEQRhed23Width(N)   writeGEQWidthCh(15, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed23Width      wroteGEQWidthCh(15, 22, GEQ_MAXNUMBANDS)

#define  readGEQRhed24Freq        readGEQFreqCh(15, 23, GEQ_MAXNUMBANDS)
#define writeGEQRhed24Freq(N)    writeGEQFreqCh(15, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed24Freq       wroteGEQFreqCh(15, 23, GEQ_MAXNUMBANDS)
#define  readGEQRhed24Level       readGEQLevelCh(15, 23, GEQ_MAXNUMBANDS)
#define writeGEQRhed24Level(N)   writeGEQLevelCh(15, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed24Level      wroteGEQLevelCh(15, 23, GEQ_MAXNUMBANDS)
#define  readGEQRhed24Width       readGEQWidthCh(15, 23, GEQ_MAXNUMBANDS)
#define writeGEQRhed24Width(N)   writeGEQWidthCh(15, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed24Width      wroteGEQWidthCh(15, 23, GEQ_MAXNUMBANDS)

#define  readGEQRhed25Freq        readGEQFreqCh(15, 24, GEQ_MAXNUMBANDS)
#define writeGEQRhed25Freq(N)    writeGEQFreqCh(15, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed25Freq       wroteGEQFreqCh(15, 24, GEQ_MAXNUMBANDS)
#define  readGEQRhed25Level       readGEQLevelCh(15, 24, GEQ_MAXNUMBANDS)
#define writeGEQRhed25Level(N)   writeGEQLevelCh(15, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed25Level      wroteGEQLevelCh(15, 24, GEQ_MAXNUMBANDS)
#define  readGEQRhed25Width       readGEQWidthCh(15, 24, GEQ_MAXNUMBANDS)
#define writeGEQRhed25Width(N)   writeGEQWidthCh(15, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed25Width      wroteGEQWidthCh(15, 24, GEQ_MAXNUMBANDS)

#define  readGEQRhed26Freq        readGEQFreqCh(15, 25, GEQ_MAXNUMBANDS)
#define writeGEQRhed26Freq(N)    writeGEQFreqCh(15, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed26Freq       wroteGEQFreqCh(15, 25, GEQ_MAXNUMBANDS)
#define  readGEQRhed26Level       readGEQLevelCh(15, 25, GEQ_MAXNUMBANDS)
#define writeGEQRhed26Level(N)   writeGEQLevelCh(15, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed26Level      wroteGEQLevelCh(15, 25, GEQ_MAXNUMBANDS)
#define  readGEQRhed26Width       readGEQWidthCh(15, 25, GEQ_MAXNUMBANDS)
#define writeGEQRhed26Width(N)   writeGEQWidthCh(15, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed26Width      wroteGEQWidthCh(15, 25, GEQ_MAXNUMBANDS)

#define  readGEQRhed27Freq        readGEQFreqCh(15, 26, GEQ_MAXNUMBANDS)
#define writeGEQRhed27Freq(N)    writeGEQFreqCh(15, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed27Freq       wroteGEQFreqCh(15, 26, GEQ_MAXNUMBANDS)
#define  readGEQRhed27Level       readGEQLevelCh(15, 26, GEQ_MAXNUMBANDS)
#define writeGEQRhed27Level(N)   writeGEQLevelCh(15, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed27Level      wroteGEQLevelCh(15, 26, GEQ_MAXNUMBANDS)
#define  readGEQRhed27Width       readGEQWidthCh(15, 26, GEQ_MAXNUMBANDS)
#define writeGEQRhed27Width(N)   writeGEQWidthCh(15, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed27Width      wroteGEQWidthCh(15, 26, GEQ_MAXNUMBANDS)

#define  readGEQRhed28Freq        readGEQFreqCh(15, 27, GEQ_MAXNUMBANDS)
#define writeGEQRhed28Freq(N)    writeGEQFreqCh(15, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed28Freq       wroteGEQFreqCh(15, 27, GEQ_MAXNUMBANDS)
#define  readGEQRhed28Level       readGEQLevelCh(15, 27, GEQ_MAXNUMBANDS)
#define writeGEQRhed28Level(N)   writeGEQLevelCh(15, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed28Level      wroteGEQLevelCh(15, 27, GEQ_MAXNUMBANDS)
#define  readGEQRhed28Width       readGEQWidthCh(15, 27, GEQ_MAXNUMBANDS)
#define writeGEQRhed28Width(N)   writeGEQWidthCh(15, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed28Width      wroteGEQWidthCh(15, 27, GEQ_MAXNUMBANDS)

#define  readGEQRhed29Freq        readGEQFreqCh(15, 28, GEQ_MAXNUMBANDS)
#define writeGEQRhed29Freq(N)    writeGEQFreqCh(15, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed29Freq       wroteGEQFreqCh(15, 28, GEQ_MAXNUMBANDS)
#define  readGEQRhed29Level       readGEQLevelCh(15, 28, GEQ_MAXNUMBANDS)
#define writeGEQRhed29Level(N)   writeGEQLevelCh(15, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed29Level      wroteGEQLevelCh(15, 28, GEQ_MAXNUMBANDS)
#define  readGEQRhed29Width       readGEQWidthCh(15, 28, GEQ_MAXNUMBANDS)
#define writeGEQRhed29Width(N)   writeGEQWidthCh(15, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed29Width      wroteGEQWidthCh(15, 28, GEQ_MAXNUMBANDS)

#define  readGEQRhed30Freq        readGEQFreqCh(15, 29, GEQ_MAXNUMBANDS)
#define writeGEQRhed30Freq(N)    writeGEQFreqCh(15, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed30Freq       wroteGEQFreqCh(15, 29, GEQ_MAXNUMBANDS)
#define  readGEQRhed30Level       readGEQLevelCh(15, 29, GEQ_MAXNUMBANDS)
#define writeGEQRhed30Level(N)   writeGEQLevelCh(15, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed30Level      wroteGEQLevelCh(15, 29, GEQ_MAXNUMBANDS)
#define  readGEQRhed30Width       readGEQWidthCh(15, 29, GEQ_MAXNUMBANDS)
#define writeGEQRhed30Width(N)   writeGEQWidthCh(15, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed30Width      wroteGEQWidthCh(15, 29, GEQ_MAXNUMBANDS)

#define  readGEQRhed31Freq        readGEQFreqCh(15, 30, GEQ_MAXNUMBANDS)
#define writeGEQRhed31Freq(N)    writeGEQFreqCh(15, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed31Freq       wroteGEQFreqCh(15, 30, GEQ_MAXNUMBANDS)
#define  readGEQRhed31Level       readGEQLevelCh(15, 30, GEQ_MAXNUMBANDS)
#define writeGEQRhed31Level(N)   writeGEQLevelCh(15, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed31Level      wroteGEQLevelCh(15, 30, GEQ_MAXNUMBANDS)
#define  readGEQRhed31Width       readGEQWidthCh(15, 30, GEQ_MAXNUMBANDS)
#define writeGEQRhed31Width(N)   writeGEQWidthCh(15, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed31Width      wroteGEQWidthCh(15, 30, GEQ_MAXNUMBANDS)

#define  readGEQRhed32Freq        readGEQFreqCh(15, 31, GEQ_MAXNUMBANDS)
#define writeGEQRhed32Freq(N)    writeGEQFreqCh(15, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed32Freq       wroteGEQFreqCh(15, 31, GEQ_MAXNUMBANDS)
#define  readGEQRhed32Level       readGEQLevelCh(15, 31, GEQ_MAXNUMBANDS)
#define writeGEQRhed32Level(N)   writeGEQLevelCh(15, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed32Level      wroteGEQLevelCh(15, 31, GEQ_MAXNUMBANDS)
#define  readGEQRhed32Width       readGEQWidthCh(15, 31, GEQ_MAXNUMBANDS)
#define writeGEQRhed32Width(N)   writeGEQWidthCh(15, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRhed32Width      wroteGEQWidthCh(15, 31, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_01Freq        readGEQFreqCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_01Freq(N)    writeGEQFreqCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_01Freq       wroteGEQFreqCh(0, 0, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_01Level       readGEQLevelCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_01Level(N)   writeGEQLevelCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_01Level      wroteGEQLevelCh(0, 0, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_01Width       readGEQWidthCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_01Width(N)   writeGEQWidthCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_01Width      wroteGEQWidthCh(0, 0, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_02Freq        readGEQFreqCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_02Freq(N)    writeGEQFreqCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_02Freq       wroteGEQFreqCh(0, 1, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_02Level       readGEQLevelCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_02Level(N)   writeGEQLevelCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_02Level      wroteGEQLevelCh(0, 1, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_02Width       readGEQWidthCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_02Width(N)   writeGEQWidthCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_02Width      wroteGEQWidthCh(0, 1, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_03Freq        readGEQFreqCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_03Freq(N)    writeGEQFreqCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_03Freq       wroteGEQFreqCh(0, 2, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_03Level       readGEQLevelCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_03Level(N)   writeGEQLevelCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_03Level      wroteGEQLevelCh(0, 2, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_03Width       readGEQWidthCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_03Width(N)   writeGEQWidthCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_03Width      wroteGEQWidthCh(0, 2, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_04Freq        readGEQFreqCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_04Freq(N)    writeGEQFreqCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_04Freq       wroteGEQFreqCh(0, 3, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_04Level       readGEQLevelCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_04Level(N)   writeGEQLevelCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_04Level      wroteGEQLevelCh(0, 3, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_04Width       readGEQWidthCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_04Width(N)   writeGEQWidthCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_04Width      wroteGEQWidthCh(0, 3, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_05Freq        readGEQFreqCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_05Freq(N)    writeGEQFreqCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_05Freq       wroteGEQFreqCh(0, 4, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_05Level       readGEQLevelCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_05Level(N)   writeGEQLevelCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_05Level      wroteGEQLevelCh(0, 4, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_05Width       readGEQWidthCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_05Width(N)   writeGEQWidthCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_05Width      wroteGEQWidthCh(0, 4, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_06Freq        readGEQFreqCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_06Freq(N)    writeGEQFreqCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_06Freq       wroteGEQFreqCh(0, 5, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_06Level       readGEQLevelCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_06Level(N)   writeGEQLevelCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_06Level      wroteGEQLevelCh(0, 5, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_06Width       readGEQWidthCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_06Width(N)   writeGEQWidthCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_06Width      wroteGEQWidthCh(0, 5, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_07Freq        readGEQFreqCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_07Freq(N)    writeGEQFreqCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_07Freq       wroteGEQFreqCh(0, 6, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_07Level       readGEQLevelCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_07Level(N)   writeGEQLevelCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_07Level      wroteGEQLevelCh(0, 6, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_07Width       readGEQWidthCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_07Width(N)   writeGEQWidthCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_07Width      wroteGEQWidthCh(0, 6, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_08Freq        readGEQFreqCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_08Freq(N)    writeGEQFreqCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_08Freq       wroteGEQFreqCh(0, 7, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_08Level       readGEQLevelCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_08Level(N)   writeGEQLevelCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_08Level      wroteGEQLevelCh(0, 7, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_08Width       readGEQWidthCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_08Width(N)   writeGEQWidthCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_08Width      wroteGEQWidthCh(0, 7, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_09Freq        readGEQFreqCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_09Freq(N)    writeGEQFreqCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_09Freq       wroteGEQFreqCh(0, 8, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_09Level       readGEQLevelCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_09Level(N)   writeGEQLevelCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_09Level      wroteGEQLevelCh(0, 8, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_09Width       readGEQWidthCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_09Width(N)   writeGEQWidthCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_09Width      wroteGEQWidthCh(0, 8, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_010Freq        readGEQFreqCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_010Freq(N)    writeGEQFreqCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_010Freq       wroteGEQFreqCh(0, 9, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_010Level       readGEQLevelCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_010Level(N)   writeGEQLevelCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_010Level      wroteGEQLevelCh(0, 9, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_010Width       readGEQWidthCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_010Width(N)   writeGEQWidthCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_010Width      wroteGEQWidthCh(0, 9, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_011Freq        readGEQFreqCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_011Freq(N)    writeGEQFreqCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_011Freq       wroteGEQFreqCh(0, 10, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_011Level       readGEQLevelCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_011Level(N)   writeGEQLevelCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_011Level      wroteGEQLevelCh(0, 10, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_011Width       readGEQWidthCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_011Width(N)   writeGEQWidthCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_011Width      wroteGEQWidthCh(0, 10, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_012Freq        readGEQFreqCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_012Freq(N)    writeGEQFreqCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_012Freq       wroteGEQFreqCh(0, 11, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_012Level       readGEQLevelCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_012Level(N)   writeGEQLevelCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_012Level      wroteGEQLevelCh(0, 11, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_012Width       readGEQWidthCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_012Width(N)   writeGEQWidthCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_012Width      wroteGEQWidthCh(0, 11, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_013Freq        readGEQFreqCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_013Freq(N)    writeGEQFreqCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_013Freq       wroteGEQFreqCh(0, 12, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_013Level       readGEQLevelCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_013Level(N)   writeGEQLevelCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_013Level      wroteGEQLevelCh(0, 12, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_013Width       readGEQWidthCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_013Width(N)   writeGEQWidthCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_013Width      wroteGEQWidthCh(0, 12, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_014Freq        readGEQFreqCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_014Freq(N)    writeGEQFreqCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_014Freq       wroteGEQFreqCh(0, 13, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_014Level       readGEQLevelCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_014Level(N)   writeGEQLevelCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_014Level      wroteGEQLevelCh(0, 13, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_014Width       readGEQWidthCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_014Width(N)   writeGEQWidthCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_014Width      wroteGEQWidthCh(0, 13, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_015Freq        readGEQFreqCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_015Freq(N)    writeGEQFreqCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_015Freq       wroteGEQFreqCh(0, 14, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_015Level       readGEQLevelCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_015Level(N)   writeGEQLevelCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_015Level      wroteGEQLevelCh(0, 14, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_015Width       readGEQWidthCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_015Width(N)   writeGEQWidthCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_015Width      wroteGEQWidthCh(0, 14, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_016Freq        readGEQFreqCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_016Freq(N)    writeGEQFreqCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_016Freq       wroteGEQFreqCh(0, 15, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_016Level       readGEQLevelCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_016Level(N)   writeGEQLevelCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_016Level      wroteGEQLevelCh(0, 15, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_016Width       readGEQWidthCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_016Width(N)   writeGEQWidthCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_016Width      wroteGEQWidthCh(0, 15, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_017Freq        readGEQFreqCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_017Freq(N)    writeGEQFreqCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_017Freq       wroteGEQFreqCh(0, 16, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_017Level       readGEQLevelCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_017Level(N)   writeGEQLevelCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_017Level      wroteGEQLevelCh(0, 16, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_017Width       readGEQWidthCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_017Width(N)   writeGEQWidthCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_017Width      wroteGEQWidthCh(0, 16, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_018Freq        readGEQFreqCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_018Freq(N)    writeGEQFreqCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_018Freq       wroteGEQFreqCh(0, 17, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_018Level       readGEQLevelCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_018Level(N)   writeGEQLevelCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_018Level      wroteGEQLevelCh(0, 17, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_018Width       readGEQWidthCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_018Width(N)   writeGEQWidthCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_018Width      wroteGEQWidthCh(0, 17, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_019Freq        readGEQFreqCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_019Freq(N)    writeGEQFreqCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_019Freq       wroteGEQFreqCh(0, 18, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_019Level       readGEQLevelCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_019Level(N)   writeGEQLevelCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_019Level      wroteGEQLevelCh(0, 18, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_019Width       readGEQWidthCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_019Width(N)   writeGEQWidthCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_019Width      wroteGEQWidthCh(0, 18, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_020Freq        readGEQFreqCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_020Freq(N)    writeGEQFreqCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_020Freq       wroteGEQFreqCh(0, 19, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_020Level       readGEQLevelCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_020Level(N)   writeGEQLevelCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_020Level      wroteGEQLevelCh(0, 19, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_020Width       readGEQWidthCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_020Width(N)   writeGEQWidthCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_020Width      wroteGEQWidthCh(0, 19, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_021Freq        readGEQFreqCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_021Freq(N)    writeGEQFreqCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_021Freq       wroteGEQFreqCh(0, 20, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_021Level       readGEQLevelCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_021Level(N)   writeGEQLevelCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_021Level      wroteGEQLevelCh(0, 20, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_021Width       readGEQWidthCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_021Width(N)   writeGEQWidthCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_021Width      wroteGEQWidthCh(0, 20, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_022Freq        readGEQFreqCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_022Freq(N)    writeGEQFreqCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_022Freq       wroteGEQFreqCh(0, 21, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_022Level       readGEQLevelCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_022Level(N)   writeGEQLevelCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_022Level      wroteGEQLevelCh(0, 21, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_022Width       readGEQWidthCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_022Width(N)   writeGEQWidthCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_022Width      wroteGEQWidthCh(0, 21, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_023Freq        readGEQFreqCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_023Freq(N)    writeGEQFreqCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_023Freq       wroteGEQFreqCh(0, 22, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_023Level       readGEQLevelCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_023Level(N)   writeGEQLevelCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_023Level      wroteGEQLevelCh(0, 22, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_023Width       readGEQWidthCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_023Width(N)   writeGEQWidthCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_023Width      wroteGEQWidthCh(0, 22, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_024Freq        readGEQFreqCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_024Freq(N)    writeGEQFreqCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_024Freq       wroteGEQFreqCh(0, 23, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_024Level       readGEQLevelCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_024Level(N)   writeGEQLevelCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_024Level      wroteGEQLevelCh(0, 23, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_024Width       readGEQWidthCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_024Width(N)   writeGEQWidthCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_024Width      wroteGEQWidthCh(0, 23, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_025Freq        readGEQFreqCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_025Freq(N)    writeGEQFreqCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_025Freq       wroteGEQFreqCh(0, 24, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_025Level       readGEQLevelCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_025Level(N)   writeGEQLevelCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_025Level      wroteGEQLevelCh(0, 24, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_025Width       readGEQWidthCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_025Width(N)   writeGEQWidthCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_025Width      wroteGEQWidthCh(0, 24, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_026Freq        readGEQFreqCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_026Freq(N)    writeGEQFreqCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_026Freq       wroteGEQFreqCh(0, 25, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_026Level       readGEQLevelCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_026Level(N)   writeGEQLevelCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_026Level      wroteGEQLevelCh(0, 25, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_026Width       readGEQWidthCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_026Width(N)   writeGEQWidthCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_026Width      wroteGEQWidthCh(0, 25, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_027Freq        readGEQFreqCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_027Freq(N)    writeGEQFreqCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_027Freq       wroteGEQFreqCh(0, 26, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_027Level       readGEQLevelCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_027Level(N)   writeGEQLevelCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_027Level      wroteGEQLevelCh(0, 26, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_027Width       readGEQWidthCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_027Width(N)   writeGEQWidthCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_027Width      wroteGEQWidthCh(0, 26, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_028Freq        readGEQFreqCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_028Freq(N)    writeGEQFreqCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_028Freq       wroteGEQFreqCh(0, 27, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_028Level       readGEQLevelCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_028Level(N)   writeGEQLevelCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_028Level      wroteGEQLevelCh(0, 27, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_028Width       readGEQWidthCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_028Width(N)   writeGEQWidthCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_028Width      wroteGEQWidthCh(0, 27, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_029Freq        readGEQFreqCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_029Freq(N)    writeGEQFreqCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_029Freq       wroteGEQFreqCh(0, 28, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_029Level       readGEQLevelCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_029Level(N)   writeGEQLevelCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_029Level      wroteGEQLevelCh(0, 28, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_029Width       readGEQWidthCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_029Width(N)   writeGEQWidthCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_029Width      wroteGEQWidthCh(0, 28, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_030Freq        readGEQFreqCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_030Freq(N)    writeGEQFreqCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_030Freq       wroteGEQFreqCh(0, 29, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_030Level       readGEQLevelCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_030Level(N)   writeGEQLevelCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_030Level      wroteGEQLevelCh(0, 29, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_030Width       readGEQWidthCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_030Width(N)   writeGEQWidthCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_030Width      wroteGEQWidthCh(0, 29, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_031Freq        readGEQFreqCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_031Freq(N)    writeGEQFreqCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_031Freq       wroteGEQFreqCh(0, 30, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_031Level       readGEQLevelCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_031Level(N)   writeGEQLevelCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_031Level      wroteGEQLevelCh(0, 30, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_031Width       readGEQWidthCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_031Width(N)   writeGEQWidthCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_031Width      wroteGEQWidthCh(0, 30, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_032Freq        readGEQFreqCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_032Freq(N)    writeGEQFreqCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_032Freq       wroteGEQFreqCh(0, 31, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_032Level       readGEQLevelCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_032Level(N)   writeGEQLevelCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_032Level      wroteGEQLevelCh(0, 31, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_032Width       readGEQWidthCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_032Width(N)   writeGEQWidthCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_032Width      wroteGEQWidthCh(0, 31, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n1Freq        readGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n1Freq(N)    writeGEQFreqCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n1Freq       wroteGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n1Level       readGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n1Level(N)   writeGEQLevelCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n1Level      wroteGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n1Width       readGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n1Width(N)   writeGEQWidthCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n1Width      wroteGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n2Freq        readGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n2Freq(N)    writeGEQFreqCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n2Freq       wroteGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n2Level       readGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n2Level(N)   writeGEQLevelCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n2Level      wroteGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n2Width       readGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n2Width(N)   writeGEQWidthCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n2Width      wroteGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n3Freq        readGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n3Freq(N)    writeGEQFreqCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n3Freq       wroteGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n3Level       readGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n3Level(N)   writeGEQLevelCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n3Level      wroteGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n3Width       readGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n3Width(N)   writeGEQWidthCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n3Width      wroteGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n4Freq        readGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n4Freq(N)    writeGEQFreqCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n4Freq       wroteGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n4Level       readGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n4Level(N)   writeGEQLevelCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n4Level      wroteGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n4Width       readGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n4Width(N)   writeGEQWidthCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n4Width      wroteGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n5Freq        readGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n5Freq(N)    writeGEQFreqCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n5Freq       wroteGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n5Level       readGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n5Level(N)   writeGEQLevelCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n5Level      wroteGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n5Width       readGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n5Width(N)   writeGEQWidthCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n5Width      wroteGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n6Freq        readGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n6Freq(N)    writeGEQFreqCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n6Freq       wroteGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n6Level       readGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n6Level(N)   writeGEQLevelCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n6Level      wroteGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n6Width       readGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n6Width(N)   writeGEQWidthCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n6Width      wroteGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n7Freq        readGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n7Freq(N)    writeGEQFreqCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n7Freq       wroteGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n7Level       readGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n7Level(N)   writeGEQLevelCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n7Level      wroteGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n7Width       readGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n7Width(N)   writeGEQWidthCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n7Width      wroteGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n8Freq        readGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n8Freq(N)    writeGEQFreqCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n8Freq       wroteGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n8Level       readGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n8Level(N)   writeGEQLevelCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n8Level      wroteGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n8Width       readGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n8Width(N)   writeGEQWidthCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n8Width      wroteGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n9Freq        readGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n9Freq(N)    writeGEQFreqCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n9Freq       wroteGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n9Level       readGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n9Level(N)   writeGEQLevelCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n9Level      wroteGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n9Width       readGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n9Width(N)   writeGEQWidthCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n9Width      wroteGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n10Freq        readGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n10Freq(N)    writeGEQFreqCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n10Freq       wroteGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n10Level       readGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n10Level(N)   writeGEQLevelCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n10Level      wroteGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n10Width       readGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n10Width(N)   writeGEQWidthCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n10Width      wroteGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n11Freq        readGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n11Freq(N)    writeGEQFreqCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n11Freq       wroteGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n11Level       readGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n11Level(N)   writeGEQLevelCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n11Level      wroteGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n11Width       readGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n11Width(N)   writeGEQWidthCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n11Width      wroteGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n12Freq        readGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n12Freq(N)    writeGEQFreqCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n12Freq       wroteGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n12Level       readGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n12Level(N)   writeGEQLevelCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n12Level      wroteGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n12Width       readGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n12Width(N)   writeGEQWidthCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n12Width      wroteGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n13Freq        readGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n13Freq(N)    writeGEQFreqCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n13Freq       wroteGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n13Level       readGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n13Level(N)   writeGEQLevelCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n13Level      wroteGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n13Width       readGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n13Width(N)   writeGEQWidthCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n13Width      wroteGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n14Freq        readGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n14Freq(N)    writeGEQFreqCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n14Freq       wroteGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n14Level       readGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n14Level(N)   writeGEQLevelCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n14Level      wroteGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n14Width       readGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n14Width(N)   writeGEQWidthCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n14Width      wroteGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n15Freq        readGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n15Freq(N)    writeGEQFreqCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n15Freq       wroteGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n15Level       readGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n15Level(N)   writeGEQLevelCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n15Level      wroteGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n15Width       readGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n15Width(N)   writeGEQWidthCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n15Width      wroteGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n16Freq        readGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n16Freq(N)    writeGEQFreqCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n16Freq       wroteGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n16Level       readGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n16Level(N)   writeGEQLevelCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n16Level      wroteGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n16Width       readGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n16Width(N)   writeGEQWidthCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n16Width      wroteGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n17Freq        readGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n17Freq(N)    writeGEQFreqCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n17Freq       wroteGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n17Level       readGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n17Level(N)   writeGEQLevelCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n17Level      wroteGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n17Width       readGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n17Width(N)   writeGEQWidthCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n17Width      wroteGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n18Freq        readGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n18Freq(N)    writeGEQFreqCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n18Freq       wroteGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n18Level       readGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n18Level(N)   writeGEQLevelCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n18Level      wroteGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n18Width       readGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n18Width(N)   writeGEQWidthCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n18Width      wroteGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n19Freq        readGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n19Freq(N)    writeGEQFreqCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n19Freq       wroteGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n19Level       readGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n19Level(N)   writeGEQLevelCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n19Level      wroteGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n19Width       readGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n19Width(N)   writeGEQWidthCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n19Width      wroteGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n20Freq        readGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n20Freq(N)    writeGEQFreqCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n20Freq       wroteGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n20Level       readGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n20Level(N)   writeGEQLevelCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n20Level      wroteGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n20Width       readGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n20Width(N)   writeGEQWidthCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n20Width      wroteGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n21Freq        readGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n21Freq(N)    writeGEQFreqCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n21Freq       wroteGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n21Level       readGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n21Level(N)   writeGEQLevelCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n21Level      wroteGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n21Width       readGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n21Width(N)   writeGEQWidthCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n21Width      wroteGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n22Freq        readGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n22Freq(N)    writeGEQFreqCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n22Freq       wroteGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n22Level       readGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n22Level(N)   writeGEQLevelCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n22Level      wroteGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n22Width       readGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n22Width(N)   writeGEQWidthCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n22Width      wroteGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n23Freq        readGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n23Freq(N)    writeGEQFreqCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n23Freq       wroteGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n23Level       readGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n23Level(N)   writeGEQLevelCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n23Level      wroteGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n23Width       readGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n23Width(N)   writeGEQWidthCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n23Width      wroteGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n24Freq        readGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n24Freq(N)    writeGEQFreqCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n24Freq       wroteGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n24Level       readGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n24Level(N)   writeGEQLevelCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n24Level      wroteGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n24Width       readGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n24Width(N)   writeGEQWidthCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n24Width      wroteGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n25Freq        readGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n25Freq(N)    writeGEQFreqCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n25Freq       wroteGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n25Level       readGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n25Level(N)   writeGEQLevelCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n25Level      wroteGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n25Width       readGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n25Width(N)   writeGEQWidthCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n25Width      wroteGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n26Freq        readGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n26Freq(N)    writeGEQFreqCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n26Freq       wroteGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n26Level       readGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n26Level(N)   writeGEQLevelCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n26Level      wroteGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n26Width       readGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n26Width(N)   writeGEQWidthCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n26Width      wroteGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n27Freq        readGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n27Freq(N)    writeGEQFreqCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n27Freq       wroteGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n27Level       readGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n27Level(N)   writeGEQLevelCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n27Level      wroteGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n27Width       readGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n27Width(N)   writeGEQWidthCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n27Width      wroteGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n28Freq        readGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n28Freq(N)    writeGEQFreqCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n28Freq       wroteGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n28Level       readGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n28Level(N)   writeGEQLevelCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n28Level      wroteGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n28Width       readGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n28Width(N)   writeGEQWidthCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n28Width      wroteGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n29Freq        readGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n29Freq(N)    writeGEQFreqCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n29Freq       wroteGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n29Level       readGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n29Level(N)   writeGEQLevelCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n29Level      wroteGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n29Width       readGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n29Width(N)   writeGEQWidthCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n29Width      wroteGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n30Freq        readGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n30Freq(N)    writeGEQFreqCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n30Freq       wroteGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n30Level       readGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n30Level(N)   writeGEQLevelCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n30Level      wroteGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n30Width       readGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n30Width(N)   writeGEQWidthCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n30Width      wroteGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n31Freq        readGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n31Freq(N)    writeGEQFreqCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n31Freq       wroteGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n31Level       readGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n31Level(N)   writeGEQLevelCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n31Level      wroteGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n31Width       readGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n31Width(N)   writeGEQWidthCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n31Width      wroteGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)

#define  readGEQFrnt_n32Freq        readGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n32Freq(N)    writeGEQFreqCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n32Freq       wroteGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n32Level       readGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n32Level(N)   writeGEQLevelCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n32Level      wroteGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQFrnt_n32Width       readGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQFrnt_n32Width(N)   writeGEQWidthCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQFrnt_n32Width      wroteGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)

#define  readGEQRear_01Freq        readGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQRear_01Freq(N)    writeGEQFreqCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_01Freq       wroteGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQRear_01Level       readGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQRear_01Level(N)   writeGEQLevelCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_01Level      wroteGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQRear_01Width       readGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQRear_01Width(N)   writeGEQWidthCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_01Width      wroteGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)

#define  readGEQRear_02Freq        readGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQRear_02Freq(N)    writeGEQFreqCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_02Freq       wroteGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQRear_02Level       readGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQRear_02Level(N)   writeGEQLevelCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_02Level      wroteGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQRear_02Width       readGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQRear_02Width(N)   writeGEQWidthCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_02Width      wroteGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)

#define  readGEQRear_03Freq        readGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQRear_03Freq(N)    writeGEQFreqCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_03Freq       wroteGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQRear_03Level       readGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQRear_03Level(N)   writeGEQLevelCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_03Level      wroteGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQRear_03Width       readGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQRear_03Width(N)   writeGEQWidthCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_03Width      wroteGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)

#define  readGEQRear_04Freq        readGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQRear_04Freq(N)    writeGEQFreqCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_04Freq       wroteGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQRear_04Level       readGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQRear_04Level(N)   writeGEQLevelCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_04Level      wroteGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQRear_04Width       readGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQRear_04Width(N)   writeGEQWidthCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_04Width      wroteGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)

#define  readGEQRear_05Freq        readGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQRear_05Freq(N)    writeGEQFreqCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_05Freq       wroteGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQRear_05Level       readGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQRear_05Level(N)   writeGEQLevelCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_05Level      wroteGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQRear_05Width       readGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQRear_05Width(N)   writeGEQWidthCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_05Width      wroteGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)

#define  readGEQRear_06Freq        readGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQRear_06Freq(N)    writeGEQFreqCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_06Freq       wroteGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQRear_06Level       readGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQRear_06Level(N)   writeGEQLevelCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_06Level      wroteGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQRear_06Width       readGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQRear_06Width(N)   writeGEQWidthCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_06Width      wroteGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)

#define  readGEQRear_07Freq        readGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQRear_07Freq(N)    writeGEQFreqCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_07Freq       wroteGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQRear_07Level       readGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQRear_07Level(N)   writeGEQLevelCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_07Level      wroteGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQRear_07Width       readGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQRear_07Width(N)   writeGEQWidthCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_07Width      wroteGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)

#define  readGEQRear_08Freq        readGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQRear_08Freq(N)    writeGEQFreqCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_08Freq       wroteGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQRear_08Level       readGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQRear_08Level(N)   writeGEQLevelCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_08Level      wroteGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQRear_08Width       readGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQRear_08Width(N)   writeGEQWidthCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_08Width      wroteGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)

#define  readGEQRear_09Freq        readGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQRear_09Freq(N)    writeGEQFreqCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_09Freq       wroteGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQRear_09Level       readGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQRear_09Level(N)   writeGEQLevelCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_09Level      wroteGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQRear_09Width       readGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQRear_09Width(N)   writeGEQWidthCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_09Width      wroteGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)

#define  readGEQRear_010Freq        readGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQRear_010Freq(N)    writeGEQFreqCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_010Freq       wroteGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQRear_010Level       readGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQRear_010Level(N)   writeGEQLevelCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_010Level      wroteGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQRear_010Width       readGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQRear_010Width(N)   writeGEQWidthCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_010Width      wroteGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)

#define  readGEQRear_011Freq        readGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQRear_011Freq(N)    writeGEQFreqCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_011Freq       wroteGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQRear_011Level       readGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQRear_011Level(N)   writeGEQLevelCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_011Level      wroteGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQRear_011Width       readGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQRear_011Width(N)   writeGEQWidthCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_011Width      wroteGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)

#define  readGEQRear_012Freq        readGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQRear_012Freq(N)    writeGEQFreqCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_012Freq       wroteGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQRear_012Level       readGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQRear_012Level(N)   writeGEQLevelCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_012Level      wroteGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQRear_012Width       readGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQRear_012Width(N)   writeGEQWidthCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_012Width      wroteGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)

#define  readGEQRear_013Freq        readGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQRear_013Freq(N)    writeGEQFreqCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_013Freq       wroteGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQRear_013Level       readGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQRear_013Level(N)   writeGEQLevelCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_013Level      wroteGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQRear_013Width       readGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQRear_013Width(N)   writeGEQWidthCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_013Width      wroteGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)

#define  readGEQRear_014Freq        readGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQRear_014Freq(N)    writeGEQFreqCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_014Freq       wroteGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQRear_014Level       readGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQRear_014Level(N)   writeGEQLevelCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_014Level      wroteGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQRear_014Width       readGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQRear_014Width(N)   writeGEQWidthCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_014Width      wroteGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)

#define  readGEQRear_015Freq        readGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQRear_015Freq(N)    writeGEQFreqCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_015Freq       wroteGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQRear_015Level       readGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQRear_015Level(N)   writeGEQLevelCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_015Level      wroteGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQRear_015Width       readGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQRear_015Width(N)   writeGEQWidthCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_015Width      wroteGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)

#define  readGEQRear_016Freq        readGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQRear_016Freq(N)    writeGEQFreqCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_016Freq       wroteGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQRear_016Level       readGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQRear_016Level(N)   writeGEQLevelCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_016Level      wroteGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQRear_016Width       readGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQRear_016Width(N)   writeGEQWidthCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_016Width      wroteGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)

#define  readGEQRear_017Freq        readGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQRear_017Freq(N)    writeGEQFreqCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_017Freq       wroteGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQRear_017Level       readGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQRear_017Level(N)   writeGEQLevelCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_017Level      wroteGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQRear_017Width       readGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQRear_017Width(N)   writeGEQWidthCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_017Width      wroteGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)

#define  readGEQRear_018Freq        readGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQRear_018Freq(N)    writeGEQFreqCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_018Freq       wroteGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQRear_018Level       readGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQRear_018Level(N)   writeGEQLevelCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_018Level      wroteGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQRear_018Width       readGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQRear_018Width(N)   writeGEQWidthCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_018Width      wroteGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)

#define  readGEQRear_019Freq        readGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQRear_019Freq(N)    writeGEQFreqCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_019Freq       wroteGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQRear_019Level       readGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQRear_019Level(N)   writeGEQLevelCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_019Level      wroteGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQRear_019Width       readGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQRear_019Width(N)   writeGEQWidthCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_019Width      wroteGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)

#define  readGEQRear_020Freq        readGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQRear_020Freq(N)    writeGEQFreqCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_020Freq       wroteGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQRear_020Level       readGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQRear_020Level(N)   writeGEQLevelCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_020Level      wroteGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQRear_020Width       readGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQRear_020Width(N)   writeGEQWidthCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_020Width      wroteGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)

#define  readGEQRear_021Freq        readGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQRear_021Freq(N)    writeGEQFreqCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_021Freq       wroteGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQRear_021Level       readGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQRear_021Level(N)   writeGEQLevelCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_021Level      wroteGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQRear_021Width       readGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQRear_021Width(N)   writeGEQWidthCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_021Width      wroteGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)

#define  readGEQRear_022Freq        readGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQRear_022Freq(N)    writeGEQFreqCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_022Freq       wroteGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQRear_022Level       readGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQRear_022Level(N)   writeGEQLevelCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_022Level      wroteGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQRear_022Width       readGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQRear_022Width(N)   writeGEQWidthCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_022Width      wroteGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)

#define  readGEQRear_023Freq        readGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQRear_023Freq(N)    writeGEQFreqCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_023Freq       wroteGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQRear_023Level       readGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQRear_023Level(N)   writeGEQLevelCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_023Level      wroteGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQRear_023Width       readGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQRear_023Width(N)   writeGEQWidthCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_023Width      wroteGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)

#define  readGEQRear_024Freq        readGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQRear_024Freq(N)    writeGEQFreqCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_024Freq       wroteGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQRear_024Level       readGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQRear_024Level(N)   writeGEQLevelCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_024Level      wroteGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQRear_024Width       readGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQRear_024Width(N)   writeGEQWidthCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_024Width      wroteGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)

#define  readGEQRear_025Freq        readGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQRear_025Freq(N)    writeGEQFreqCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_025Freq       wroteGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQRear_025Level       readGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQRear_025Level(N)   writeGEQLevelCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_025Level      wroteGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQRear_025Width       readGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQRear_025Width(N)   writeGEQWidthCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_025Width      wroteGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)

#define  readGEQRear_026Freq        readGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQRear_026Freq(N)    writeGEQFreqCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_026Freq       wroteGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQRear_026Level       readGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQRear_026Level(N)   writeGEQLevelCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_026Level      wroteGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQRear_026Width       readGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQRear_026Width(N)   writeGEQWidthCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_026Width      wroteGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)

#define  readGEQRear_027Freq        readGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQRear_027Freq(N)    writeGEQFreqCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_027Freq       wroteGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQRear_027Level       readGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQRear_027Level(N)   writeGEQLevelCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_027Level      wroteGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQRear_027Width       readGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQRear_027Width(N)   writeGEQWidthCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_027Width      wroteGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)

#define  readGEQRear_028Freq        readGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQRear_028Freq(N)    writeGEQFreqCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_028Freq       wroteGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQRear_028Level       readGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQRear_028Level(N)   writeGEQLevelCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_028Level      wroteGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQRear_028Width       readGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQRear_028Width(N)   writeGEQWidthCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_028Width      wroteGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)

#define  readGEQRear_029Freq        readGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQRear_029Freq(N)    writeGEQFreqCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_029Freq       wroteGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQRear_029Level       readGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQRear_029Level(N)   writeGEQLevelCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_029Level      wroteGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQRear_029Width       readGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQRear_029Width(N)   writeGEQWidthCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_029Width      wroteGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)

#define  readGEQRear_030Freq        readGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQRear_030Freq(N)    writeGEQFreqCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_030Freq       wroteGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQRear_030Level       readGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQRear_030Level(N)   writeGEQLevelCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_030Level      wroteGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQRear_030Width       readGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQRear_030Width(N)   writeGEQWidthCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_030Width      wroteGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)

#define  readGEQRear_031Freq        readGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQRear_031Freq(N)    writeGEQFreqCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_031Freq       wroteGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQRear_031Level       readGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQRear_031Level(N)   writeGEQLevelCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_031Level      wroteGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQRear_031Width       readGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQRear_031Width(N)   writeGEQWidthCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_031Width      wroteGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)

#define  readGEQRear_032Freq        readGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQRear_032Freq(N)    writeGEQFreqCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_032Freq       wroteGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQRear_032Level       readGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQRear_032Level(N)   writeGEQLevelCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_032Level      wroteGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQRear_032Width       readGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQRear_032Width(N)   writeGEQWidthCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_032Width      wroteGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)

#define  readGEQRear_n1Freq        readGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQRear_n1Freq(N)    writeGEQFreqCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n1Freq       wroteGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQRear_n1Level       readGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQRear_n1Level(N)   writeGEQLevelCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n1Level      wroteGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQRear_n1Width       readGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQRear_n1Width(N)   writeGEQWidthCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n1Width      wroteGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)

#define  readGEQRear_n2Freq        readGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQRear_n2Freq(N)    writeGEQFreqCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n2Freq       wroteGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQRear_n2Level       readGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQRear_n2Level(N)   writeGEQLevelCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n2Level      wroteGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQRear_n2Width       readGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQRear_n2Width(N)   writeGEQWidthCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n2Width      wroteGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)

#define  readGEQRear_n3Freq        readGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQRear_n3Freq(N)    writeGEQFreqCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n3Freq       wroteGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQRear_n3Level       readGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQRear_n3Level(N)   writeGEQLevelCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n3Level      wroteGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQRear_n3Width       readGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQRear_n3Width(N)   writeGEQWidthCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n3Width      wroteGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)

#define  readGEQRear_n4Freq        readGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQRear_n4Freq(N)    writeGEQFreqCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n4Freq       wroteGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQRear_n4Level       readGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQRear_n4Level(N)   writeGEQLevelCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n4Level      wroteGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQRear_n4Width       readGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQRear_n4Width(N)   writeGEQWidthCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n4Width      wroteGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)

#define  readGEQRear_n5Freq        readGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQRear_n5Freq(N)    writeGEQFreqCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n5Freq       wroteGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQRear_n5Level       readGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQRear_n5Level(N)   writeGEQLevelCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n5Level      wroteGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQRear_n5Width       readGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQRear_n5Width(N)   writeGEQWidthCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n5Width      wroteGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)

#define  readGEQRear_n6Freq        readGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQRear_n6Freq(N)    writeGEQFreqCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n6Freq       wroteGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQRear_n6Level       readGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQRear_n6Level(N)   writeGEQLevelCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n6Level      wroteGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQRear_n6Width       readGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQRear_n6Width(N)   writeGEQWidthCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n6Width      wroteGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)

#define  readGEQRear_n7Freq        readGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQRear_n7Freq(N)    writeGEQFreqCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n7Freq       wroteGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQRear_n7Level       readGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQRear_n7Level(N)   writeGEQLevelCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n7Level      wroteGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQRear_n7Width       readGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQRear_n7Width(N)   writeGEQWidthCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n7Width      wroteGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)

#define  readGEQRear_n8Freq        readGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQRear_n8Freq(N)    writeGEQFreqCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n8Freq       wroteGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQRear_n8Level       readGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQRear_n8Level(N)   writeGEQLevelCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n8Level      wroteGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQRear_n8Width       readGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQRear_n8Width(N)   writeGEQWidthCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n8Width      wroteGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)

#define  readGEQRear_n9Freq        readGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQRear_n9Freq(N)    writeGEQFreqCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n9Freq       wroteGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQRear_n9Level       readGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQRear_n9Level(N)   writeGEQLevelCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n9Level      wroteGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQRear_n9Width       readGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQRear_n9Width(N)   writeGEQWidthCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n9Width      wroteGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)

#define  readGEQRear_n10Freq        readGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQRear_n10Freq(N)    writeGEQFreqCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n10Freq       wroteGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQRear_n10Level       readGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQRear_n10Level(N)   writeGEQLevelCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n10Level      wroteGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQRear_n10Width       readGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQRear_n10Width(N)   writeGEQWidthCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n10Width      wroteGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)

#define  readGEQRear_n11Freq        readGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQRear_n11Freq(N)    writeGEQFreqCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n11Freq       wroteGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQRear_n11Level       readGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQRear_n11Level(N)   writeGEQLevelCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n11Level      wroteGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQRear_n11Width       readGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQRear_n11Width(N)   writeGEQWidthCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n11Width      wroteGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)

#define  readGEQRear_n12Freq        readGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQRear_n12Freq(N)    writeGEQFreqCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n12Freq       wroteGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQRear_n12Level       readGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQRear_n12Level(N)   writeGEQLevelCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n12Level      wroteGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQRear_n12Width       readGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQRear_n12Width(N)   writeGEQWidthCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n12Width      wroteGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)

#define  readGEQRear_n13Freq        readGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQRear_n13Freq(N)    writeGEQFreqCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n13Freq       wroteGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQRear_n13Level       readGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQRear_n13Level(N)   writeGEQLevelCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n13Level      wroteGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQRear_n13Width       readGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQRear_n13Width(N)   writeGEQWidthCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n13Width      wroteGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)

#define  readGEQRear_n14Freq        readGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQRear_n14Freq(N)    writeGEQFreqCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n14Freq       wroteGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQRear_n14Level       readGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQRear_n14Level(N)   writeGEQLevelCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n14Level      wroteGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQRear_n14Width       readGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQRear_n14Width(N)   writeGEQWidthCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n14Width      wroteGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)

#define  readGEQRear_n15Freq        readGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQRear_n15Freq(N)    writeGEQFreqCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n15Freq       wroteGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQRear_n15Level       readGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQRear_n15Level(N)   writeGEQLevelCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n15Level      wroteGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQRear_n15Width       readGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQRear_n15Width(N)   writeGEQWidthCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n15Width      wroteGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)

#define  readGEQRear_n16Freq        readGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQRear_n16Freq(N)    writeGEQFreqCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n16Freq       wroteGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQRear_n16Level       readGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQRear_n16Level(N)   writeGEQLevelCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n16Level      wroteGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQRear_n16Width       readGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQRear_n16Width(N)   writeGEQWidthCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n16Width      wroteGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)

#define  readGEQRear_n17Freq        readGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQRear_n17Freq(N)    writeGEQFreqCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n17Freq       wroteGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQRear_n17Level       readGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQRear_n17Level(N)   writeGEQLevelCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n17Level      wroteGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQRear_n17Width       readGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQRear_n17Width(N)   writeGEQWidthCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n17Width      wroteGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)

#define  readGEQRear_n18Freq        readGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQRear_n18Freq(N)    writeGEQFreqCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n18Freq       wroteGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQRear_n18Level       readGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQRear_n18Level(N)   writeGEQLevelCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n18Level      wroteGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQRear_n18Width       readGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQRear_n18Width(N)   writeGEQWidthCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n18Width      wroteGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)

#define  readGEQRear_n19Freq        readGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQRear_n19Freq(N)    writeGEQFreqCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n19Freq       wroteGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQRear_n19Level       readGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQRear_n19Level(N)   writeGEQLevelCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n19Level      wroteGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQRear_n19Width       readGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQRear_n19Width(N)   writeGEQWidthCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n19Width      wroteGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)

#define  readGEQRear_n20Freq        readGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQRear_n20Freq(N)    writeGEQFreqCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n20Freq       wroteGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQRear_n20Level       readGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQRear_n20Level(N)   writeGEQLevelCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n20Level      wroteGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQRear_n20Width       readGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQRear_n20Width(N)   writeGEQWidthCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n20Width      wroteGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)

#define  readGEQRear_n21Freq        readGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQRear_n21Freq(N)    writeGEQFreqCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n21Freq       wroteGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQRear_n21Level       readGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQRear_n21Level(N)   writeGEQLevelCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n21Level      wroteGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQRear_n21Width       readGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQRear_n21Width(N)   writeGEQWidthCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n21Width      wroteGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)

#define  readGEQRear_n22Freq        readGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQRear_n22Freq(N)    writeGEQFreqCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n22Freq       wroteGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQRear_n22Level       readGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQRear_n22Level(N)   writeGEQLevelCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n22Level      wroteGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQRear_n22Width       readGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQRear_n22Width(N)   writeGEQWidthCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n22Width      wroteGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)

#define  readGEQRear_n23Freq        readGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQRear_n23Freq(N)    writeGEQFreqCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n23Freq       wroteGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQRear_n23Level       readGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQRear_n23Level(N)   writeGEQLevelCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n23Level      wroteGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQRear_n23Width       readGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQRear_n23Width(N)   writeGEQWidthCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n23Width      wroteGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)

#define  readGEQRear_n24Freq        readGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQRear_n24Freq(N)    writeGEQFreqCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n24Freq       wroteGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQRear_n24Level       readGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQRear_n24Level(N)   writeGEQLevelCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n24Level      wroteGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQRear_n24Width       readGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQRear_n24Width(N)   writeGEQWidthCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n24Width      wroteGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)

#define  readGEQRear_n25Freq        readGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQRear_n25Freq(N)    writeGEQFreqCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n25Freq       wroteGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQRear_n25Level       readGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQRear_n25Level(N)   writeGEQLevelCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n25Level      wroteGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQRear_n25Width       readGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQRear_n25Width(N)   writeGEQWidthCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n25Width      wroteGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)

#define  readGEQRear_n26Freq        readGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQRear_n26Freq(N)    writeGEQFreqCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n26Freq       wroteGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQRear_n26Level       readGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQRear_n26Level(N)   writeGEQLevelCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n26Level      wroteGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQRear_n26Width       readGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQRear_n26Width(N)   writeGEQWidthCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n26Width      wroteGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)

#define  readGEQRear_n27Freq        readGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQRear_n27Freq(N)    writeGEQFreqCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n27Freq       wroteGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQRear_n27Level       readGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQRear_n27Level(N)   writeGEQLevelCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n27Level      wroteGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQRear_n27Width       readGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQRear_n27Width(N)   writeGEQWidthCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n27Width      wroteGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)

#define  readGEQRear_n28Freq        readGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQRear_n28Freq(N)    writeGEQFreqCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n28Freq       wroteGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQRear_n28Level       readGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQRear_n28Level(N)   writeGEQLevelCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n28Level      wroteGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQRear_n28Width       readGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQRear_n28Width(N)   writeGEQWidthCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n28Width      wroteGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)

#define  readGEQRear_n29Freq        readGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQRear_n29Freq(N)    writeGEQFreqCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n29Freq       wroteGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQRear_n29Level       readGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQRear_n29Level(N)   writeGEQLevelCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n29Level      wroteGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQRear_n29Width       readGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQRear_n29Width(N)   writeGEQWidthCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n29Width      wroteGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)

#define  readGEQRear_n30Freq        readGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQRear_n30Freq(N)    writeGEQFreqCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n30Freq       wroteGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQRear_n30Level       readGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQRear_n30Level(N)   writeGEQLevelCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n30Level      wroteGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQRear_n30Width       readGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQRear_n30Width(N)   writeGEQWidthCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n30Width      wroteGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)

#define  readGEQRear_n31Freq        readGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQRear_n31Freq(N)    writeGEQFreqCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n31Freq       wroteGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQRear_n31Level       readGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQRear_n31Level(N)   writeGEQLevelCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n31Level      wroteGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQRear_n31Width       readGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQRear_n31Width(N)   writeGEQWidthCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n31Width      wroteGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)

#define  readGEQRear_n32Freq        readGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQRear_n32Freq(N)    writeGEQFreqCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n32Freq       wroteGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQRear_n32Level       readGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQRear_n32Level(N)   writeGEQLevelCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n32Level      wroteGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQRear_n32Width       readGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQRear_n32Width(N)   writeGEQWidthCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQRear_n32Width      wroteGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)

#define  readGEQBass_01Freq        readGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQBass_01Freq(N)    writeGEQFreqCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_01Freq       wroteGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQBass_01Level       readGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQBass_01Level(N)   writeGEQLevelCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_01Level      wroteGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQBass_01Width       readGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQBass_01Width(N)   writeGEQWidthCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_01Width      wroteGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)

#define  readGEQBass_02Freq        readGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQBass_02Freq(N)    writeGEQFreqCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_02Freq       wroteGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQBass_02Level       readGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQBass_02Level(N)   writeGEQLevelCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_02Level      wroteGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQBass_02Width       readGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQBass_02Width(N)   writeGEQWidthCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_02Width      wroteGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)

#define  readGEQBass_03Freq        readGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQBass_03Freq(N)    writeGEQFreqCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_03Freq       wroteGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQBass_03Level       readGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQBass_03Level(N)   writeGEQLevelCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_03Level      wroteGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQBass_03Width       readGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQBass_03Width(N)   writeGEQWidthCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_03Width      wroteGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)

#define  readGEQBass_04Freq        readGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQBass_04Freq(N)    writeGEQFreqCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_04Freq       wroteGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQBass_04Level       readGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQBass_04Level(N)   writeGEQLevelCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_04Level      wroteGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQBass_04Width       readGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQBass_04Width(N)   writeGEQWidthCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_04Width      wroteGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)

#define  readGEQBass_05Freq        readGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQBass_05Freq(N)    writeGEQFreqCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_05Freq       wroteGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQBass_05Level       readGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQBass_05Level(N)   writeGEQLevelCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_05Level      wroteGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQBass_05Width       readGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQBass_05Width(N)   writeGEQWidthCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_05Width      wroteGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)

#define  readGEQBass_06Freq        readGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQBass_06Freq(N)    writeGEQFreqCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_06Freq       wroteGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQBass_06Level       readGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQBass_06Level(N)   writeGEQLevelCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_06Level      wroteGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQBass_06Width       readGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQBass_06Width(N)   writeGEQWidthCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_06Width      wroteGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)

#define  readGEQBass_07Freq        readGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQBass_07Freq(N)    writeGEQFreqCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_07Freq       wroteGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQBass_07Level       readGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQBass_07Level(N)   writeGEQLevelCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_07Level      wroteGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQBass_07Width       readGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQBass_07Width(N)   writeGEQWidthCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_07Width      wroteGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)

#define  readGEQBass_08Freq        readGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQBass_08Freq(N)    writeGEQFreqCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_08Freq       wroteGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQBass_08Level       readGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQBass_08Level(N)   writeGEQLevelCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_08Level      wroteGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQBass_08Width       readGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQBass_08Width(N)   writeGEQWidthCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_08Width      wroteGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)

#define  readGEQBass_09Freq        readGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQBass_09Freq(N)    writeGEQFreqCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_09Freq       wroteGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQBass_09Level       readGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQBass_09Level(N)   writeGEQLevelCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_09Level      wroteGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQBass_09Width       readGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQBass_09Width(N)   writeGEQWidthCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_09Width      wroteGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)

#define  readGEQBass_010Freq        readGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQBass_010Freq(N)    writeGEQFreqCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_010Freq       wroteGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQBass_010Level       readGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQBass_010Level(N)   writeGEQLevelCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_010Level      wroteGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQBass_010Width       readGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQBass_010Width(N)   writeGEQWidthCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_010Width      wroteGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)

#define  readGEQBass_011Freq        readGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQBass_011Freq(N)    writeGEQFreqCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_011Freq       wroteGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQBass_011Level       readGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQBass_011Level(N)   writeGEQLevelCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_011Level      wroteGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQBass_011Width       readGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQBass_011Width(N)   writeGEQWidthCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_011Width      wroteGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)

#define  readGEQBass_012Freq        readGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQBass_012Freq(N)    writeGEQFreqCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_012Freq       wroteGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQBass_012Level       readGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQBass_012Level(N)   writeGEQLevelCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_012Level      wroteGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQBass_012Width       readGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQBass_012Width(N)   writeGEQWidthCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_012Width      wroteGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)

#define  readGEQBass_013Freq        readGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQBass_013Freq(N)    writeGEQFreqCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_013Freq       wroteGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQBass_013Level       readGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQBass_013Level(N)   writeGEQLevelCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_013Level      wroteGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQBass_013Width       readGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQBass_013Width(N)   writeGEQWidthCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_013Width      wroteGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)

#define  readGEQBass_014Freq        readGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQBass_014Freq(N)    writeGEQFreqCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_014Freq       wroteGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQBass_014Level       readGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQBass_014Level(N)   writeGEQLevelCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_014Level      wroteGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQBass_014Width       readGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQBass_014Width(N)   writeGEQWidthCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_014Width      wroteGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)

#define  readGEQBass_015Freq        readGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQBass_015Freq(N)    writeGEQFreqCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_015Freq       wroteGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQBass_015Level       readGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQBass_015Level(N)   writeGEQLevelCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_015Level      wroteGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQBass_015Width       readGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQBass_015Width(N)   writeGEQWidthCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_015Width      wroteGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)

#define  readGEQBass_016Freq        readGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQBass_016Freq(N)    writeGEQFreqCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_016Freq       wroteGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQBass_016Level       readGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQBass_016Level(N)   writeGEQLevelCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_016Level      wroteGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQBass_016Width       readGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQBass_016Width(N)   writeGEQWidthCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_016Width      wroteGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)

#define  readGEQBass_017Freq        readGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQBass_017Freq(N)    writeGEQFreqCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_017Freq       wroteGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQBass_017Level       readGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQBass_017Level(N)   writeGEQLevelCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_017Level      wroteGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQBass_017Width       readGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQBass_017Width(N)   writeGEQWidthCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_017Width      wroteGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)

#define  readGEQBass_018Freq        readGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQBass_018Freq(N)    writeGEQFreqCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_018Freq       wroteGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQBass_018Level       readGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQBass_018Level(N)   writeGEQLevelCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_018Level      wroteGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQBass_018Width       readGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQBass_018Width(N)   writeGEQWidthCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_018Width      wroteGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)

#define  readGEQBass_019Freq        readGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQBass_019Freq(N)    writeGEQFreqCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_019Freq       wroteGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQBass_019Level       readGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQBass_019Level(N)   writeGEQLevelCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_019Level      wroteGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQBass_019Width       readGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQBass_019Width(N)   writeGEQWidthCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_019Width      wroteGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)

#define  readGEQBass_020Freq        readGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQBass_020Freq(N)    writeGEQFreqCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_020Freq       wroteGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQBass_020Level       readGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQBass_020Level(N)   writeGEQLevelCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_020Level      wroteGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQBass_020Width       readGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQBass_020Width(N)   writeGEQWidthCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_020Width      wroteGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)

#define  readGEQBass_021Freq        readGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQBass_021Freq(N)    writeGEQFreqCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_021Freq       wroteGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQBass_021Level       readGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQBass_021Level(N)   writeGEQLevelCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_021Level      wroteGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQBass_021Width       readGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQBass_021Width(N)   writeGEQWidthCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_021Width      wroteGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)

#define  readGEQBass_022Freq        readGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQBass_022Freq(N)    writeGEQFreqCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_022Freq       wroteGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQBass_022Level       readGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQBass_022Level(N)   writeGEQLevelCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_022Level      wroteGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQBass_022Width       readGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQBass_022Width(N)   writeGEQWidthCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_022Width      wroteGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)

#define  readGEQBass_023Freq        readGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQBass_023Freq(N)    writeGEQFreqCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_023Freq       wroteGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQBass_023Level       readGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQBass_023Level(N)   writeGEQLevelCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_023Level      wroteGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQBass_023Width       readGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQBass_023Width(N)   writeGEQWidthCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_023Width      wroteGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)

#define  readGEQBass_024Freq        readGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQBass_024Freq(N)    writeGEQFreqCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_024Freq       wroteGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQBass_024Level       readGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQBass_024Level(N)   writeGEQLevelCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_024Level      wroteGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQBass_024Width       readGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQBass_024Width(N)   writeGEQWidthCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_024Width      wroteGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)

#define  readGEQBass_025Freq        readGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQBass_025Freq(N)    writeGEQFreqCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_025Freq       wroteGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQBass_025Level       readGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQBass_025Level(N)   writeGEQLevelCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_025Level      wroteGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQBass_025Width       readGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQBass_025Width(N)   writeGEQWidthCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_025Width      wroteGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)

#define  readGEQBass_026Freq        readGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQBass_026Freq(N)    writeGEQFreqCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_026Freq       wroteGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQBass_026Level       readGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQBass_026Level(N)   writeGEQLevelCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_026Level      wroteGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQBass_026Width       readGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQBass_026Width(N)   writeGEQWidthCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_026Width      wroteGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)

#define  readGEQBass_027Freq        readGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQBass_027Freq(N)    writeGEQFreqCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_027Freq       wroteGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQBass_027Level       readGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQBass_027Level(N)   writeGEQLevelCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_027Level      wroteGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQBass_027Width       readGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQBass_027Width(N)   writeGEQWidthCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_027Width      wroteGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)

#define  readGEQBass_028Freq        readGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQBass_028Freq(N)    writeGEQFreqCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_028Freq       wroteGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQBass_028Level       readGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQBass_028Level(N)   writeGEQLevelCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_028Level      wroteGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQBass_028Width       readGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQBass_028Width(N)   writeGEQWidthCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_028Width      wroteGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)

#define  readGEQBass_029Freq        readGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQBass_029Freq(N)    writeGEQFreqCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_029Freq       wroteGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQBass_029Level       readGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQBass_029Level(N)   writeGEQLevelCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_029Level      wroteGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQBass_029Width       readGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQBass_029Width(N)   writeGEQWidthCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_029Width      wroteGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)

#define  readGEQBass_030Freq        readGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQBass_030Freq(N)    writeGEQFreqCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_030Freq       wroteGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQBass_030Level       readGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQBass_030Level(N)   writeGEQLevelCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_030Level      wroteGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQBass_030Width       readGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQBass_030Width(N)   writeGEQWidthCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_030Width      wroteGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)

#define  readGEQBass_031Freq        readGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQBass_031Freq(N)    writeGEQFreqCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_031Freq       wroteGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQBass_031Level       readGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQBass_031Level(N)   writeGEQLevelCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_031Level      wroteGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQBass_031Width       readGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQBass_031Width(N)   writeGEQWidthCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_031Width      wroteGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)

#define  readGEQBass_032Freq        readGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQBass_032Freq(N)    writeGEQFreqCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_032Freq       wroteGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQBass_032Level       readGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQBass_032Level(N)   writeGEQLevelCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_032Level      wroteGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQBass_032Width       readGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQBass_032Width(N)   writeGEQWidthCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_032Width      wroteGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)

#define  readGEQBass_n1Freq        readGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQBass_n1Freq(N)    writeGEQFreqCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n1Freq       wroteGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQBass_n1Level       readGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQBass_n1Level(N)   writeGEQLevelCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n1Level      wroteGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQBass_n1Width       readGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQBass_n1Width(N)   writeGEQWidthCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n1Width      wroteGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)

#define  readGEQBass_n2Freq        readGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQBass_n2Freq(N)    writeGEQFreqCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n2Freq       wroteGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQBass_n2Level       readGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQBass_n2Level(N)   writeGEQLevelCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n2Level      wroteGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQBass_n2Width       readGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQBass_n2Width(N)   writeGEQWidthCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n2Width      wroteGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)

#define  readGEQBass_n3Freq        readGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQBass_n3Freq(N)    writeGEQFreqCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n3Freq       wroteGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQBass_n3Level       readGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQBass_n3Level(N)   writeGEQLevelCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n3Level      wroteGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQBass_n3Width       readGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQBass_n3Width(N)   writeGEQWidthCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n3Width      wroteGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)

#define  readGEQBass_n4Freq        readGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQBass_n4Freq(N)    writeGEQFreqCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n4Freq       wroteGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQBass_n4Level       readGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQBass_n4Level(N)   writeGEQLevelCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n4Level      wroteGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQBass_n4Width       readGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQBass_n4Width(N)   writeGEQWidthCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n4Width      wroteGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)

#define  readGEQBass_n5Freq        readGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQBass_n5Freq(N)    writeGEQFreqCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n5Freq       wroteGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQBass_n5Level       readGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQBass_n5Level(N)   writeGEQLevelCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n5Level      wroteGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQBass_n5Width       readGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQBass_n5Width(N)   writeGEQWidthCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n5Width      wroteGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)

#define  readGEQBass_n6Freq        readGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQBass_n6Freq(N)    writeGEQFreqCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n6Freq       wroteGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQBass_n6Level       readGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQBass_n6Level(N)   writeGEQLevelCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n6Level      wroteGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQBass_n6Width       readGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQBass_n6Width(N)   writeGEQWidthCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n6Width      wroteGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)

#define  readGEQBass_n7Freq        readGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQBass_n7Freq(N)    writeGEQFreqCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n7Freq       wroteGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQBass_n7Level       readGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQBass_n7Level(N)   writeGEQLevelCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n7Level      wroteGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQBass_n7Width       readGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQBass_n7Width(N)   writeGEQWidthCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n7Width      wroteGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)

#define  readGEQBass_n8Freq        readGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQBass_n8Freq(N)    writeGEQFreqCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n8Freq       wroteGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQBass_n8Level       readGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQBass_n8Level(N)   writeGEQLevelCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n8Level      wroteGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQBass_n8Width       readGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQBass_n8Width(N)   writeGEQWidthCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n8Width      wroteGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)

#define  readGEQBass_n9Freq        readGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQBass_n9Freq(N)    writeGEQFreqCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n9Freq       wroteGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQBass_n9Level       readGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQBass_n9Level(N)   writeGEQLevelCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n9Level      wroteGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQBass_n9Width       readGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQBass_n9Width(N)   writeGEQWidthCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n9Width      wroteGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)

#define  readGEQBass_n10Freq        readGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQBass_n10Freq(N)    writeGEQFreqCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n10Freq       wroteGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQBass_n10Level       readGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQBass_n10Level(N)   writeGEQLevelCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n10Level      wroteGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQBass_n10Width       readGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQBass_n10Width(N)   writeGEQWidthCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n10Width      wroteGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)

#define  readGEQBass_n11Freq        readGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQBass_n11Freq(N)    writeGEQFreqCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n11Freq       wroteGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQBass_n11Level       readGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQBass_n11Level(N)   writeGEQLevelCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n11Level      wroteGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQBass_n11Width       readGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQBass_n11Width(N)   writeGEQWidthCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n11Width      wroteGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)

#define  readGEQBass_n12Freq        readGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQBass_n12Freq(N)    writeGEQFreqCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n12Freq       wroteGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQBass_n12Level       readGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQBass_n12Level(N)   writeGEQLevelCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n12Level      wroteGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQBass_n12Width       readGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQBass_n12Width(N)   writeGEQWidthCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n12Width      wroteGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)

#define  readGEQBass_n13Freq        readGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQBass_n13Freq(N)    writeGEQFreqCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n13Freq       wroteGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQBass_n13Level       readGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQBass_n13Level(N)   writeGEQLevelCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n13Level      wroteGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQBass_n13Width       readGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQBass_n13Width(N)   writeGEQWidthCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n13Width      wroteGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)

#define  readGEQBass_n14Freq        readGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQBass_n14Freq(N)    writeGEQFreqCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n14Freq       wroteGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQBass_n14Level       readGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQBass_n14Level(N)   writeGEQLevelCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n14Level      wroteGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQBass_n14Width       readGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQBass_n14Width(N)   writeGEQWidthCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n14Width      wroteGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)

#define  readGEQBass_n15Freq        readGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQBass_n15Freq(N)    writeGEQFreqCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n15Freq       wroteGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQBass_n15Level       readGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQBass_n15Level(N)   writeGEQLevelCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n15Level      wroteGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQBass_n15Width       readGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQBass_n15Width(N)   writeGEQWidthCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n15Width      wroteGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)

#define  readGEQBass_n16Freq        readGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQBass_n16Freq(N)    writeGEQFreqCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n16Freq       wroteGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQBass_n16Level       readGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQBass_n16Level(N)   writeGEQLevelCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n16Level      wroteGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQBass_n16Width       readGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQBass_n16Width(N)   writeGEQWidthCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n16Width      wroteGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)

#define  readGEQBass_n17Freq        readGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQBass_n17Freq(N)    writeGEQFreqCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n17Freq       wroteGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQBass_n17Level       readGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQBass_n17Level(N)   writeGEQLevelCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n17Level      wroteGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQBass_n17Width       readGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQBass_n17Width(N)   writeGEQWidthCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n17Width      wroteGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)

#define  readGEQBass_n18Freq        readGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQBass_n18Freq(N)    writeGEQFreqCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n18Freq       wroteGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQBass_n18Level       readGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQBass_n18Level(N)   writeGEQLevelCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n18Level      wroteGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQBass_n18Width       readGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQBass_n18Width(N)   writeGEQWidthCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n18Width      wroteGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)

#define  readGEQBass_n19Freq        readGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQBass_n19Freq(N)    writeGEQFreqCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n19Freq       wroteGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQBass_n19Level       readGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQBass_n19Level(N)   writeGEQLevelCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n19Level      wroteGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQBass_n19Width       readGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQBass_n19Width(N)   writeGEQWidthCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n19Width      wroteGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)

#define  readGEQBass_n20Freq        readGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQBass_n20Freq(N)    writeGEQFreqCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n20Freq       wroteGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQBass_n20Level       readGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQBass_n20Level(N)   writeGEQLevelCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n20Level      wroteGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQBass_n20Width       readGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQBass_n20Width(N)   writeGEQWidthCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n20Width      wroteGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)

#define  readGEQBass_n21Freq        readGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQBass_n21Freq(N)    writeGEQFreqCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n21Freq       wroteGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQBass_n21Level       readGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQBass_n21Level(N)   writeGEQLevelCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n21Level      wroteGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQBass_n21Width       readGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQBass_n21Width(N)   writeGEQWidthCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n21Width      wroteGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)

#define  readGEQBass_n22Freq        readGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQBass_n22Freq(N)    writeGEQFreqCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n22Freq       wroteGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQBass_n22Level       readGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQBass_n22Level(N)   writeGEQLevelCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n22Level      wroteGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQBass_n22Width       readGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQBass_n22Width(N)   writeGEQWidthCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n22Width      wroteGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)

#define  readGEQBass_n23Freq        readGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQBass_n23Freq(N)    writeGEQFreqCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n23Freq       wroteGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQBass_n23Level       readGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQBass_n23Level(N)   writeGEQLevelCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n23Level      wroteGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQBass_n23Width       readGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQBass_n23Width(N)   writeGEQWidthCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n23Width      wroteGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)

#define  readGEQBass_n24Freq        readGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQBass_n24Freq(N)    writeGEQFreqCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n24Freq       wroteGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQBass_n24Level       readGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQBass_n24Level(N)   writeGEQLevelCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n24Level      wroteGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQBass_n24Width       readGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQBass_n24Width(N)   writeGEQWidthCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n24Width      wroteGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)

#define  readGEQBass_n25Freq        readGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQBass_n25Freq(N)    writeGEQFreqCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n25Freq       wroteGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQBass_n25Level       readGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQBass_n25Level(N)   writeGEQLevelCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n25Level      wroteGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQBass_n25Width       readGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQBass_n25Width(N)   writeGEQWidthCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n25Width      wroteGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)

#define  readGEQBass_n26Freq        readGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQBass_n26Freq(N)    writeGEQFreqCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n26Freq       wroteGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQBass_n26Level       readGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQBass_n26Level(N)   writeGEQLevelCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n26Level      wroteGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQBass_n26Width       readGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQBass_n26Width(N)   writeGEQWidthCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n26Width      wroteGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)

#define  readGEQBass_n27Freq        readGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQBass_n27Freq(N)    writeGEQFreqCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n27Freq       wroteGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQBass_n27Level       readGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQBass_n27Level(N)   writeGEQLevelCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n27Level      wroteGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQBass_n27Width       readGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQBass_n27Width(N)   writeGEQWidthCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n27Width      wroteGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)

#define  readGEQBass_n28Freq        readGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQBass_n28Freq(N)    writeGEQFreqCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n28Freq       wroteGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQBass_n28Level       readGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQBass_n28Level(N)   writeGEQLevelCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n28Level      wroteGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQBass_n28Width       readGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQBass_n28Width(N)   writeGEQWidthCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n28Width      wroteGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)

#define  readGEQBass_n29Freq        readGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQBass_n29Freq(N)    writeGEQFreqCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n29Freq       wroteGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQBass_n29Level       readGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQBass_n29Level(N)   writeGEQLevelCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n29Level      wroteGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQBass_n29Width       readGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQBass_n29Width(N)   writeGEQWidthCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n29Width      wroteGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)

#define  readGEQBass_n30Freq        readGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQBass_n30Freq(N)    writeGEQFreqCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n30Freq       wroteGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQBass_n30Level       readGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQBass_n30Level(N)   writeGEQLevelCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n30Level      wroteGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQBass_n30Width       readGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQBass_n30Width(N)   writeGEQWidthCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n30Width      wroteGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)

#define  readGEQBass_n31Freq        readGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQBass_n31Freq(N)    writeGEQFreqCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n31Freq       wroteGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQBass_n31Level       readGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQBass_n31Level(N)   writeGEQLevelCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n31Level      wroteGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQBass_n31Width       readGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQBass_n31Width(N)   writeGEQWidthCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n31Width      wroteGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)

#define  readGEQBass_n32Freq        readGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQBass_n32Freq(N)    writeGEQFreqCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n32Freq       wroteGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQBass_n32Level       readGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQBass_n32Level(N)   writeGEQLevelCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n32Level      wroteGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQBass_n32Width       readGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQBass_n32Width(N)   writeGEQWidthCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQBass_n32Width      wroteGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)

#define  readGEQHead_01Freq        readGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQHead_01Freq(N)    writeGEQFreqCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_01Freq       wroteGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQHead_01Level       readGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQHead_01Level(N)   writeGEQLevelCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_01Level      wroteGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQHead_01Width       readGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQHead_01Width(N)   writeGEQWidthCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_01Width      wroteGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)

#define  readGEQHead_02Freq        readGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQHead_02Freq(N)    writeGEQFreqCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_02Freq       wroteGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQHead_02Level       readGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQHead_02Level(N)   writeGEQLevelCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_02Level      wroteGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQHead_02Width       readGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQHead_02Width(N)   writeGEQWidthCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_02Width      wroteGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)

#define  readGEQHead_03Freq        readGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQHead_03Freq(N)    writeGEQFreqCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_03Freq       wroteGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQHead_03Level       readGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQHead_03Level(N)   writeGEQLevelCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_03Level      wroteGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQHead_03Width       readGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQHead_03Width(N)   writeGEQWidthCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_03Width      wroteGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)

#define  readGEQHead_04Freq        readGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQHead_04Freq(N)    writeGEQFreqCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_04Freq       wroteGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQHead_04Level       readGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQHead_04Level(N)   writeGEQLevelCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_04Level      wroteGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQHead_04Width       readGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQHead_04Width(N)   writeGEQWidthCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_04Width      wroteGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)

#define  readGEQHead_05Freq        readGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQHead_05Freq(N)    writeGEQFreqCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_05Freq       wroteGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQHead_05Level       readGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQHead_05Level(N)   writeGEQLevelCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_05Level      wroteGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQHead_05Width       readGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQHead_05Width(N)   writeGEQWidthCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_05Width      wroteGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)

#define  readGEQHead_06Freq        readGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQHead_06Freq(N)    writeGEQFreqCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_06Freq       wroteGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQHead_06Level       readGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQHead_06Level(N)   writeGEQLevelCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_06Level      wroteGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQHead_06Width       readGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQHead_06Width(N)   writeGEQWidthCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_06Width      wroteGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)

#define  readGEQHead_07Freq        readGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQHead_07Freq(N)    writeGEQFreqCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_07Freq       wroteGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQHead_07Level       readGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQHead_07Level(N)   writeGEQLevelCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_07Level      wroteGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQHead_07Width       readGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQHead_07Width(N)   writeGEQWidthCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_07Width      wroteGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)

#define  readGEQHead_08Freq        readGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQHead_08Freq(N)    writeGEQFreqCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_08Freq       wroteGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQHead_08Level       readGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQHead_08Level(N)   writeGEQLevelCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_08Level      wroteGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQHead_08Width       readGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQHead_08Width(N)   writeGEQWidthCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_08Width      wroteGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)

#define  readGEQHead_09Freq        readGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQHead_09Freq(N)    writeGEQFreqCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_09Freq       wroteGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQHead_09Level       readGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQHead_09Level(N)   writeGEQLevelCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_09Level      wroteGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQHead_09Width       readGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQHead_09Width(N)   writeGEQWidthCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_09Width      wroteGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)

#define  readGEQHead_010Freq        readGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQHead_010Freq(N)    writeGEQFreqCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_010Freq       wroteGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQHead_010Level       readGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQHead_010Level(N)   writeGEQLevelCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_010Level      wroteGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQHead_010Width       readGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQHead_010Width(N)   writeGEQWidthCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_010Width      wroteGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)

#define  readGEQHead_011Freq        readGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQHead_011Freq(N)    writeGEQFreqCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_011Freq       wroteGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQHead_011Level       readGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQHead_011Level(N)   writeGEQLevelCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_011Level      wroteGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQHead_011Width       readGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQHead_011Width(N)   writeGEQWidthCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_011Width      wroteGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)

#define  readGEQHead_012Freq        readGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQHead_012Freq(N)    writeGEQFreqCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_012Freq       wroteGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQHead_012Level       readGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQHead_012Level(N)   writeGEQLevelCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_012Level      wroteGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQHead_012Width       readGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQHead_012Width(N)   writeGEQWidthCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_012Width      wroteGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)

#define  readGEQHead_013Freq        readGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQHead_013Freq(N)    writeGEQFreqCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_013Freq       wroteGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQHead_013Level       readGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQHead_013Level(N)   writeGEQLevelCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_013Level      wroteGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQHead_013Width       readGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQHead_013Width(N)   writeGEQWidthCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_013Width      wroteGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)

#define  readGEQHead_014Freq        readGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQHead_014Freq(N)    writeGEQFreqCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_014Freq       wroteGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQHead_014Level       readGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQHead_014Level(N)   writeGEQLevelCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_014Level      wroteGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQHead_014Width       readGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQHead_014Width(N)   writeGEQWidthCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_014Width      wroteGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)

#define  readGEQHead_015Freq        readGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQHead_015Freq(N)    writeGEQFreqCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_015Freq       wroteGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQHead_015Level       readGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQHead_015Level(N)   writeGEQLevelCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_015Level      wroteGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQHead_015Width       readGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQHead_015Width(N)   writeGEQWidthCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_015Width      wroteGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)

#define  readGEQHead_016Freq        readGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQHead_016Freq(N)    writeGEQFreqCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_016Freq       wroteGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQHead_016Level       readGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQHead_016Level(N)   writeGEQLevelCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_016Level      wroteGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQHead_016Width       readGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQHead_016Width(N)   writeGEQWidthCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_016Width      wroteGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)

#define  readGEQHead_017Freq        readGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQHead_017Freq(N)    writeGEQFreqCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_017Freq       wroteGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQHead_017Level       readGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQHead_017Level(N)   writeGEQLevelCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_017Level      wroteGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQHead_017Width       readGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQHead_017Width(N)   writeGEQWidthCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_017Width      wroteGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)

#define  readGEQHead_018Freq        readGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQHead_018Freq(N)    writeGEQFreqCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_018Freq       wroteGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQHead_018Level       readGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQHead_018Level(N)   writeGEQLevelCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_018Level      wroteGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQHead_018Width       readGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQHead_018Width(N)   writeGEQWidthCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_018Width      wroteGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)

#define  readGEQHead_019Freq        readGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQHead_019Freq(N)    writeGEQFreqCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_019Freq       wroteGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQHead_019Level       readGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQHead_019Level(N)   writeGEQLevelCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_019Level      wroteGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQHead_019Width       readGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQHead_019Width(N)   writeGEQWidthCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_019Width      wroteGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)

#define  readGEQHead_020Freq        readGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQHead_020Freq(N)    writeGEQFreqCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_020Freq       wroteGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQHead_020Level       readGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQHead_020Level(N)   writeGEQLevelCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_020Level      wroteGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQHead_020Width       readGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQHead_020Width(N)   writeGEQWidthCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_020Width      wroteGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)

#define  readGEQHead_021Freq        readGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQHead_021Freq(N)    writeGEQFreqCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_021Freq       wroteGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQHead_021Level       readGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQHead_021Level(N)   writeGEQLevelCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_021Level      wroteGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQHead_021Width       readGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQHead_021Width(N)   writeGEQWidthCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_021Width      wroteGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)

#define  readGEQHead_022Freq        readGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQHead_022Freq(N)    writeGEQFreqCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_022Freq       wroteGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQHead_022Level       readGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQHead_022Level(N)   writeGEQLevelCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_022Level      wroteGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQHead_022Width       readGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQHead_022Width(N)   writeGEQWidthCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_022Width      wroteGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)

#define  readGEQHead_023Freq        readGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQHead_023Freq(N)    writeGEQFreqCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_023Freq       wroteGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQHead_023Level       readGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQHead_023Level(N)   writeGEQLevelCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_023Level      wroteGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQHead_023Width       readGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQHead_023Width(N)   writeGEQWidthCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_023Width      wroteGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)

#define  readGEQHead_024Freq        readGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQHead_024Freq(N)    writeGEQFreqCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_024Freq       wroteGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQHead_024Level       readGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQHead_024Level(N)   writeGEQLevelCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_024Level      wroteGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQHead_024Width       readGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQHead_024Width(N)   writeGEQWidthCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_024Width      wroteGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)

#define  readGEQHead_025Freq        readGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQHead_025Freq(N)    writeGEQFreqCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_025Freq       wroteGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQHead_025Level       readGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQHead_025Level(N)   writeGEQLevelCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_025Level      wroteGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQHead_025Width       readGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQHead_025Width(N)   writeGEQWidthCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_025Width      wroteGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)

#define  readGEQHead_026Freq        readGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQHead_026Freq(N)    writeGEQFreqCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_026Freq       wroteGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQHead_026Level       readGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQHead_026Level(N)   writeGEQLevelCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_026Level      wroteGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQHead_026Width       readGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQHead_026Width(N)   writeGEQWidthCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_026Width      wroteGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)

#define  readGEQHead_027Freq        readGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQHead_027Freq(N)    writeGEQFreqCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_027Freq       wroteGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQHead_027Level       readGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQHead_027Level(N)   writeGEQLevelCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_027Level      wroteGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQHead_027Width       readGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQHead_027Width(N)   writeGEQWidthCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_027Width      wroteGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)

#define  readGEQHead_028Freq        readGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQHead_028Freq(N)    writeGEQFreqCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_028Freq       wroteGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQHead_028Level       readGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQHead_028Level(N)   writeGEQLevelCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_028Level      wroteGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQHead_028Width       readGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQHead_028Width(N)   writeGEQWidthCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_028Width      wroteGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)

#define  readGEQHead_029Freq        readGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQHead_029Freq(N)    writeGEQFreqCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_029Freq       wroteGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQHead_029Level       readGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQHead_029Level(N)   writeGEQLevelCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_029Level      wroteGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQHead_029Width       readGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQHead_029Width(N)   writeGEQWidthCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_029Width      wroteGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)

#define  readGEQHead_030Freq        readGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQHead_030Freq(N)    writeGEQFreqCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_030Freq       wroteGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQHead_030Level       readGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQHead_030Level(N)   writeGEQLevelCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_030Level      wroteGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQHead_030Width       readGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQHead_030Width(N)   writeGEQWidthCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_030Width      wroteGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)

#define  readGEQHead_031Freq        readGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQHead_031Freq(N)    writeGEQFreqCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_031Freq       wroteGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQHead_031Level       readGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQHead_031Level(N)   writeGEQLevelCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_031Level      wroteGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQHead_031Width       readGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQHead_031Width(N)   writeGEQWidthCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_031Width      wroteGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)

#define  readGEQHead_032Freq        readGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQHead_032Freq(N)    writeGEQFreqCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_032Freq       wroteGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQHead_032Level       readGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQHead_032Level(N)   writeGEQLevelCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_032Level      wroteGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQHead_032Width       readGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQHead_032Width(N)   writeGEQWidthCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQHead_032Width      wroteGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba1Freq        readGEQFreqCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba1Freq(N)    writeGEQFreqCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba1Freq       wroteGEQFreqCh(0, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba1Level       readGEQLevelCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba1Level(N)   writeGEQLevelCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba1Level      wroteGEQLevelCh(0, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba1Width       readGEQWidthCh(0, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba1Width(N)   writeGEQWidthCh(0, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba1Width      wroteGEQWidthCh(0, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba2Freq        readGEQFreqCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba2Freq(N)    writeGEQFreqCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba2Freq       wroteGEQFreqCh(0, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba2Level       readGEQLevelCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba2Level(N)   writeGEQLevelCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba2Level      wroteGEQLevelCh(0, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba2Width       readGEQWidthCh(0, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba2Width(N)   writeGEQWidthCh(0, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba2Width      wroteGEQWidthCh(0, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba3Freq        readGEQFreqCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba3Freq(N)    writeGEQFreqCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba3Freq       wroteGEQFreqCh(0, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba3Level       readGEQLevelCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba3Level(N)   writeGEQLevelCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba3Level      wroteGEQLevelCh(0, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba3Width       readGEQWidthCh(0, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba3Width(N)   writeGEQWidthCh(0, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba3Width      wroteGEQWidthCh(0, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba4Freq        readGEQFreqCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba4Freq(N)    writeGEQFreqCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba4Freq       wroteGEQFreqCh(0, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba4Level       readGEQLevelCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba4Level(N)   writeGEQLevelCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba4Level      wroteGEQLevelCh(0, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba4Width       readGEQWidthCh(0, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba4Width(N)   writeGEQWidthCh(0, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba4Width      wroteGEQWidthCh(0, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba5Freq        readGEQFreqCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba5Freq(N)    writeGEQFreqCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba5Freq       wroteGEQFreqCh(0, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba5Level       readGEQLevelCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba5Level(N)   writeGEQLevelCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba5Level      wroteGEQLevelCh(0, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba5Width       readGEQWidthCh(0, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba5Width(N)   writeGEQWidthCh(0, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba5Width      wroteGEQWidthCh(0, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba6Freq        readGEQFreqCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba6Freq(N)    writeGEQFreqCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba6Freq       wroteGEQFreqCh(0, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba6Level       readGEQLevelCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba6Level(N)   writeGEQLevelCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba6Level      wroteGEQLevelCh(0, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba6Width       readGEQWidthCh(0, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba6Width(N)   writeGEQWidthCh(0, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba6Width      wroteGEQWidthCh(0, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba7Freq        readGEQFreqCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba7Freq(N)    writeGEQFreqCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba7Freq       wroteGEQFreqCh(0, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba7Level       readGEQLevelCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba7Level(N)   writeGEQLevelCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba7Level      wroteGEQLevelCh(0, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba7Width       readGEQWidthCh(0, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba7Width(N)   writeGEQWidthCh(0, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba7Width      wroteGEQWidthCh(0, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba8Freq        readGEQFreqCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba8Freq(N)    writeGEQFreqCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba8Freq       wroteGEQFreqCh(0, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba8Level       readGEQLevelCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba8Level(N)   writeGEQLevelCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba8Level      wroteGEQLevelCh(0, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba8Width       readGEQWidthCh(0, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba8Width(N)   writeGEQWidthCh(0, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba8Width      wroteGEQWidthCh(0, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba9Freq        readGEQFreqCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba9Freq(N)    writeGEQFreqCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba9Freq       wroteGEQFreqCh(0, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba9Level       readGEQLevelCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba9Level(N)   writeGEQLevelCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba9Level      wroteGEQLevelCh(0, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba9Width       readGEQWidthCh(0, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba9Width(N)   writeGEQWidthCh(0, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba9Width      wroteGEQWidthCh(0, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba10Freq        readGEQFreqCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba10Freq(N)    writeGEQFreqCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba10Freq       wroteGEQFreqCh(0, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba10Level       readGEQLevelCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba10Level(N)   writeGEQLevelCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba10Level      wroteGEQLevelCh(0, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba10Width       readGEQWidthCh(0, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba10Width(N)   writeGEQWidthCh(0, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba10Width      wroteGEQWidthCh(0, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba11Freq        readGEQFreqCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba11Freq(N)    writeGEQFreqCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba11Freq       wroteGEQFreqCh(0, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba11Level       readGEQLevelCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba11Level(N)   writeGEQLevelCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba11Level      wroteGEQLevelCh(0, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba11Width       readGEQWidthCh(0, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba11Width(N)   writeGEQWidthCh(0, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba11Width      wroteGEQWidthCh(0, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba12Freq        readGEQFreqCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba12Freq(N)    writeGEQFreqCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba12Freq       wroteGEQFreqCh(0, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba12Level       readGEQLevelCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba12Level(N)   writeGEQLevelCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba12Level      wroteGEQLevelCh(0, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba12Width       readGEQWidthCh(0, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba12Width(N)   writeGEQWidthCh(0, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba12Width      wroteGEQWidthCh(0, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba13Freq        readGEQFreqCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba13Freq(N)    writeGEQFreqCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba13Freq       wroteGEQFreqCh(0, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba13Level       readGEQLevelCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba13Level(N)   writeGEQLevelCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba13Level      wroteGEQLevelCh(0, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba13Width       readGEQWidthCh(0, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba13Width(N)   writeGEQWidthCh(0, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba13Width      wroteGEQWidthCh(0, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba14Freq        readGEQFreqCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba14Freq(N)    writeGEQFreqCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba14Freq       wroteGEQFreqCh(0, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba14Level       readGEQLevelCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba14Level(N)   writeGEQLevelCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba14Level      wroteGEQLevelCh(0, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba14Width       readGEQWidthCh(0, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba14Width(N)   writeGEQWidthCh(0, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba14Width      wroteGEQWidthCh(0, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba15Freq        readGEQFreqCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba15Freq(N)    writeGEQFreqCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba15Freq       wroteGEQFreqCh(0, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba15Level       readGEQLevelCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba15Level(N)   writeGEQLevelCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba15Level      wroteGEQLevelCh(0, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba15Width       readGEQWidthCh(0, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba15Width(N)   writeGEQWidthCh(0, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba15Width      wroteGEQWidthCh(0, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba16Freq        readGEQFreqCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba16Freq(N)    writeGEQFreqCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba16Freq       wroteGEQFreqCh(0, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba16Level       readGEQLevelCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba16Level(N)   writeGEQLevelCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba16Level      wroteGEQLevelCh(0, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba16Width       readGEQWidthCh(0, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba16Width(N)   writeGEQWidthCh(0, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba16Width      wroteGEQWidthCh(0, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba17Freq        readGEQFreqCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba17Freq(N)    writeGEQFreqCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba17Freq       wroteGEQFreqCh(0, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba17Level       readGEQLevelCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba17Level(N)   writeGEQLevelCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba17Level      wroteGEQLevelCh(0, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba17Width       readGEQWidthCh(0, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba17Width(N)   writeGEQWidthCh(0, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba17Width      wroteGEQWidthCh(0, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba18Freq        readGEQFreqCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba18Freq(N)    writeGEQFreqCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba18Freq       wroteGEQFreqCh(0, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba18Level       readGEQLevelCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba18Level(N)   writeGEQLevelCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba18Level      wroteGEQLevelCh(0, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba18Width       readGEQWidthCh(0, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba18Width(N)   writeGEQWidthCh(0, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba18Width      wroteGEQWidthCh(0, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba19Freq        readGEQFreqCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba19Freq(N)    writeGEQFreqCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba19Freq       wroteGEQFreqCh(0, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba19Level       readGEQLevelCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba19Level(N)   writeGEQLevelCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba19Level      wroteGEQLevelCh(0, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba19Width       readGEQWidthCh(0, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba19Width(N)   writeGEQWidthCh(0, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba19Width      wroteGEQWidthCh(0, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba20Freq        readGEQFreqCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba20Freq(N)    writeGEQFreqCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba20Freq       wroteGEQFreqCh(0, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba20Level       readGEQLevelCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba20Level(N)   writeGEQLevelCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba20Level      wroteGEQLevelCh(0, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba20Width       readGEQWidthCh(0, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba20Width(N)   writeGEQWidthCh(0, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba20Width      wroteGEQWidthCh(0, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba21Freq        readGEQFreqCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba21Freq(N)    writeGEQFreqCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba21Freq       wroteGEQFreqCh(0, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba21Level       readGEQLevelCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba21Level(N)   writeGEQLevelCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba21Level      wroteGEQLevelCh(0, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba21Width       readGEQWidthCh(0, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba21Width(N)   writeGEQWidthCh(0, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba21Width      wroteGEQWidthCh(0, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba22Freq        readGEQFreqCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba22Freq(N)    writeGEQFreqCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba22Freq       wroteGEQFreqCh(0, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba22Level       readGEQLevelCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba22Level(N)   writeGEQLevelCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba22Level      wroteGEQLevelCh(0, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba22Width       readGEQWidthCh(0, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba22Width(N)   writeGEQWidthCh(0, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba22Width      wroteGEQWidthCh(0, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba23Freq        readGEQFreqCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba23Freq(N)    writeGEQFreqCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba23Freq       wroteGEQFreqCh(0, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba23Level       readGEQLevelCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba23Level(N)   writeGEQLevelCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba23Level      wroteGEQLevelCh(0, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba23Width       readGEQWidthCh(0, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba23Width(N)   writeGEQWidthCh(0, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba23Width      wroteGEQWidthCh(0, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba24Freq        readGEQFreqCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba24Freq(N)    writeGEQFreqCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba24Freq       wroteGEQFreqCh(0, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba24Level       readGEQLevelCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba24Level(N)   writeGEQLevelCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba24Level      wroteGEQLevelCh(0, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba24Width       readGEQWidthCh(0, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba24Width(N)   writeGEQWidthCh(0, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba24Width      wroteGEQWidthCh(0, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba25Freq        readGEQFreqCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba25Freq(N)    writeGEQFreqCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba25Freq       wroteGEQFreqCh(0, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba25Level       readGEQLevelCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba25Level(N)   writeGEQLevelCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba25Level      wroteGEQLevelCh(0, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba25Width       readGEQWidthCh(0, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba25Width(N)   writeGEQWidthCh(0, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba25Width      wroteGEQWidthCh(0, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba26Freq        readGEQFreqCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba26Freq(N)    writeGEQFreqCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba26Freq       wroteGEQFreqCh(0, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba26Level       readGEQLevelCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba26Level(N)   writeGEQLevelCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba26Level      wroteGEQLevelCh(0, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba26Width       readGEQWidthCh(0, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba26Width(N)   writeGEQWidthCh(0, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba26Width      wroteGEQWidthCh(0, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba27Freq        readGEQFreqCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba27Freq(N)    writeGEQFreqCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba27Freq       wroteGEQFreqCh(0, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba27Level       readGEQLevelCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba27Level(N)   writeGEQLevelCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba27Level      wroteGEQLevelCh(0, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba27Width       readGEQWidthCh(0, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba27Width(N)   writeGEQWidthCh(0, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba27Width      wroteGEQWidthCh(0, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba28Freq        readGEQFreqCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba28Freq(N)    writeGEQFreqCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba28Freq       wroteGEQFreqCh(0, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba28Level       readGEQLevelCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba28Level(N)   writeGEQLevelCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba28Level      wroteGEQLevelCh(0, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba28Width       readGEQWidthCh(0, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba28Width(N)   writeGEQWidthCh(0, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba28Width      wroteGEQWidthCh(0, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba29Freq        readGEQFreqCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba29Freq(N)    writeGEQFreqCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba29Freq       wroteGEQFreqCh(0, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba29Level       readGEQLevelCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba29Level(N)   writeGEQLevelCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba29Level      wroteGEQLevelCh(0, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba29Width       readGEQWidthCh(0, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba29Width(N)   writeGEQWidthCh(0, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba29Width      wroteGEQWidthCh(0, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba30Freq        readGEQFreqCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba30Freq(N)    writeGEQFreqCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba30Freq       wroteGEQFreqCh(0, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba30Level       readGEQLevelCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba30Level(N)   writeGEQLevelCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba30Level      wroteGEQLevelCh(0, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba30Width       readGEQWidthCh(0, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba30Width(N)   writeGEQWidthCh(0, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba30Width      wroteGEQWidthCh(0, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba31Freq        readGEQFreqCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba31Freq(N)    writeGEQFreqCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba31Freq       wroteGEQFreqCh(0, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba31Level       readGEQLevelCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba31Level(N)   writeGEQLevelCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba31Level      wroteGEQLevelCh(0, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba31Width       readGEQWidthCh(0, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba31Width(N)   writeGEQWidthCh(0, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba31Width      wroteGEQWidthCh(0, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh0Ba32Freq        readGEQFreqCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba32Freq(N)    writeGEQFreqCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba32Freq       wroteGEQFreqCh(0, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba32Level       readGEQLevelCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba32Level(N)   writeGEQLevelCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba32Level      wroteGEQLevelCh(0, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh0Ba32Width       readGEQWidthCh(0, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh0Ba32Width(N)   writeGEQWidthCh(0, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh0Ba32Width      wroteGEQWidthCh(0, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba1Freq        readGEQFreqCh(1, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba1Freq(N)    writeGEQFreqCh(1, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba1Freq       wroteGEQFreqCh(1, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba1Level       readGEQLevelCh(1, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba1Level(N)   writeGEQLevelCh(1, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba1Level      wroteGEQLevelCh(1, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba1Width       readGEQWidthCh(1, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba1Width(N)   writeGEQWidthCh(1, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba1Width      wroteGEQWidthCh(1, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba2Freq        readGEQFreqCh(1, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba2Freq(N)    writeGEQFreqCh(1, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba2Freq       wroteGEQFreqCh(1, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba2Level       readGEQLevelCh(1, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba2Level(N)   writeGEQLevelCh(1, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba2Level      wroteGEQLevelCh(1, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba2Width       readGEQWidthCh(1, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba2Width(N)   writeGEQWidthCh(1, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba2Width      wroteGEQWidthCh(1, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba3Freq        readGEQFreqCh(1, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba3Freq(N)    writeGEQFreqCh(1, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba3Freq       wroteGEQFreqCh(1, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba3Level       readGEQLevelCh(1, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba3Level(N)   writeGEQLevelCh(1, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba3Level      wroteGEQLevelCh(1, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba3Width       readGEQWidthCh(1, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba3Width(N)   writeGEQWidthCh(1, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba3Width      wroteGEQWidthCh(1, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba4Freq        readGEQFreqCh(1, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba4Freq(N)    writeGEQFreqCh(1, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba4Freq       wroteGEQFreqCh(1, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba4Level       readGEQLevelCh(1, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba4Level(N)   writeGEQLevelCh(1, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba4Level      wroteGEQLevelCh(1, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba4Width       readGEQWidthCh(1, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba4Width(N)   writeGEQWidthCh(1, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba4Width      wroteGEQWidthCh(1, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba5Freq        readGEQFreqCh(1, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba5Freq(N)    writeGEQFreqCh(1, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba5Freq       wroteGEQFreqCh(1, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba5Level       readGEQLevelCh(1, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba5Level(N)   writeGEQLevelCh(1, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba5Level      wroteGEQLevelCh(1, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba5Width       readGEQWidthCh(1, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba5Width(N)   writeGEQWidthCh(1, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba5Width      wroteGEQWidthCh(1, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba6Freq        readGEQFreqCh(1, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba6Freq(N)    writeGEQFreqCh(1, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba6Freq       wroteGEQFreqCh(1, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba6Level       readGEQLevelCh(1, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba6Level(N)   writeGEQLevelCh(1, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba6Level      wroteGEQLevelCh(1, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba6Width       readGEQWidthCh(1, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba6Width(N)   writeGEQWidthCh(1, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba6Width      wroteGEQWidthCh(1, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba7Freq        readGEQFreqCh(1, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba7Freq(N)    writeGEQFreqCh(1, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba7Freq       wroteGEQFreqCh(1, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba7Level       readGEQLevelCh(1, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba7Level(N)   writeGEQLevelCh(1, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba7Level      wroteGEQLevelCh(1, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba7Width       readGEQWidthCh(1, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba7Width(N)   writeGEQWidthCh(1, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba7Width      wroteGEQWidthCh(1, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba8Freq        readGEQFreqCh(1, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba8Freq(N)    writeGEQFreqCh(1, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba8Freq       wroteGEQFreqCh(1, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba8Level       readGEQLevelCh(1, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba8Level(N)   writeGEQLevelCh(1, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba8Level      wroteGEQLevelCh(1, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba8Width       readGEQWidthCh(1, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba8Width(N)   writeGEQWidthCh(1, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba8Width      wroteGEQWidthCh(1, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba9Freq        readGEQFreqCh(1, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba9Freq(N)    writeGEQFreqCh(1, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba9Freq       wroteGEQFreqCh(1, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba9Level       readGEQLevelCh(1, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba9Level(N)   writeGEQLevelCh(1, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba9Level      wroteGEQLevelCh(1, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba9Width       readGEQWidthCh(1, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba9Width(N)   writeGEQWidthCh(1, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba9Width      wroteGEQWidthCh(1, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba10Freq        readGEQFreqCh(1, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba10Freq(N)    writeGEQFreqCh(1, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba10Freq       wroteGEQFreqCh(1, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba10Level       readGEQLevelCh(1, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba10Level(N)   writeGEQLevelCh(1, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba10Level      wroteGEQLevelCh(1, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba10Width       readGEQWidthCh(1, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba10Width(N)   writeGEQWidthCh(1, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba10Width      wroteGEQWidthCh(1, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba11Freq        readGEQFreqCh(1, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba11Freq(N)    writeGEQFreqCh(1, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba11Freq       wroteGEQFreqCh(1, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba11Level       readGEQLevelCh(1, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba11Level(N)   writeGEQLevelCh(1, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba11Level      wroteGEQLevelCh(1, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba11Width       readGEQWidthCh(1, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba11Width(N)   writeGEQWidthCh(1, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba11Width      wroteGEQWidthCh(1, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba12Freq        readGEQFreqCh(1, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba12Freq(N)    writeGEQFreqCh(1, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba12Freq       wroteGEQFreqCh(1, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba12Level       readGEQLevelCh(1, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba12Level(N)   writeGEQLevelCh(1, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba12Level      wroteGEQLevelCh(1, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba12Width       readGEQWidthCh(1, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba12Width(N)   writeGEQWidthCh(1, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba12Width      wroteGEQWidthCh(1, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba13Freq        readGEQFreqCh(1, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba13Freq(N)    writeGEQFreqCh(1, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba13Freq       wroteGEQFreqCh(1, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba13Level       readGEQLevelCh(1, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba13Level(N)   writeGEQLevelCh(1, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba13Level      wroteGEQLevelCh(1, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba13Width       readGEQWidthCh(1, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba13Width(N)   writeGEQWidthCh(1, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba13Width      wroteGEQWidthCh(1, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba14Freq        readGEQFreqCh(1, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba14Freq(N)    writeGEQFreqCh(1, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba14Freq       wroteGEQFreqCh(1, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba14Level       readGEQLevelCh(1, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba14Level(N)   writeGEQLevelCh(1, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba14Level      wroteGEQLevelCh(1, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba14Width       readGEQWidthCh(1, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba14Width(N)   writeGEQWidthCh(1, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba14Width      wroteGEQWidthCh(1, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba15Freq        readGEQFreqCh(1, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba15Freq(N)    writeGEQFreqCh(1, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba15Freq       wroteGEQFreqCh(1, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba15Level       readGEQLevelCh(1, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba15Level(N)   writeGEQLevelCh(1, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba15Level      wroteGEQLevelCh(1, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba15Width       readGEQWidthCh(1, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba15Width(N)   writeGEQWidthCh(1, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba15Width      wroteGEQWidthCh(1, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba16Freq        readGEQFreqCh(1, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba16Freq(N)    writeGEQFreqCh(1, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba16Freq       wroteGEQFreqCh(1, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba16Level       readGEQLevelCh(1, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba16Level(N)   writeGEQLevelCh(1, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba16Level      wroteGEQLevelCh(1, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba16Width       readGEQWidthCh(1, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba16Width(N)   writeGEQWidthCh(1, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba16Width      wroteGEQWidthCh(1, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba17Freq        readGEQFreqCh(1, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba17Freq(N)    writeGEQFreqCh(1, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba17Freq       wroteGEQFreqCh(1, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba17Level       readGEQLevelCh(1, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba17Level(N)   writeGEQLevelCh(1, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba17Level      wroteGEQLevelCh(1, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba17Width       readGEQWidthCh(1, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba17Width(N)   writeGEQWidthCh(1, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba17Width      wroteGEQWidthCh(1, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba18Freq        readGEQFreqCh(1, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba18Freq(N)    writeGEQFreqCh(1, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba18Freq       wroteGEQFreqCh(1, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba18Level       readGEQLevelCh(1, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba18Level(N)   writeGEQLevelCh(1, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba18Level      wroteGEQLevelCh(1, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba18Width       readGEQWidthCh(1, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba18Width(N)   writeGEQWidthCh(1, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba18Width      wroteGEQWidthCh(1, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba19Freq        readGEQFreqCh(1, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba19Freq(N)    writeGEQFreqCh(1, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba19Freq       wroteGEQFreqCh(1, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba19Level       readGEQLevelCh(1, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba19Level(N)   writeGEQLevelCh(1, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba19Level      wroteGEQLevelCh(1, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba19Width       readGEQWidthCh(1, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba19Width(N)   writeGEQWidthCh(1, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba19Width      wroteGEQWidthCh(1, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba20Freq        readGEQFreqCh(1, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba20Freq(N)    writeGEQFreqCh(1, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba20Freq       wroteGEQFreqCh(1, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba20Level       readGEQLevelCh(1, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba20Level(N)   writeGEQLevelCh(1, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba20Level      wroteGEQLevelCh(1, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba20Width       readGEQWidthCh(1, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba20Width(N)   writeGEQWidthCh(1, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba20Width      wroteGEQWidthCh(1, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba21Freq        readGEQFreqCh(1, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba21Freq(N)    writeGEQFreqCh(1, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba21Freq       wroteGEQFreqCh(1, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba21Level       readGEQLevelCh(1, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba21Level(N)   writeGEQLevelCh(1, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba21Level      wroteGEQLevelCh(1, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba21Width       readGEQWidthCh(1, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba21Width(N)   writeGEQWidthCh(1, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba21Width      wroteGEQWidthCh(1, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba22Freq        readGEQFreqCh(1, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba22Freq(N)    writeGEQFreqCh(1, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba22Freq       wroteGEQFreqCh(1, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba22Level       readGEQLevelCh(1, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba22Level(N)   writeGEQLevelCh(1, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba22Level      wroteGEQLevelCh(1, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba22Width       readGEQWidthCh(1, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba22Width(N)   writeGEQWidthCh(1, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba22Width      wroteGEQWidthCh(1, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba23Freq        readGEQFreqCh(1, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba23Freq(N)    writeGEQFreqCh(1, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba23Freq       wroteGEQFreqCh(1, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba23Level       readGEQLevelCh(1, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba23Level(N)   writeGEQLevelCh(1, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba23Level      wroteGEQLevelCh(1, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba23Width       readGEQWidthCh(1, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba23Width(N)   writeGEQWidthCh(1, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba23Width      wroteGEQWidthCh(1, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba24Freq        readGEQFreqCh(1, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba24Freq(N)    writeGEQFreqCh(1, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba24Freq       wroteGEQFreqCh(1, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba24Level       readGEQLevelCh(1, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba24Level(N)   writeGEQLevelCh(1, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba24Level      wroteGEQLevelCh(1, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba24Width       readGEQWidthCh(1, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba24Width(N)   writeGEQWidthCh(1, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba24Width      wroteGEQWidthCh(1, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba25Freq        readGEQFreqCh(1, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba25Freq(N)    writeGEQFreqCh(1, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba25Freq       wroteGEQFreqCh(1, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba25Level       readGEQLevelCh(1, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba25Level(N)   writeGEQLevelCh(1, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba25Level      wroteGEQLevelCh(1, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba25Width       readGEQWidthCh(1, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba25Width(N)   writeGEQWidthCh(1, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba25Width      wroteGEQWidthCh(1, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba26Freq        readGEQFreqCh(1, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba26Freq(N)    writeGEQFreqCh(1, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba26Freq       wroteGEQFreqCh(1, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba26Level       readGEQLevelCh(1, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba26Level(N)   writeGEQLevelCh(1, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba26Level      wroteGEQLevelCh(1, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba26Width       readGEQWidthCh(1, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba26Width(N)   writeGEQWidthCh(1, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba26Width      wroteGEQWidthCh(1, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba27Freq        readGEQFreqCh(1, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba27Freq(N)    writeGEQFreqCh(1, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba27Freq       wroteGEQFreqCh(1, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba27Level       readGEQLevelCh(1, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba27Level(N)   writeGEQLevelCh(1, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba27Level      wroteGEQLevelCh(1, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba27Width       readGEQWidthCh(1, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba27Width(N)   writeGEQWidthCh(1, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba27Width      wroteGEQWidthCh(1, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba28Freq        readGEQFreqCh(1, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba28Freq(N)    writeGEQFreqCh(1, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba28Freq       wroteGEQFreqCh(1, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba28Level       readGEQLevelCh(1, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba28Level(N)   writeGEQLevelCh(1, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba28Level      wroteGEQLevelCh(1, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba28Width       readGEQWidthCh(1, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba28Width(N)   writeGEQWidthCh(1, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba28Width      wroteGEQWidthCh(1, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba29Freq        readGEQFreqCh(1, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba29Freq(N)    writeGEQFreqCh(1, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba29Freq       wroteGEQFreqCh(1, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba29Level       readGEQLevelCh(1, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba29Level(N)   writeGEQLevelCh(1, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba29Level      wroteGEQLevelCh(1, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba29Width       readGEQWidthCh(1, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba29Width(N)   writeGEQWidthCh(1, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba29Width      wroteGEQWidthCh(1, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba30Freq        readGEQFreqCh(1, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba30Freq(N)    writeGEQFreqCh(1, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba30Freq       wroteGEQFreqCh(1, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba30Level       readGEQLevelCh(1, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba30Level(N)   writeGEQLevelCh(1, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba30Level      wroteGEQLevelCh(1, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba30Width       readGEQWidthCh(1, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba30Width(N)   writeGEQWidthCh(1, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba30Width      wroteGEQWidthCh(1, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba31Freq        readGEQFreqCh(1, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba31Freq(N)    writeGEQFreqCh(1, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba31Freq       wroteGEQFreqCh(1, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba31Level       readGEQLevelCh(1, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba31Level(N)   writeGEQLevelCh(1, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba31Level      wroteGEQLevelCh(1, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba31Width       readGEQWidthCh(1, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba31Width(N)   writeGEQWidthCh(1, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba31Width      wroteGEQWidthCh(1, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh1Ba32Freq        readGEQFreqCh(1, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba32Freq(N)    writeGEQFreqCh(1, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba32Freq       wroteGEQFreqCh(1, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba32Level       readGEQLevelCh(1, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba32Level(N)   writeGEQLevelCh(1, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba32Level      wroteGEQLevelCh(1, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh1Ba32Width       readGEQWidthCh(1, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh1Ba32Width(N)   writeGEQWidthCh(1, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh1Ba32Width      wroteGEQWidthCh(1, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba1Freq        readGEQFreqCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba1Freq(N)    writeGEQFreqCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba1Freq       wroteGEQFreqCh(2, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba1Level       readGEQLevelCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba1Level(N)   writeGEQLevelCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba1Level      wroteGEQLevelCh(2, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba1Width       readGEQWidthCh(2, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba1Width(N)   writeGEQWidthCh(2, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba1Width      wroteGEQWidthCh(2, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba2Freq        readGEQFreqCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba2Freq(N)    writeGEQFreqCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba2Freq       wroteGEQFreqCh(2, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba2Level       readGEQLevelCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba2Level(N)   writeGEQLevelCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba2Level      wroteGEQLevelCh(2, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba2Width       readGEQWidthCh(2, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba2Width(N)   writeGEQWidthCh(2, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba2Width      wroteGEQWidthCh(2, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba3Freq        readGEQFreqCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba3Freq(N)    writeGEQFreqCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba3Freq       wroteGEQFreqCh(2, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba3Level       readGEQLevelCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba3Level(N)   writeGEQLevelCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba3Level      wroteGEQLevelCh(2, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba3Width       readGEQWidthCh(2, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba3Width(N)   writeGEQWidthCh(2, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba3Width      wroteGEQWidthCh(2, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba4Freq        readGEQFreqCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba4Freq(N)    writeGEQFreqCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba4Freq       wroteGEQFreqCh(2, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba4Level       readGEQLevelCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba4Level(N)   writeGEQLevelCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba4Level      wroteGEQLevelCh(2, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba4Width       readGEQWidthCh(2, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba4Width(N)   writeGEQWidthCh(2, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba4Width      wroteGEQWidthCh(2, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba5Freq        readGEQFreqCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba5Freq(N)    writeGEQFreqCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba5Freq       wroteGEQFreqCh(2, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba5Level       readGEQLevelCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba5Level(N)   writeGEQLevelCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba5Level      wroteGEQLevelCh(2, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba5Width       readGEQWidthCh(2, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba5Width(N)   writeGEQWidthCh(2, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba5Width      wroteGEQWidthCh(2, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba6Freq        readGEQFreqCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba6Freq(N)    writeGEQFreqCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba6Freq       wroteGEQFreqCh(2, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba6Level       readGEQLevelCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba6Level(N)   writeGEQLevelCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba6Level      wroteGEQLevelCh(2, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba6Width       readGEQWidthCh(2, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba6Width(N)   writeGEQWidthCh(2, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba6Width      wroteGEQWidthCh(2, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba7Freq        readGEQFreqCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba7Freq(N)    writeGEQFreqCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba7Freq       wroteGEQFreqCh(2, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba7Level       readGEQLevelCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba7Level(N)   writeGEQLevelCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba7Level      wroteGEQLevelCh(2, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba7Width       readGEQWidthCh(2, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba7Width(N)   writeGEQWidthCh(2, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba7Width      wroteGEQWidthCh(2, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba8Freq        readGEQFreqCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba8Freq(N)    writeGEQFreqCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba8Freq       wroteGEQFreqCh(2, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba8Level       readGEQLevelCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba8Level(N)   writeGEQLevelCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba8Level      wroteGEQLevelCh(2, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba8Width       readGEQWidthCh(2, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba8Width(N)   writeGEQWidthCh(2, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba8Width      wroteGEQWidthCh(2, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba9Freq        readGEQFreqCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba9Freq(N)    writeGEQFreqCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba9Freq       wroteGEQFreqCh(2, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba9Level       readGEQLevelCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba9Level(N)   writeGEQLevelCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba9Level      wroteGEQLevelCh(2, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba9Width       readGEQWidthCh(2, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba9Width(N)   writeGEQWidthCh(2, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba9Width      wroteGEQWidthCh(2, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba10Freq        readGEQFreqCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba10Freq(N)    writeGEQFreqCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba10Freq       wroteGEQFreqCh(2, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba10Level       readGEQLevelCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba10Level(N)   writeGEQLevelCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba10Level      wroteGEQLevelCh(2, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba10Width       readGEQWidthCh(2, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba10Width(N)   writeGEQWidthCh(2, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba10Width      wroteGEQWidthCh(2, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba11Freq        readGEQFreqCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba11Freq(N)    writeGEQFreqCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba11Freq       wroteGEQFreqCh(2, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba11Level       readGEQLevelCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba11Level(N)   writeGEQLevelCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba11Level      wroteGEQLevelCh(2, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba11Width       readGEQWidthCh(2, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba11Width(N)   writeGEQWidthCh(2, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba11Width      wroteGEQWidthCh(2, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba12Freq        readGEQFreqCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba12Freq(N)    writeGEQFreqCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba12Freq       wroteGEQFreqCh(2, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba12Level       readGEQLevelCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba12Level(N)   writeGEQLevelCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba12Level      wroteGEQLevelCh(2, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba12Width       readGEQWidthCh(2, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba12Width(N)   writeGEQWidthCh(2, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba12Width      wroteGEQWidthCh(2, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba13Freq        readGEQFreqCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba13Freq(N)    writeGEQFreqCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba13Freq       wroteGEQFreqCh(2, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba13Level       readGEQLevelCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba13Level(N)   writeGEQLevelCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba13Level      wroteGEQLevelCh(2, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba13Width       readGEQWidthCh(2, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba13Width(N)   writeGEQWidthCh(2, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba13Width      wroteGEQWidthCh(2, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba14Freq        readGEQFreqCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba14Freq(N)    writeGEQFreqCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba14Freq       wroteGEQFreqCh(2, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba14Level       readGEQLevelCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba14Level(N)   writeGEQLevelCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba14Level      wroteGEQLevelCh(2, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba14Width       readGEQWidthCh(2, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba14Width(N)   writeGEQWidthCh(2, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba14Width      wroteGEQWidthCh(2, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba15Freq        readGEQFreqCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba15Freq(N)    writeGEQFreqCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba15Freq       wroteGEQFreqCh(2, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba15Level       readGEQLevelCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba15Level(N)   writeGEQLevelCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba15Level      wroteGEQLevelCh(2, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba15Width       readGEQWidthCh(2, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba15Width(N)   writeGEQWidthCh(2, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba15Width      wroteGEQWidthCh(2, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba16Freq        readGEQFreqCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba16Freq(N)    writeGEQFreqCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba16Freq       wroteGEQFreqCh(2, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba16Level       readGEQLevelCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba16Level(N)   writeGEQLevelCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba16Level      wroteGEQLevelCh(2, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba16Width       readGEQWidthCh(2, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba16Width(N)   writeGEQWidthCh(2, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba16Width      wroteGEQWidthCh(2, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba17Freq        readGEQFreqCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba17Freq(N)    writeGEQFreqCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba17Freq       wroteGEQFreqCh(2, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba17Level       readGEQLevelCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba17Level(N)   writeGEQLevelCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba17Level      wroteGEQLevelCh(2, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba17Width       readGEQWidthCh(2, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba17Width(N)   writeGEQWidthCh(2, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba17Width      wroteGEQWidthCh(2, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba18Freq        readGEQFreqCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba18Freq(N)    writeGEQFreqCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba18Freq       wroteGEQFreqCh(2, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba18Level       readGEQLevelCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba18Level(N)   writeGEQLevelCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba18Level      wroteGEQLevelCh(2, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba18Width       readGEQWidthCh(2, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba18Width(N)   writeGEQWidthCh(2, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba18Width      wroteGEQWidthCh(2, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba19Freq        readGEQFreqCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba19Freq(N)    writeGEQFreqCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba19Freq       wroteGEQFreqCh(2, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba19Level       readGEQLevelCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba19Level(N)   writeGEQLevelCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba19Level      wroteGEQLevelCh(2, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba19Width       readGEQWidthCh(2, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba19Width(N)   writeGEQWidthCh(2, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba19Width      wroteGEQWidthCh(2, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba20Freq        readGEQFreqCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba20Freq(N)    writeGEQFreqCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba20Freq       wroteGEQFreqCh(2, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba20Level       readGEQLevelCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba20Level(N)   writeGEQLevelCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba20Level      wroteGEQLevelCh(2, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba20Width       readGEQWidthCh(2, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba20Width(N)   writeGEQWidthCh(2, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba20Width      wroteGEQWidthCh(2, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba21Freq        readGEQFreqCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba21Freq(N)    writeGEQFreqCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba21Freq       wroteGEQFreqCh(2, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba21Level       readGEQLevelCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba21Level(N)   writeGEQLevelCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba21Level      wroteGEQLevelCh(2, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba21Width       readGEQWidthCh(2, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba21Width(N)   writeGEQWidthCh(2, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba21Width      wroteGEQWidthCh(2, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba22Freq        readGEQFreqCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba22Freq(N)    writeGEQFreqCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba22Freq       wroteGEQFreqCh(2, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba22Level       readGEQLevelCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba22Level(N)   writeGEQLevelCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba22Level      wroteGEQLevelCh(2, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba22Width       readGEQWidthCh(2, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba22Width(N)   writeGEQWidthCh(2, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba22Width      wroteGEQWidthCh(2, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba23Freq        readGEQFreqCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba23Freq(N)    writeGEQFreqCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba23Freq       wroteGEQFreqCh(2, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba23Level       readGEQLevelCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba23Level(N)   writeGEQLevelCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba23Level      wroteGEQLevelCh(2, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba23Width       readGEQWidthCh(2, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba23Width(N)   writeGEQWidthCh(2, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba23Width      wroteGEQWidthCh(2, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba24Freq        readGEQFreqCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba24Freq(N)    writeGEQFreqCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba24Freq       wroteGEQFreqCh(2, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba24Level       readGEQLevelCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba24Level(N)   writeGEQLevelCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba24Level      wroteGEQLevelCh(2, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba24Width       readGEQWidthCh(2, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba24Width(N)   writeGEQWidthCh(2, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba24Width      wroteGEQWidthCh(2, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba25Freq        readGEQFreqCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba25Freq(N)    writeGEQFreqCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba25Freq       wroteGEQFreqCh(2, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba25Level       readGEQLevelCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba25Level(N)   writeGEQLevelCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba25Level      wroteGEQLevelCh(2, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba25Width       readGEQWidthCh(2, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba25Width(N)   writeGEQWidthCh(2, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba25Width      wroteGEQWidthCh(2, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba26Freq        readGEQFreqCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba26Freq(N)    writeGEQFreqCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba26Freq       wroteGEQFreqCh(2, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba26Level       readGEQLevelCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba26Level(N)   writeGEQLevelCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba26Level      wroteGEQLevelCh(2, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba26Width       readGEQWidthCh(2, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba26Width(N)   writeGEQWidthCh(2, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba26Width      wroteGEQWidthCh(2, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba27Freq        readGEQFreqCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba27Freq(N)    writeGEQFreqCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba27Freq       wroteGEQFreqCh(2, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba27Level       readGEQLevelCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba27Level(N)   writeGEQLevelCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba27Level      wroteGEQLevelCh(2, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba27Width       readGEQWidthCh(2, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba27Width(N)   writeGEQWidthCh(2, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba27Width      wroteGEQWidthCh(2, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba28Freq        readGEQFreqCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba28Freq(N)    writeGEQFreqCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba28Freq       wroteGEQFreqCh(2, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba28Level       readGEQLevelCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba28Level(N)   writeGEQLevelCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba28Level      wroteGEQLevelCh(2, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba28Width       readGEQWidthCh(2, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba28Width(N)   writeGEQWidthCh(2, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba28Width      wroteGEQWidthCh(2, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba29Freq        readGEQFreqCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba29Freq(N)    writeGEQFreqCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba29Freq       wroteGEQFreqCh(2, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba29Level       readGEQLevelCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba29Level(N)   writeGEQLevelCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba29Level      wroteGEQLevelCh(2, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba29Width       readGEQWidthCh(2, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba29Width(N)   writeGEQWidthCh(2, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba29Width      wroteGEQWidthCh(2, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba30Freq        readGEQFreqCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba30Freq(N)    writeGEQFreqCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba30Freq       wroteGEQFreqCh(2, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba30Level       readGEQLevelCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba30Level(N)   writeGEQLevelCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba30Level      wroteGEQLevelCh(2, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba30Width       readGEQWidthCh(2, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba30Width(N)   writeGEQWidthCh(2, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba30Width      wroteGEQWidthCh(2, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba31Freq        readGEQFreqCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba31Freq(N)    writeGEQFreqCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba31Freq       wroteGEQFreqCh(2, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba31Level       readGEQLevelCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba31Level(N)   writeGEQLevelCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba31Level      wroteGEQLevelCh(2, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba31Width       readGEQWidthCh(2, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba31Width(N)   writeGEQWidthCh(2, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba31Width      wroteGEQWidthCh(2, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh2Ba32Freq        readGEQFreqCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba32Freq(N)    writeGEQFreqCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba32Freq       wroteGEQFreqCh(2, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba32Level       readGEQLevelCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba32Level(N)   writeGEQLevelCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba32Level      wroteGEQLevelCh(2, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh2Ba32Width       readGEQWidthCh(2, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh2Ba32Width(N)   writeGEQWidthCh(2, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh2Ba32Width      wroteGEQWidthCh(2, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba1Freq        readGEQFreqCh(3, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba1Freq(N)    writeGEQFreqCh(3, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba1Freq       wroteGEQFreqCh(3, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba1Level       readGEQLevelCh(3, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba1Level(N)   writeGEQLevelCh(3, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba1Level      wroteGEQLevelCh(3, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba1Width       readGEQWidthCh(3, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba1Width(N)   writeGEQWidthCh(3, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba1Width      wroteGEQWidthCh(3, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba2Freq        readGEQFreqCh(3, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba2Freq(N)    writeGEQFreqCh(3, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba2Freq       wroteGEQFreqCh(3, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba2Level       readGEQLevelCh(3, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba2Level(N)   writeGEQLevelCh(3, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba2Level      wroteGEQLevelCh(3, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba2Width       readGEQWidthCh(3, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba2Width(N)   writeGEQWidthCh(3, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba2Width      wroteGEQWidthCh(3, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba3Freq        readGEQFreqCh(3, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba3Freq(N)    writeGEQFreqCh(3, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba3Freq       wroteGEQFreqCh(3, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba3Level       readGEQLevelCh(3, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba3Level(N)   writeGEQLevelCh(3, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba3Level      wroteGEQLevelCh(3, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba3Width       readGEQWidthCh(3, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba3Width(N)   writeGEQWidthCh(3, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba3Width      wroteGEQWidthCh(3, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba4Freq        readGEQFreqCh(3, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba4Freq(N)    writeGEQFreqCh(3, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba4Freq       wroteGEQFreqCh(3, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba4Level       readGEQLevelCh(3, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba4Level(N)   writeGEQLevelCh(3, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba4Level      wroteGEQLevelCh(3, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba4Width       readGEQWidthCh(3, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba4Width(N)   writeGEQWidthCh(3, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba4Width      wroteGEQWidthCh(3, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba5Freq        readGEQFreqCh(3, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba5Freq(N)    writeGEQFreqCh(3, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba5Freq       wroteGEQFreqCh(3, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba5Level       readGEQLevelCh(3, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba5Level(N)   writeGEQLevelCh(3, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba5Level      wroteGEQLevelCh(3, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba5Width       readGEQWidthCh(3, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba5Width(N)   writeGEQWidthCh(3, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba5Width      wroteGEQWidthCh(3, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba6Freq        readGEQFreqCh(3, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba6Freq(N)    writeGEQFreqCh(3, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba6Freq       wroteGEQFreqCh(3, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba6Level       readGEQLevelCh(3, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba6Level(N)   writeGEQLevelCh(3, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba6Level      wroteGEQLevelCh(3, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba6Width       readGEQWidthCh(3, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba6Width(N)   writeGEQWidthCh(3, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba6Width      wroteGEQWidthCh(3, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba7Freq        readGEQFreqCh(3, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba7Freq(N)    writeGEQFreqCh(3, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba7Freq       wroteGEQFreqCh(3, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba7Level       readGEQLevelCh(3, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba7Level(N)   writeGEQLevelCh(3, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba7Level      wroteGEQLevelCh(3, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba7Width       readGEQWidthCh(3, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba7Width(N)   writeGEQWidthCh(3, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba7Width      wroteGEQWidthCh(3, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba8Freq        readGEQFreqCh(3, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba8Freq(N)    writeGEQFreqCh(3, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba8Freq       wroteGEQFreqCh(3, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba8Level       readGEQLevelCh(3, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba8Level(N)   writeGEQLevelCh(3, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba8Level      wroteGEQLevelCh(3, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba8Width       readGEQWidthCh(3, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba8Width(N)   writeGEQWidthCh(3, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba8Width      wroteGEQWidthCh(3, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba9Freq        readGEQFreqCh(3, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba9Freq(N)    writeGEQFreqCh(3, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba9Freq       wroteGEQFreqCh(3, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba9Level       readGEQLevelCh(3, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba9Level(N)   writeGEQLevelCh(3, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba9Level      wroteGEQLevelCh(3, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba9Width       readGEQWidthCh(3, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba9Width(N)   writeGEQWidthCh(3, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba9Width      wroteGEQWidthCh(3, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba10Freq        readGEQFreqCh(3, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba10Freq(N)    writeGEQFreqCh(3, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba10Freq       wroteGEQFreqCh(3, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba10Level       readGEQLevelCh(3, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba10Level(N)   writeGEQLevelCh(3, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba10Level      wroteGEQLevelCh(3, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba10Width       readGEQWidthCh(3, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba10Width(N)   writeGEQWidthCh(3, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba10Width      wroteGEQWidthCh(3, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba11Freq        readGEQFreqCh(3, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba11Freq(N)    writeGEQFreqCh(3, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba11Freq       wroteGEQFreqCh(3, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba11Level       readGEQLevelCh(3, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba11Level(N)   writeGEQLevelCh(3, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba11Level      wroteGEQLevelCh(3, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba11Width       readGEQWidthCh(3, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba11Width(N)   writeGEQWidthCh(3, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba11Width      wroteGEQWidthCh(3, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba12Freq        readGEQFreqCh(3, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba12Freq(N)    writeGEQFreqCh(3, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba12Freq       wroteGEQFreqCh(3, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba12Level       readGEQLevelCh(3, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba12Level(N)   writeGEQLevelCh(3, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba12Level      wroteGEQLevelCh(3, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba12Width       readGEQWidthCh(3, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba12Width(N)   writeGEQWidthCh(3, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba12Width      wroteGEQWidthCh(3, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba13Freq        readGEQFreqCh(3, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba13Freq(N)    writeGEQFreqCh(3, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba13Freq       wroteGEQFreqCh(3, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba13Level       readGEQLevelCh(3, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba13Level(N)   writeGEQLevelCh(3, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba13Level      wroteGEQLevelCh(3, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba13Width       readGEQWidthCh(3, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba13Width(N)   writeGEQWidthCh(3, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba13Width      wroteGEQWidthCh(3, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba14Freq        readGEQFreqCh(3, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba14Freq(N)    writeGEQFreqCh(3, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba14Freq       wroteGEQFreqCh(3, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba14Level       readGEQLevelCh(3, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba14Level(N)   writeGEQLevelCh(3, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba14Level      wroteGEQLevelCh(3, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba14Width       readGEQWidthCh(3, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba14Width(N)   writeGEQWidthCh(3, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba14Width      wroteGEQWidthCh(3, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba15Freq        readGEQFreqCh(3, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba15Freq(N)    writeGEQFreqCh(3, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba15Freq       wroteGEQFreqCh(3, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba15Level       readGEQLevelCh(3, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba15Level(N)   writeGEQLevelCh(3, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba15Level      wroteGEQLevelCh(3, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba15Width       readGEQWidthCh(3, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba15Width(N)   writeGEQWidthCh(3, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba15Width      wroteGEQWidthCh(3, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba16Freq        readGEQFreqCh(3, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba16Freq(N)    writeGEQFreqCh(3, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba16Freq       wroteGEQFreqCh(3, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba16Level       readGEQLevelCh(3, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba16Level(N)   writeGEQLevelCh(3, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba16Level      wroteGEQLevelCh(3, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba16Width       readGEQWidthCh(3, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba16Width(N)   writeGEQWidthCh(3, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba16Width      wroteGEQWidthCh(3, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba17Freq        readGEQFreqCh(3, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba17Freq(N)    writeGEQFreqCh(3, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba17Freq       wroteGEQFreqCh(3, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba17Level       readGEQLevelCh(3, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba17Level(N)   writeGEQLevelCh(3, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba17Level      wroteGEQLevelCh(3, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba17Width       readGEQWidthCh(3, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba17Width(N)   writeGEQWidthCh(3, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba17Width      wroteGEQWidthCh(3, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba18Freq        readGEQFreqCh(3, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba18Freq(N)    writeGEQFreqCh(3, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba18Freq       wroteGEQFreqCh(3, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba18Level       readGEQLevelCh(3, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba18Level(N)   writeGEQLevelCh(3, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba18Level      wroteGEQLevelCh(3, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba18Width       readGEQWidthCh(3, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba18Width(N)   writeGEQWidthCh(3, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba18Width      wroteGEQWidthCh(3, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba19Freq        readGEQFreqCh(3, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba19Freq(N)    writeGEQFreqCh(3, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba19Freq       wroteGEQFreqCh(3, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba19Level       readGEQLevelCh(3, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba19Level(N)   writeGEQLevelCh(3, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba19Level      wroteGEQLevelCh(3, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba19Width       readGEQWidthCh(3, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba19Width(N)   writeGEQWidthCh(3, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba19Width      wroteGEQWidthCh(3, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba20Freq        readGEQFreqCh(3, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba20Freq(N)    writeGEQFreqCh(3, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba20Freq       wroteGEQFreqCh(3, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba20Level       readGEQLevelCh(3, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba20Level(N)   writeGEQLevelCh(3, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba20Level      wroteGEQLevelCh(3, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba20Width       readGEQWidthCh(3, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba20Width(N)   writeGEQWidthCh(3, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba20Width      wroteGEQWidthCh(3, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba21Freq        readGEQFreqCh(3, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba21Freq(N)    writeGEQFreqCh(3, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba21Freq       wroteGEQFreqCh(3, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba21Level       readGEQLevelCh(3, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba21Level(N)   writeGEQLevelCh(3, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba21Level      wroteGEQLevelCh(3, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba21Width       readGEQWidthCh(3, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba21Width(N)   writeGEQWidthCh(3, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba21Width      wroteGEQWidthCh(3, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba22Freq        readGEQFreqCh(3, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba22Freq(N)    writeGEQFreqCh(3, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba22Freq       wroteGEQFreqCh(3, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba22Level       readGEQLevelCh(3, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba22Level(N)   writeGEQLevelCh(3, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba22Level      wroteGEQLevelCh(3, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba22Width       readGEQWidthCh(3, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba22Width(N)   writeGEQWidthCh(3, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba22Width      wroteGEQWidthCh(3, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba23Freq        readGEQFreqCh(3, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba23Freq(N)    writeGEQFreqCh(3, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba23Freq       wroteGEQFreqCh(3, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba23Level       readGEQLevelCh(3, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba23Level(N)   writeGEQLevelCh(3, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba23Level      wroteGEQLevelCh(3, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba23Width       readGEQWidthCh(3, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba23Width(N)   writeGEQWidthCh(3, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba23Width      wroteGEQWidthCh(3, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba24Freq        readGEQFreqCh(3, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba24Freq(N)    writeGEQFreqCh(3, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba24Freq       wroteGEQFreqCh(3, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba24Level       readGEQLevelCh(3, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba24Level(N)   writeGEQLevelCh(3, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba24Level      wroteGEQLevelCh(3, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba24Width       readGEQWidthCh(3, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba24Width(N)   writeGEQWidthCh(3, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba24Width      wroteGEQWidthCh(3, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba25Freq        readGEQFreqCh(3, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba25Freq(N)    writeGEQFreqCh(3, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba25Freq       wroteGEQFreqCh(3, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba25Level       readGEQLevelCh(3, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba25Level(N)   writeGEQLevelCh(3, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba25Level      wroteGEQLevelCh(3, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba25Width       readGEQWidthCh(3, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba25Width(N)   writeGEQWidthCh(3, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba25Width      wroteGEQWidthCh(3, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba26Freq        readGEQFreqCh(3, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba26Freq(N)    writeGEQFreqCh(3, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba26Freq       wroteGEQFreqCh(3, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba26Level       readGEQLevelCh(3, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba26Level(N)   writeGEQLevelCh(3, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba26Level      wroteGEQLevelCh(3, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba26Width       readGEQWidthCh(3, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba26Width(N)   writeGEQWidthCh(3, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba26Width      wroteGEQWidthCh(3, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba27Freq        readGEQFreqCh(3, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba27Freq(N)    writeGEQFreqCh(3, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba27Freq       wroteGEQFreqCh(3, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba27Level       readGEQLevelCh(3, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba27Level(N)   writeGEQLevelCh(3, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba27Level      wroteGEQLevelCh(3, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba27Width       readGEQWidthCh(3, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba27Width(N)   writeGEQWidthCh(3, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba27Width      wroteGEQWidthCh(3, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba28Freq        readGEQFreqCh(3, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba28Freq(N)    writeGEQFreqCh(3, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba28Freq       wroteGEQFreqCh(3, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba28Level       readGEQLevelCh(3, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba28Level(N)   writeGEQLevelCh(3, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba28Level      wroteGEQLevelCh(3, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba28Width       readGEQWidthCh(3, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba28Width(N)   writeGEQWidthCh(3, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba28Width      wroteGEQWidthCh(3, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba29Freq        readGEQFreqCh(3, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba29Freq(N)    writeGEQFreqCh(3, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba29Freq       wroteGEQFreqCh(3, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba29Level       readGEQLevelCh(3, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba29Level(N)   writeGEQLevelCh(3, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba29Level      wroteGEQLevelCh(3, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba29Width       readGEQWidthCh(3, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba29Width(N)   writeGEQWidthCh(3, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba29Width      wroteGEQWidthCh(3, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba30Freq        readGEQFreqCh(3, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba30Freq(N)    writeGEQFreqCh(3, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba30Freq       wroteGEQFreqCh(3, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba30Level       readGEQLevelCh(3, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba30Level(N)   writeGEQLevelCh(3, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba30Level      wroteGEQLevelCh(3, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba30Width       readGEQWidthCh(3, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba30Width(N)   writeGEQWidthCh(3, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba30Width      wroteGEQWidthCh(3, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba31Freq        readGEQFreqCh(3, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba31Freq(N)    writeGEQFreqCh(3, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba31Freq       wroteGEQFreqCh(3, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba31Level       readGEQLevelCh(3, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba31Level(N)   writeGEQLevelCh(3, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba31Level      wroteGEQLevelCh(3, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba31Width       readGEQWidthCh(3, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba31Width(N)   writeGEQWidthCh(3, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba31Width      wroteGEQWidthCh(3, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh3Ba32Freq        readGEQFreqCh(3, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba32Freq(N)    writeGEQFreqCh(3, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba32Freq       wroteGEQFreqCh(3, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba32Level       readGEQLevelCh(3, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba32Level(N)   writeGEQLevelCh(3, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba32Level      wroteGEQLevelCh(3, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh3Ba32Width       readGEQWidthCh(3, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh3Ba32Width(N)   writeGEQWidthCh(3, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh3Ba32Width      wroteGEQWidthCh(3, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba1Freq        readGEQFreqCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba1Freq(N)    writeGEQFreqCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba1Freq       wroteGEQFreqCh(4, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba1Level       readGEQLevelCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba1Level(N)   writeGEQLevelCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba1Level      wroteGEQLevelCh(4, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba1Width       readGEQWidthCh(4, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba1Width(N)   writeGEQWidthCh(4, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba1Width      wroteGEQWidthCh(4, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba2Freq        readGEQFreqCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba2Freq(N)    writeGEQFreqCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba2Freq       wroteGEQFreqCh(4, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba2Level       readGEQLevelCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba2Level(N)   writeGEQLevelCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba2Level      wroteGEQLevelCh(4, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba2Width       readGEQWidthCh(4, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba2Width(N)   writeGEQWidthCh(4, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba2Width      wroteGEQWidthCh(4, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba3Freq        readGEQFreqCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba3Freq(N)    writeGEQFreqCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba3Freq       wroteGEQFreqCh(4, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba3Level       readGEQLevelCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba3Level(N)   writeGEQLevelCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba3Level      wroteGEQLevelCh(4, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba3Width       readGEQWidthCh(4, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba3Width(N)   writeGEQWidthCh(4, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba3Width      wroteGEQWidthCh(4, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba4Freq        readGEQFreqCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba4Freq(N)    writeGEQFreqCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba4Freq       wroteGEQFreqCh(4, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba4Level       readGEQLevelCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba4Level(N)   writeGEQLevelCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba4Level      wroteGEQLevelCh(4, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba4Width       readGEQWidthCh(4, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba4Width(N)   writeGEQWidthCh(4, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba4Width      wroteGEQWidthCh(4, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba5Freq        readGEQFreqCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba5Freq(N)    writeGEQFreqCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba5Freq       wroteGEQFreqCh(4, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba5Level       readGEQLevelCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba5Level(N)   writeGEQLevelCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba5Level      wroteGEQLevelCh(4, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba5Width       readGEQWidthCh(4, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba5Width(N)   writeGEQWidthCh(4, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba5Width      wroteGEQWidthCh(4, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba6Freq        readGEQFreqCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba6Freq(N)    writeGEQFreqCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba6Freq       wroteGEQFreqCh(4, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba6Level       readGEQLevelCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba6Level(N)   writeGEQLevelCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba6Level      wroteGEQLevelCh(4, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba6Width       readGEQWidthCh(4, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba6Width(N)   writeGEQWidthCh(4, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba6Width      wroteGEQWidthCh(4, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba7Freq        readGEQFreqCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba7Freq(N)    writeGEQFreqCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba7Freq       wroteGEQFreqCh(4, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba7Level       readGEQLevelCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba7Level(N)   writeGEQLevelCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba7Level      wroteGEQLevelCh(4, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba7Width       readGEQWidthCh(4, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba7Width(N)   writeGEQWidthCh(4, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba7Width      wroteGEQWidthCh(4, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba8Freq        readGEQFreqCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba8Freq(N)    writeGEQFreqCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba8Freq       wroteGEQFreqCh(4, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba8Level       readGEQLevelCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba8Level(N)   writeGEQLevelCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba8Level      wroteGEQLevelCh(4, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba8Width       readGEQWidthCh(4, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba8Width(N)   writeGEQWidthCh(4, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba8Width      wroteGEQWidthCh(4, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba9Freq        readGEQFreqCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba9Freq(N)    writeGEQFreqCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba9Freq       wroteGEQFreqCh(4, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba9Level       readGEQLevelCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba9Level(N)   writeGEQLevelCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba9Level      wroteGEQLevelCh(4, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba9Width       readGEQWidthCh(4, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba9Width(N)   writeGEQWidthCh(4, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba9Width      wroteGEQWidthCh(4, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba10Freq        readGEQFreqCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba10Freq(N)    writeGEQFreqCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba10Freq       wroteGEQFreqCh(4, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba10Level       readGEQLevelCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba10Level(N)   writeGEQLevelCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba10Level      wroteGEQLevelCh(4, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba10Width       readGEQWidthCh(4, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba10Width(N)   writeGEQWidthCh(4, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba10Width      wroteGEQWidthCh(4, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba11Freq        readGEQFreqCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba11Freq(N)    writeGEQFreqCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba11Freq       wroteGEQFreqCh(4, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba11Level       readGEQLevelCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba11Level(N)   writeGEQLevelCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba11Level      wroteGEQLevelCh(4, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba11Width       readGEQWidthCh(4, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba11Width(N)   writeGEQWidthCh(4, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba11Width      wroteGEQWidthCh(4, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba12Freq        readGEQFreqCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba12Freq(N)    writeGEQFreqCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba12Freq       wroteGEQFreqCh(4, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba12Level       readGEQLevelCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba12Level(N)   writeGEQLevelCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba12Level      wroteGEQLevelCh(4, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba12Width       readGEQWidthCh(4, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba12Width(N)   writeGEQWidthCh(4, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba12Width      wroteGEQWidthCh(4, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba13Freq        readGEQFreqCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba13Freq(N)    writeGEQFreqCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba13Freq       wroteGEQFreqCh(4, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba13Level       readGEQLevelCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba13Level(N)   writeGEQLevelCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba13Level      wroteGEQLevelCh(4, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba13Width       readGEQWidthCh(4, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba13Width(N)   writeGEQWidthCh(4, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba13Width      wroteGEQWidthCh(4, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba14Freq        readGEQFreqCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba14Freq(N)    writeGEQFreqCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba14Freq       wroteGEQFreqCh(4, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba14Level       readGEQLevelCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba14Level(N)   writeGEQLevelCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba14Level      wroteGEQLevelCh(4, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba14Width       readGEQWidthCh(4, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba14Width(N)   writeGEQWidthCh(4, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba14Width      wroteGEQWidthCh(4, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba15Freq        readGEQFreqCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba15Freq(N)    writeGEQFreqCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba15Freq       wroteGEQFreqCh(4, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba15Level       readGEQLevelCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba15Level(N)   writeGEQLevelCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba15Level      wroteGEQLevelCh(4, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba15Width       readGEQWidthCh(4, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba15Width(N)   writeGEQWidthCh(4, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba15Width      wroteGEQWidthCh(4, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba16Freq        readGEQFreqCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba16Freq(N)    writeGEQFreqCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba16Freq       wroteGEQFreqCh(4, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba16Level       readGEQLevelCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba16Level(N)   writeGEQLevelCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba16Level      wroteGEQLevelCh(4, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba16Width       readGEQWidthCh(4, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba16Width(N)   writeGEQWidthCh(4, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba16Width      wroteGEQWidthCh(4, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba17Freq        readGEQFreqCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba17Freq(N)    writeGEQFreqCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba17Freq       wroteGEQFreqCh(4, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba17Level       readGEQLevelCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba17Level(N)   writeGEQLevelCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba17Level      wroteGEQLevelCh(4, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba17Width       readGEQWidthCh(4, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba17Width(N)   writeGEQWidthCh(4, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba17Width      wroteGEQWidthCh(4, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba18Freq        readGEQFreqCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba18Freq(N)    writeGEQFreqCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba18Freq       wroteGEQFreqCh(4, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba18Level       readGEQLevelCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba18Level(N)   writeGEQLevelCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba18Level      wroteGEQLevelCh(4, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba18Width       readGEQWidthCh(4, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba18Width(N)   writeGEQWidthCh(4, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba18Width      wroteGEQWidthCh(4, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba19Freq        readGEQFreqCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba19Freq(N)    writeGEQFreqCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba19Freq       wroteGEQFreqCh(4, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba19Level       readGEQLevelCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba19Level(N)   writeGEQLevelCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba19Level      wroteGEQLevelCh(4, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba19Width       readGEQWidthCh(4, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba19Width(N)   writeGEQWidthCh(4, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba19Width      wroteGEQWidthCh(4, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba20Freq        readGEQFreqCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba20Freq(N)    writeGEQFreqCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba20Freq       wroteGEQFreqCh(4, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba20Level       readGEQLevelCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba20Level(N)   writeGEQLevelCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba20Level      wroteGEQLevelCh(4, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba20Width       readGEQWidthCh(4, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba20Width(N)   writeGEQWidthCh(4, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba20Width      wroteGEQWidthCh(4, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba21Freq        readGEQFreqCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba21Freq(N)    writeGEQFreqCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba21Freq       wroteGEQFreqCh(4, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba21Level       readGEQLevelCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba21Level(N)   writeGEQLevelCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba21Level      wroteGEQLevelCh(4, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba21Width       readGEQWidthCh(4, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba21Width(N)   writeGEQWidthCh(4, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba21Width      wroteGEQWidthCh(4, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba22Freq        readGEQFreqCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba22Freq(N)    writeGEQFreqCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba22Freq       wroteGEQFreqCh(4, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba22Level       readGEQLevelCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba22Level(N)   writeGEQLevelCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba22Level      wroteGEQLevelCh(4, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba22Width       readGEQWidthCh(4, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba22Width(N)   writeGEQWidthCh(4, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba22Width      wroteGEQWidthCh(4, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba23Freq        readGEQFreqCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba23Freq(N)    writeGEQFreqCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba23Freq       wroteGEQFreqCh(4, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba23Level       readGEQLevelCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba23Level(N)   writeGEQLevelCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba23Level      wroteGEQLevelCh(4, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba23Width       readGEQWidthCh(4, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba23Width(N)   writeGEQWidthCh(4, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba23Width      wroteGEQWidthCh(4, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba24Freq        readGEQFreqCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba24Freq(N)    writeGEQFreqCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba24Freq       wroteGEQFreqCh(4, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba24Level       readGEQLevelCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba24Level(N)   writeGEQLevelCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba24Level      wroteGEQLevelCh(4, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba24Width       readGEQWidthCh(4, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba24Width(N)   writeGEQWidthCh(4, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba24Width      wroteGEQWidthCh(4, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba25Freq        readGEQFreqCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba25Freq(N)    writeGEQFreqCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba25Freq       wroteGEQFreqCh(4, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba25Level       readGEQLevelCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba25Level(N)   writeGEQLevelCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba25Level      wroteGEQLevelCh(4, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba25Width       readGEQWidthCh(4, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba25Width(N)   writeGEQWidthCh(4, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba25Width      wroteGEQWidthCh(4, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba26Freq        readGEQFreqCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba26Freq(N)    writeGEQFreqCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba26Freq       wroteGEQFreqCh(4, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba26Level       readGEQLevelCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba26Level(N)   writeGEQLevelCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba26Level      wroteGEQLevelCh(4, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba26Width       readGEQWidthCh(4, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba26Width(N)   writeGEQWidthCh(4, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba26Width      wroteGEQWidthCh(4, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba27Freq        readGEQFreqCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba27Freq(N)    writeGEQFreqCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba27Freq       wroteGEQFreqCh(4, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba27Level       readGEQLevelCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba27Level(N)   writeGEQLevelCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba27Level      wroteGEQLevelCh(4, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba27Width       readGEQWidthCh(4, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba27Width(N)   writeGEQWidthCh(4, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba27Width      wroteGEQWidthCh(4, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba28Freq        readGEQFreqCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba28Freq(N)    writeGEQFreqCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba28Freq       wroteGEQFreqCh(4, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba28Level       readGEQLevelCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba28Level(N)   writeGEQLevelCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba28Level      wroteGEQLevelCh(4, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba28Width       readGEQWidthCh(4, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba28Width(N)   writeGEQWidthCh(4, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba28Width      wroteGEQWidthCh(4, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba29Freq        readGEQFreqCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba29Freq(N)    writeGEQFreqCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba29Freq       wroteGEQFreqCh(4, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba29Level       readGEQLevelCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba29Level(N)   writeGEQLevelCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba29Level      wroteGEQLevelCh(4, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba29Width       readGEQWidthCh(4, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba29Width(N)   writeGEQWidthCh(4, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba29Width      wroteGEQWidthCh(4, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba30Freq        readGEQFreqCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba30Freq(N)    writeGEQFreqCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba30Freq       wroteGEQFreqCh(4, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba30Level       readGEQLevelCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba30Level(N)   writeGEQLevelCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba30Level      wroteGEQLevelCh(4, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba30Width       readGEQWidthCh(4, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba30Width(N)   writeGEQWidthCh(4, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba30Width      wroteGEQWidthCh(4, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba31Freq        readGEQFreqCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba31Freq(N)    writeGEQFreqCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba31Freq       wroteGEQFreqCh(4, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba31Level       readGEQLevelCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba31Level(N)   writeGEQLevelCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba31Level      wroteGEQLevelCh(4, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba31Width       readGEQWidthCh(4, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba31Width(N)   writeGEQWidthCh(4, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba31Width      wroteGEQWidthCh(4, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh4Ba32Freq        readGEQFreqCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba32Freq(N)    writeGEQFreqCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba32Freq       wroteGEQFreqCh(4, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba32Level       readGEQLevelCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba32Level(N)   writeGEQLevelCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba32Level      wroteGEQLevelCh(4, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh4Ba32Width       readGEQWidthCh(4, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh4Ba32Width(N)   writeGEQWidthCh(4, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh4Ba32Width      wroteGEQWidthCh(4, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba1Freq        readGEQFreqCh(5, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba1Freq(N)    writeGEQFreqCh(5, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba1Freq       wroteGEQFreqCh(5, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba1Level       readGEQLevelCh(5, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba1Level(N)   writeGEQLevelCh(5, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba1Level      wroteGEQLevelCh(5, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba1Width       readGEQWidthCh(5, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba1Width(N)   writeGEQWidthCh(5, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba1Width      wroteGEQWidthCh(5, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba2Freq        readGEQFreqCh(5, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba2Freq(N)    writeGEQFreqCh(5, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba2Freq       wroteGEQFreqCh(5, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba2Level       readGEQLevelCh(5, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba2Level(N)   writeGEQLevelCh(5, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba2Level      wroteGEQLevelCh(5, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba2Width       readGEQWidthCh(5, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba2Width(N)   writeGEQWidthCh(5, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba2Width      wroteGEQWidthCh(5, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba3Freq        readGEQFreqCh(5, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba3Freq(N)    writeGEQFreqCh(5, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba3Freq       wroteGEQFreqCh(5, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba3Level       readGEQLevelCh(5, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba3Level(N)   writeGEQLevelCh(5, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba3Level      wroteGEQLevelCh(5, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba3Width       readGEQWidthCh(5, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba3Width(N)   writeGEQWidthCh(5, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba3Width      wroteGEQWidthCh(5, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba4Freq        readGEQFreqCh(5, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba4Freq(N)    writeGEQFreqCh(5, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba4Freq       wroteGEQFreqCh(5, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba4Level       readGEQLevelCh(5, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba4Level(N)   writeGEQLevelCh(5, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba4Level      wroteGEQLevelCh(5, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba4Width       readGEQWidthCh(5, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba4Width(N)   writeGEQWidthCh(5, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba4Width      wroteGEQWidthCh(5, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba5Freq        readGEQFreqCh(5, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba5Freq(N)    writeGEQFreqCh(5, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba5Freq       wroteGEQFreqCh(5, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba5Level       readGEQLevelCh(5, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba5Level(N)   writeGEQLevelCh(5, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba5Level      wroteGEQLevelCh(5, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba5Width       readGEQWidthCh(5, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba5Width(N)   writeGEQWidthCh(5, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba5Width      wroteGEQWidthCh(5, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba6Freq        readGEQFreqCh(5, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba6Freq(N)    writeGEQFreqCh(5, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba6Freq       wroteGEQFreqCh(5, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba6Level       readGEQLevelCh(5, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba6Level(N)   writeGEQLevelCh(5, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba6Level      wroteGEQLevelCh(5, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba6Width       readGEQWidthCh(5, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba6Width(N)   writeGEQWidthCh(5, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba6Width      wroteGEQWidthCh(5, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba7Freq        readGEQFreqCh(5, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba7Freq(N)    writeGEQFreqCh(5, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba7Freq       wroteGEQFreqCh(5, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba7Level       readGEQLevelCh(5, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba7Level(N)   writeGEQLevelCh(5, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba7Level      wroteGEQLevelCh(5, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba7Width       readGEQWidthCh(5, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba7Width(N)   writeGEQWidthCh(5, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba7Width      wroteGEQWidthCh(5, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba8Freq        readGEQFreqCh(5, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba8Freq(N)    writeGEQFreqCh(5, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba8Freq       wroteGEQFreqCh(5, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba8Level       readGEQLevelCh(5, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba8Level(N)   writeGEQLevelCh(5, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba8Level      wroteGEQLevelCh(5, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba8Width       readGEQWidthCh(5, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba8Width(N)   writeGEQWidthCh(5, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba8Width      wroteGEQWidthCh(5, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba9Freq        readGEQFreqCh(5, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba9Freq(N)    writeGEQFreqCh(5, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba9Freq       wroteGEQFreqCh(5, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba9Level       readGEQLevelCh(5, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba9Level(N)   writeGEQLevelCh(5, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba9Level      wroteGEQLevelCh(5, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba9Width       readGEQWidthCh(5, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba9Width(N)   writeGEQWidthCh(5, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba9Width      wroteGEQWidthCh(5, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba10Freq        readGEQFreqCh(5, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba10Freq(N)    writeGEQFreqCh(5, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba10Freq       wroteGEQFreqCh(5, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba10Level       readGEQLevelCh(5, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba10Level(N)   writeGEQLevelCh(5, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba10Level      wroteGEQLevelCh(5, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba10Width       readGEQWidthCh(5, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba10Width(N)   writeGEQWidthCh(5, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba10Width      wroteGEQWidthCh(5, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba11Freq        readGEQFreqCh(5, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba11Freq(N)    writeGEQFreqCh(5, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba11Freq       wroteGEQFreqCh(5, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba11Level       readGEQLevelCh(5, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba11Level(N)   writeGEQLevelCh(5, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba11Level      wroteGEQLevelCh(5, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba11Width       readGEQWidthCh(5, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba11Width(N)   writeGEQWidthCh(5, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba11Width      wroteGEQWidthCh(5, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba12Freq        readGEQFreqCh(5, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba12Freq(N)    writeGEQFreqCh(5, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba12Freq       wroteGEQFreqCh(5, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba12Level       readGEQLevelCh(5, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba12Level(N)   writeGEQLevelCh(5, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba12Level      wroteGEQLevelCh(5, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba12Width       readGEQWidthCh(5, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba12Width(N)   writeGEQWidthCh(5, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba12Width      wroteGEQWidthCh(5, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba13Freq        readGEQFreqCh(5, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba13Freq(N)    writeGEQFreqCh(5, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba13Freq       wroteGEQFreqCh(5, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba13Level       readGEQLevelCh(5, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba13Level(N)   writeGEQLevelCh(5, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba13Level      wroteGEQLevelCh(5, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba13Width       readGEQWidthCh(5, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba13Width(N)   writeGEQWidthCh(5, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba13Width      wroteGEQWidthCh(5, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba14Freq        readGEQFreqCh(5, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba14Freq(N)    writeGEQFreqCh(5, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba14Freq       wroteGEQFreqCh(5, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba14Level       readGEQLevelCh(5, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba14Level(N)   writeGEQLevelCh(5, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba14Level      wroteGEQLevelCh(5, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba14Width       readGEQWidthCh(5, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba14Width(N)   writeGEQWidthCh(5, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba14Width      wroteGEQWidthCh(5, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba15Freq        readGEQFreqCh(5, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba15Freq(N)    writeGEQFreqCh(5, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba15Freq       wroteGEQFreqCh(5, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba15Level       readGEQLevelCh(5, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba15Level(N)   writeGEQLevelCh(5, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba15Level      wroteGEQLevelCh(5, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba15Width       readGEQWidthCh(5, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba15Width(N)   writeGEQWidthCh(5, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba15Width      wroteGEQWidthCh(5, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba16Freq        readGEQFreqCh(5, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba16Freq(N)    writeGEQFreqCh(5, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba16Freq       wroteGEQFreqCh(5, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba16Level       readGEQLevelCh(5, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba16Level(N)   writeGEQLevelCh(5, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba16Level      wroteGEQLevelCh(5, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba16Width       readGEQWidthCh(5, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba16Width(N)   writeGEQWidthCh(5, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba16Width      wroteGEQWidthCh(5, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba17Freq        readGEQFreqCh(5, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba17Freq(N)    writeGEQFreqCh(5, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba17Freq       wroteGEQFreqCh(5, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba17Level       readGEQLevelCh(5, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba17Level(N)   writeGEQLevelCh(5, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba17Level      wroteGEQLevelCh(5, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba17Width       readGEQWidthCh(5, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba17Width(N)   writeGEQWidthCh(5, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba17Width      wroteGEQWidthCh(5, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba18Freq        readGEQFreqCh(5, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba18Freq(N)    writeGEQFreqCh(5, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba18Freq       wroteGEQFreqCh(5, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba18Level       readGEQLevelCh(5, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba18Level(N)   writeGEQLevelCh(5, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba18Level      wroteGEQLevelCh(5, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba18Width       readGEQWidthCh(5, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba18Width(N)   writeGEQWidthCh(5, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba18Width      wroteGEQWidthCh(5, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba19Freq        readGEQFreqCh(5, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba19Freq(N)    writeGEQFreqCh(5, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba19Freq       wroteGEQFreqCh(5, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba19Level       readGEQLevelCh(5, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba19Level(N)   writeGEQLevelCh(5, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba19Level      wroteGEQLevelCh(5, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba19Width       readGEQWidthCh(5, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba19Width(N)   writeGEQWidthCh(5, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba19Width      wroteGEQWidthCh(5, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba20Freq        readGEQFreqCh(5, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba20Freq(N)    writeGEQFreqCh(5, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba20Freq       wroteGEQFreqCh(5, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba20Level       readGEQLevelCh(5, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba20Level(N)   writeGEQLevelCh(5, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba20Level      wroteGEQLevelCh(5, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba20Width       readGEQWidthCh(5, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba20Width(N)   writeGEQWidthCh(5, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba20Width      wroteGEQWidthCh(5, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba21Freq        readGEQFreqCh(5, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba21Freq(N)    writeGEQFreqCh(5, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba21Freq       wroteGEQFreqCh(5, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba21Level       readGEQLevelCh(5, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba21Level(N)   writeGEQLevelCh(5, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba21Level      wroteGEQLevelCh(5, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba21Width       readGEQWidthCh(5, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba21Width(N)   writeGEQWidthCh(5, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba21Width      wroteGEQWidthCh(5, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba22Freq        readGEQFreqCh(5, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba22Freq(N)    writeGEQFreqCh(5, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba22Freq       wroteGEQFreqCh(5, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba22Level       readGEQLevelCh(5, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba22Level(N)   writeGEQLevelCh(5, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba22Level      wroteGEQLevelCh(5, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba22Width       readGEQWidthCh(5, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba22Width(N)   writeGEQWidthCh(5, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba22Width      wroteGEQWidthCh(5, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba23Freq        readGEQFreqCh(5, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba23Freq(N)    writeGEQFreqCh(5, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba23Freq       wroteGEQFreqCh(5, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba23Level       readGEQLevelCh(5, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba23Level(N)   writeGEQLevelCh(5, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba23Level      wroteGEQLevelCh(5, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba23Width       readGEQWidthCh(5, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba23Width(N)   writeGEQWidthCh(5, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba23Width      wroteGEQWidthCh(5, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba24Freq        readGEQFreqCh(5, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba24Freq(N)    writeGEQFreqCh(5, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba24Freq       wroteGEQFreqCh(5, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba24Level       readGEQLevelCh(5, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba24Level(N)   writeGEQLevelCh(5, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba24Level      wroteGEQLevelCh(5, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba24Width       readGEQWidthCh(5, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba24Width(N)   writeGEQWidthCh(5, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba24Width      wroteGEQWidthCh(5, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba25Freq        readGEQFreqCh(5, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba25Freq(N)    writeGEQFreqCh(5, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba25Freq       wroteGEQFreqCh(5, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba25Level       readGEQLevelCh(5, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba25Level(N)   writeGEQLevelCh(5, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba25Level      wroteGEQLevelCh(5, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba25Width       readGEQWidthCh(5, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba25Width(N)   writeGEQWidthCh(5, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba25Width      wroteGEQWidthCh(5, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba26Freq        readGEQFreqCh(5, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba26Freq(N)    writeGEQFreqCh(5, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba26Freq       wroteGEQFreqCh(5, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba26Level       readGEQLevelCh(5, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba26Level(N)   writeGEQLevelCh(5, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba26Level      wroteGEQLevelCh(5, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba26Width       readGEQWidthCh(5, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba26Width(N)   writeGEQWidthCh(5, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba26Width      wroteGEQWidthCh(5, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba27Freq        readGEQFreqCh(5, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba27Freq(N)    writeGEQFreqCh(5, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba27Freq       wroteGEQFreqCh(5, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba27Level       readGEQLevelCh(5, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba27Level(N)   writeGEQLevelCh(5, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba27Level      wroteGEQLevelCh(5, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba27Width       readGEQWidthCh(5, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba27Width(N)   writeGEQWidthCh(5, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba27Width      wroteGEQWidthCh(5, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba28Freq        readGEQFreqCh(5, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba28Freq(N)    writeGEQFreqCh(5, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba28Freq       wroteGEQFreqCh(5, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba28Level       readGEQLevelCh(5, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba28Level(N)   writeGEQLevelCh(5, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba28Level      wroteGEQLevelCh(5, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba28Width       readGEQWidthCh(5, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba28Width(N)   writeGEQWidthCh(5, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba28Width      wroteGEQWidthCh(5, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba29Freq        readGEQFreqCh(5, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba29Freq(N)    writeGEQFreqCh(5, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba29Freq       wroteGEQFreqCh(5, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba29Level       readGEQLevelCh(5, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba29Level(N)   writeGEQLevelCh(5, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba29Level      wroteGEQLevelCh(5, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba29Width       readGEQWidthCh(5, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba29Width(N)   writeGEQWidthCh(5, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba29Width      wroteGEQWidthCh(5, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba30Freq        readGEQFreqCh(5, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba30Freq(N)    writeGEQFreqCh(5, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba30Freq       wroteGEQFreqCh(5, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba30Level       readGEQLevelCh(5, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba30Level(N)   writeGEQLevelCh(5, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba30Level      wroteGEQLevelCh(5, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba30Width       readGEQWidthCh(5, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba30Width(N)   writeGEQWidthCh(5, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba30Width      wroteGEQWidthCh(5, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba31Freq        readGEQFreqCh(5, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba31Freq(N)    writeGEQFreqCh(5, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba31Freq       wroteGEQFreqCh(5, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba31Level       readGEQLevelCh(5, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba31Level(N)   writeGEQLevelCh(5, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba31Level      wroteGEQLevelCh(5, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba31Width       readGEQWidthCh(5, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba31Width(N)   writeGEQWidthCh(5, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba31Width      wroteGEQWidthCh(5, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh5Ba32Freq        readGEQFreqCh(5, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba32Freq(N)    writeGEQFreqCh(5, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba32Freq       wroteGEQFreqCh(5, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba32Level       readGEQLevelCh(5, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba32Level(N)   writeGEQLevelCh(5, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba32Level      wroteGEQLevelCh(5, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh5Ba32Width       readGEQWidthCh(5, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh5Ba32Width(N)   writeGEQWidthCh(5, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh5Ba32Width      wroteGEQWidthCh(5, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba1Freq        readGEQFreqCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba1Freq(N)    writeGEQFreqCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba1Freq       wroteGEQFreqCh(6, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba1Level       readGEQLevelCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba1Level(N)   writeGEQLevelCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba1Level      wroteGEQLevelCh(6, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba1Width       readGEQWidthCh(6, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba1Width(N)   writeGEQWidthCh(6, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba1Width      wroteGEQWidthCh(6, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba2Freq        readGEQFreqCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba2Freq(N)    writeGEQFreqCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba2Freq       wroteGEQFreqCh(6, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba2Level       readGEQLevelCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba2Level(N)   writeGEQLevelCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba2Level      wroteGEQLevelCh(6, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba2Width       readGEQWidthCh(6, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba2Width(N)   writeGEQWidthCh(6, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba2Width      wroteGEQWidthCh(6, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba3Freq        readGEQFreqCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba3Freq(N)    writeGEQFreqCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba3Freq       wroteGEQFreqCh(6, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba3Level       readGEQLevelCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba3Level(N)   writeGEQLevelCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba3Level      wroteGEQLevelCh(6, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba3Width       readGEQWidthCh(6, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba3Width(N)   writeGEQWidthCh(6, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba3Width      wroteGEQWidthCh(6, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba4Freq        readGEQFreqCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba4Freq(N)    writeGEQFreqCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba4Freq       wroteGEQFreqCh(6, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba4Level       readGEQLevelCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba4Level(N)   writeGEQLevelCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba4Level      wroteGEQLevelCh(6, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba4Width       readGEQWidthCh(6, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba4Width(N)   writeGEQWidthCh(6, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba4Width      wroteGEQWidthCh(6, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba5Freq        readGEQFreqCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba5Freq(N)    writeGEQFreqCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba5Freq       wroteGEQFreqCh(6, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba5Level       readGEQLevelCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba5Level(N)   writeGEQLevelCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba5Level      wroteGEQLevelCh(6, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba5Width       readGEQWidthCh(6, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba5Width(N)   writeGEQWidthCh(6, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba5Width      wroteGEQWidthCh(6, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba6Freq        readGEQFreqCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba6Freq(N)    writeGEQFreqCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba6Freq       wroteGEQFreqCh(6, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba6Level       readGEQLevelCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba6Level(N)   writeGEQLevelCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba6Level      wroteGEQLevelCh(6, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba6Width       readGEQWidthCh(6, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba6Width(N)   writeGEQWidthCh(6, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba6Width      wroteGEQWidthCh(6, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba7Freq        readGEQFreqCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba7Freq(N)    writeGEQFreqCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba7Freq       wroteGEQFreqCh(6, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba7Level       readGEQLevelCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba7Level(N)   writeGEQLevelCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba7Level      wroteGEQLevelCh(6, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba7Width       readGEQWidthCh(6, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba7Width(N)   writeGEQWidthCh(6, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba7Width      wroteGEQWidthCh(6, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba8Freq        readGEQFreqCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba8Freq(N)    writeGEQFreqCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba8Freq       wroteGEQFreqCh(6, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba8Level       readGEQLevelCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba8Level(N)   writeGEQLevelCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba8Level      wroteGEQLevelCh(6, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba8Width       readGEQWidthCh(6, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba8Width(N)   writeGEQWidthCh(6, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba8Width      wroteGEQWidthCh(6, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba9Freq        readGEQFreqCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba9Freq(N)    writeGEQFreqCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba9Freq       wroteGEQFreqCh(6, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba9Level       readGEQLevelCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba9Level(N)   writeGEQLevelCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba9Level      wroteGEQLevelCh(6, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba9Width       readGEQWidthCh(6, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba9Width(N)   writeGEQWidthCh(6, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba9Width      wroteGEQWidthCh(6, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba10Freq        readGEQFreqCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba10Freq(N)    writeGEQFreqCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba10Freq       wroteGEQFreqCh(6, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba10Level       readGEQLevelCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba10Level(N)   writeGEQLevelCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba10Level      wroteGEQLevelCh(6, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba10Width       readGEQWidthCh(6, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba10Width(N)   writeGEQWidthCh(6, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba10Width      wroteGEQWidthCh(6, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba11Freq        readGEQFreqCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba11Freq(N)    writeGEQFreqCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba11Freq       wroteGEQFreqCh(6, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba11Level       readGEQLevelCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba11Level(N)   writeGEQLevelCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba11Level      wroteGEQLevelCh(6, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba11Width       readGEQWidthCh(6, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba11Width(N)   writeGEQWidthCh(6, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba11Width      wroteGEQWidthCh(6, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba12Freq        readGEQFreqCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba12Freq(N)    writeGEQFreqCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba12Freq       wroteGEQFreqCh(6, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba12Level       readGEQLevelCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba12Level(N)   writeGEQLevelCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba12Level      wroteGEQLevelCh(6, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba12Width       readGEQWidthCh(6, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba12Width(N)   writeGEQWidthCh(6, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba12Width      wroteGEQWidthCh(6, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba13Freq        readGEQFreqCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba13Freq(N)    writeGEQFreqCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba13Freq       wroteGEQFreqCh(6, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba13Level       readGEQLevelCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba13Level(N)   writeGEQLevelCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba13Level      wroteGEQLevelCh(6, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba13Width       readGEQWidthCh(6, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba13Width(N)   writeGEQWidthCh(6, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba13Width      wroteGEQWidthCh(6, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba14Freq        readGEQFreqCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba14Freq(N)    writeGEQFreqCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba14Freq       wroteGEQFreqCh(6, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba14Level       readGEQLevelCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba14Level(N)   writeGEQLevelCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba14Level      wroteGEQLevelCh(6, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba14Width       readGEQWidthCh(6, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba14Width(N)   writeGEQWidthCh(6, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba14Width      wroteGEQWidthCh(6, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba15Freq        readGEQFreqCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba15Freq(N)    writeGEQFreqCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba15Freq       wroteGEQFreqCh(6, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba15Level       readGEQLevelCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba15Level(N)   writeGEQLevelCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba15Level      wroteGEQLevelCh(6, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba15Width       readGEQWidthCh(6, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba15Width(N)   writeGEQWidthCh(6, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba15Width      wroteGEQWidthCh(6, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba16Freq        readGEQFreqCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba16Freq(N)    writeGEQFreqCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba16Freq       wroteGEQFreqCh(6, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba16Level       readGEQLevelCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba16Level(N)   writeGEQLevelCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba16Level      wroteGEQLevelCh(6, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba16Width       readGEQWidthCh(6, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba16Width(N)   writeGEQWidthCh(6, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba16Width      wroteGEQWidthCh(6, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba17Freq        readGEQFreqCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba17Freq(N)    writeGEQFreqCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba17Freq       wroteGEQFreqCh(6, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba17Level       readGEQLevelCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba17Level(N)   writeGEQLevelCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba17Level      wroteGEQLevelCh(6, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba17Width       readGEQWidthCh(6, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba17Width(N)   writeGEQWidthCh(6, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba17Width      wroteGEQWidthCh(6, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba18Freq        readGEQFreqCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba18Freq(N)    writeGEQFreqCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba18Freq       wroteGEQFreqCh(6, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba18Level       readGEQLevelCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba18Level(N)   writeGEQLevelCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba18Level      wroteGEQLevelCh(6, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba18Width       readGEQWidthCh(6, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba18Width(N)   writeGEQWidthCh(6, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba18Width      wroteGEQWidthCh(6, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba19Freq        readGEQFreqCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba19Freq(N)    writeGEQFreqCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba19Freq       wroteGEQFreqCh(6, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba19Level       readGEQLevelCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba19Level(N)   writeGEQLevelCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba19Level      wroteGEQLevelCh(6, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba19Width       readGEQWidthCh(6, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba19Width(N)   writeGEQWidthCh(6, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba19Width      wroteGEQWidthCh(6, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba20Freq        readGEQFreqCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba20Freq(N)    writeGEQFreqCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba20Freq       wroteGEQFreqCh(6, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba20Level       readGEQLevelCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba20Level(N)   writeGEQLevelCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba20Level      wroteGEQLevelCh(6, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba20Width       readGEQWidthCh(6, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba20Width(N)   writeGEQWidthCh(6, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba20Width      wroteGEQWidthCh(6, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba21Freq        readGEQFreqCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba21Freq(N)    writeGEQFreqCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba21Freq       wroteGEQFreqCh(6, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba21Level       readGEQLevelCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba21Level(N)   writeGEQLevelCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba21Level      wroteGEQLevelCh(6, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba21Width       readGEQWidthCh(6, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba21Width(N)   writeGEQWidthCh(6, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba21Width      wroteGEQWidthCh(6, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba22Freq        readGEQFreqCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba22Freq(N)    writeGEQFreqCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba22Freq       wroteGEQFreqCh(6, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba22Level       readGEQLevelCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba22Level(N)   writeGEQLevelCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba22Level      wroteGEQLevelCh(6, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba22Width       readGEQWidthCh(6, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba22Width(N)   writeGEQWidthCh(6, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba22Width      wroteGEQWidthCh(6, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba23Freq        readGEQFreqCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba23Freq(N)    writeGEQFreqCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba23Freq       wroteGEQFreqCh(6, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba23Level       readGEQLevelCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba23Level(N)   writeGEQLevelCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba23Level      wroteGEQLevelCh(6, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba23Width       readGEQWidthCh(6, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba23Width(N)   writeGEQWidthCh(6, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba23Width      wroteGEQWidthCh(6, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba24Freq        readGEQFreqCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba24Freq(N)    writeGEQFreqCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba24Freq       wroteGEQFreqCh(6, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba24Level       readGEQLevelCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba24Level(N)   writeGEQLevelCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba24Level      wroteGEQLevelCh(6, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba24Width       readGEQWidthCh(6, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba24Width(N)   writeGEQWidthCh(6, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba24Width      wroteGEQWidthCh(6, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba25Freq        readGEQFreqCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba25Freq(N)    writeGEQFreqCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba25Freq       wroteGEQFreqCh(6, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba25Level       readGEQLevelCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba25Level(N)   writeGEQLevelCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba25Level      wroteGEQLevelCh(6, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba25Width       readGEQWidthCh(6, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba25Width(N)   writeGEQWidthCh(6, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba25Width      wroteGEQWidthCh(6, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba26Freq        readGEQFreqCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba26Freq(N)    writeGEQFreqCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba26Freq       wroteGEQFreqCh(6, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba26Level       readGEQLevelCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba26Level(N)   writeGEQLevelCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba26Level      wroteGEQLevelCh(6, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba26Width       readGEQWidthCh(6, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba26Width(N)   writeGEQWidthCh(6, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba26Width      wroteGEQWidthCh(6, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba27Freq        readGEQFreqCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba27Freq(N)    writeGEQFreqCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba27Freq       wroteGEQFreqCh(6, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba27Level       readGEQLevelCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba27Level(N)   writeGEQLevelCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba27Level      wroteGEQLevelCh(6, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba27Width       readGEQWidthCh(6, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba27Width(N)   writeGEQWidthCh(6, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba27Width      wroteGEQWidthCh(6, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba28Freq        readGEQFreqCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba28Freq(N)    writeGEQFreqCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba28Freq       wroteGEQFreqCh(6, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba28Level       readGEQLevelCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba28Level(N)   writeGEQLevelCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba28Level      wroteGEQLevelCh(6, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba28Width       readGEQWidthCh(6, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba28Width(N)   writeGEQWidthCh(6, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba28Width      wroteGEQWidthCh(6, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba29Freq        readGEQFreqCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba29Freq(N)    writeGEQFreqCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba29Freq       wroteGEQFreqCh(6, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba29Level       readGEQLevelCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba29Level(N)   writeGEQLevelCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba29Level      wroteGEQLevelCh(6, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba29Width       readGEQWidthCh(6, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba29Width(N)   writeGEQWidthCh(6, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba29Width      wroteGEQWidthCh(6, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba30Freq        readGEQFreqCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba30Freq(N)    writeGEQFreqCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba30Freq       wroteGEQFreqCh(6, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba30Level       readGEQLevelCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba30Level(N)   writeGEQLevelCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba30Level      wroteGEQLevelCh(6, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba30Width       readGEQWidthCh(6, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba30Width(N)   writeGEQWidthCh(6, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba30Width      wroteGEQWidthCh(6, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba31Freq        readGEQFreqCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba31Freq(N)    writeGEQFreqCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba31Freq       wroteGEQFreqCh(6, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba31Level       readGEQLevelCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba31Level(N)   writeGEQLevelCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba31Level      wroteGEQLevelCh(6, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba31Width       readGEQWidthCh(6, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba31Width(N)   writeGEQWidthCh(6, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba31Width      wroteGEQWidthCh(6, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh6Ba32Freq        readGEQFreqCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba32Freq(N)    writeGEQFreqCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba32Freq       wroteGEQFreqCh(6, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba32Level       readGEQLevelCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba32Level(N)   writeGEQLevelCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba32Level      wroteGEQLevelCh(6, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh6Ba32Width       readGEQWidthCh(6, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh6Ba32Width(N)   writeGEQWidthCh(6, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh6Ba32Width      wroteGEQWidthCh(6, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba1Freq        readGEQFreqCh(7, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba1Freq(N)    writeGEQFreqCh(7, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba1Freq       wroteGEQFreqCh(7, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba1Level       readGEQLevelCh(7, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba1Level(N)   writeGEQLevelCh(7, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba1Level      wroteGEQLevelCh(7, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba1Width       readGEQWidthCh(7, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba1Width(N)   writeGEQWidthCh(7, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba1Width      wroteGEQWidthCh(7, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba2Freq        readGEQFreqCh(7, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba2Freq(N)    writeGEQFreqCh(7, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba2Freq       wroteGEQFreqCh(7, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba2Level       readGEQLevelCh(7, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba2Level(N)   writeGEQLevelCh(7, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba2Level      wroteGEQLevelCh(7, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba2Width       readGEQWidthCh(7, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba2Width(N)   writeGEQWidthCh(7, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba2Width      wroteGEQWidthCh(7, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba3Freq        readGEQFreqCh(7, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba3Freq(N)    writeGEQFreqCh(7, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba3Freq       wroteGEQFreqCh(7, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba3Level       readGEQLevelCh(7, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba3Level(N)   writeGEQLevelCh(7, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba3Level      wroteGEQLevelCh(7, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba3Width       readGEQWidthCh(7, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba3Width(N)   writeGEQWidthCh(7, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba3Width      wroteGEQWidthCh(7, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba4Freq        readGEQFreqCh(7, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba4Freq(N)    writeGEQFreqCh(7, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba4Freq       wroteGEQFreqCh(7, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba4Level       readGEQLevelCh(7, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba4Level(N)   writeGEQLevelCh(7, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba4Level      wroteGEQLevelCh(7, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba4Width       readGEQWidthCh(7, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba4Width(N)   writeGEQWidthCh(7, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba4Width      wroteGEQWidthCh(7, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba5Freq        readGEQFreqCh(7, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba5Freq(N)    writeGEQFreqCh(7, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba5Freq       wroteGEQFreqCh(7, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba5Level       readGEQLevelCh(7, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba5Level(N)   writeGEQLevelCh(7, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba5Level      wroteGEQLevelCh(7, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba5Width       readGEQWidthCh(7, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba5Width(N)   writeGEQWidthCh(7, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba5Width      wroteGEQWidthCh(7, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba6Freq        readGEQFreqCh(7, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba6Freq(N)    writeGEQFreqCh(7, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba6Freq       wroteGEQFreqCh(7, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba6Level       readGEQLevelCh(7, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba6Level(N)   writeGEQLevelCh(7, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba6Level      wroteGEQLevelCh(7, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba6Width       readGEQWidthCh(7, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba6Width(N)   writeGEQWidthCh(7, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba6Width      wroteGEQWidthCh(7, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba7Freq        readGEQFreqCh(7, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba7Freq(N)    writeGEQFreqCh(7, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba7Freq       wroteGEQFreqCh(7, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba7Level       readGEQLevelCh(7, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba7Level(N)   writeGEQLevelCh(7, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba7Level      wroteGEQLevelCh(7, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba7Width       readGEQWidthCh(7, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba7Width(N)   writeGEQWidthCh(7, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba7Width      wroteGEQWidthCh(7, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba8Freq        readGEQFreqCh(7, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba8Freq(N)    writeGEQFreqCh(7, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba8Freq       wroteGEQFreqCh(7, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba8Level       readGEQLevelCh(7, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba8Level(N)   writeGEQLevelCh(7, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba8Level      wroteGEQLevelCh(7, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba8Width       readGEQWidthCh(7, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba8Width(N)   writeGEQWidthCh(7, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba8Width      wroteGEQWidthCh(7, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba9Freq        readGEQFreqCh(7, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba9Freq(N)    writeGEQFreqCh(7, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba9Freq       wroteGEQFreqCh(7, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba9Level       readGEQLevelCh(7, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba9Level(N)   writeGEQLevelCh(7, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba9Level      wroteGEQLevelCh(7, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba9Width       readGEQWidthCh(7, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba9Width(N)   writeGEQWidthCh(7, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba9Width      wroteGEQWidthCh(7, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba10Freq        readGEQFreqCh(7, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba10Freq(N)    writeGEQFreqCh(7, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba10Freq       wroteGEQFreqCh(7, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba10Level       readGEQLevelCh(7, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba10Level(N)   writeGEQLevelCh(7, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba10Level      wroteGEQLevelCh(7, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba10Width       readGEQWidthCh(7, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba10Width(N)   writeGEQWidthCh(7, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba10Width      wroteGEQWidthCh(7, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba11Freq        readGEQFreqCh(7, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba11Freq(N)    writeGEQFreqCh(7, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba11Freq       wroteGEQFreqCh(7, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba11Level       readGEQLevelCh(7, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba11Level(N)   writeGEQLevelCh(7, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba11Level      wroteGEQLevelCh(7, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba11Width       readGEQWidthCh(7, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba11Width(N)   writeGEQWidthCh(7, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba11Width      wroteGEQWidthCh(7, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba12Freq        readGEQFreqCh(7, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba12Freq(N)    writeGEQFreqCh(7, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba12Freq       wroteGEQFreqCh(7, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba12Level       readGEQLevelCh(7, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba12Level(N)   writeGEQLevelCh(7, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba12Level      wroteGEQLevelCh(7, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba12Width       readGEQWidthCh(7, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba12Width(N)   writeGEQWidthCh(7, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba12Width      wroteGEQWidthCh(7, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba13Freq        readGEQFreqCh(7, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba13Freq(N)    writeGEQFreqCh(7, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba13Freq       wroteGEQFreqCh(7, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba13Level       readGEQLevelCh(7, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba13Level(N)   writeGEQLevelCh(7, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba13Level      wroteGEQLevelCh(7, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba13Width       readGEQWidthCh(7, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba13Width(N)   writeGEQWidthCh(7, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba13Width      wroteGEQWidthCh(7, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba14Freq        readGEQFreqCh(7, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba14Freq(N)    writeGEQFreqCh(7, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba14Freq       wroteGEQFreqCh(7, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba14Level       readGEQLevelCh(7, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba14Level(N)   writeGEQLevelCh(7, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba14Level      wroteGEQLevelCh(7, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba14Width       readGEQWidthCh(7, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba14Width(N)   writeGEQWidthCh(7, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba14Width      wroteGEQWidthCh(7, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba15Freq        readGEQFreqCh(7, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba15Freq(N)    writeGEQFreqCh(7, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba15Freq       wroteGEQFreqCh(7, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba15Level       readGEQLevelCh(7, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba15Level(N)   writeGEQLevelCh(7, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba15Level      wroteGEQLevelCh(7, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba15Width       readGEQWidthCh(7, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba15Width(N)   writeGEQWidthCh(7, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba15Width      wroteGEQWidthCh(7, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba16Freq        readGEQFreqCh(7, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba16Freq(N)    writeGEQFreqCh(7, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba16Freq       wroteGEQFreqCh(7, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba16Level       readGEQLevelCh(7, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba16Level(N)   writeGEQLevelCh(7, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba16Level      wroteGEQLevelCh(7, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba16Width       readGEQWidthCh(7, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba16Width(N)   writeGEQWidthCh(7, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba16Width      wroteGEQWidthCh(7, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba17Freq        readGEQFreqCh(7, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba17Freq(N)    writeGEQFreqCh(7, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba17Freq       wroteGEQFreqCh(7, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba17Level       readGEQLevelCh(7, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba17Level(N)   writeGEQLevelCh(7, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba17Level      wroteGEQLevelCh(7, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba17Width       readGEQWidthCh(7, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba17Width(N)   writeGEQWidthCh(7, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba17Width      wroteGEQWidthCh(7, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba18Freq        readGEQFreqCh(7, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba18Freq(N)    writeGEQFreqCh(7, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba18Freq       wroteGEQFreqCh(7, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba18Level       readGEQLevelCh(7, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba18Level(N)   writeGEQLevelCh(7, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba18Level      wroteGEQLevelCh(7, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba18Width       readGEQWidthCh(7, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba18Width(N)   writeGEQWidthCh(7, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba18Width      wroteGEQWidthCh(7, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba19Freq        readGEQFreqCh(7, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba19Freq(N)    writeGEQFreqCh(7, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba19Freq       wroteGEQFreqCh(7, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba19Level       readGEQLevelCh(7, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba19Level(N)   writeGEQLevelCh(7, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba19Level      wroteGEQLevelCh(7, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba19Width       readGEQWidthCh(7, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba19Width(N)   writeGEQWidthCh(7, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba19Width      wroteGEQWidthCh(7, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba20Freq        readGEQFreqCh(7, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba20Freq(N)    writeGEQFreqCh(7, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba20Freq       wroteGEQFreqCh(7, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba20Level       readGEQLevelCh(7, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba20Level(N)   writeGEQLevelCh(7, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba20Level      wroteGEQLevelCh(7, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba20Width       readGEQWidthCh(7, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba20Width(N)   writeGEQWidthCh(7, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba20Width      wroteGEQWidthCh(7, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba21Freq        readGEQFreqCh(7, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba21Freq(N)    writeGEQFreqCh(7, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba21Freq       wroteGEQFreqCh(7, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba21Level       readGEQLevelCh(7, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba21Level(N)   writeGEQLevelCh(7, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba21Level      wroteGEQLevelCh(7, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba21Width       readGEQWidthCh(7, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba21Width(N)   writeGEQWidthCh(7, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba21Width      wroteGEQWidthCh(7, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba22Freq        readGEQFreqCh(7, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba22Freq(N)    writeGEQFreqCh(7, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba22Freq       wroteGEQFreqCh(7, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba22Level       readGEQLevelCh(7, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba22Level(N)   writeGEQLevelCh(7, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba22Level      wroteGEQLevelCh(7, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba22Width       readGEQWidthCh(7, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba22Width(N)   writeGEQWidthCh(7, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba22Width      wroteGEQWidthCh(7, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba23Freq        readGEQFreqCh(7, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba23Freq(N)    writeGEQFreqCh(7, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba23Freq       wroteGEQFreqCh(7, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba23Level       readGEQLevelCh(7, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba23Level(N)   writeGEQLevelCh(7, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba23Level      wroteGEQLevelCh(7, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba23Width       readGEQWidthCh(7, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba23Width(N)   writeGEQWidthCh(7, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba23Width      wroteGEQWidthCh(7, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba24Freq        readGEQFreqCh(7, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba24Freq(N)    writeGEQFreqCh(7, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba24Freq       wroteGEQFreqCh(7, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba24Level       readGEQLevelCh(7, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba24Level(N)   writeGEQLevelCh(7, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba24Level      wroteGEQLevelCh(7, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba24Width       readGEQWidthCh(7, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba24Width(N)   writeGEQWidthCh(7, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba24Width      wroteGEQWidthCh(7, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba25Freq        readGEQFreqCh(7, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba25Freq(N)    writeGEQFreqCh(7, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba25Freq       wroteGEQFreqCh(7, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba25Level       readGEQLevelCh(7, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba25Level(N)   writeGEQLevelCh(7, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba25Level      wroteGEQLevelCh(7, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba25Width       readGEQWidthCh(7, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba25Width(N)   writeGEQWidthCh(7, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba25Width      wroteGEQWidthCh(7, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba26Freq        readGEQFreqCh(7, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba26Freq(N)    writeGEQFreqCh(7, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba26Freq       wroteGEQFreqCh(7, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba26Level       readGEQLevelCh(7, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba26Level(N)   writeGEQLevelCh(7, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba26Level      wroteGEQLevelCh(7, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba26Width       readGEQWidthCh(7, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba26Width(N)   writeGEQWidthCh(7, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba26Width      wroteGEQWidthCh(7, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba27Freq        readGEQFreqCh(7, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba27Freq(N)    writeGEQFreqCh(7, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba27Freq       wroteGEQFreqCh(7, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba27Level       readGEQLevelCh(7, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba27Level(N)   writeGEQLevelCh(7, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba27Level      wroteGEQLevelCh(7, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba27Width       readGEQWidthCh(7, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba27Width(N)   writeGEQWidthCh(7, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba27Width      wroteGEQWidthCh(7, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba28Freq        readGEQFreqCh(7, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba28Freq(N)    writeGEQFreqCh(7, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba28Freq       wroteGEQFreqCh(7, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba28Level       readGEQLevelCh(7, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba28Level(N)   writeGEQLevelCh(7, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba28Level      wroteGEQLevelCh(7, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba28Width       readGEQWidthCh(7, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba28Width(N)   writeGEQWidthCh(7, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba28Width      wroteGEQWidthCh(7, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba29Freq        readGEQFreqCh(7, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba29Freq(N)    writeGEQFreqCh(7, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba29Freq       wroteGEQFreqCh(7, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba29Level       readGEQLevelCh(7, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba29Level(N)   writeGEQLevelCh(7, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba29Level      wroteGEQLevelCh(7, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba29Width       readGEQWidthCh(7, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba29Width(N)   writeGEQWidthCh(7, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba29Width      wroteGEQWidthCh(7, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba30Freq        readGEQFreqCh(7, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba30Freq(N)    writeGEQFreqCh(7, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba30Freq       wroteGEQFreqCh(7, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba30Level       readGEQLevelCh(7, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba30Level(N)   writeGEQLevelCh(7, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba30Level      wroteGEQLevelCh(7, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba30Width       readGEQWidthCh(7, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba30Width(N)   writeGEQWidthCh(7, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba30Width      wroteGEQWidthCh(7, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba31Freq        readGEQFreqCh(7, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba31Freq(N)    writeGEQFreqCh(7, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba31Freq       wroteGEQFreqCh(7, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba31Level       readGEQLevelCh(7, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba31Level(N)   writeGEQLevelCh(7, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba31Level      wroteGEQLevelCh(7, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba31Width       readGEQWidthCh(7, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba31Width(N)   writeGEQWidthCh(7, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba31Width      wroteGEQWidthCh(7, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh7Ba32Freq        readGEQFreqCh(7, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba32Freq(N)    writeGEQFreqCh(7, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba32Freq       wroteGEQFreqCh(7, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba32Level       readGEQLevelCh(7, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba32Level(N)   writeGEQLevelCh(7, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba32Level      wroteGEQLevelCh(7, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh7Ba32Width       readGEQWidthCh(7, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh7Ba32Width(N)   writeGEQWidthCh(7, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh7Ba32Width      wroteGEQWidthCh(7, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba1Freq        readGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba1Freq(N)    writeGEQFreqCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba1Freq       wroteGEQFreqCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba1Level       readGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba1Level(N)   writeGEQLevelCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba1Level      wroteGEQLevelCh(8, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba1Width       readGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba1Width(N)   writeGEQWidthCh(8, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba1Width      wroteGEQWidthCh(8, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba2Freq        readGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba2Freq(N)    writeGEQFreqCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba2Freq       wroteGEQFreqCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba2Level       readGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba2Level(N)   writeGEQLevelCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba2Level      wroteGEQLevelCh(8, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba2Width       readGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba2Width(N)   writeGEQWidthCh(8, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba2Width      wroteGEQWidthCh(8, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba3Freq        readGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba3Freq(N)    writeGEQFreqCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba3Freq       wroteGEQFreqCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba3Level       readGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba3Level(N)   writeGEQLevelCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba3Level      wroteGEQLevelCh(8, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba3Width       readGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba3Width(N)   writeGEQWidthCh(8, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba3Width      wroteGEQWidthCh(8, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba4Freq        readGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba4Freq(N)    writeGEQFreqCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba4Freq       wroteGEQFreqCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba4Level       readGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba4Level(N)   writeGEQLevelCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba4Level      wroteGEQLevelCh(8, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba4Width       readGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba4Width(N)   writeGEQWidthCh(8, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba4Width      wroteGEQWidthCh(8, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba5Freq        readGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba5Freq(N)    writeGEQFreqCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba5Freq       wroteGEQFreqCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba5Level       readGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba5Level(N)   writeGEQLevelCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba5Level      wroteGEQLevelCh(8, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba5Width       readGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba5Width(N)   writeGEQWidthCh(8, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba5Width      wroteGEQWidthCh(8, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba6Freq        readGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba6Freq(N)    writeGEQFreqCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba6Freq       wroteGEQFreqCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba6Level       readGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba6Level(N)   writeGEQLevelCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba6Level      wroteGEQLevelCh(8, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba6Width       readGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba6Width(N)   writeGEQWidthCh(8, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba6Width      wroteGEQWidthCh(8, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba7Freq        readGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba7Freq(N)    writeGEQFreqCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba7Freq       wroteGEQFreqCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba7Level       readGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba7Level(N)   writeGEQLevelCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba7Level      wroteGEQLevelCh(8, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba7Width       readGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba7Width(N)   writeGEQWidthCh(8, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba7Width      wroteGEQWidthCh(8, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba8Freq        readGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba8Freq(N)    writeGEQFreqCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba8Freq       wroteGEQFreqCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba8Level       readGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba8Level(N)   writeGEQLevelCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba8Level      wroteGEQLevelCh(8, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba8Width       readGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba8Width(N)   writeGEQWidthCh(8, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba8Width      wroteGEQWidthCh(8, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba9Freq        readGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba9Freq(N)    writeGEQFreqCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba9Freq       wroteGEQFreqCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba9Level       readGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba9Level(N)   writeGEQLevelCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba9Level      wroteGEQLevelCh(8, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba9Width       readGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba9Width(N)   writeGEQWidthCh(8, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba9Width      wroteGEQWidthCh(8, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba10Freq        readGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba10Freq(N)    writeGEQFreqCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba10Freq       wroteGEQFreqCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba10Level       readGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba10Level(N)   writeGEQLevelCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba10Level      wroteGEQLevelCh(8, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba10Width       readGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba10Width(N)   writeGEQWidthCh(8, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba10Width      wroteGEQWidthCh(8, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba11Freq        readGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba11Freq(N)    writeGEQFreqCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba11Freq       wroteGEQFreqCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba11Level       readGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba11Level(N)   writeGEQLevelCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba11Level      wroteGEQLevelCh(8, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba11Width       readGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba11Width(N)   writeGEQWidthCh(8, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba11Width      wroteGEQWidthCh(8, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba12Freq        readGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba12Freq(N)    writeGEQFreqCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba12Freq       wroteGEQFreqCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba12Level       readGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba12Level(N)   writeGEQLevelCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba12Level      wroteGEQLevelCh(8, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba12Width       readGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba12Width(N)   writeGEQWidthCh(8, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba12Width      wroteGEQWidthCh(8, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba13Freq        readGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba13Freq(N)    writeGEQFreqCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba13Freq       wroteGEQFreqCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba13Level       readGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba13Level(N)   writeGEQLevelCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba13Level      wroteGEQLevelCh(8, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba13Width       readGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba13Width(N)   writeGEQWidthCh(8, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba13Width      wroteGEQWidthCh(8, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba14Freq        readGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba14Freq(N)    writeGEQFreqCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba14Freq       wroteGEQFreqCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba14Level       readGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba14Level(N)   writeGEQLevelCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba14Level      wroteGEQLevelCh(8, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba14Width       readGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba14Width(N)   writeGEQWidthCh(8, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba14Width      wroteGEQWidthCh(8, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba15Freq        readGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba15Freq(N)    writeGEQFreqCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba15Freq       wroteGEQFreqCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba15Level       readGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba15Level(N)   writeGEQLevelCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba15Level      wroteGEQLevelCh(8, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba15Width       readGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba15Width(N)   writeGEQWidthCh(8, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba15Width      wroteGEQWidthCh(8, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba16Freq        readGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba16Freq(N)    writeGEQFreqCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba16Freq       wroteGEQFreqCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba16Level       readGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba16Level(N)   writeGEQLevelCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba16Level      wroteGEQLevelCh(8, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba16Width       readGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba16Width(N)   writeGEQWidthCh(8, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba16Width      wroteGEQWidthCh(8, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba17Freq        readGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba17Freq(N)    writeGEQFreqCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba17Freq       wroteGEQFreqCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba17Level       readGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba17Level(N)   writeGEQLevelCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba17Level      wroteGEQLevelCh(8, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba17Width       readGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba17Width(N)   writeGEQWidthCh(8, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba17Width      wroteGEQWidthCh(8, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba18Freq        readGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba18Freq(N)    writeGEQFreqCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba18Freq       wroteGEQFreqCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba18Level       readGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba18Level(N)   writeGEQLevelCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba18Level      wroteGEQLevelCh(8, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba18Width       readGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba18Width(N)   writeGEQWidthCh(8, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba18Width      wroteGEQWidthCh(8, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba19Freq        readGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba19Freq(N)    writeGEQFreqCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba19Freq       wroteGEQFreqCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba19Level       readGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba19Level(N)   writeGEQLevelCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba19Level      wroteGEQLevelCh(8, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba19Width       readGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba19Width(N)   writeGEQWidthCh(8, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba19Width      wroteGEQWidthCh(8, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba20Freq        readGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba20Freq(N)    writeGEQFreqCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba20Freq       wroteGEQFreqCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba20Level       readGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba20Level(N)   writeGEQLevelCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba20Level      wroteGEQLevelCh(8, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba20Width       readGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba20Width(N)   writeGEQWidthCh(8, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba20Width      wroteGEQWidthCh(8, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba21Freq        readGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba21Freq(N)    writeGEQFreqCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba21Freq       wroteGEQFreqCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba21Level       readGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba21Level(N)   writeGEQLevelCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba21Level      wroteGEQLevelCh(8, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba21Width       readGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba21Width(N)   writeGEQWidthCh(8, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba21Width      wroteGEQWidthCh(8, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba22Freq        readGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba22Freq(N)    writeGEQFreqCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba22Freq       wroteGEQFreqCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba22Level       readGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba22Level(N)   writeGEQLevelCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba22Level      wroteGEQLevelCh(8, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba22Width       readGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba22Width(N)   writeGEQWidthCh(8, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba22Width      wroteGEQWidthCh(8, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba23Freq        readGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba23Freq(N)    writeGEQFreqCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba23Freq       wroteGEQFreqCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba23Level       readGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba23Level(N)   writeGEQLevelCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba23Level      wroteGEQLevelCh(8, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba23Width       readGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba23Width(N)   writeGEQWidthCh(8, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba23Width      wroteGEQWidthCh(8, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba24Freq        readGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba24Freq(N)    writeGEQFreqCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba24Freq       wroteGEQFreqCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba24Level       readGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba24Level(N)   writeGEQLevelCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba24Level      wroteGEQLevelCh(8, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba24Width       readGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba24Width(N)   writeGEQWidthCh(8, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba24Width      wroteGEQWidthCh(8, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba25Freq        readGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba25Freq(N)    writeGEQFreqCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba25Freq       wroteGEQFreqCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba25Level       readGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba25Level(N)   writeGEQLevelCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba25Level      wroteGEQLevelCh(8, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba25Width       readGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba25Width(N)   writeGEQWidthCh(8, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba25Width      wroteGEQWidthCh(8, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba26Freq        readGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba26Freq(N)    writeGEQFreqCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba26Freq       wroteGEQFreqCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba26Level       readGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba26Level(N)   writeGEQLevelCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba26Level      wroteGEQLevelCh(8, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba26Width       readGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba26Width(N)   writeGEQWidthCh(8, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba26Width      wroteGEQWidthCh(8, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba27Freq        readGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba27Freq(N)    writeGEQFreqCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba27Freq       wroteGEQFreqCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba27Level       readGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba27Level(N)   writeGEQLevelCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba27Level      wroteGEQLevelCh(8, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba27Width       readGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba27Width(N)   writeGEQWidthCh(8, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba27Width      wroteGEQWidthCh(8, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba28Freq        readGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba28Freq(N)    writeGEQFreqCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba28Freq       wroteGEQFreqCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba28Level       readGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba28Level(N)   writeGEQLevelCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba28Level      wroteGEQLevelCh(8, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba28Width       readGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba28Width(N)   writeGEQWidthCh(8, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba28Width      wroteGEQWidthCh(8, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba29Freq        readGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba29Freq(N)    writeGEQFreqCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba29Freq       wroteGEQFreqCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba29Level       readGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba29Level(N)   writeGEQLevelCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba29Level      wroteGEQLevelCh(8, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba29Width       readGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba29Width(N)   writeGEQWidthCh(8, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba29Width      wroteGEQWidthCh(8, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba30Freq        readGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba30Freq(N)    writeGEQFreqCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba30Freq       wroteGEQFreqCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba30Level       readGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba30Level(N)   writeGEQLevelCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba30Level      wroteGEQLevelCh(8, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba30Width       readGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba30Width(N)   writeGEQWidthCh(8, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba30Width      wroteGEQWidthCh(8, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba31Freq        readGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba31Freq(N)    writeGEQFreqCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba31Freq       wroteGEQFreqCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba31Level       readGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba31Level(N)   writeGEQLevelCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba31Level      wroteGEQLevelCh(8, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba31Width       readGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba31Width(N)   writeGEQWidthCh(8, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba31Width      wroteGEQWidthCh(8, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh8Ba32Freq        readGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba32Freq(N)    writeGEQFreqCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba32Freq       wroteGEQFreqCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba32Level       readGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba32Level(N)   writeGEQLevelCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba32Level      wroteGEQLevelCh(8, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh8Ba32Width       readGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh8Ba32Width(N)   writeGEQWidthCh(8, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh8Ba32Width      wroteGEQWidthCh(8, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba1Freq        readGEQFreqCh(9, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba1Freq(N)    writeGEQFreqCh(9, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba1Freq       wroteGEQFreqCh(9, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba1Level       readGEQLevelCh(9, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba1Level(N)   writeGEQLevelCh(9, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba1Level      wroteGEQLevelCh(9, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba1Width       readGEQWidthCh(9, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba1Width(N)   writeGEQWidthCh(9, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba1Width      wroteGEQWidthCh(9, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba2Freq        readGEQFreqCh(9, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba2Freq(N)    writeGEQFreqCh(9, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba2Freq       wroteGEQFreqCh(9, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba2Level       readGEQLevelCh(9, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba2Level(N)   writeGEQLevelCh(9, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba2Level      wroteGEQLevelCh(9, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba2Width       readGEQWidthCh(9, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba2Width(N)   writeGEQWidthCh(9, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba2Width      wroteGEQWidthCh(9, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba3Freq        readGEQFreqCh(9, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba3Freq(N)    writeGEQFreqCh(9, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba3Freq       wroteGEQFreqCh(9, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba3Level       readGEQLevelCh(9, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba3Level(N)   writeGEQLevelCh(9, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba3Level      wroteGEQLevelCh(9, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba3Width       readGEQWidthCh(9, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba3Width(N)   writeGEQWidthCh(9, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba3Width      wroteGEQWidthCh(9, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba4Freq        readGEQFreqCh(9, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba4Freq(N)    writeGEQFreqCh(9, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba4Freq       wroteGEQFreqCh(9, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba4Level       readGEQLevelCh(9, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba4Level(N)   writeGEQLevelCh(9, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba4Level      wroteGEQLevelCh(9, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba4Width       readGEQWidthCh(9, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba4Width(N)   writeGEQWidthCh(9, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba4Width      wroteGEQWidthCh(9, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba5Freq        readGEQFreqCh(9, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba5Freq(N)    writeGEQFreqCh(9, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba5Freq       wroteGEQFreqCh(9, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba5Level       readGEQLevelCh(9, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba5Level(N)   writeGEQLevelCh(9, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba5Level      wroteGEQLevelCh(9, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba5Width       readGEQWidthCh(9, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba5Width(N)   writeGEQWidthCh(9, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba5Width      wroteGEQWidthCh(9, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba6Freq        readGEQFreqCh(9, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba6Freq(N)    writeGEQFreqCh(9, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba6Freq       wroteGEQFreqCh(9, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba6Level       readGEQLevelCh(9, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba6Level(N)   writeGEQLevelCh(9, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba6Level      wroteGEQLevelCh(9, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba6Width       readGEQWidthCh(9, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba6Width(N)   writeGEQWidthCh(9, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba6Width      wroteGEQWidthCh(9, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba7Freq        readGEQFreqCh(9, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba7Freq(N)    writeGEQFreqCh(9, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba7Freq       wroteGEQFreqCh(9, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba7Level       readGEQLevelCh(9, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba7Level(N)   writeGEQLevelCh(9, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba7Level      wroteGEQLevelCh(9, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba7Width       readGEQWidthCh(9, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba7Width(N)   writeGEQWidthCh(9, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba7Width      wroteGEQWidthCh(9, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba8Freq        readGEQFreqCh(9, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba8Freq(N)    writeGEQFreqCh(9, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba8Freq       wroteGEQFreqCh(9, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba8Level       readGEQLevelCh(9, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba8Level(N)   writeGEQLevelCh(9, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba8Level      wroteGEQLevelCh(9, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba8Width       readGEQWidthCh(9, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba8Width(N)   writeGEQWidthCh(9, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba8Width      wroteGEQWidthCh(9, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba9Freq        readGEQFreqCh(9, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba9Freq(N)    writeGEQFreqCh(9, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba9Freq       wroteGEQFreqCh(9, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba9Level       readGEQLevelCh(9, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba9Level(N)   writeGEQLevelCh(9, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba9Level      wroteGEQLevelCh(9, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba9Width       readGEQWidthCh(9, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba9Width(N)   writeGEQWidthCh(9, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba9Width      wroteGEQWidthCh(9, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba10Freq        readGEQFreqCh(9, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba10Freq(N)    writeGEQFreqCh(9, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba10Freq       wroteGEQFreqCh(9, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba10Level       readGEQLevelCh(9, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba10Level(N)   writeGEQLevelCh(9, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba10Level      wroteGEQLevelCh(9, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba10Width       readGEQWidthCh(9, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba10Width(N)   writeGEQWidthCh(9, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba10Width      wroteGEQWidthCh(9, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba11Freq        readGEQFreqCh(9, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba11Freq(N)    writeGEQFreqCh(9, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba11Freq       wroteGEQFreqCh(9, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba11Level       readGEQLevelCh(9, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba11Level(N)   writeGEQLevelCh(9, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba11Level      wroteGEQLevelCh(9, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba11Width       readGEQWidthCh(9, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba11Width(N)   writeGEQWidthCh(9, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba11Width      wroteGEQWidthCh(9, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba12Freq        readGEQFreqCh(9, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba12Freq(N)    writeGEQFreqCh(9, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba12Freq       wroteGEQFreqCh(9, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba12Level       readGEQLevelCh(9, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba12Level(N)   writeGEQLevelCh(9, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba12Level      wroteGEQLevelCh(9, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba12Width       readGEQWidthCh(9, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba12Width(N)   writeGEQWidthCh(9, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba12Width      wroteGEQWidthCh(9, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba13Freq        readGEQFreqCh(9, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba13Freq(N)    writeGEQFreqCh(9, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba13Freq       wroteGEQFreqCh(9, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba13Level       readGEQLevelCh(9, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba13Level(N)   writeGEQLevelCh(9, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba13Level      wroteGEQLevelCh(9, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba13Width       readGEQWidthCh(9, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba13Width(N)   writeGEQWidthCh(9, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba13Width      wroteGEQWidthCh(9, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba14Freq        readGEQFreqCh(9, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba14Freq(N)    writeGEQFreqCh(9, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba14Freq       wroteGEQFreqCh(9, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba14Level       readGEQLevelCh(9, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba14Level(N)   writeGEQLevelCh(9, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba14Level      wroteGEQLevelCh(9, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba14Width       readGEQWidthCh(9, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba14Width(N)   writeGEQWidthCh(9, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba14Width      wroteGEQWidthCh(9, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba15Freq        readGEQFreqCh(9, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba15Freq(N)    writeGEQFreqCh(9, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba15Freq       wroteGEQFreqCh(9, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba15Level       readGEQLevelCh(9, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba15Level(N)   writeGEQLevelCh(9, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba15Level      wroteGEQLevelCh(9, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba15Width       readGEQWidthCh(9, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba15Width(N)   writeGEQWidthCh(9, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba15Width      wroteGEQWidthCh(9, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba16Freq        readGEQFreqCh(9, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba16Freq(N)    writeGEQFreqCh(9, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba16Freq       wroteGEQFreqCh(9, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba16Level       readGEQLevelCh(9, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba16Level(N)   writeGEQLevelCh(9, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba16Level      wroteGEQLevelCh(9, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba16Width       readGEQWidthCh(9, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba16Width(N)   writeGEQWidthCh(9, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba16Width      wroteGEQWidthCh(9, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba17Freq        readGEQFreqCh(9, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba17Freq(N)    writeGEQFreqCh(9, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba17Freq       wroteGEQFreqCh(9, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba17Level       readGEQLevelCh(9, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba17Level(N)   writeGEQLevelCh(9, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba17Level      wroteGEQLevelCh(9, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba17Width       readGEQWidthCh(9, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba17Width(N)   writeGEQWidthCh(9, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba17Width      wroteGEQWidthCh(9, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba18Freq        readGEQFreqCh(9, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba18Freq(N)    writeGEQFreqCh(9, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba18Freq       wroteGEQFreqCh(9, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba18Level       readGEQLevelCh(9, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba18Level(N)   writeGEQLevelCh(9, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba18Level      wroteGEQLevelCh(9, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba18Width       readGEQWidthCh(9, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba18Width(N)   writeGEQWidthCh(9, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba18Width      wroteGEQWidthCh(9, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba19Freq        readGEQFreqCh(9, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba19Freq(N)    writeGEQFreqCh(9, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba19Freq       wroteGEQFreqCh(9, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba19Level       readGEQLevelCh(9, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba19Level(N)   writeGEQLevelCh(9, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba19Level      wroteGEQLevelCh(9, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba19Width       readGEQWidthCh(9, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba19Width(N)   writeGEQWidthCh(9, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba19Width      wroteGEQWidthCh(9, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba20Freq        readGEQFreqCh(9, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba20Freq(N)    writeGEQFreqCh(9, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba20Freq       wroteGEQFreqCh(9, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba20Level       readGEQLevelCh(9, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba20Level(N)   writeGEQLevelCh(9, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba20Level      wroteGEQLevelCh(9, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba20Width       readGEQWidthCh(9, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba20Width(N)   writeGEQWidthCh(9, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba20Width      wroteGEQWidthCh(9, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba21Freq        readGEQFreqCh(9, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba21Freq(N)    writeGEQFreqCh(9, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba21Freq       wroteGEQFreqCh(9, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba21Level       readGEQLevelCh(9, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba21Level(N)   writeGEQLevelCh(9, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba21Level      wroteGEQLevelCh(9, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba21Width       readGEQWidthCh(9, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba21Width(N)   writeGEQWidthCh(9, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba21Width      wroteGEQWidthCh(9, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba22Freq        readGEQFreqCh(9, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba22Freq(N)    writeGEQFreqCh(9, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba22Freq       wroteGEQFreqCh(9, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba22Level       readGEQLevelCh(9, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba22Level(N)   writeGEQLevelCh(9, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba22Level      wroteGEQLevelCh(9, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba22Width       readGEQWidthCh(9, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba22Width(N)   writeGEQWidthCh(9, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba22Width      wroteGEQWidthCh(9, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba23Freq        readGEQFreqCh(9, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba23Freq(N)    writeGEQFreqCh(9, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba23Freq       wroteGEQFreqCh(9, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba23Level       readGEQLevelCh(9, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba23Level(N)   writeGEQLevelCh(9, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba23Level      wroteGEQLevelCh(9, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba23Width       readGEQWidthCh(9, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba23Width(N)   writeGEQWidthCh(9, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba23Width      wroteGEQWidthCh(9, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba24Freq        readGEQFreqCh(9, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba24Freq(N)    writeGEQFreqCh(9, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba24Freq       wroteGEQFreqCh(9, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba24Level       readGEQLevelCh(9, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba24Level(N)   writeGEQLevelCh(9, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba24Level      wroteGEQLevelCh(9, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba24Width       readGEQWidthCh(9, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba24Width(N)   writeGEQWidthCh(9, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba24Width      wroteGEQWidthCh(9, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba25Freq        readGEQFreqCh(9, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba25Freq(N)    writeGEQFreqCh(9, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba25Freq       wroteGEQFreqCh(9, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba25Level       readGEQLevelCh(9, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba25Level(N)   writeGEQLevelCh(9, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba25Level      wroteGEQLevelCh(9, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba25Width       readGEQWidthCh(9, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba25Width(N)   writeGEQWidthCh(9, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba25Width      wroteGEQWidthCh(9, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba26Freq        readGEQFreqCh(9, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba26Freq(N)    writeGEQFreqCh(9, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba26Freq       wroteGEQFreqCh(9, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba26Level       readGEQLevelCh(9, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba26Level(N)   writeGEQLevelCh(9, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba26Level      wroteGEQLevelCh(9, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba26Width       readGEQWidthCh(9, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba26Width(N)   writeGEQWidthCh(9, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba26Width      wroteGEQWidthCh(9, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba27Freq        readGEQFreqCh(9, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba27Freq(N)    writeGEQFreqCh(9, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba27Freq       wroteGEQFreqCh(9, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba27Level       readGEQLevelCh(9, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba27Level(N)   writeGEQLevelCh(9, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba27Level      wroteGEQLevelCh(9, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba27Width       readGEQWidthCh(9, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba27Width(N)   writeGEQWidthCh(9, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba27Width      wroteGEQWidthCh(9, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba28Freq        readGEQFreqCh(9, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba28Freq(N)    writeGEQFreqCh(9, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba28Freq       wroteGEQFreqCh(9, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba28Level       readGEQLevelCh(9, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba28Level(N)   writeGEQLevelCh(9, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba28Level      wroteGEQLevelCh(9, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba28Width       readGEQWidthCh(9, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba28Width(N)   writeGEQWidthCh(9, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba28Width      wroteGEQWidthCh(9, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba29Freq        readGEQFreqCh(9, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba29Freq(N)    writeGEQFreqCh(9, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba29Freq       wroteGEQFreqCh(9, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba29Level       readGEQLevelCh(9, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba29Level(N)   writeGEQLevelCh(9, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba29Level      wroteGEQLevelCh(9, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba29Width       readGEQWidthCh(9, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba29Width(N)   writeGEQWidthCh(9, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba29Width      wroteGEQWidthCh(9, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba30Freq        readGEQFreqCh(9, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba30Freq(N)    writeGEQFreqCh(9, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba30Freq       wroteGEQFreqCh(9, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba30Level       readGEQLevelCh(9, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba30Level(N)   writeGEQLevelCh(9, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba30Level      wroteGEQLevelCh(9, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba30Width       readGEQWidthCh(9, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba30Width(N)   writeGEQWidthCh(9, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba30Width      wroteGEQWidthCh(9, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba31Freq        readGEQFreqCh(9, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba31Freq(N)    writeGEQFreqCh(9, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba31Freq       wroteGEQFreqCh(9, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba31Level       readGEQLevelCh(9, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba31Level(N)   writeGEQLevelCh(9, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba31Level      wroteGEQLevelCh(9, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba31Width       readGEQWidthCh(9, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba31Width(N)   writeGEQWidthCh(9, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba31Width      wroteGEQWidthCh(9, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh9Ba32Freq        readGEQFreqCh(9, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba32Freq(N)    writeGEQFreqCh(9, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba32Freq       wroteGEQFreqCh(9, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba32Level       readGEQLevelCh(9, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba32Level(N)   writeGEQLevelCh(9, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba32Level      wroteGEQLevelCh(9, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh9Ba32Width       readGEQWidthCh(9, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh9Ba32Width(N)   writeGEQWidthCh(9, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh9Ba32Width      wroteGEQWidthCh(9, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba1Freq        readGEQFreqCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba1Freq(N)    writeGEQFreqCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba1Freq       wroteGEQFreqCh(10, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba1Level       readGEQLevelCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba1Level(N)   writeGEQLevelCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba1Level      wroteGEQLevelCh(10, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba1Width       readGEQWidthCh(10, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba1Width(N)   writeGEQWidthCh(10, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba1Width      wroteGEQWidthCh(10, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba2Freq        readGEQFreqCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba2Freq(N)    writeGEQFreqCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba2Freq       wroteGEQFreqCh(10, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba2Level       readGEQLevelCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba2Level(N)   writeGEQLevelCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba2Level      wroteGEQLevelCh(10, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba2Width       readGEQWidthCh(10, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba2Width(N)   writeGEQWidthCh(10, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba2Width      wroteGEQWidthCh(10, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba3Freq        readGEQFreqCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba3Freq(N)    writeGEQFreqCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba3Freq       wroteGEQFreqCh(10, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba3Level       readGEQLevelCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba3Level(N)   writeGEQLevelCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba3Level      wroteGEQLevelCh(10, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba3Width       readGEQWidthCh(10, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba3Width(N)   writeGEQWidthCh(10, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba3Width      wroteGEQWidthCh(10, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba4Freq        readGEQFreqCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba4Freq(N)    writeGEQFreqCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba4Freq       wroteGEQFreqCh(10, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba4Level       readGEQLevelCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba4Level(N)   writeGEQLevelCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba4Level      wroteGEQLevelCh(10, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba4Width       readGEQWidthCh(10, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba4Width(N)   writeGEQWidthCh(10, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba4Width      wroteGEQWidthCh(10, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba5Freq        readGEQFreqCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba5Freq(N)    writeGEQFreqCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba5Freq       wroteGEQFreqCh(10, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba5Level       readGEQLevelCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba5Level(N)   writeGEQLevelCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba5Level      wroteGEQLevelCh(10, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba5Width       readGEQWidthCh(10, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba5Width(N)   writeGEQWidthCh(10, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba5Width      wroteGEQWidthCh(10, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba6Freq        readGEQFreqCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba6Freq(N)    writeGEQFreqCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba6Freq       wroteGEQFreqCh(10, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba6Level       readGEQLevelCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba6Level(N)   writeGEQLevelCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba6Level      wroteGEQLevelCh(10, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba6Width       readGEQWidthCh(10, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba6Width(N)   writeGEQWidthCh(10, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba6Width      wroteGEQWidthCh(10, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba7Freq        readGEQFreqCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba7Freq(N)    writeGEQFreqCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba7Freq       wroteGEQFreqCh(10, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba7Level       readGEQLevelCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba7Level(N)   writeGEQLevelCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba7Level      wroteGEQLevelCh(10, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba7Width       readGEQWidthCh(10, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba7Width(N)   writeGEQWidthCh(10, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba7Width      wroteGEQWidthCh(10, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba8Freq        readGEQFreqCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba8Freq(N)    writeGEQFreqCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba8Freq       wroteGEQFreqCh(10, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba8Level       readGEQLevelCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba8Level(N)   writeGEQLevelCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba8Level      wroteGEQLevelCh(10, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba8Width       readGEQWidthCh(10, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba8Width(N)   writeGEQWidthCh(10, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba8Width      wroteGEQWidthCh(10, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba9Freq        readGEQFreqCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba9Freq(N)    writeGEQFreqCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba9Freq       wroteGEQFreqCh(10, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba9Level       readGEQLevelCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba9Level(N)   writeGEQLevelCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba9Level      wroteGEQLevelCh(10, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba9Width       readGEQWidthCh(10, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba9Width(N)   writeGEQWidthCh(10, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba9Width      wroteGEQWidthCh(10, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba10Freq        readGEQFreqCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba10Freq(N)    writeGEQFreqCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba10Freq       wroteGEQFreqCh(10, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba10Level       readGEQLevelCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba10Level(N)   writeGEQLevelCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba10Level      wroteGEQLevelCh(10, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba10Width       readGEQWidthCh(10, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba10Width(N)   writeGEQWidthCh(10, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba10Width      wroteGEQWidthCh(10, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba11Freq        readGEQFreqCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba11Freq(N)    writeGEQFreqCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba11Freq       wroteGEQFreqCh(10, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba11Level       readGEQLevelCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba11Level(N)   writeGEQLevelCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba11Level      wroteGEQLevelCh(10, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba11Width       readGEQWidthCh(10, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba11Width(N)   writeGEQWidthCh(10, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba11Width      wroteGEQWidthCh(10, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba12Freq        readGEQFreqCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba12Freq(N)    writeGEQFreqCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba12Freq       wroteGEQFreqCh(10, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba12Level       readGEQLevelCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba12Level(N)   writeGEQLevelCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba12Level      wroteGEQLevelCh(10, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba12Width       readGEQWidthCh(10, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba12Width(N)   writeGEQWidthCh(10, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba12Width      wroteGEQWidthCh(10, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba13Freq        readGEQFreqCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba13Freq(N)    writeGEQFreqCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba13Freq       wroteGEQFreqCh(10, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba13Level       readGEQLevelCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba13Level(N)   writeGEQLevelCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba13Level      wroteGEQLevelCh(10, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba13Width       readGEQWidthCh(10, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba13Width(N)   writeGEQWidthCh(10, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba13Width      wroteGEQWidthCh(10, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba14Freq        readGEQFreqCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba14Freq(N)    writeGEQFreqCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba14Freq       wroteGEQFreqCh(10, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba14Level       readGEQLevelCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba14Level(N)   writeGEQLevelCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba14Level      wroteGEQLevelCh(10, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba14Width       readGEQWidthCh(10, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba14Width(N)   writeGEQWidthCh(10, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba14Width      wroteGEQWidthCh(10, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba15Freq        readGEQFreqCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba15Freq(N)    writeGEQFreqCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba15Freq       wroteGEQFreqCh(10, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba15Level       readGEQLevelCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba15Level(N)   writeGEQLevelCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba15Level      wroteGEQLevelCh(10, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba15Width       readGEQWidthCh(10, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba15Width(N)   writeGEQWidthCh(10, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba15Width      wroteGEQWidthCh(10, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba16Freq        readGEQFreqCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba16Freq(N)    writeGEQFreqCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba16Freq       wroteGEQFreqCh(10, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba16Level       readGEQLevelCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba16Level(N)   writeGEQLevelCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba16Level      wroteGEQLevelCh(10, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba16Width       readGEQWidthCh(10, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba16Width(N)   writeGEQWidthCh(10, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba16Width      wroteGEQWidthCh(10, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba17Freq        readGEQFreqCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba17Freq(N)    writeGEQFreqCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba17Freq       wroteGEQFreqCh(10, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba17Level       readGEQLevelCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba17Level(N)   writeGEQLevelCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba17Level      wroteGEQLevelCh(10, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba17Width       readGEQWidthCh(10, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba17Width(N)   writeGEQWidthCh(10, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba17Width      wroteGEQWidthCh(10, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba18Freq        readGEQFreqCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba18Freq(N)    writeGEQFreqCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba18Freq       wroteGEQFreqCh(10, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba18Level       readGEQLevelCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba18Level(N)   writeGEQLevelCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba18Level      wroteGEQLevelCh(10, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba18Width       readGEQWidthCh(10, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba18Width(N)   writeGEQWidthCh(10, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba18Width      wroteGEQWidthCh(10, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba19Freq        readGEQFreqCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba19Freq(N)    writeGEQFreqCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba19Freq       wroteGEQFreqCh(10, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba19Level       readGEQLevelCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba19Level(N)   writeGEQLevelCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba19Level      wroteGEQLevelCh(10, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba19Width       readGEQWidthCh(10, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba19Width(N)   writeGEQWidthCh(10, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba19Width      wroteGEQWidthCh(10, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba20Freq        readGEQFreqCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba20Freq(N)    writeGEQFreqCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba20Freq       wroteGEQFreqCh(10, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba20Level       readGEQLevelCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba20Level(N)   writeGEQLevelCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba20Level      wroteGEQLevelCh(10, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba20Width       readGEQWidthCh(10, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba20Width(N)   writeGEQWidthCh(10, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba20Width      wroteGEQWidthCh(10, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba21Freq        readGEQFreqCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba21Freq(N)    writeGEQFreqCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba21Freq       wroteGEQFreqCh(10, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba21Level       readGEQLevelCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba21Level(N)   writeGEQLevelCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba21Level      wroteGEQLevelCh(10, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba21Width       readGEQWidthCh(10, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba21Width(N)   writeGEQWidthCh(10, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba21Width      wroteGEQWidthCh(10, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba22Freq        readGEQFreqCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba22Freq(N)    writeGEQFreqCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba22Freq       wroteGEQFreqCh(10, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba22Level       readGEQLevelCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba22Level(N)   writeGEQLevelCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba22Level      wroteGEQLevelCh(10, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba22Width       readGEQWidthCh(10, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba22Width(N)   writeGEQWidthCh(10, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba22Width      wroteGEQWidthCh(10, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba23Freq        readGEQFreqCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba23Freq(N)    writeGEQFreqCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba23Freq       wroteGEQFreqCh(10, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba23Level       readGEQLevelCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba23Level(N)   writeGEQLevelCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba23Level      wroteGEQLevelCh(10, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba23Width       readGEQWidthCh(10, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba23Width(N)   writeGEQWidthCh(10, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba23Width      wroteGEQWidthCh(10, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba24Freq        readGEQFreqCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba24Freq(N)    writeGEQFreqCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba24Freq       wroteGEQFreqCh(10, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba24Level       readGEQLevelCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba24Level(N)   writeGEQLevelCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba24Level      wroteGEQLevelCh(10, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba24Width       readGEQWidthCh(10, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba24Width(N)   writeGEQWidthCh(10, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba24Width      wroteGEQWidthCh(10, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba25Freq        readGEQFreqCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba25Freq(N)    writeGEQFreqCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba25Freq       wroteGEQFreqCh(10, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba25Level       readGEQLevelCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba25Level(N)   writeGEQLevelCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba25Level      wroteGEQLevelCh(10, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba25Width       readGEQWidthCh(10, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba25Width(N)   writeGEQWidthCh(10, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba25Width      wroteGEQWidthCh(10, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba26Freq        readGEQFreqCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba26Freq(N)    writeGEQFreqCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba26Freq       wroteGEQFreqCh(10, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba26Level       readGEQLevelCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba26Level(N)   writeGEQLevelCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba26Level      wroteGEQLevelCh(10, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba26Width       readGEQWidthCh(10, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba26Width(N)   writeGEQWidthCh(10, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba26Width      wroteGEQWidthCh(10, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba27Freq        readGEQFreqCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba27Freq(N)    writeGEQFreqCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba27Freq       wroteGEQFreqCh(10, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba27Level       readGEQLevelCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba27Level(N)   writeGEQLevelCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba27Level      wroteGEQLevelCh(10, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba27Width       readGEQWidthCh(10, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba27Width(N)   writeGEQWidthCh(10, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba27Width      wroteGEQWidthCh(10, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba28Freq        readGEQFreqCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba28Freq(N)    writeGEQFreqCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba28Freq       wroteGEQFreqCh(10, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba28Level       readGEQLevelCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba28Level(N)   writeGEQLevelCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba28Level      wroteGEQLevelCh(10, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba28Width       readGEQWidthCh(10, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba28Width(N)   writeGEQWidthCh(10, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba28Width      wroteGEQWidthCh(10, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba29Freq        readGEQFreqCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba29Freq(N)    writeGEQFreqCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba29Freq       wroteGEQFreqCh(10, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba29Level       readGEQLevelCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba29Level(N)   writeGEQLevelCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba29Level      wroteGEQLevelCh(10, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba29Width       readGEQWidthCh(10, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba29Width(N)   writeGEQWidthCh(10, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba29Width      wroteGEQWidthCh(10, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba30Freq        readGEQFreqCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba30Freq(N)    writeGEQFreqCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba30Freq       wroteGEQFreqCh(10, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba30Level       readGEQLevelCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba30Level(N)   writeGEQLevelCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba30Level      wroteGEQLevelCh(10, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba30Width       readGEQWidthCh(10, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba30Width(N)   writeGEQWidthCh(10, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba30Width      wroteGEQWidthCh(10, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba31Freq        readGEQFreqCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba31Freq(N)    writeGEQFreqCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba31Freq       wroteGEQFreqCh(10, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba31Level       readGEQLevelCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba31Level(N)   writeGEQLevelCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba31Level      wroteGEQLevelCh(10, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba31Width       readGEQWidthCh(10, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba31Width(N)   writeGEQWidthCh(10, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba31Width      wroteGEQWidthCh(10, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh10Ba32Freq        readGEQFreqCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba32Freq(N)    writeGEQFreqCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba32Freq       wroteGEQFreqCh(10, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba32Level       readGEQLevelCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba32Level(N)   writeGEQLevelCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba32Level      wroteGEQLevelCh(10, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh10Ba32Width       readGEQWidthCh(10, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh10Ba32Width(N)   writeGEQWidthCh(10, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh10Ba32Width      wroteGEQWidthCh(10, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba1Freq        readGEQFreqCh(11, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba1Freq(N)    writeGEQFreqCh(11, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba1Freq       wroteGEQFreqCh(11, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba1Level       readGEQLevelCh(11, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba1Level(N)   writeGEQLevelCh(11, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba1Level      wroteGEQLevelCh(11, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba1Width       readGEQWidthCh(11, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba1Width(N)   writeGEQWidthCh(11, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba1Width      wroteGEQWidthCh(11, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba2Freq        readGEQFreqCh(11, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba2Freq(N)    writeGEQFreqCh(11, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba2Freq       wroteGEQFreqCh(11, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba2Level       readGEQLevelCh(11, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba2Level(N)   writeGEQLevelCh(11, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba2Level      wroteGEQLevelCh(11, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba2Width       readGEQWidthCh(11, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba2Width(N)   writeGEQWidthCh(11, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba2Width      wroteGEQWidthCh(11, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba3Freq        readGEQFreqCh(11, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba3Freq(N)    writeGEQFreqCh(11, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba3Freq       wroteGEQFreqCh(11, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba3Level       readGEQLevelCh(11, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba3Level(N)   writeGEQLevelCh(11, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba3Level      wroteGEQLevelCh(11, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba3Width       readGEQWidthCh(11, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba3Width(N)   writeGEQWidthCh(11, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba3Width      wroteGEQWidthCh(11, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba4Freq        readGEQFreqCh(11, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba4Freq(N)    writeGEQFreqCh(11, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba4Freq       wroteGEQFreqCh(11, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba4Level       readGEQLevelCh(11, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba4Level(N)   writeGEQLevelCh(11, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba4Level      wroteGEQLevelCh(11, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba4Width       readGEQWidthCh(11, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba4Width(N)   writeGEQWidthCh(11, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba4Width      wroteGEQWidthCh(11, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba5Freq        readGEQFreqCh(11, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba5Freq(N)    writeGEQFreqCh(11, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba5Freq       wroteGEQFreqCh(11, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba5Level       readGEQLevelCh(11, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba5Level(N)   writeGEQLevelCh(11, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba5Level      wroteGEQLevelCh(11, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba5Width       readGEQWidthCh(11, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba5Width(N)   writeGEQWidthCh(11, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba5Width      wroteGEQWidthCh(11, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba6Freq        readGEQFreqCh(11, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba6Freq(N)    writeGEQFreqCh(11, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba6Freq       wroteGEQFreqCh(11, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba6Level       readGEQLevelCh(11, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba6Level(N)   writeGEQLevelCh(11, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba6Level      wroteGEQLevelCh(11, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba6Width       readGEQWidthCh(11, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba6Width(N)   writeGEQWidthCh(11, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba6Width      wroteGEQWidthCh(11, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba7Freq        readGEQFreqCh(11, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba7Freq(N)    writeGEQFreqCh(11, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba7Freq       wroteGEQFreqCh(11, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba7Level       readGEQLevelCh(11, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba7Level(N)   writeGEQLevelCh(11, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba7Level      wroteGEQLevelCh(11, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba7Width       readGEQWidthCh(11, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba7Width(N)   writeGEQWidthCh(11, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba7Width      wroteGEQWidthCh(11, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba8Freq        readGEQFreqCh(11, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba8Freq(N)    writeGEQFreqCh(11, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba8Freq       wroteGEQFreqCh(11, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba8Level       readGEQLevelCh(11, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba8Level(N)   writeGEQLevelCh(11, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba8Level      wroteGEQLevelCh(11, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba8Width       readGEQWidthCh(11, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba8Width(N)   writeGEQWidthCh(11, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba8Width      wroteGEQWidthCh(11, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba9Freq        readGEQFreqCh(11, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba9Freq(N)    writeGEQFreqCh(11, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba9Freq       wroteGEQFreqCh(11, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba9Level       readGEQLevelCh(11, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba9Level(N)   writeGEQLevelCh(11, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba9Level      wroteGEQLevelCh(11, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba9Width       readGEQWidthCh(11, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba9Width(N)   writeGEQWidthCh(11, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba9Width      wroteGEQWidthCh(11, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba10Freq        readGEQFreqCh(11, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba10Freq(N)    writeGEQFreqCh(11, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba10Freq       wroteGEQFreqCh(11, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba10Level       readGEQLevelCh(11, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba10Level(N)   writeGEQLevelCh(11, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba10Level      wroteGEQLevelCh(11, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba10Width       readGEQWidthCh(11, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba10Width(N)   writeGEQWidthCh(11, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba10Width      wroteGEQWidthCh(11, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba11Freq        readGEQFreqCh(11, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba11Freq(N)    writeGEQFreqCh(11, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba11Freq       wroteGEQFreqCh(11, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba11Level       readGEQLevelCh(11, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba11Level(N)   writeGEQLevelCh(11, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba11Level      wroteGEQLevelCh(11, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba11Width       readGEQWidthCh(11, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba11Width(N)   writeGEQWidthCh(11, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba11Width      wroteGEQWidthCh(11, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba12Freq        readGEQFreqCh(11, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba12Freq(N)    writeGEQFreqCh(11, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba12Freq       wroteGEQFreqCh(11, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba12Level       readGEQLevelCh(11, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba12Level(N)   writeGEQLevelCh(11, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba12Level      wroteGEQLevelCh(11, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba12Width       readGEQWidthCh(11, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba12Width(N)   writeGEQWidthCh(11, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba12Width      wroteGEQWidthCh(11, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba13Freq        readGEQFreqCh(11, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba13Freq(N)    writeGEQFreqCh(11, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba13Freq       wroteGEQFreqCh(11, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba13Level       readGEQLevelCh(11, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba13Level(N)   writeGEQLevelCh(11, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba13Level      wroteGEQLevelCh(11, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba13Width       readGEQWidthCh(11, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba13Width(N)   writeGEQWidthCh(11, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba13Width      wroteGEQWidthCh(11, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba14Freq        readGEQFreqCh(11, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba14Freq(N)    writeGEQFreqCh(11, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba14Freq       wroteGEQFreqCh(11, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba14Level       readGEQLevelCh(11, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba14Level(N)   writeGEQLevelCh(11, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba14Level      wroteGEQLevelCh(11, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba14Width       readGEQWidthCh(11, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba14Width(N)   writeGEQWidthCh(11, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba14Width      wroteGEQWidthCh(11, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba15Freq        readGEQFreqCh(11, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba15Freq(N)    writeGEQFreqCh(11, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba15Freq       wroteGEQFreqCh(11, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba15Level       readGEQLevelCh(11, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba15Level(N)   writeGEQLevelCh(11, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba15Level      wroteGEQLevelCh(11, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba15Width       readGEQWidthCh(11, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba15Width(N)   writeGEQWidthCh(11, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba15Width      wroteGEQWidthCh(11, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba16Freq        readGEQFreqCh(11, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba16Freq(N)    writeGEQFreqCh(11, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba16Freq       wroteGEQFreqCh(11, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba16Level       readGEQLevelCh(11, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba16Level(N)   writeGEQLevelCh(11, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba16Level      wroteGEQLevelCh(11, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba16Width       readGEQWidthCh(11, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba16Width(N)   writeGEQWidthCh(11, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba16Width      wroteGEQWidthCh(11, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba17Freq        readGEQFreqCh(11, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba17Freq(N)    writeGEQFreqCh(11, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba17Freq       wroteGEQFreqCh(11, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba17Level       readGEQLevelCh(11, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba17Level(N)   writeGEQLevelCh(11, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba17Level      wroteGEQLevelCh(11, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba17Width       readGEQWidthCh(11, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba17Width(N)   writeGEQWidthCh(11, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba17Width      wroteGEQWidthCh(11, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba18Freq        readGEQFreqCh(11, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba18Freq(N)    writeGEQFreqCh(11, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba18Freq       wroteGEQFreqCh(11, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba18Level       readGEQLevelCh(11, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba18Level(N)   writeGEQLevelCh(11, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba18Level      wroteGEQLevelCh(11, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba18Width       readGEQWidthCh(11, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba18Width(N)   writeGEQWidthCh(11, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba18Width      wroteGEQWidthCh(11, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba19Freq        readGEQFreqCh(11, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba19Freq(N)    writeGEQFreqCh(11, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba19Freq       wroteGEQFreqCh(11, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba19Level       readGEQLevelCh(11, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba19Level(N)   writeGEQLevelCh(11, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba19Level      wroteGEQLevelCh(11, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba19Width       readGEQWidthCh(11, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba19Width(N)   writeGEQWidthCh(11, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba19Width      wroteGEQWidthCh(11, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba20Freq        readGEQFreqCh(11, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba20Freq(N)    writeGEQFreqCh(11, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba20Freq       wroteGEQFreqCh(11, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba20Level       readGEQLevelCh(11, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba20Level(N)   writeGEQLevelCh(11, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba20Level      wroteGEQLevelCh(11, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba20Width       readGEQWidthCh(11, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba20Width(N)   writeGEQWidthCh(11, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba20Width      wroteGEQWidthCh(11, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba21Freq        readGEQFreqCh(11, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba21Freq(N)    writeGEQFreqCh(11, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba21Freq       wroteGEQFreqCh(11, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba21Level       readGEQLevelCh(11, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba21Level(N)   writeGEQLevelCh(11, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba21Level      wroteGEQLevelCh(11, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba21Width       readGEQWidthCh(11, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba21Width(N)   writeGEQWidthCh(11, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba21Width      wroteGEQWidthCh(11, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba22Freq        readGEQFreqCh(11, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba22Freq(N)    writeGEQFreqCh(11, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba22Freq       wroteGEQFreqCh(11, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba22Level       readGEQLevelCh(11, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba22Level(N)   writeGEQLevelCh(11, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba22Level      wroteGEQLevelCh(11, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba22Width       readGEQWidthCh(11, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba22Width(N)   writeGEQWidthCh(11, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba22Width      wroteGEQWidthCh(11, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba23Freq        readGEQFreqCh(11, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba23Freq(N)    writeGEQFreqCh(11, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba23Freq       wroteGEQFreqCh(11, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba23Level       readGEQLevelCh(11, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba23Level(N)   writeGEQLevelCh(11, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba23Level      wroteGEQLevelCh(11, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba23Width       readGEQWidthCh(11, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba23Width(N)   writeGEQWidthCh(11, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba23Width      wroteGEQWidthCh(11, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba24Freq        readGEQFreqCh(11, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba24Freq(N)    writeGEQFreqCh(11, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba24Freq       wroteGEQFreqCh(11, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba24Level       readGEQLevelCh(11, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba24Level(N)   writeGEQLevelCh(11, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba24Level      wroteGEQLevelCh(11, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba24Width       readGEQWidthCh(11, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba24Width(N)   writeGEQWidthCh(11, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba24Width      wroteGEQWidthCh(11, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba25Freq        readGEQFreqCh(11, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba25Freq(N)    writeGEQFreqCh(11, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba25Freq       wroteGEQFreqCh(11, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba25Level       readGEQLevelCh(11, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba25Level(N)   writeGEQLevelCh(11, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba25Level      wroteGEQLevelCh(11, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba25Width       readGEQWidthCh(11, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba25Width(N)   writeGEQWidthCh(11, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba25Width      wroteGEQWidthCh(11, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba26Freq        readGEQFreqCh(11, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba26Freq(N)    writeGEQFreqCh(11, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba26Freq       wroteGEQFreqCh(11, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba26Level       readGEQLevelCh(11, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba26Level(N)   writeGEQLevelCh(11, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba26Level      wroteGEQLevelCh(11, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba26Width       readGEQWidthCh(11, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba26Width(N)   writeGEQWidthCh(11, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba26Width      wroteGEQWidthCh(11, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba27Freq        readGEQFreqCh(11, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba27Freq(N)    writeGEQFreqCh(11, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba27Freq       wroteGEQFreqCh(11, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba27Level       readGEQLevelCh(11, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba27Level(N)   writeGEQLevelCh(11, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba27Level      wroteGEQLevelCh(11, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba27Width       readGEQWidthCh(11, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba27Width(N)   writeGEQWidthCh(11, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba27Width      wroteGEQWidthCh(11, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba28Freq        readGEQFreqCh(11, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba28Freq(N)    writeGEQFreqCh(11, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba28Freq       wroteGEQFreqCh(11, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba28Level       readGEQLevelCh(11, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba28Level(N)   writeGEQLevelCh(11, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba28Level      wroteGEQLevelCh(11, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba28Width       readGEQWidthCh(11, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba28Width(N)   writeGEQWidthCh(11, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba28Width      wroteGEQWidthCh(11, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba29Freq        readGEQFreqCh(11, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba29Freq(N)    writeGEQFreqCh(11, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba29Freq       wroteGEQFreqCh(11, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba29Level       readGEQLevelCh(11, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba29Level(N)   writeGEQLevelCh(11, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba29Level      wroteGEQLevelCh(11, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba29Width       readGEQWidthCh(11, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba29Width(N)   writeGEQWidthCh(11, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba29Width      wroteGEQWidthCh(11, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba30Freq        readGEQFreqCh(11, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba30Freq(N)    writeGEQFreqCh(11, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba30Freq       wroteGEQFreqCh(11, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba30Level       readGEQLevelCh(11, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba30Level(N)   writeGEQLevelCh(11, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba30Level      wroteGEQLevelCh(11, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba30Width       readGEQWidthCh(11, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba30Width(N)   writeGEQWidthCh(11, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba30Width      wroteGEQWidthCh(11, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba31Freq        readGEQFreqCh(11, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba31Freq(N)    writeGEQFreqCh(11, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba31Freq       wroteGEQFreqCh(11, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba31Level       readGEQLevelCh(11, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba31Level(N)   writeGEQLevelCh(11, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba31Level      wroteGEQLevelCh(11, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba31Width       readGEQWidthCh(11, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba31Width(N)   writeGEQWidthCh(11, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba31Width      wroteGEQWidthCh(11, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh11Ba32Freq        readGEQFreqCh(11, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba32Freq(N)    writeGEQFreqCh(11, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba32Freq       wroteGEQFreqCh(11, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba32Level       readGEQLevelCh(11, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba32Level(N)   writeGEQLevelCh(11, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba32Level      wroteGEQLevelCh(11, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh11Ba32Width       readGEQWidthCh(11, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh11Ba32Width(N)   writeGEQWidthCh(11, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh11Ba32Width      wroteGEQWidthCh(11, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba1Freq        readGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba1Freq(N)    writeGEQFreqCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba1Freq       wroteGEQFreqCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba1Level       readGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba1Level(N)   writeGEQLevelCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba1Level      wroteGEQLevelCh(12, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba1Width       readGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba1Width(N)   writeGEQWidthCh(12, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba1Width      wroteGEQWidthCh(12, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba2Freq        readGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba2Freq(N)    writeGEQFreqCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba2Freq       wroteGEQFreqCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba2Level       readGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba2Level(N)   writeGEQLevelCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba2Level      wroteGEQLevelCh(12, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba2Width       readGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba2Width(N)   writeGEQWidthCh(12, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba2Width      wroteGEQWidthCh(12, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba3Freq        readGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba3Freq(N)    writeGEQFreqCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba3Freq       wroteGEQFreqCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba3Level       readGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba3Level(N)   writeGEQLevelCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba3Level      wroteGEQLevelCh(12, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba3Width       readGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba3Width(N)   writeGEQWidthCh(12, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba3Width      wroteGEQWidthCh(12, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba4Freq        readGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba4Freq(N)    writeGEQFreqCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba4Freq       wroteGEQFreqCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba4Level       readGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba4Level(N)   writeGEQLevelCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba4Level      wroteGEQLevelCh(12, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba4Width       readGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba4Width(N)   writeGEQWidthCh(12, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba4Width      wroteGEQWidthCh(12, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba5Freq        readGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba5Freq(N)    writeGEQFreqCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba5Freq       wroteGEQFreqCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba5Level       readGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba5Level(N)   writeGEQLevelCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba5Level      wroteGEQLevelCh(12, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba5Width       readGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba5Width(N)   writeGEQWidthCh(12, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba5Width      wroteGEQWidthCh(12, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba6Freq        readGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba6Freq(N)    writeGEQFreqCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba6Freq       wroteGEQFreqCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba6Level       readGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba6Level(N)   writeGEQLevelCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba6Level      wroteGEQLevelCh(12, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba6Width       readGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba6Width(N)   writeGEQWidthCh(12, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba6Width      wroteGEQWidthCh(12, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba7Freq        readGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba7Freq(N)    writeGEQFreqCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba7Freq       wroteGEQFreqCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba7Level       readGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba7Level(N)   writeGEQLevelCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba7Level      wroteGEQLevelCh(12, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba7Width       readGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba7Width(N)   writeGEQWidthCh(12, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba7Width      wroteGEQWidthCh(12, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba8Freq        readGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba8Freq(N)    writeGEQFreqCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba8Freq       wroteGEQFreqCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba8Level       readGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba8Level(N)   writeGEQLevelCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba8Level      wroteGEQLevelCh(12, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba8Width       readGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba8Width(N)   writeGEQWidthCh(12, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba8Width      wroteGEQWidthCh(12, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba9Freq        readGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba9Freq(N)    writeGEQFreqCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba9Freq       wroteGEQFreqCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba9Level       readGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba9Level(N)   writeGEQLevelCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba9Level      wroteGEQLevelCh(12, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba9Width       readGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba9Width(N)   writeGEQWidthCh(12, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba9Width      wroteGEQWidthCh(12, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba10Freq        readGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba10Freq(N)    writeGEQFreqCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba10Freq       wroteGEQFreqCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba10Level       readGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba10Level(N)   writeGEQLevelCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba10Level      wroteGEQLevelCh(12, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba10Width       readGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba10Width(N)   writeGEQWidthCh(12, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba10Width      wroteGEQWidthCh(12, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba11Freq        readGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba11Freq(N)    writeGEQFreqCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba11Freq       wroteGEQFreqCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba11Level       readGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba11Level(N)   writeGEQLevelCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba11Level      wroteGEQLevelCh(12, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba11Width       readGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba11Width(N)   writeGEQWidthCh(12, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba11Width      wroteGEQWidthCh(12, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba12Freq        readGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba12Freq(N)    writeGEQFreqCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba12Freq       wroteGEQFreqCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba12Level       readGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba12Level(N)   writeGEQLevelCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba12Level      wroteGEQLevelCh(12, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba12Width       readGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba12Width(N)   writeGEQWidthCh(12, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba12Width      wroteGEQWidthCh(12, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba13Freq        readGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba13Freq(N)    writeGEQFreqCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba13Freq       wroteGEQFreqCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba13Level       readGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba13Level(N)   writeGEQLevelCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba13Level      wroteGEQLevelCh(12, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba13Width       readGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba13Width(N)   writeGEQWidthCh(12, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba13Width      wroteGEQWidthCh(12, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba14Freq        readGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba14Freq(N)    writeGEQFreqCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba14Freq       wroteGEQFreqCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba14Level       readGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba14Level(N)   writeGEQLevelCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba14Level      wroteGEQLevelCh(12, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba14Width       readGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba14Width(N)   writeGEQWidthCh(12, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba14Width      wroteGEQWidthCh(12, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba15Freq        readGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba15Freq(N)    writeGEQFreqCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba15Freq       wroteGEQFreqCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba15Level       readGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba15Level(N)   writeGEQLevelCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba15Level      wroteGEQLevelCh(12, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba15Width       readGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba15Width(N)   writeGEQWidthCh(12, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba15Width      wroteGEQWidthCh(12, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba16Freq        readGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba16Freq(N)    writeGEQFreqCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba16Freq       wroteGEQFreqCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba16Level       readGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba16Level(N)   writeGEQLevelCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba16Level      wroteGEQLevelCh(12, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba16Width       readGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba16Width(N)   writeGEQWidthCh(12, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba16Width      wroteGEQWidthCh(12, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba17Freq        readGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba17Freq(N)    writeGEQFreqCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba17Freq       wroteGEQFreqCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba17Level       readGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba17Level(N)   writeGEQLevelCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba17Level      wroteGEQLevelCh(12, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba17Width       readGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba17Width(N)   writeGEQWidthCh(12, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba17Width      wroteGEQWidthCh(12, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba18Freq        readGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba18Freq(N)    writeGEQFreqCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba18Freq       wroteGEQFreqCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba18Level       readGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba18Level(N)   writeGEQLevelCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba18Level      wroteGEQLevelCh(12, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba18Width       readGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba18Width(N)   writeGEQWidthCh(12, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba18Width      wroteGEQWidthCh(12, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba19Freq        readGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba19Freq(N)    writeGEQFreqCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba19Freq       wroteGEQFreqCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba19Level       readGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba19Level(N)   writeGEQLevelCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba19Level      wroteGEQLevelCh(12, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba19Width       readGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba19Width(N)   writeGEQWidthCh(12, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba19Width      wroteGEQWidthCh(12, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba20Freq        readGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba20Freq(N)    writeGEQFreqCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba20Freq       wroteGEQFreqCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba20Level       readGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba20Level(N)   writeGEQLevelCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba20Level      wroteGEQLevelCh(12, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba20Width       readGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba20Width(N)   writeGEQWidthCh(12, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba20Width      wroteGEQWidthCh(12, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba21Freq        readGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba21Freq(N)    writeGEQFreqCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba21Freq       wroteGEQFreqCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba21Level       readGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba21Level(N)   writeGEQLevelCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba21Level      wroteGEQLevelCh(12, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba21Width       readGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba21Width(N)   writeGEQWidthCh(12, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba21Width      wroteGEQWidthCh(12, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba22Freq        readGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba22Freq(N)    writeGEQFreqCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba22Freq       wroteGEQFreqCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba22Level       readGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba22Level(N)   writeGEQLevelCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba22Level      wroteGEQLevelCh(12, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba22Width       readGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba22Width(N)   writeGEQWidthCh(12, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba22Width      wroteGEQWidthCh(12, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba23Freq        readGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba23Freq(N)    writeGEQFreqCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba23Freq       wroteGEQFreqCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba23Level       readGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba23Level(N)   writeGEQLevelCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba23Level      wroteGEQLevelCh(12, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba23Width       readGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba23Width(N)   writeGEQWidthCh(12, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba23Width      wroteGEQWidthCh(12, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba24Freq        readGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba24Freq(N)    writeGEQFreqCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba24Freq       wroteGEQFreqCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba24Level       readGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba24Level(N)   writeGEQLevelCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba24Level      wroteGEQLevelCh(12, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba24Width       readGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba24Width(N)   writeGEQWidthCh(12, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba24Width      wroteGEQWidthCh(12, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba25Freq        readGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba25Freq(N)    writeGEQFreqCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba25Freq       wroteGEQFreqCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba25Level       readGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba25Level(N)   writeGEQLevelCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba25Level      wroteGEQLevelCh(12, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba25Width       readGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba25Width(N)   writeGEQWidthCh(12, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba25Width      wroteGEQWidthCh(12, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba26Freq        readGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba26Freq(N)    writeGEQFreqCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba26Freq       wroteGEQFreqCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba26Level       readGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba26Level(N)   writeGEQLevelCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba26Level      wroteGEQLevelCh(12, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba26Width       readGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba26Width(N)   writeGEQWidthCh(12, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba26Width      wroteGEQWidthCh(12, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba27Freq        readGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba27Freq(N)    writeGEQFreqCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba27Freq       wroteGEQFreqCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba27Level       readGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba27Level(N)   writeGEQLevelCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba27Level      wroteGEQLevelCh(12, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba27Width       readGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba27Width(N)   writeGEQWidthCh(12, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba27Width      wroteGEQWidthCh(12, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba28Freq        readGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba28Freq(N)    writeGEQFreqCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba28Freq       wroteGEQFreqCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba28Level       readGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba28Level(N)   writeGEQLevelCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba28Level      wroteGEQLevelCh(12, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba28Width       readGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba28Width(N)   writeGEQWidthCh(12, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba28Width      wroteGEQWidthCh(12, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba29Freq        readGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba29Freq(N)    writeGEQFreqCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba29Freq       wroteGEQFreqCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba29Level       readGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba29Level(N)   writeGEQLevelCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba29Level      wroteGEQLevelCh(12, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba29Width       readGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba29Width(N)   writeGEQWidthCh(12, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba29Width      wroteGEQWidthCh(12, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba30Freq        readGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba30Freq(N)    writeGEQFreqCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba30Freq       wroteGEQFreqCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba30Level       readGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba30Level(N)   writeGEQLevelCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba30Level      wroteGEQLevelCh(12, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba30Width       readGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba30Width(N)   writeGEQWidthCh(12, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba30Width      wroteGEQWidthCh(12, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba31Freq        readGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba31Freq(N)    writeGEQFreqCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba31Freq       wroteGEQFreqCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba31Level       readGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba31Level(N)   writeGEQLevelCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba31Level      wroteGEQLevelCh(12, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba31Width       readGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba31Width(N)   writeGEQWidthCh(12, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba31Width      wroteGEQWidthCh(12, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh12Ba32Freq        readGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba32Freq(N)    writeGEQFreqCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba32Freq       wroteGEQFreqCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba32Level       readGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba32Level(N)   writeGEQLevelCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba32Level      wroteGEQLevelCh(12, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh12Ba32Width       readGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh12Ba32Width(N)   writeGEQWidthCh(12, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh12Ba32Width      wroteGEQWidthCh(12, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba1Freq        readGEQFreqCh(13, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba1Freq(N)    writeGEQFreqCh(13, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba1Freq       wroteGEQFreqCh(13, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba1Level       readGEQLevelCh(13, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba1Level(N)   writeGEQLevelCh(13, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba1Level      wroteGEQLevelCh(13, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba1Width       readGEQWidthCh(13, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba1Width(N)   writeGEQWidthCh(13, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba1Width      wroteGEQWidthCh(13, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba2Freq        readGEQFreqCh(13, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba2Freq(N)    writeGEQFreqCh(13, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba2Freq       wroteGEQFreqCh(13, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba2Level       readGEQLevelCh(13, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba2Level(N)   writeGEQLevelCh(13, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba2Level      wroteGEQLevelCh(13, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba2Width       readGEQWidthCh(13, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba2Width(N)   writeGEQWidthCh(13, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba2Width      wroteGEQWidthCh(13, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba3Freq        readGEQFreqCh(13, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba3Freq(N)    writeGEQFreqCh(13, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba3Freq       wroteGEQFreqCh(13, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba3Level       readGEQLevelCh(13, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba3Level(N)   writeGEQLevelCh(13, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba3Level      wroteGEQLevelCh(13, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba3Width       readGEQWidthCh(13, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba3Width(N)   writeGEQWidthCh(13, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba3Width      wroteGEQWidthCh(13, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba4Freq        readGEQFreqCh(13, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba4Freq(N)    writeGEQFreqCh(13, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba4Freq       wroteGEQFreqCh(13, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba4Level       readGEQLevelCh(13, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba4Level(N)   writeGEQLevelCh(13, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba4Level      wroteGEQLevelCh(13, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba4Width       readGEQWidthCh(13, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba4Width(N)   writeGEQWidthCh(13, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba4Width      wroteGEQWidthCh(13, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba5Freq        readGEQFreqCh(13, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba5Freq(N)    writeGEQFreqCh(13, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba5Freq       wroteGEQFreqCh(13, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba5Level       readGEQLevelCh(13, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba5Level(N)   writeGEQLevelCh(13, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba5Level      wroteGEQLevelCh(13, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba5Width       readGEQWidthCh(13, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba5Width(N)   writeGEQWidthCh(13, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba5Width      wroteGEQWidthCh(13, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba6Freq        readGEQFreqCh(13, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba6Freq(N)    writeGEQFreqCh(13, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba6Freq       wroteGEQFreqCh(13, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba6Level       readGEQLevelCh(13, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba6Level(N)   writeGEQLevelCh(13, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba6Level      wroteGEQLevelCh(13, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba6Width       readGEQWidthCh(13, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba6Width(N)   writeGEQWidthCh(13, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba6Width      wroteGEQWidthCh(13, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba7Freq        readGEQFreqCh(13, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba7Freq(N)    writeGEQFreqCh(13, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba7Freq       wroteGEQFreqCh(13, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba7Level       readGEQLevelCh(13, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba7Level(N)   writeGEQLevelCh(13, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba7Level      wroteGEQLevelCh(13, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba7Width       readGEQWidthCh(13, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba7Width(N)   writeGEQWidthCh(13, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba7Width      wroteGEQWidthCh(13, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba8Freq        readGEQFreqCh(13, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba8Freq(N)    writeGEQFreqCh(13, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba8Freq       wroteGEQFreqCh(13, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba8Level       readGEQLevelCh(13, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba8Level(N)   writeGEQLevelCh(13, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba8Level      wroteGEQLevelCh(13, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba8Width       readGEQWidthCh(13, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba8Width(N)   writeGEQWidthCh(13, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba8Width      wroteGEQWidthCh(13, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba9Freq        readGEQFreqCh(13, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba9Freq(N)    writeGEQFreqCh(13, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba9Freq       wroteGEQFreqCh(13, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba9Level       readGEQLevelCh(13, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba9Level(N)   writeGEQLevelCh(13, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba9Level      wroteGEQLevelCh(13, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba9Width       readGEQWidthCh(13, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba9Width(N)   writeGEQWidthCh(13, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba9Width      wroteGEQWidthCh(13, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba10Freq        readGEQFreqCh(13, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba10Freq(N)    writeGEQFreqCh(13, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba10Freq       wroteGEQFreqCh(13, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba10Level       readGEQLevelCh(13, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba10Level(N)   writeGEQLevelCh(13, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba10Level      wroteGEQLevelCh(13, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba10Width       readGEQWidthCh(13, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba10Width(N)   writeGEQWidthCh(13, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba10Width      wroteGEQWidthCh(13, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba11Freq        readGEQFreqCh(13, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba11Freq(N)    writeGEQFreqCh(13, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba11Freq       wroteGEQFreqCh(13, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba11Level       readGEQLevelCh(13, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba11Level(N)   writeGEQLevelCh(13, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba11Level      wroteGEQLevelCh(13, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba11Width       readGEQWidthCh(13, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba11Width(N)   writeGEQWidthCh(13, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba11Width      wroteGEQWidthCh(13, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba12Freq        readGEQFreqCh(13, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba12Freq(N)    writeGEQFreqCh(13, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba12Freq       wroteGEQFreqCh(13, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba12Level       readGEQLevelCh(13, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba12Level(N)   writeGEQLevelCh(13, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba12Level      wroteGEQLevelCh(13, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba12Width       readGEQWidthCh(13, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba12Width(N)   writeGEQWidthCh(13, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba12Width      wroteGEQWidthCh(13, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba13Freq        readGEQFreqCh(13, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba13Freq(N)    writeGEQFreqCh(13, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba13Freq       wroteGEQFreqCh(13, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba13Level       readGEQLevelCh(13, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba13Level(N)   writeGEQLevelCh(13, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba13Level      wroteGEQLevelCh(13, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba13Width       readGEQWidthCh(13, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba13Width(N)   writeGEQWidthCh(13, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba13Width      wroteGEQWidthCh(13, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba14Freq        readGEQFreqCh(13, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba14Freq(N)    writeGEQFreqCh(13, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba14Freq       wroteGEQFreqCh(13, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba14Level       readGEQLevelCh(13, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba14Level(N)   writeGEQLevelCh(13, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba14Level      wroteGEQLevelCh(13, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba14Width       readGEQWidthCh(13, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba14Width(N)   writeGEQWidthCh(13, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba14Width      wroteGEQWidthCh(13, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba15Freq        readGEQFreqCh(13, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba15Freq(N)    writeGEQFreqCh(13, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba15Freq       wroteGEQFreqCh(13, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba15Level       readGEQLevelCh(13, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba15Level(N)   writeGEQLevelCh(13, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba15Level      wroteGEQLevelCh(13, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba15Width       readGEQWidthCh(13, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba15Width(N)   writeGEQWidthCh(13, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba15Width      wroteGEQWidthCh(13, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba16Freq        readGEQFreqCh(13, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba16Freq(N)    writeGEQFreqCh(13, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba16Freq       wroteGEQFreqCh(13, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba16Level       readGEQLevelCh(13, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba16Level(N)   writeGEQLevelCh(13, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba16Level      wroteGEQLevelCh(13, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba16Width       readGEQWidthCh(13, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba16Width(N)   writeGEQWidthCh(13, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba16Width      wroteGEQWidthCh(13, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba17Freq        readGEQFreqCh(13, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba17Freq(N)    writeGEQFreqCh(13, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba17Freq       wroteGEQFreqCh(13, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba17Level       readGEQLevelCh(13, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba17Level(N)   writeGEQLevelCh(13, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba17Level      wroteGEQLevelCh(13, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba17Width       readGEQWidthCh(13, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba17Width(N)   writeGEQWidthCh(13, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba17Width      wroteGEQWidthCh(13, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba18Freq        readGEQFreqCh(13, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba18Freq(N)    writeGEQFreqCh(13, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba18Freq       wroteGEQFreqCh(13, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba18Level       readGEQLevelCh(13, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba18Level(N)   writeGEQLevelCh(13, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba18Level      wroteGEQLevelCh(13, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba18Width       readGEQWidthCh(13, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba18Width(N)   writeGEQWidthCh(13, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba18Width      wroteGEQWidthCh(13, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba19Freq        readGEQFreqCh(13, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba19Freq(N)    writeGEQFreqCh(13, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba19Freq       wroteGEQFreqCh(13, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba19Level       readGEQLevelCh(13, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba19Level(N)   writeGEQLevelCh(13, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba19Level      wroteGEQLevelCh(13, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba19Width       readGEQWidthCh(13, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba19Width(N)   writeGEQWidthCh(13, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba19Width      wroteGEQWidthCh(13, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba20Freq        readGEQFreqCh(13, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba20Freq(N)    writeGEQFreqCh(13, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba20Freq       wroteGEQFreqCh(13, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba20Level       readGEQLevelCh(13, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba20Level(N)   writeGEQLevelCh(13, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba20Level      wroteGEQLevelCh(13, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba20Width       readGEQWidthCh(13, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba20Width(N)   writeGEQWidthCh(13, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba20Width      wroteGEQWidthCh(13, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba21Freq        readGEQFreqCh(13, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba21Freq(N)    writeGEQFreqCh(13, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba21Freq       wroteGEQFreqCh(13, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba21Level       readGEQLevelCh(13, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba21Level(N)   writeGEQLevelCh(13, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba21Level      wroteGEQLevelCh(13, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba21Width       readGEQWidthCh(13, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba21Width(N)   writeGEQWidthCh(13, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba21Width      wroteGEQWidthCh(13, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba22Freq        readGEQFreqCh(13, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba22Freq(N)    writeGEQFreqCh(13, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba22Freq       wroteGEQFreqCh(13, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba22Level       readGEQLevelCh(13, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba22Level(N)   writeGEQLevelCh(13, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba22Level      wroteGEQLevelCh(13, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba22Width       readGEQWidthCh(13, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba22Width(N)   writeGEQWidthCh(13, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba22Width      wroteGEQWidthCh(13, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba23Freq        readGEQFreqCh(13, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba23Freq(N)    writeGEQFreqCh(13, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba23Freq       wroteGEQFreqCh(13, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba23Level       readGEQLevelCh(13, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba23Level(N)   writeGEQLevelCh(13, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba23Level      wroteGEQLevelCh(13, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba23Width       readGEQWidthCh(13, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba23Width(N)   writeGEQWidthCh(13, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba23Width      wroteGEQWidthCh(13, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba24Freq        readGEQFreqCh(13, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba24Freq(N)    writeGEQFreqCh(13, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba24Freq       wroteGEQFreqCh(13, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba24Level       readGEQLevelCh(13, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba24Level(N)   writeGEQLevelCh(13, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba24Level      wroteGEQLevelCh(13, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba24Width       readGEQWidthCh(13, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba24Width(N)   writeGEQWidthCh(13, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba24Width      wroteGEQWidthCh(13, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba25Freq        readGEQFreqCh(13, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba25Freq(N)    writeGEQFreqCh(13, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba25Freq       wroteGEQFreqCh(13, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba25Level       readGEQLevelCh(13, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba25Level(N)   writeGEQLevelCh(13, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba25Level      wroteGEQLevelCh(13, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba25Width       readGEQWidthCh(13, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba25Width(N)   writeGEQWidthCh(13, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba25Width      wroteGEQWidthCh(13, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba26Freq        readGEQFreqCh(13, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba26Freq(N)    writeGEQFreqCh(13, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba26Freq       wroteGEQFreqCh(13, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba26Level       readGEQLevelCh(13, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba26Level(N)   writeGEQLevelCh(13, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba26Level      wroteGEQLevelCh(13, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba26Width       readGEQWidthCh(13, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba26Width(N)   writeGEQWidthCh(13, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba26Width      wroteGEQWidthCh(13, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba27Freq        readGEQFreqCh(13, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba27Freq(N)    writeGEQFreqCh(13, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba27Freq       wroteGEQFreqCh(13, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba27Level       readGEQLevelCh(13, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba27Level(N)   writeGEQLevelCh(13, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba27Level      wroteGEQLevelCh(13, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba27Width       readGEQWidthCh(13, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba27Width(N)   writeGEQWidthCh(13, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba27Width      wroteGEQWidthCh(13, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba28Freq        readGEQFreqCh(13, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba28Freq(N)    writeGEQFreqCh(13, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba28Freq       wroteGEQFreqCh(13, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba28Level       readGEQLevelCh(13, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba28Level(N)   writeGEQLevelCh(13, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba28Level      wroteGEQLevelCh(13, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba28Width       readGEQWidthCh(13, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba28Width(N)   writeGEQWidthCh(13, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba28Width      wroteGEQWidthCh(13, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba29Freq        readGEQFreqCh(13, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba29Freq(N)    writeGEQFreqCh(13, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba29Freq       wroteGEQFreqCh(13, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba29Level       readGEQLevelCh(13, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba29Level(N)   writeGEQLevelCh(13, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba29Level      wroteGEQLevelCh(13, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba29Width       readGEQWidthCh(13, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba29Width(N)   writeGEQWidthCh(13, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba29Width      wroteGEQWidthCh(13, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba30Freq        readGEQFreqCh(13, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba30Freq(N)    writeGEQFreqCh(13, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba30Freq       wroteGEQFreqCh(13, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba30Level       readGEQLevelCh(13, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba30Level(N)   writeGEQLevelCh(13, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba30Level      wroteGEQLevelCh(13, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba30Width       readGEQWidthCh(13, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba30Width(N)   writeGEQWidthCh(13, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba30Width      wroteGEQWidthCh(13, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba31Freq        readGEQFreqCh(13, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba31Freq(N)    writeGEQFreqCh(13, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba31Freq       wroteGEQFreqCh(13, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba31Level       readGEQLevelCh(13, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba31Level(N)   writeGEQLevelCh(13, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba31Level      wroteGEQLevelCh(13, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba31Width       readGEQWidthCh(13, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba31Width(N)   writeGEQWidthCh(13, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba31Width      wroteGEQWidthCh(13, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh13Ba32Freq        readGEQFreqCh(13, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba32Freq(N)    writeGEQFreqCh(13, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba32Freq       wroteGEQFreqCh(13, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba32Level       readGEQLevelCh(13, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba32Level(N)   writeGEQLevelCh(13, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba32Level      wroteGEQLevelCh(13, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh13Ba32Width       readGEQWidthCh(13, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh13Ba32Width(N)   writeGEQWidthCh(13, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh13Ba32Width      wroteGEQWidthCh(13, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba1Freq        readGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba1Freq(N)    writeGEQFreqCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba1Freq       wroteGEQFreqCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba1Level       readGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba1Level(N)   writeGEQLevelCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba1Level      wroteGEQLevelCh(14, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba1Width       readGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba1Width(N)   writeGEQWidthCh(14, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba1Width      wroteGEQWidthCh(14, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba2Freq        readGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba2Freq(N)    writeGEQFreqCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba2Freq       wroteGEQFreqCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba2Level       readGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba2Level(N)   writeGEQLevelCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba2Level      wroteGEQLevelCh(14, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba2Width       readGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba2Width(N)   writeGEQWidthCh(14, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba2Width      wroteGEQWidthCh(14, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba3Freq        readGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba3Freq(N)    writeGEQFreqCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba3Freq       wroteGEQFreqCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba3Level       readGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba3Level(N)   writeGEQLevelCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba3Level      wroteGEQLevelCh(14, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba3Width       readGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba3Width(N)   writeGEQWidthCh(14, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba3Width      wroteGEQWidthCh(14, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba4Freq        readGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba4Freq(N)    writeGEQFreqCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba4Freq       wroteGEQFreqCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba4Level       readGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba4Level(N)   writeGEQLevelCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba4Level      wroteGEQLevelCh(14, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba4Width       readGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba4Width(N)   writeGEQWidthCh(14, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba4Width      wroteGEQWidthCh(14, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba5Freq        readGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba5Freq(N)    writeGEQFreqCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba5Freq       wroteGEQFreqCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba5Level       readGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba5Level(N)   writeGEQLevelCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba5Level      wroteGEQLevelCh(14, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba5Width       readGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba5Width(N)   writeGEQWidthCh(14, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba5Width      wroteGEQWidthCh(14, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba6Freq        readGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba6Freq(N)    writeGEQFreqCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba6Freq       wroteGEQFreqCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba6Level       readGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba6Level(N)   writeGEQLevelCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba6Level      wroteGEQLevelCh(14, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba6Width       readGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba6Width(N)   writeGEQWidthCh(14, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba6Width      wroteGEQWidthCh(14, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba7Freq        readGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba7Freq(N)    writeGEQFreqCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba7Freq       wroteGEQFreqCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba7Level       readGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba7Level(N)   writeGEQLevelCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba7Level      wroteGEQLevelCh(14, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba7Width       readGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba7Width(N)   writeGEQWidthCh(14, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba7Width      wroteGEQWidthCh(14, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba8Freq        readGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba8Freq(N)    writeGEQFreqCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba8Freq       wroteGEQFreqCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba8Level       readGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba8Level(N)   writeGEQLevelCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba8Level      wroteGEQLevelCh(14, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba8Width       readGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba8Width(N)   writeGEQWidthCh(14, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba8Width      wroteGEQWidthCh(14, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba9Freq        readGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba9Freq(N)    writeGEQFreqCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba9Freq       wroteGEQFreqCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba9Level       readGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba9Level(N)   writeGEQLevelCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba9Level      wroteGEQLevelCh(14, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba9Width       readGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba9Width(N)   writeGEQWidthCh(14, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba9Width      wroteGEQWidthCh(14, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba10Freq        readGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba10Freq(N)    writeGEQFreqCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba10Freq       wroteGEQFreqCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba10Level       readGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba10Level(N)   writeGEQLevelCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba10Level      wroteGEQLevelCh(14, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba10Width       readGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba10Width(N)   writeGEQWidthCh(14, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba10Width      wroteGEQWidthCh(14, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba11Freq        readGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba11Freq(N)    writeGEQFreqCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba11Freq       wroteGEQFreqCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba11Level       readGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba11Level(N)   writeGEQLevelCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba11Level      wroteGEQLevelCh(14, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba11Width       readGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba11Width(N)   writeGEQWidthCh(14, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba11Width      wroteGEQWidthCh(14, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba12Freq        readGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba12Freq(N)    writeGEQFreqCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba12Freq       wroteGEQFreqCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba12Level       readGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba12Level(N)   writeGEQLevelCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba12Level      wroteGEQLevelCh(14, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba12Width       readGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba12Width(N)   writeGEQWidthCh(14, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba12Width      wroteGEQWidthCh(14, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba13Freq        readGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba13Freq(N)    writeGEQFreqCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba13Freq       wroteGEQFreqCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba13Level       readGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba13Level(N)   writeGEQLevelCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba13Level      wroteGEQLevelCh(14, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba13Width       readGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba13Width(N)   writeGEQWidthCh(14, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba13Width      wroteGEQWidthCh(14, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba14Freq        readGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba14Freq(N)    writeGEQFreqCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba14Freq       wroteGEQFreqCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba14Level       readGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba14Level(N)   writeGEQLevelCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba14Level      wroteGEQLevelCh(14, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba14Width       readGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba14Width(N)   writeGEQWidthCh(14, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba14Width      wroteGEQWidthCh(14, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba15Freq        readGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba15Freq(N)    writeGEQFreqCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba15Freq       wroteGEQFreqCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba15Level       readGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba15Level(N)   writeGEQLevelCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba15Level      wroteGEQLevelCh(14, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba15Width       readGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba15Width(N)   writeGEQWidthCh(14, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba15Width      wroteGEQWidthCh(14, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba16Freq        readGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba16Freq(N)    writeGEQFreqCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba16Freq       wroteGEQFreqCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba16Level       readGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba16Level(N)   writeGEQLevelCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba16Level      wroteGEQLevelCh(14, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba16Width       readGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba16Width(N)   writeGEQWidthCh(14, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba16Width      wroteGEQWidthCh(14, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba17Freq        readGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba17Freq(N)    writeGEQFreqCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba17Freq       wroteGEQFreqCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba17Level       readGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba17Level(N)   writeGEQLevelCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba17Level      wroteGEQLevelCh(14, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba17Width       readGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba17Width(N)   writeGEQWidthCh(14, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba17Width      wroteGEQWidthCh(14, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba18Freq        readGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba18Freq(N)    writeGEQFreqCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba18Freq       wroteGEQFreqCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba18Level       readGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba18Level(N)   writeGEQLevelCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba18Level      wroteGEQLevelCh(14, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba18Width       readGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba18Width(N)   writeGEQWidthCh(14, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba18Width      wroteGEQWidthCh(14, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba19Freq        readGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba19Freq(N)    writeGEQFreqCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba19Freq       wroteGEQFreqCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba19Level       readGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba19Level(N)   writeGEQLevelCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba19Level      wroteGEQLevelCh(14, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba19Width       readGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba19Width(N)   writeGEQWidthCh(14, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba19Width      wroteGEQWidthCh(14, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba20Freq        readGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba20Freq(N)    writeGEQFreqCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba20Freq       wroteGEQFreqCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba20Level       readGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba20Level(N)   writeGEQLevelCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba20Level      wroteGEQLevelCh(14, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba20Width       readGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba20Width(N)   writeGEQWidthCh(14, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba20Width      wroteGEQWidthCh(14, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba21Freq        readGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba21Freq(N)    writeGEQFreqCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba21Freq       wroteGEQFreqCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba21Level       readGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba21Level(N)   writeGEQLevelCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba21Level      wroteGEQLevelCh(14, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba21Width       readGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba21Width(N)   writeGEQWidthCh(14, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba21Width      wroteGEQWidthCh(14, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba22Freq        readGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba22Freq(N)    writeGEQFreqCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba22Freq       wroteGEQFreqCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba22Level       readGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba22Level(N)   writeGEQLevelCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba22Level      wroteGEQLevelCh(14, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba22Width       readGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba22Width(N)   writeGEQWidthCh(14, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba22Width      wroteGEQWidthCh(14, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba23Freq        readGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba23Freq(N)    writeGEQFreqCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba23Freq       wroteGEQFreqCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba23Level       readGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba23Level(N)   writeGEQLevelCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba23Level      wroteGEQLevelCh(14, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba23Width       readGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba23Width(N)   writeGEQWidthCh(14, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba23Width      wroteGEQWidthCh(14, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba24Freq        readGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba24Freq(N)    writeGEQFreqCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba24Freq       wroteGEQFreqCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba24Level       readGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba24Level(N)   writeGEQLevelCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba24Level      wroteGEQLevelCh(14, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba24Width       readGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba24Width(N)   writeGEQWidthCh(14, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba24Width      wroteGEQWidthCh(14, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba25Freq        readGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba25Freq(N)    writeGEQFreqCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba25Freq       wroteGEQFreqCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba25Level       readGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba25Level(N)   writeGEQLevelCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba25Level      wroteGEQLevelCh(14, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba25Width       readGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba25Width(N)   writeGEQWidthCh(14, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba25Width      wroteGEQWidthCh(14, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba26Freq        readGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba26Freq(N)    writeGEQFreqCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba26Freq       wroteGEQFreqCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba26Level       readGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba26Level(N)   writeGEQLevelCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba26Level      wroteGEQLevelCh(14, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba26Width       readGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba26Width(N)   writeGEQWidthCh(14, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba26Width      wroteGEQWidthCh(14, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba27Freq        readGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba27Freq(N)    writeGEQFreqCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba27Freq       wroteGEQFreqCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba27Level       readGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba27Level(N)   writeGEQLevelCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba27Level      wroteGEQLevelCh(14, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba27Width       readGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba27Width(N)   writeGEQWidthCh(14, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba27Width      wroteGEQWidthCh(14, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba28Freq        readGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba28Freq(N)    writeGEQFreqCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba28Freq       wroteGEQFreqCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba28Level       readGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba28Level(N)   writeGEQLevelCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba28Level      wroteGEQLevelCh(14, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba28Width       readGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba28Width(N)   writeGEQWidthCh(14, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba28Width      wroteGEQWidthCh(14, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba29Freq        readGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba29Freq(N)    writeGEQFreqCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba29Freq       wroteGEQFreqCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba29Level       readGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba29Level(N)   writeGEQLevelCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba29Level      wroteGEQLevelCh(14, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba29Width       readGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba29Width(N)   writeGEQWidthCh(14, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba29Width      wroteGEQWidthCh(14, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba30Freq        readGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba30Freq(N)    writeGEQFreqCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba30Freq       wroteGEQFreqCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba30Level       readGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba30Level(N)   writeGEQLevelCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba30Level      wroteGEQLevelCh(14, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba30Width       readGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba30Width(N)   writeGEQWidthCh(14, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba30Width      wroteGEQWidthCh(14, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba31Freq        readGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba31Freq(N)    writeGEQFreqCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba31Freq       wroteGEQFreqCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba31Level       readGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba31Level(N)   writeGEQLevelCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba31Level      wroteGEQLevelCh(14, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba31Width       readGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba31Width(N)   writeGEQWidthCh(14, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba31Width      wroteGEQWidthCh(14, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh14Ba32Freq        readGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba32Freq(N)    writeGEQFreqCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba32Freq       wroteGEQFreqCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba32Level       readGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba32Level(N)   writeGEQLevelCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba32Level      wroteGEQLevelCh(14, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh14Ba32Width       readGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh14Ba32Width(N)   writeGEQWidthCh(14, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh14Ba32Width      wroteGEQWidthCh(14, 31, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba1Freq        readGEQFreqCh(15, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba1Freq(N)    writeGEQFreqCh(15, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba1Freq       wroteGEQFreqCh(15, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba1Level       readGEQLevelCh(15, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba1Level(N)   writeGEQLevelCh(15, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba1Level      wroteGEQLevelCh(15, 0, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba1Width       readGEQWidthCh(15, 0, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba1Width(N)   writeGEQWidthCh(15, 0, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba1Width      wroteGEQWidthCh(15, 0, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba2Freq        readGEQFreqCh(15, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba2Freq(N)    writeGEQFreqCh(15, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba2Freq       wroteGEQFreqCh(15, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba2Level       readGEQLevelCh(15, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba2Level(N)   writeGEQLevelCh(15, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba2Level      wroteGEQLevelCh(15, 1, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba2Width       readGEQWidthCh(15, 1, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba2Width(N)   writeGEQWidthCh(15, 1, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba2Width      wroteGEQWidthCh(15, 1, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba3Freq        readGEQFreqCh(15, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba3Freq(N)    writeGEQFreqCh(15, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba3Freq       wroteGEQFreqCh(15, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba3Level       readGEQLevelCh(15, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba3Level(N)   writeGEQLevelCh(15, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba3Level      wroteGEQLevelCh(15, 2, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba3Width       readGEQWidthCh(15, 2, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba3Width(N)   writeGEQWidthCh(15, 2, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba3Width      wroteGEQWidthCh(15, 2, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba4Freq        readGEQFreqCh(15, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba4Freq(N)    writeGEQFreqCh(15, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba4Freq       wroteGEQFreqCh(15, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba4Level       readGEQLevelCh(15, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba4Level(N)   writeGEQLevelCh(15, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba4Level      wroteGEQLevelCh(15, 3, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba4Width       readGEQWidthCh(15, 3, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba4Width(N)   writeGEQWidthCh(15, 3, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba4Width      wroteGEQWidthCh(15, 3, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba5Freq        readGEQFreqCh(15, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba5Freq(N)    writeGEQFreqCh(15, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba5Freq       wroteGEQFreqCh(15, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba5Level       readGEQLevelCh(15, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba5Level(N)   writeGEQLevelCh(15, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba5Level      wroteGEQLevelCh(15, 4, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba5Width       readGEQWidthCh(15, 4, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba5Width(N)   writeGEQWidthCh(15, 4, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba5Width      wroteGEQWidthCh(15, 4, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba6Freq        readGEQFreqCh(15, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba6Freq(N)    writeGEQFreqCh(15, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba6Freq       wroteGEQFreqCh(15, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba6Level       readGEQLevelCh(15, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba6Level(N)   writeGEQLevelCh(15, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba6Level      wroteGEQLevelCh(15, 5, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba6Width       readGEQWidthCh(15, 5, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba6Width(N)   writeGEQWidthCh(15, 5, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba6Width      wroteGEQWidthCh(15, 5, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba7Freq        readGEQFreqCh(15, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba7Freq(N)    writeGEQFreqCh(15, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba7Freq       wroteGEQFreqCh(15, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba7Level       readGEQLevelCh(15, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba7Level(N)   writeGEQLevelCh(15, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba7Level      wroteGEQLevelCh(15, 6, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba7Width       readGEQWidthCh(15, 6, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba7Width(N)   writeGEQWidthCh(15, 6, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba7Width      wroteGEQWidthCh(15, 6, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba8Freq        readGEQFreqCh(15, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba8Freq(N)    writeGEQFreqCh(15, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba8Freq       wroteGEQFreqCh(15, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba8Level       readGEQLevelCh(15, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba8Level(N)   writeGEQLevelCh(15, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba8Level      wroteGEQLevelCh(15, 7, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba8Width       readGEQWidthCh(15, 7, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba8Width(N)   writeGEQWidthCh(15, 7, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba8Width      wroteGEQWidthCh(15, 7, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba9Freq        readGEQFreqCh(15, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba9Freq(N)    writeGEQFreqCh(15, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba9Freq       wroteGEQFreqCh(15, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba9Level       readGEQLevelCh(15, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba9Level(N)   writeGEQLevelCh(15, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba9Level      wroteGEQLevelCh(15, 8, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba9Width       readGEQWidthCh(15, 8, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba9Width(N)   writeGEQWidthCh(15, 8, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba9Width      wroteGEQWidthCh(15, 8, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba10Freq        readGEQFreqCh(15, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba10Freq(N)    writeGEQFreqCh(15, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba10Freq       wroteGEQFreqCh(15, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba10Level       readGEQLevelCh(15, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba10Level(N)   writeGEQLevelCh(15, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba10Level      wroteGEQLevelCh(15, 9, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba10Width       readGEQWidthCh(15, 9, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba10Width(N)   writeGEQWidthCh(15, 9, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba10Width      wroteGEQWidthCh(15, 9, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba11Freq        readGEQFreqCh(15, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba11Freq(N)    writeGEQFreqCh(15, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba11Freq       wroteGEQFreqCh(15, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba11Level       readGEQLevelCh(15, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba11Level(N)   writeGEQLevelCh(15, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba11Level      wroteGEQLevelCh(15, 10, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba11Width       readGEQWidthCh(15, 10, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba11Width(N)   writeGEQWidthCh(15, 10, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba11Width      wroteGEQWidthCh(15, 10, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba12Freq        readGEQFreqCh(15, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba12Freq(N)    writeGEQFreqCh(15, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba12Freq       wroteGEQFreqCh(15, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba12Level       readGEQLevelCh(15, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba12Level(N)   writeGEQLevelCh(15, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba12Level      wroteGEQLevelCh(15, 11, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba12Width       readGEQWidthCh(15, 11, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba12Width(N)   writeGEQWidthCh(15, 11, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba12Width      wroteGEQWidthCh(15, 11, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba13Freq        readGEQFreqCh(15, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba13Freq(N)    writeGEQFreqCh(15, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba13Freq       wroteGEQFreqCh(15, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba13Level       readGEQLevelCh(15, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba13Level(N)   writeGEQLevelCh(15, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba13Level      wroteGEQLevelCh(15, 12, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba13Width       readGEQWidthCh(15, 12, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba13Width(N)   writeGEQWidthCh(15, 12, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba13Width      wroteGEQWidthCh(15, 12, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba14Freq        readGEQFreqCh(15, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba14Freq(N)    writeGEQFreqCh(15, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba14Freq       wroteGEQFreqCh(15, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba14Level       readGEQLevelCh(15, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba14Level(N)   writeGEQLevelCh(15, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba14Level      wroteGEQLevelCh(15, 13, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba14Width       readGEQWidthCh(15, 13, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba14Width(N)   writeGEQWidthCh(15, 13, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba14Width      wroteGEQWidthCh(15, 13, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba15Freq        readGEQFreqCh(15, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba15Freq(N)    writeGEQFreqCh(15, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba15Freq       wroteGEQFreqCh(15, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba15Level       readGEQLevelCh(15, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba15Level(N)   writeGEQLevelCh(15, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba15Level      wroteGEQLevelCh(15, 14, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba15Width       readGEQWidthCh(15, 14, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba15Width(N)   writeGEQWidthCh(15, 14, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba15Width      wroteGEQWidthCh(15, 14, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba16Freq        readGEQFreqCh(15, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba16Freq(N)    writeGEQFreqCh(15, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba16Freq       wroteGEQFreqCh(15, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba16Level       readGEQLevelCh(15, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba16Level(N)   writeGEQLevelCh(15, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba16Level      wroteGEQLevelCh(15, 15, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba16Width       readGEQWidthCh(15, 15, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba16Width(N)   writeGEQWidthCh(15, 15, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba16Width      wroteGEQWidthCh(15, 15, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba17Freq        readGEQFreqCh(15, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba17Freq(N)    writeGEQFreqCh(15, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba17Freq       wroteGEQFreqCh(15, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba17Level       readGEQLevelCh(15, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba17Level(N)   writeGEQLevelCh(15, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba17Level      wroteGEQLevelCh(15, 16, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba17Width       readGEQWidthCh(15, 16, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba17Width(N)   writeGEQWidthCh(15, 16, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba17Width      wroteGEQWidthCh(15, 16, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba18Freq        readGEQFreqCh(15, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba18Freq(N)    writeGEQFreqCh(15, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba18Freq       wroteGEQFreqCh(15, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba18Level       readGEQLevelCh(15, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba18Level(N)   writeGEQLevelCh(15, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba18Level      wroteGEQLevelCh(15, 17, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba18Width       readGEQWidthCh(15, 17, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba18Width(N)   writeGEQWidthCh(15, 17, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba18Width      wroteGEQWidthCh(15, 17, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba19Freq        readGEQFreqCh(15, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba19Freq(N)    writeGEQFreqCh(15, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba19Freq       wroteGEQFreqCh(15, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba19Level       readGEQLevelCh(15, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba19Level(N)   writeGEQLevelCh(15, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba19Level      wroteGEQLevelCh(15, 18, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba19Width       readGEQWidthCh(15, 18, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba19Width(N)   writeGEQWidthCh(15, 18, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba19Width      wroteGEQWidthCh(15, 18, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba20Freq        readGEQFreqCh(15, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba20Freq(N)    writeGEQFreqCh(15, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba20Freq       wroteGEQFreqCh(15, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba20Level       readGEQLevelCh(15, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba20Level(N)   writeGEQLevelCh(15, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba20Level      wroteGEQLevelCh(15, 19, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba20Width       readGEQWidthCh(15, 19, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba20Width(N)   writeGEQWidthCh(15, 19, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba20Width      wroteGEQWidthCh(15, 19, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba21Freq        readGEQFreqCh(15, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba21Freq(N)    writeGEQFreqCh(15, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba21Freq       wroteGEQFreqCh(15, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba21Level       readGEQLevelCh(15, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba21Level(N)   writeGEQLevelCh(15, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba21Level      wroteGEQLevelCh(15, 20, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba21Width       readGEQWidthCh(15, 20, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba21Width(N)   writeGEQWidthCh(15, 20, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba21Width      wroteGEQWidthCh(15, 20, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba22Freq        readGEQFreqCh(15, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba22Freq(N)    writeGEQFreqCh(15, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba22Freq       wroteGEQFreqCh(15, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba22Level       readGEQLevelCh(15, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba22Level(N)   writeGEQLevelCh(15, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba22Level      wroteGEQLevelCh(15, 21, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba22Width       readGEQWidthCh(15, 21, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba22Width(N)   writeGEQWidthCh(15, 21, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba22Width      wroteGEQWidthCh(15, 21, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba23Freq        readGEQFreqCh(15, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba23Freq(N)    writeGEQFreqCh(15, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba23Freq       wroteGEQFreqCh(15, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba23Level       readGEQLevelCh(15, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba23Level(N)   writeGEQLevelCh(15, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba23Level      wroteGEQLevelCh(15, 22, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba23Width       readGEQWidthCh(15, 22, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba23Width(N)   writeGEQWidthCh(15, 22, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba23Width      wroteGEQWidthCh(15, 22, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba24Freq        readGEQFreqCh(15, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba24Freq(N)    writeGEQFreqCh(15, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba24Freq       wroteGEQFreqCh(15, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba24Level       readGEQLevelCh(15, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba24Level(N)   writeGEQLevelCh(15, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba24Level      wroteGEQLevelCh(15, 23, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba24Width       readGEQWidthCh(15, 23, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba24Width(N)   writeGEQWidthCh(15, 23, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba24Width      wroteGEQWidthCh(15, 23, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba25Freq        readGEQFreqCh(15, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba25Freq(N)    writeGEQFreqCh(15, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba25Freq       wroteGEQFreqCh(15, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba25Level       readGEQLevelCh(15, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba25Level(N)   writeGEQLevelCh(15, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba25Level      wroteGEQLevelCh(15, 24, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba25Width       readGEQWidthCh(15, 24, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba25Width(N)   writeGEQWidthCh(15, 24, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba25Width      wroteGEQWidthCh(15, 24, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba26Freq        readGEQFreqCh(15, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba26Freq(N)    writeGEQFreqCh(15, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba26Freq       wroteGEQFreqCh(15, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba26Level       readGEQLevelCh(15, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba26Level(N)   writeGEQLevelCh(15, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba26Level      wroteGEQLevelCh(15, 25, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba26Width       readGEQWidthCh(15, 25, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba26Width(N)   writeGEQWidthCh(15, 25, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba26Width      wroteGEQWidthCh(15, 25, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba27Freq        readGEQFreqCh(15, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba27Freq(N)    writeGEQFreqCh(15, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba27Freq       wroteGEQFreqCh(15, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba27Level       readGEQLevelCh(15, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba27Level(N)   writeGEQLevelCh(15, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba27Level      wroteGEQLevelCh(15, 26, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba27Width       readGEQWidthCh(15, 26, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba27Width(N)   writeGEQWidthCh(15, 26, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba27Width      wroteGEQWidthCh(15, 26, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba28Freq        readGEQFreqCh(15, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba28Freq(N)    writeGEQFreqCh(15, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba28Freq       wroteGEQFreqCh(15, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba28Level       readGEQLevelCh(15, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba28Level(N)   writeGEQLevelCh(15, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba28Level      wroteGEQLevelCh(15, 27, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba28Width       readGEQWidthCh(15, 27, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba28Width(N)   writeGEQWidthCh(15, 27, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba28Width      wroteGEQWidthCh(15, 27, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba29Freq        readGEQFreqCh(15, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba29Freq(N)    writeGEQFreqCh(15, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba29Freq       wroteGEQFreqCh(15, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba29Level       readGEQLevelCh(15, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba29Level(N)   writeGEQLevelCh(15, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba29Level      wroteGEQLevelCh(15, 28, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba29Width       readGEQWidthCh(15, 28, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba29Width(N)   writeGEQWidthCh(15, 28, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba29Width      wroteGEQWidthCh(15, 28, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba30Freq        readGEQFreqCh(15, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba30Freq(N)    writeGEQFreqCh(15, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba30Freq       wroteGEQFreqCh(15, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba30Level       readGEQLevelCh(15, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba30Level(N)   writeGEQLevelCh(15, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba30Level      wroteGEQLevelCh(15, 29, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba30Width       readGEQWidthCh(15, 29, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba30Width(N)   writeGEQWidthCh(15, 29, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba30Width      wroteGEQWidthCh(15, 29, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba31Freq        readGEQFreqCh(15, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba31Freq(N)    writeGEQFreqCh(15, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba31Freq       wroteGEQFreqCh(15, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba31Level       readGEQLevelCh(15, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba31Level(N)   writeGEQLevelCh(15, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba31Level      wroteGEQLevelCh(15, 30, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba31Width       readGEQWidthCh(15, 30, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba31Width(N)   writeGEQWidthCh(15, 30, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba31Width      wroteGEQWidthCh(15, 30, GEQ_MAXNUMBANDS)

#define  readGEQCh15Ba32Freq        readGEQFreqCh(15, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba32Freq(N)    writeGEQFreqCh(15, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba32Freq       wroteGEQFreqCh(15, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba32Level       readGEQLevelCh(15, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba32Level(N)   writeGEQLevelCh(15, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba32Level      wroteGEQLevelCh(15, 31, GEQ_MAXNUMBANDS)
#define  readGEQCh15Ba32Width       readGEQWidthCh(15, 31, GEQ_MAXNUMBANDS)
#define writeGEQCh15Ba32Width(N)   writeGEQWidthCh(15, 31, GEQ_MAXNUMBANDS,N)
#define wroteGEQCh15Ba32Width      wroteGEQWidthCh(15, 31, GEQ_MAXNUMBANDS)

/* 
 * *Incomplete* Control read 
 *
 * The following alpha code reads only those registers of the GEQ status
 * structure that are guaranteed to be present in any instantiation of
 * the ASP.
 *
 */
#define  readGEQControl \
         readGEQMode, \
         readGEQUse, \
         readGEQparamChg, \
         readGEQnumBands, \
         readGEQenableBand, \
         readGEQenableChan, \
         readGEQ1Freq, \
         readGEQ1Level, \
         readGEQ1Width


/* LOU alpha codes */

#ifndef STD_BETA_LOU
#   define STD_BETA_LOU    0x59
#endif

#define  readLOUMode        0xc200+STD_BETA_LOU,0x0400
#define writeLOUModeDisable 0xca00+STD_BETA_LOU,0x0400
#define writeLOUModeEnable  0xca00+STD_BETA_LOU,0x0401

#define  readLOUBypass          0xc200+STD_BETA_LOU,0x0500
#define writeLOUBypassEnable    0xca00+STD_BETA_LOU,0x0500
#define writeLOUBypassDisable    0xca00+STD_BETA_LOU,0x0501

#define  readLOUUse              readLOUBypass
#define writeLOUUseDisable      writeLOUBypassEnable
#define writeLOUUseEnable       writeLOUBypassDisable


/* readLOUStatus is commented out for now. LOUStatus invokes
   the GEQ3 status structure which is too large to be transmitted
   in a single payload within PA/F. */
// #define  readLOUStatus 0xc508,STD_BETA_LOU
#define  readLOUControl \
         readLOUMode, \
         readLOUBypass

#define  readGEQLOUMode         readLOUMode
#define writeGEQLOUModeDisable  writeLOUModeDisable
#define writeGEQLOUModeEnable   writeLOUModeEnable

#define  readGEQLOUBypass            readLOUBypass
#define writeGEQLOUBypassEnable     writeLOUBypassEnable
#define writeGEQLOUBypassDisable    writeLOUBypassDisable

#define  readGEQLOUUse               readGEQLOUBypass
#define writeGEQLOUUseDisable       writeGEQLOUBypassEnable
#define writeGEQLOUUseEnable        writeGEQLOUBypassDisable

//#define  readGEQLOUStatus       readLOUStatus
#define  readGEQLOUControl      readLOUControl


#endif /* _GEQ_A */

